#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <stack>
#include <queue>

#define int long long int

using namespace std;

vector <int> checkCol(int n, int m)
{
    int s1 = ((2 + (n - 1) * m) * n) / 2;
    int so = ((1 + n * m) * (n * m)) / 2;
    int s = s1;
    int left = 0, right = m, mid1, mid2;
    while (right - left > 2)
    {
        mid1 = left + (right - left) / 3;
        mid2 = right - (right - left) / 3;
        int sm1 = (mid1 + 1) * s1 + (n * mid1 * (mid1 + 1)) / 2;
        int sm2 = (mid2 + 1) * s1 + (n * mid2 * (mid2 + 1)) / 2;
        if (abs(sm1 - (so - sm1)) > abs(sm2 - (so - sm2)))
        {
            left = mid1;
        }
        else
        {
            right = mid2;
        }
    }
    //cout << left << endl;
    int bestI = max(0, left - 3), best = abs(s - (so - s));
    s = (bestI + 1) * s1 + (n * bestI * (bestI + 1)) / 2;
    for (int i = left - 3; i <= min(m, right + 3); i++)
    {
        s = (i + 1) * s1 + (n * i * (i + 1)) / 2;
        if (abs(s - (so - s)) < best)
        {
            best = abs(s - (so - s));
            bestI = i;
        }
    }
    vector <int> A;
    A.push_back(bestI);
    A.push_back(best);
    return(A);
}
vector <int> checkRow(int n, int m)
{
    int s1 = ((1 + m) * m) / 2;
    int so = ((1 + n * m) * (n * m)) / 2;
    int s = s1;
    int left = 0, right = n, mid1, mid2;
    while (right - left > 2)
    {
        mid1 = left + (right - left) / 3;
        mid2 = right - (right - left) / 3;
        int sm1 = (mid1 + 1) * s1 + (m * m * mid1 * (mid1 + 1)) / 2;
        int sm2 = (mid2 + 1) * s1 + (m * m * mid2 * (mid2 + 1)) / 2;
        if (abs(sm1 - (so - sm1)) > abs(sm2 - (so - sm2)))
        {
            left = mid1;
        }
        else
        {
            right = mid2;
        }
    }
    int bestI = max(0, left - 3), best = abs(s - (so - s));
    s = (bestI + 1) * s1 + (m * m * bestI * (bestI + 1)) / 2;
    for (int i = left - 3; i <= min(n, right + 3); i++)
    {
        s = (i + 1) * s1 + (m * m * i * (i + 1)) / 2;
        if (abs(s - (so - s)) < best)
        {
            best = abs(s - (so - s));
            bestI = i;
        }
    }
    vector <int> A;
    A.push_back(bestI);
    A.push_back(best);
    return(A);
}
string intToString(int num)
{
    string res = "";
    while (num > 0)
    {
        char t = (char)(num % 10 + (int)('0'));
        res = "!" + res;
        res[0] = t;
        num = num / 10;
    }
    return(res);
}

int32_t main()
{
    int t;
    cin >> t;
    for (int i = 0; i < t; i++)
    {
        int n, m;
        cin >> n >> m;
        vector <int> col = checkCol(n, m);
        vector <int> row = checkRow(n, m);
        string ans1, ans2;
        if (col[1] <= row[1])
        {
            ans1 = "V " + intToString(col[0] + 2);
        }
        else
        {
            ans1 = "H " + intToString(row[0] + 2);
        }
        cout << ans1 << endl;
    }
}
