// ukurok.ilkras.ru

#include <string>
#include <iostream>
#include <vector>

using namespace std;

bool is_DNA_char(char ch){
    return !(('0' <= ch) && (ch <= '9'));
}

char generate_other(char ch){
    if (ch == 'G'){
        return 'A';
    } else {
        return 'G';
    }
}

int how_many_digits(int x){
    if (x < 10){
        return 1;
    }
    int res = 0;
    while (true){
        if (x == 0){
            break;
        }
//        int d = x % 10;
        x /= 10;
        res++;
    }
    return res;
}

struct Sequence{
    int count = 1;
    char glyph = 'A';

    Sequence()=default;

    Sequence(int _c, char _g){
        count = _c;
        glyph = _g;
    }
};

std::vector<Sequence> decode_to_sequence(const std::string& str){
    std::vector<Sequence> res;
    bool collecting_int = false;
    int collected_int = 0;
    for (char ch: str){
        if (collecting_int){
            if (is_DNA_char(ch)){
                collecting_int = false;
                res.emplace_back(collected_int, ch);
                collected_int = 0;
            } else {
                collected_int *= 10;
                collected_int += (ch - '0');
            }
        } else {
            if (is_DNA_char(ch)){
                res.emplace_back(1, ch);
            } else {
                collecting_int = true;
                collected_int = (ch - '0');
            }
        }
    }
    return res;
}

//string decode(const string& str){
//    string res;
//    bool collecting_int = false;
//    int collected_int = 0;
//    for (char ch: str){
//        if (collecting_int){
//            if (is_DNA_char(ch)){
//                collecting_int = false;
//                for (int i = 0; i < collected_int; i++){
//                    res += ch;
//                }
//                collected_int = 0;
//            } else {
//                collected_int *= 10;
//                collected_int += (ch - '0');
//            }
//        } else {
//            if (is_DNA_char(ch)){
//                res += ch;
//            } else {
//                collecting_int = true;
//                collected_int = (ch - '0');
//            }
//        }
//    }
//    return res;
//}
//
//string encode(const string& str){
//    string res;
//    char prev = '.';
//    int count = 0;
//
//    auto oborvat = [&](){
//        if (count >= 2){
//            res += to_string(count);
//        }
//        if (count >= 1){
//            res += prev;
//        }
//        count = 1;
//    };
//
//    for (char ch: str){
//        if (ch == prev){
//            count++;
//        } else {
//            oborvat();
//        }
//        prev = ch;
//    }
//    oborvat();
//    return res;
//}

pair<int, char> max_task_part(const vector<Sequence>& blocks){
    int n = blocks.size();
    vector<int> block_offset(n, 0);
    for (int i = 1; i < n; i++){
        block_offset[i] = block_offset[i - 1] + blocks[i - 1].count;
    }

    int max_maximization = 1;
    int res_index = 0;
    char res_char = generate_other(blocks[0].glyph);

    for (int i = 0; i < n; i++){
        if (blocks[i].count < 3){
            continue;
        }
        int prev_block_size = how_many_digits(blocks[i].count) + 1;

        int cur_maximization_res = 0;
        int cur_res_index = -1;
        char cur_res_char = generate_other(blocks[i].glyph);

        // Here will be our lambda
        auto check_one_block_breaking = [&](int a) -> void{
            int b = blocks[i].count - a;
            int new_block_size = 0;
            if (a == 1){
                new_block_size = 1 + 1 + how_many_digits(b) + 1;
            } else {
                new_block_size = how_many_digits(a) + 1 + 1 + how_many_digits(b) + 1;
            }

            int cur_cur_maximization_res = new_block_size - prev_block_size;
            if (cur_maximization_res <= cur_cur_maximization_res){
                cur_maximization_res = cur_cur_maximization_res;
                cur_res_index = block_offset[i] + a;
            }
        };

        if (blocks[i].count > 3){
            check_one_block_breaking(2);
        }

        int digits_in_a = 1;
        int a = 1;

        while (true){
            if (a + 2 > n){
                break;
            }

            check_one_block_breaking(a);

            digits_in_a++;
            a *= 10;
        }

        if (max_maximization <= cur_maximization_res){
            max_maximization = cur_maximization_res;
            res_index = cur_res_index;
            res_char = cur_res_char;
        }
    }
    return {res_index, res_char};
}

int min_task_part(const std::vector<Sequence>& start_blocks){
    int n = start_blocks.size();
    std::vector<int> block_offset(n, 0);
    for (int i = 1; i < n; i++){
        block_offset[i] = block_offset[i - 1] + start_blocks[i - 1].count;
    }

    int max_minimization = 0;
    int corresponding_index = -1;

    for (int i = 0; i < n; i++){
        int res = 0;
        if (start_blocks[i].count > 1){
            int prev_count = start_blocks[i].count;
            int new_count = start_blocks[i].count - 1;
            if (new_count == 1){
                res += 1;
            } else {
                res += how_many_digits(prev_count) - how_many_digits(new_count);
            }
        } else {
            res += 1;
            if ((i != 0) && (i != n - 1)){
                if (start_blocks[i - 1].glyph == start_blocks[i + 1].glyph){
                    int left_count = start_blocks[i - 1].count;
                    int right_count = start_blocks[i + 1].count;
                    int prev_size = 2 + how_many_digits(left_count) + how_many_digits(right_count);
                    int new_size = 1 + how_many_digits(left_count + right_count);
                    res += prev_size - new_size;
                }
            }
        }
        if (max_minimization <= res){
            max_minimization = res;
            corresponding_index = block_offset[i] + 1;
        }
    }
    return corresponding_index;
}

int main(){
    std::string encoded_start;
    std::cin >> encoded_start;
    std::vector<Sequence> start_blocks = decode_to_sequence(encoded_start);
    cout << "2 " << min_task_part(start_blocks) << "\n";
    auto max_result = max_task_part(start_blocks);
    cout << "1 " << max_result.first << " " << max_result.second << "\n";
    return 0;
}
