#include <iostream>
#include <vector>
#include <string>
#include <functional>

#define int __int128
#define MOD 1000000009

using namespace std;

string readStr(){
    string res;
    cin >> res;
    return res;
}

int gcd(int a, int b, int& x, int& y){
    if (b == 0){
        x = 1;
        y = 0;
        return a;
    } else {
        int x2, y2;
        int r = a % b;
        int k = a / b;
        int g = gcd(b, r, x2, y2);
        x = y2;
        y = x2 - k * y2;
        return g;
    }
}

int get_obratniy_po_modulu(int p, int a){
    int ash, rk;
    gcd(a, p, ash, rk);
//    int t = a * ash + p * rk;
//    int t2 = (a * ash) % p;
    return ash;
}

struct Column{
    bool forward;
    bool backward;
    bool have_zero;

    Column(bool _f, bool _b, bool _z){
        forward = _f;
        backward = _b;
        have_zero = _z;
    }

    Column()=default;
};

signed main(){
    string A_str = readStr();
    string B_str = readStr();
    string C_str = readStr();
    int n = A_str.size();
    vector<Column> columns;
    bool had_troubles_with_init = false;
    for (int i = 0; i < n; i++){
        int a = A_str[i] - (int)'0';
        int b = B_str[i] - (int)'0';
        int c = C_str[i] - (int)'0';
        int r = a + b;
        bool took_from_back;
        if ((r % 10) == c){
            took_from_back = false;
        } else if ((r % 10) + 1 == c){
            took_from_back = true;
        } else {
            had_troubles_with_init = true;
            break;
        }
        bool give_it_forward = r + (int)took_from_back >= 10;
        bool have_zero = (a == 0) || (b == 0) || (c == 0);
        columns.emplace_back(give_it_forward, took_from_back, have_zero);
    }
    if (had_troubles_with_init){
        cout << "0\n";
    } else {
        int a = 0;
        int b = 0;
        int c = 0;
        int d = 0;

        vector<int> factorial(3 * n + 1, 1);
        for (int i = 1; i <= n; i++) {
            factorial[i] = (factorial[i - 1] * i) % MOD;
        }

        for (int i = 0; i < n; i++){
            if (columns[i].backward){
                if (columns[i].forward){
                    d++;
                } else {
                    b++;
                }
            } else {
                if (columns[i].forward){
                    c++;
                } else {
                    a++;
                }
            }
        }
        if (b != c || ((d > 0) && (b == 0))){
            cout << "0\n";
        } else {
            // No troubles with initialization
            // All data is correct

            function<int(int, int)> normal_mod = [](int x, int p) -> int{
                if (x >= 0){
                    return x % p;
                }
                x = -x;
                x %= p;
                x = -x;
                return x + p;
            };

            function<void(int&, int)> mod_imul = [&normal_mod](int& n, int x) -> void{
                n *= x;
                n = normal_mod(n, MOD);
            };

            function<int(int, int)> comb = [&factorial, &mod_imul](int k, int n) -> int {
                int res = factorial[n];
                mod_imul(res, get_obratniy_po_modulu(MOD, factorial[k]));
                mod_imul(res, get_obratniy_po_modulu(MOD, factorial[n - k]));
                return res;
            };

            int ans = 1;
            mod_imul(ans, factorial[a]);
            mod_imul(ans, factorial[b]);
            mod_imul(ans, factorial[c]);
            mod_imul(ans, factorial[d]);
            mod_imul(ans, comb(a, a + b));
            mod_imul(ans, comb(d, d + b - 1));
            cout << (long long)ans << "\n";
            // Warning: eto reshenie ne uchitivaet nuli
        }
    }
    return 0;
}
