#include <bits/stdc++.h>

using namespace std;

struct Answer {
  int type;  // 1 - add  2 - del  3 - change
  int x;
  char Z;
  int sz = -1;
};

Answer mina, maxa;
char LETTERS[] = {'A', 'T', 'G', 'C'};

void relaxmin(int t, int x, char z, int sz) {
  if (mina.sz == -1 || mina.sz > sz) {
    mina.type = t;
    mina.x = x;
    mina.Z = z;
    mina.sz = sz;
  }
}

void relaxmax(int t, int x, char z, int sz) {
  if (maxa.sz == -1 || maxa.sz < sz) {
    maxa.type = t;
    maxa.x = x;
    maxa.Z = z;
    maxa.sz = sz;
  }
}

void relaxdel(int x, int sz) {
  x++;
  relaxmax(2, x, -1, sz);
  relaxmin(2, x, -1, sz);
}

void relaxadd(int x, char z, int sz) {
  relaxmax(1, x, z, sz);
  relaxmin(1, x, z, sz);
}

void relaxupd(int x, char z, int sz) {
  x++;
  relaxmax(3, x, z, sz);
  relaxmin(3, x, z, sz);
}

vector<pair<int, char>> arr, cur;
int curlen;

int len(int x) {
  if (x == 0)
    return 0;
  if (x == 1)
    return 1;
  return to_string(x).size() + 1;
}

vector<pair<int, char>> toback;

void add(pair<int, char> x) {
  if (x.first == 0)
    return;
  if (cur.empty() || cur.back().second != x.second) {
    cur.push_back(x);
    curlen += len(x.first);
    toback.emplace_back(-1, -1);
  } else {
    auto old = cur.back();
    cur.back().first += x.first;
    toback.push_back(old);
    toback.emplace_back(-1, -1);
    curlen -= len(old.first);
    curlen += len(cur.back().first);
  }
}

void rollback() {
  while (!toback.empty()) {
    auto x = toback.back();
    toback.pop_back();
    if (x.first == -1) {
      curlen -= len(cur.back().first);
      cur.pop_back();
    } else {
      curlen += len(x.first);
      cur.push_back(x);
    }
  }
}

vector<int> sufflen;
int n;

void solvedel() {
  cur.clear();
  curlen = 0;
  int LEN = 0;
  for (int i = 0; i < n; ++i) {
    auto x = arr[i];
    x.first--;
    add(x);
    if (i + 1 < n)
      add(arr[i + 1]);
    relaxdel(LEN, curlen + sufflen[i + 2]);
    rollback();
    add(arr[i]);
    LEN += arr[i].first;
    toback.clear();
  }
}

void solveadd() {
  cur.clear();
  curlen = 0;
  int LEN = 0;
  for (int i = 0; i <= n; ++i) {
    for (char c : LETTERS) {
      pair<int, char> x(1, c);
      add(x);
      if (i < n)
        add(arr[i]);
      relaxadd(LEN, c, curlen + sufflen[i + 1]);
      rollback();
    }
    if (i < n) {
      add(arr[i]);
      toback.clear();
      LEN += arr[i].first;
    }
  }
}

void solveupd1() {
  cur.clear();
  curlen = 0;
  int LEN = 0;
  for (int i = 0; i < n; ++i) {
    for (char c : LETTERS) {
      if (c == arr[i].second)
        continue;
      pair<int, char> x(1, c);
      add(x);
      auto y = arr[i];
      y.first--;
      add(y);
      if (i + 1 < n)
        add(arr[i + 1]);
      relaxupd(LEN, c, curlen + sufflen[i + 2]);
      rollback();
    }
    add(arr[i]);
    LEN += arr[i].first;
    toback.clear();
  }
}

void solveupd2() {
  cur.clear();
  curlen = 0;
  int LEN = 0;
  for (int i = 0; i < n; ++i) {
    int LLEN = LEN + arr[i].first - 1;
    for (char c : LETTERS) {
      if (c == arr[i].second)
        continue;
      auto y = arr[i];
      y.first--;
      add(y);
      pair<int, char> x(1, c);
      add(x);
      if (i + 1 < n)
        add(arr[i + 1]);
      relaxupd(LLEN, c, curlen + sufflen[i + 2]);
      rollback();
    }
    add(arr[i]);
    LEN += arr[i].first;
    toback.clear();
  }
}

bool isletter(char c) {
  return c == 'A' || c == 'T' || c == 'G' || c == 'C';
}

void output(Answer a) {
  cout << a.type << ' ' << a.x;
  if (a.type != 2)
    cout << ' ' << a.Z;
  cout << '\n';
}

pair<int, int> split(int x) {
  int ln = -1;
  int res = 0;
  for (int i = 1; i <= 12; ++i) {
    if (x - i <= 0)
      break;
    int nln = len(i) + len(x - i);
    if (nln > ln) {
      ln = nln;
      res = i;
    }
  }
  for (int i = 10; x - i > 0; i *= 10) {
    int nln = len(i) + len(x - i);
    if (nln > ln) {
      ln = nln;
      res = i;
    }
  }
  return {res, x - res};
}

void solveadd2() {
  cur.clear();
  curlen = 0;
  int LEN = 0;
  for (int i = 0; i < n; ++i) {
    auto[n1, n2] = split(arr[i].first);
    int LLEN = LEN + n1;
    for (char c : LETTERS) {
      if (c == arr[i].second)
        continue;
      pair<int, char> first(n1, arr[i].second);
      add(first);
      pair<int, char> x(1, c);
      add(x);
      pair<int, char> second(n2, arr[i].second);
      add(second);
      if (i + 1 < n)
        add(arr[i + 1]);
      relaxadd(LLEN, c, curlen + sufflen[i + 2]);
      rollback();
    }
    add(arr[i]);
    toback.clear();
    LEN += arr[i].first;
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  string s;
  cin >> s;
  string num = "";
  for (char c : s) {
    if (isletter(c)) {
      int x = 1;
      if (!num.empty())
        x = stoi(num);
      num = "";
      arr.emplace_back(x, c);
    } else {
      num.push_back(c);
    }
  }
  n = arr.size();
  sufflen.resize(n + 3, 0);
  for (int i = n - 1; i >= 0; --i)
    sufflen[i] = sufflen[i + 1] + len(arr[i].first);
  solveadd();
  solvedel();
  solveupd1();
  solveupd2();
  solveadd2();
  output(mina);
  output(maxa);
  return 0;
}
