#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 1e5 + 10;
const int MAXC = MAXN * 4 + 10;

struct Edge {
  int v, u, i;
};

struct Segm {
  vector<int> mrr;
  int s;
};

vector<Edge> graph[MAXC];
int cntin[MAXC];
int cntout[MAXC];
int vsz;
vector<int> zip;
bitset<MAXC> islife;

int getv(int x) {
  int ind = lower_bound(zip.begin(), zip.end(), x) - zip.begin();
  assert(ind < zip.size() && zip[ind] == x);
  return ind;
}

void fail() {
  cout << "No";
  exit(0);
}

vector<int> ans;

void dfs(int v) {
  while (!graph[v].empty()) {
    auto e = graph[v].back();
    graph[v].pop_back();
    ans.push_back(e.i);
    dfs(e.u);
  }
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int n;
  cin >> n;
  vector<Segm> arr(n);
  int len = -1;
  for (int i = 0; i < n; ++i) {
    int m, s;
    cin >> m >> s;
    arr[i].mrr.resize(m);
    arr[i].s = s;
    for (int &el : arr[i].mrr)
      cin >> el;
    zip.push_back(arr[i].mrr[0]);
    zip.push_back(s - arr[i].mrr.back());
    if (m >= 2) {
      int ln = arr[i].mrr[1] - arr[i].mrr[0];
      if (len == -1)
        len = ln;
      else if (len != ln)
        fail();
      for (int j = 0; j < m - 1; ++j) {
        if (arr[i].mrr[j + 1] - arr[i].mrr[j] != len)
          fail();
      }
    }
  }
  assert(len != -1);
  int zsz = zip.size();
  for (int i = 0; i < zsz; ++i) {
    zip.push_back(len - zip[i]);
  }
  sort(zip.begin(), zip.end());
  zip.resize(unique(zip.begin(), zip.end()) - zip.begin());
  vsz = zip.size();
  for (int i = 0; i < n; ++i) {
    int a = arr[i].mrr[0];
    int b = arr[i].s - arr[i].mrr.back();
    int ba = len - b;
    int v = getv(a);
    int u = getv(ba);
    graph[v].push_back({v, u, i});
    cntout[v]++;
    cntin[u]++;
  }
  int start = -1;
  int end = -1;
  vector<int> lifev;
  for (int v = 0; v < vsz; ++v) {
    if (cntin[v] == 0 && cntout[v] == 0)
      continue;
    lifev.push_back(v);
    islife[v] = true;
    if (cntin[v] == cntout[v])
      continue;
    if (abs(cntin[v] - cntout[v]) > 1)
      fail();
    if (cntin[v] > cntout[v]) {
      if (end != -1)
        fail();
      end = v;
    } else {
      if (start != -1)
        fail();
      start = v;
    }
  }
  if (start == -1 && end != -1)
    fail();
  if (start != -1 && end == -1)
    fail();
  if (start == -1) {
    start = lifev[0];
    end = lifev[0];
  }
  dfs(start);
  if (ans.size() != n)
    fail();
  cout << "Yes\n";
//  for (int el : ans)
//    cout << el + 1 << ' ';
  return 0;
}
