#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 1e5 + 10;
const int MAXC = MAXN * 4 + 10;

struct Edge {
  int v, u, i;
};

struct Segm {
  vector<int> mrr;
  int s;
};

vector<Edge> graph[MAXC];
int cntin[MAXC];
int cntout[MAXC];
int vsz;
vector<int> zip;
vector<int> ans;
int n;
vector<Segm> arr;



int getv(int x) {
  int ind = lower_bound(zip.begin(), zip.end(), x) - zip.begin();
  assert(ind < zip.size() && zip[ind] == x);
  return ind;
}

void fail() {
  cout << "No";
  exit(0);
}

void dfs(int v) {
  while (!graph[v].empty()) {
    auto e = graph[v].back();
    graph[v].pop_back();
    dfs(e.u);
    ans.push_back(e.i);
  }
}

void solvelen(int len) {
  int zsz = zip.size();
  for (int i = 0; i < zsz; ++i) {
    zip.push_back(len - zip[i]);
  }
  sort(zip.begin(), zip.end());
  zip.resize(unique(zip.begin(), zip.end()) - zip.begin());
  vsz = zip.size();
  for (int i = 0; i < n; ++i) {
    int a = arr[i].mrr[0];
    int b = arr[i].s - arr[i].mrr.back();
    int ba = len - b;
    int v = getv(a);
    int u = getv(ba);
    graph[v].push_back({v, u, i});
    cntout[v]++;
    cntin[u]++;
  }
  int start = -1;
  int end = -1;
  vector<int> lifev;
  for (int v = 0; v < vsz; ++v) {
    if (cntin[v] == 0 && cntout[v] == 0)
      continue;
    lifev.push_back(v);
    if (cntin[v] == cntout[v])
      continue;
    if (abs(cntin[v] - cntout[v]) > 1)
      return;
    if (cntin[v] > cntout[v]) {
      if (end != -1)
        return;
      end = v;
    } else {
      if (start != -1)
        return;
      start = v;
    }
  }
  if (start == -1 && end != -1)
    return;
  if (start != -1 && end == -1)
    return;
  if (start == -1) {
    start = lifev[0];
    end = lifev[0];
  }
  dfs(start);
  reverse(ans.begin(), ans.end());
  if (ans.size() != n)
    return;
  cout << "Yes\n";
  for (int el : ans)
    cout << el + 1 << ' ';
  exit(0);
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cin >> n;
  arr.resize(n);
  int len = -1;
  vector<int> zipp;
  for (int i = 0; i < n; ++i) {
    int m, s;
    cin >> m >> s;
    arr[i].mrr.resize(m);
    arr[i].s = s;
    for (int &el : arr[i].mrr)
      cin >> el;
    zipp.push_back(arr[i].mrr[0]);
    zipp.push_back(s - arr[i].mrr.back());
    if (m >= 2) {
      int ln = arr[i].mrr[1] - arr[i].mrr[0];
      if (len == -1)
        len = ln;
      else if (len != ln)
        fail();
      for (int j = 0; j < m - 1; ++j) {
        if (arr[i].mrr[j + 1] - arr[i].mrr[j] != len)
          fail();
      }
    }
  }
  if (len != -1) {
    zip = zipp;
    solvelen(len);
    fail();
  }
  for (int i = 0; i <= 100; ++i) {
    zip = zipp;
    ans.clear();
    memset(cntin, 0, sizeof cntin);
    memset(cntout, 0, sizeof cntout);
    for (int j = 0; j < MAXC; ++j) {
      graph[j].clear();
    }
    solvelen(i);
  }
  fail();
  return 0;
}
