#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 1e5 + 10;
const int MAXC = MAXN * 4 + 10;

struct Edge {
  int v, u, i;
};

struct Segm {
  vector<int> mrr;
  int s;
};

vector<Edge> graph[MAXC];
int cntin[MAXC];
int cntout[MAXC];
int vsz;
vector<int> zip;
vector<int> ans;
int n;
vector<Segm> arr;
vector<int> lifev;



int getv(int x) {
  int ind = lower_bound(zip.begin(), zip.end(), x) - zip.begin();
  assert(ind < zip.size() && zip[ind] == x);
  return ind;
}

void fail() {
  cout << "No";
  exit(0);
}

void dfs(int v) {
  while (!graph[v].empty()) {
    auto e = graph[v].back();
    graph[v].pop_back();
    dfs(e.u);
    ans.push_back(e.i);
  }
}

int min1s = 1e9 + 1, min2s = 1e9 + 2, maxs = -1;
unordered_set<int> checked;
void solvelen(int len) {
  if (len < maxs || len > min1s + min2s)
    return;
  if (!checked.insert(len).second)
    return;
  int zsz = zip.size();
  for (int i = 0; i < zsz; ++i) {
    zip.push_back(len - zip[i]);
  }
  sort(zip.begin(), zip.end());
  zip.resize(unique(zip.begin(), zip.end()) - zip.begin());
  vsz = zip.size();
  for (int i = 0; i < n; ++i) {
    int a = arr[i].mrr[0];
    int b = arr[i].s - arr[i].mrr.back();
    int ba = len - b;
    int v = getv(a);
    int u = getv(ba);
    graph[v].push_back({v, u, i});
    cntout[v]++;
    cntin[u]++;
    lifev.push_back(u);
    lifev.push_back(v);
  }
  sort(lifev.begin(), lifev.end());
  lifev.resize(unique(lifev.begin(), lifev.end()) - lifev.begin());
  int start = -1;
  int end = -1;
  for (int v : lifev) {
    if (cntin[v] == 0 && cntout[v] == 0)
      continue;
    if (cntin[v] == cntout[v])
      continue;
    if (abs(cntin[v] - cntout[v]) > 1)
      return;
    if (cntin[v] > cntout[v]) {
      if (end != -1)
        return;
      end = v;
    } else {
      if (start != -1)
        return;
      start = v;
    }
  }
  if (start == -1 && end != -1)
    return;
  if (start != -1 && end == -1)
    return;
  if (start == -1) {
    start = lifev[0];
    end = lifev[0];
  }
  dfs(start);
  reverse(ans.begin(), ans.end());
  if (ans.size() != n)
    return;
  cout << "Yes\n";
  for (int el : ans)
    cout << el + 1 << ' ';
  exit(0);
}

void clearall() {
  for (int v : lifev) {
    cntin[v] = 0;
    cntout[v] = 0;
    graph[v].clear();
  }
  lifev.clear();
  ans.clear();
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cin >> n;
  arr.resize(n);
  int len = -1;
  vector<int> zipp;
  int sumS = 0;
  for (int i = 0; i < n; ++i) {
    int m, s;
    cin >> m >> s;
    if (s <= min1s)
      min2s = min1s, min1s = s;
    else if (s < min2s)
      min2s = s;
    if (s > maxs)
      maxs = s;
    sumS += s;
    arr[i].mrr.resize(m);
    arr[i].s = s;
    for (int &el : arr[i].mrr)
      cin >> el;
    zipp.push_back(arr[i].mrr[0]);
    zipp.push_back(s - arr[i].mrr.back());
    if (m >= 2) {
      int ln = arr[i].mrr[1] - arr[i].mrr[0];
      if (len == -1)
        len = ln;
      else if (len != ln)
        fail();
      for (int j = 0; j < m - 1; ++j) {
        if (arr[i].mrr[j + 1] - arr[i].mrr[j] != len)
          fail();
      }
    }
  }
  if (maxs > min1s + min2s)
    fail();
  sort(zipp.begin(), zipp.end());
  zipp.resize(unique(zipp.begin(), zipp.end()) - zipp.begin());
  if (len != -1) {
    zip = zipp;
    solvelen(len);
    fail();
  }
  if (maxs <= 100) {
    for (int i = 0; i <= maxs; ++i) {
      zip = zipp;
      solvelen(i);
      clearall();
    }
    fail();
  }
  if (n <= 1000) {
    for (int i = 1; i < n; ++i) {
      len = (arr[0].s - arr[0].mrr.back()) + arr[i].mrr[0];
      zip = zipp;
      solvelen(len);
      clearall();
    }
    for (int i = 0; i < n - 1; ++i) {
      len = (arr[n - 1].s - arr[n - 1].mrr.back()) + arr[i].mrr[0];
      zip = zipp;
      solvelen(len);
      clearall();
    }
    fail();
  }
  vector<int> aa(n), bb(n);
  for (int i = 0; i < n; ++i) {
    aa[i] = arr[i].mrr[0];
    bb[i] = arr[i].s - arr[i].mrr.back();
  }
  sort(aa.begin(), aa.end());
  aa.resize(unique(aa.begin(), aa.end()) - aa.begin());
  sort(bb.begin(), bb.end());
  bb.resize(unique(bb.begin(), bb.end()) - bb.begin());
  vector<vector<int>> rrr(n - 1);
  int mod = n - 1;
  for (int i = 0; i < aa.size(); ++i) {
    rrr[aa[i] % mod].push_back(aa[i]);
  }
  int sr = sumS % mod;
  for (int i = 0; i < bb.size(); ++i) {
    int b = bb[i];
    int r = b % mod;
    int t = (sr - r + mod) % mod;
    for (int a : rrr[t]) {
      int kek = sumS - a - b;
      len = kek / mod;
      solvelen(len);
    }
  }
  fail();
  return 0;
}
