#include <iostream>
#include <vector>
#include <queue>
#include <stack>
#include <algorithm>
#include <sstream>
#include <math.h>
#include <cmath>
#include <set>

using namespace std;

long long findMinIndexVert(long long n, long long m, long long& minDiff) {
	long long allSum = ((n * m) * (n * m + 1)) / 2;
	set<long long> visited;

	long long index = (1 + m) / 2;
	long long step = (1 + m) / 2;
	minDiff = allSum;
	long long minIndex = -1;
	while (visited.find(index) == visited.end())
	{
		visited.insert(index);
		long long partSum = (n * index * (index + 1)) / 2 + (n * (n - 1) * m * index) / 2; 
		long long diff = allSum - 2 * partSum;
		if (abs(diff) < minDiff) {
			minDiff = abs(diff);
			minIndex = index;
		}
		step = (1 + step) / 2;
		if (diff < 0) {
			index -= step;
		}
		else if (diff > 0) {
			index += step;
		}
		else
		{
			return index;
		}
	}

	return minIndex;
}

long long findMinIndexHor(long long n, long long m, long long& minDiff) {
	long long allSum = ((n * m) * (n * m + 1)) / 2;
	set<long long> visited;

	long long index = (1 + n) / 2;
	long long step = (1 + n) / 2;
	minDiff = allSum;
	long long minIndex = -1;
	while (visited.find(index) == visited.end())
	{
		visited.insert(index);
		long long partSum = ((index * m) * (index * m + 1)) / 2;
		long long diff = allSum - 2 * partSum;
		if (abs(diff) < minDiff) {
			minDiff = abs(diff);
			minIndex = index;
		}
		step = (1 + step) / 2;
		if (diff < 0) {
			index -= step;
		}
		else if (diff > 0) {
			index += step;
		}
		else
		{
			return index;
		}
	}

	return minIndex;
}

int main()
{
	long long t;
	cin >> t;
	for (long long i = 0; i < t; i++)
	{
		long long n, m;
		cin >> n;
		cin >> m;

		long long minDiffVert = 0;
		long long minIndVert = findMinIndexVert(n, m, minDiffVert);

		long long minDiffHor = 0;
		long long minIndHor = findMinIndexHor(n, m, minDiffHor);

		if (minDiffHor < minDiffVert) {
			cout << "H " << minIndHor + 1 << endl;
		}
		else
		{
			cout << "V " << minIndVert + 1 << endl;
		}
	}
}

