#include <iostream>
#include <vector>
#include <queue>
#include <stack>
#include <algorithm>
#include <sstream>
#include <math.h>
#include <cmath>
#include <set>

using namespace std;

long long findMinIndexVert(long long n, long long m, long long& minDiff) {
	long long allSum = ((n * m) * (n * m + 1)) / 2;
	set<long long> visited;

	long long index = (1 + m) / 2;
	long long step = (1 + m) / 2;
	minDiff = allSum;
	long long minIndex = -1;
	for(index = 0; index < m; index++)
	{
		visited.insert(index);
		long long partSum = (n * index * (index + 1)) / 2 + (n * (n - 1) * m * index) / 2;
		long long diff = allSum - 2 * partSum;
		if (abs(diff) < minDiff) {
			minDiff = abs(diff);
			minIndex = index;
		}
	}

	return minIndex;
}

long long findMinIndexHor(long long n, long long m, long long& minDiff) {
	long long allSum = ((n * m) * (n * m + 1)) / 2;
	set<long long> visited;

	long long index = (1 + n) / 2;
	long long step = (1 + n) / 2;
	minDiff = allSum;
	long long minIndex = -1;
	for(index = n / 2; index < n; index++)
	{
		visited.insert(index);
		long long partSum = ((index * m) * (index * m + 1)) / 2;
		long long diff = allSum - 2 * partSum;
		if (abs(diff) < minDiff) {
			minDiff = abs(diff);
			minIndex = index;
		}
	
	}

	return minIndex;
}

int main()
{
	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		long long n, m;
		cin >> n;
		cin >> m;


		if (n == 1) {
			long long k = (long long)(sqrt(1 + 2 * m * (m + 1)) - 1.0f) / 2.0f;
			long long summ1 = k * (k + 1) / 2;
			long long summ2 = k * (k - 1) / 2;
			long long summ3 = (k + 1) * (k + 2) / 2;

			long long allSumm = m * (m + 1) / 2;

			long long diff1 = abs(allSumm - 2 * summ1);
			long long diff2 = abs(allSumm - 2 * summ2);
			long long diff3 = abs(allSumm - 2 * summ3);

			if (diff1 < diff2 && diff1 < diff3) {
				cout << "V " << k + 1 << endl;
				continue;
			}
			else if (diff2 < diff1 && diff2 < diff3) {
				cout << "V " << k << endl;
				continue;
			}
			else
			{
				cout << "V " << k + 2 << endl;
				continue;
			}
		}

		long long minDiffVert = 0;
		long long minIndVert = findMinIndexVert(n, m, minDiffVert);

		long long minDiffHor = 0;
		long long minIndHor = findMinIndexHor(n, m, minDiffHor);

		if (minDiffHor < minDiffVert) {
			cout << "H " << minIndHor + 1 << endl;
		}
		else
		{
			cout << "V " << minIndVert + 1 << endl;
		}
	}
}

