#include <iostream>
#include <vector>
#include <queue>
#include <stack>
#include <algorithm>
#include <sstream>
#include <math.h>
#include <cmath>
#include <set>

using namespace std;

long long findMinIndexVert(long long n, long long m, long long& minDiff, long long begin, long long end) {
	long long allSum = ((n * m) * (n * m + 1ll)) / 2ll;

	long long index = (1 + m) / 2ll;
	long long step = (1 + m) / 2ll;
	minDiff = allSum;
	long long minIndex = -1ll;
	for (index = max(begin, 0ll); index <= end && index < m; index++)
	{
		long long partSum = (n * index * (index + 1ll)) / 2ll + (n * (n - 1ll) * m * index) / 2ll;
		long long diff = allSum - 2ll * partSum;
		if (abs(diff) < minDiff) {
			minDiff = abs(diff);
			minIndex = index;
		}
	}

	return minIndex;
}

const int FINAL_STEP_SIZE = 128;

long long findMinIndexVert(long long n, long long m, long long& minDiff) {
	long long allSum = ((n * m) * (n * m + 1ll)) / 2ll;
	set<long long> visited;

	long long index = (1 + m) / 2ll;
	long long step = (1 + m) / 2ll;
	minDiff = allSum;
	long long minIndex = -1ll;
	while (visited.find(index) == visited.end())
	{
		visited.insert(index);
		long long partSum = (n * index * (index + 1ll)) / 2ll + (n * (n - 1ll) * m * index) / 2ll;
		long long diff = allSum - 2ll * partSum;
		if (abs(diff) < minDiff) {
			minDiff = abs(diff);
			minIndex = index;
		}

		step = (1ll + step) / 2ll;
		if (diff < 0) {
			if (step < FINAL_STEP_SIZE) {
				return findMinIndexVert(n, m, minDiff, index - step * 2, index);
			}
			index -= step;
		}
		else {
			if (step < FINAL_STEP_SIZE) {
				return findMinIndexVert(n, m, minDiff, index, index + step * 2);
			}
			index += step;
		}
	}

	return minIndex;
}

long long findMinIndexHor(long long n, long long m, long long& minDiff, long long begin, long long end) {
	long long allSum = ((n * m) * (n * m + 1ll)) / 2ll;

	long long index = (1ll + n) / 2ll;
	minDiff = allSum;
	long long minIndex = -1;
	for(index = max(begin, 0ll); index <= end && index < n; index++)
	{
		long long partSum = ((index * m) * (index * m + 1)) / 2ll;
		long long diff = allSum - 2ll * partSum;
		if (abs(diff) < minDiff) {
			minDiff = abs(diff);
			minIndex = index;
		}

	}

	return minIndex;
}

long long findMinIndexHor(long long n, long long m, long long& minDiff) {
	long long allSum = ((n * m) * (n * m + 1ll)) / 2ll;
	set<long long> visited;

	long long index = (1ll + n) / 2ll;
	long long step = (1ll + n) / 2ll;
	minDiff = allSum;
	long long minIndex = -1;
	while (visited.find(index) == visited.end() || step > 1)
	{
		visited.insert(index);
		long long partSum = ((index * m) * (index * m + 1)) / 2ll;
		long long diff = allSum - 2ll * partSum;
		if (abs(diff) < minDiff) {
			minDiff = abs(diff);
			minIndex = index;
		}

		step = (1ll + step) / 2ll;
		if (diff < 0) {
			if (step < FINAL_STEP_SIZE) {
				return findMinIndexHor(n, m, minDiff, index - step * 2, index);
			}
			index -= step;
			
		}
		else {
			if (step < FINAL_STEP_SIZE) {
				return findMinIndexHor(n, m, minDiff, index, index + step * 2);
			}
			index += step;
			
		}
	
	}

	return minIndex;
}

int main()
{
	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		long long n, m;
		cin >> n;
		cin >> m;


		if (n == 1) {
			long long k = (long long)((sqrt(1 + 2 * m * (m + 1)) - 1.0) / 2.0);
			long long summ1 = (k * (k + 1)) / 2;
			long long summ2 = (k * (k - 1)) / 2;
			long long summ3 = ((k + 1) * (k + 2)) / 2;

			long long allSumm = m * (m + 1) / 2;

			long long diff1 = abs(allSumm - 2ll * summ1);
			long long diff2 = abs(allSumm - 2ll * summ2);
			long long diff3 = abs(allSumm - 2ll * summ3);

			if (diff1 < diff2 && diff1 < diff3) {
				cout << "V " << k + 1 << endl;
				continue;
			}
			else if (diff2 < diff1 && diff2 < diff3) {
				cout << "V " << k << endl;
				continue;
			}
			else
			{
				cout << "V " << k + 2 << endl;
				continue;
			}
		}

		long long minDiffVert = 0;
		long long minIndVert = findMinIndexVert(n, m, minDiffVert);

		long long minDiffHor = 0;
		long long minIndHor = findMinIndexHor(n, m, minDiffHor);

		if (minDiffHor < minDiffVert) {
			cout << "H " << minIndHor + 1 << endl;
		}
		else
		{
			cout << "V " << minIndVert + 1 << endl;
		}
	}
}

