#include <iostream>
#include <vector>
#include <queue>
#include <stack>
#include <algorithm>
#include <sstream>
#include <math.h>
#include <cmath>
#include <set>

using namespace std;

set<char> DNA_SYMBOLS = { 'A', 'C', 'T', 'G' };

typedef vector<pair<int, char>> DNA;

DNA parseDNA(string source) {
	vector<pair<int, char>> result;
    string currentCount = "";
	for (int i = 0; i < source.length(); i++)
	{
		if (DNA_SYMBOLS.find(source[i]) == DNA_SYMBOLS.end()) {
			currentCount += source[i];
		}
		else
		{
			int count = currentCount.length() > 0 ? atoi(currentCount.c_str()) : 1;
			currentCount = "";
			result.push_back(make_pair(count, source[i]));
		}
	}
	return result;
}

int numSize(int number) {
	int result = 0;
	while (number != 0)
	{
		number /= 10;
		result++;
	}
	return result;
}

void findMin(DNA source) {
	int current = 0;
	int maxDel = -1;
	int index = -1;
	for (int i = 0; i < source.size(); i++)
	{
		current += source[i].first;
		int delNow = -1;
		if (source[i].first == 1) {
			if (i != 0 && i != source.size() - 1) {
				if (source[i - 1].second == source[i + 1].second) {
					delNow = 2 + numSize(source[i - 1].first) + numSize(source[i + 1].first)
						- numSize(source[i - 1].first + source[i + 1].first);
				}
				else
				{
					delNow = 1;
				}
			}
			else
			{
				delNow = 1;
			}
		}
		else
		{
			delNow = numSize(source[i].first) - numSize(source[i].first - 1);
			if (source[i].first == 2) {
				delNow = 1;
			}
		}

		if (delNow > maxDel) {
			maxDel = delNow;
			index = current;
		}
	}
	cout << "2 " << index << endl;
}

char getOtherSymbol(char a) {
	for (auto s : DNA_SYMBOLS)
	{
		if (s != a) {
			return s;
		}
	}
}

char getOtherSymbol(char a, char b) {
	for (auto s : DNA_SYMBOLS)
	{
		if (s != a && s != b) {
			return s;
		}
	}
}

void findMax(DNA source) {
	int maxAdd = -1;
	int index = -1;
	int current = 0;
	char symb = '\0';
	char symbol = '\0';
	for (int i = 0; i < source.size(); i++)
	{
		int addNow2 = 1;
		int ind2 = current + source[i].first;
		char symb2 = i == source.size() - 1 ? 
			getOtherSymbol(source[i].second) : getOtherSymbol(source[i].second, source[i + 1].second);


		int addNow1 = -1;
		int ind1 = -1;
		int size = numSize(source[i].first);
		if (source[i].first >= 2 * pow(10, size - 1)) {
			addNow1 = 2 + size;
			ind1 = current + source[i].first / 2;
			symb = getOtherSymbol(source[i].second);
		}
		else
		{
			if (source[i].first >= pow(10, size - 1) + pow(10, size - 2)) {
				addNow1 = 1 + size;
				ind1 = current + pow(10, size - 1);
				symb = getOtherSymbol(source[i].second);
			}
			else
			{
				addNow1 = size;
				ind1 = current + source[i].first / 2;
				symb = getOtherSymbol(source[i].second);
			}
		}
		if (source[i].first == 3) {
			addNow1 = 2;
			ind1 = current + 1;
			symb = getOtherSymbol(source[i].second);
		}
		if (source[i].first == 2) {
			addNow1 = 1;
			ind1 = current + 1;
			symb = getOtherSymbol(source[i].second);
		}
		if (source[i].first == 1) {
			addNow1 = 0;
			ind1 = -1;
		}

		if (addNow1 > maxAdd) {
			maxAdd = addNow1;
			index = ind1;
			symbol = symb;
		}
		if (addNow2 > maxAdd) {
			maxAdd = addNow2;
			index = ind2;
			symbol = symb2;
		}

		current += source[i].first;

	}

	cout << "1 " << index << " " << symbol << endl;
}

int main()
{
	string source;
	cin >> source;
    DNA dna = parseDNA(source);
	findMin(dna);
	findMax(dna);
}

