#include <iostream>
#include <vector>
#include <queue>
#include <stack>
#include <algorithm>
#include <sstream>
#include <math.h>
#include <cmath>
#include <set>
#include <map>
using namespace std;
#define LL long long

const LL modulo = 1000000007ll;

vector<int> strToVec(string source) {
	vector<int> result;
	result.resize(source.length());
	for (int i = 0; i < source.length(); i++)
	{
		result[i] = source[i] - '0';
	}
	return result;
}

bool isOk(int num) {
	if (num == -1 ||
		num == 0 ||
		num == 9 ||
		num == 10) {
		return true;
	}
	else
	{
		return false;
	}
}

LL countPermutations(map<int, int> diffsCounts, bool hasOne) {
	LL result = 0ll;
	if (hasOne) {
		if (diffsCounts[-1] == 1) {
			result += 1;
		}
		else if (diffsCounts[-1] > 1) {
			map<int, int> diffCountsCopy = diffsCounts;
			diffCountsCopy[-1]--;
			result += (LL)diffsCounts[-1] * countPermutations(diffCountsCopy, false);
		}

		if (diffsCounts[9] == 1) {
			if (diffsCounts.size() > 1) {
				result += 1;
			}
		}
		else if (diffsCounts[9] > 1) {
			map<int, int> diffCountsCopy = diffsCounts;
			diffCountsCopy[9]--;
			result += (LL)diffsCounts[9] * countPermutations(diffCountsCopy, true);
		}
	}
	else
	{
		if (diffsCounts[0] == 1) {
			result += 1;
		}
		else if (diffsCounts[0] > 1) {
			map<int, int> diffCountsCopy = diffsCounts;
			diffCountsCopy[0]--;
			result += (LL)diffsCounts[0] * countPermutations(diffCountsCopy, false);
		}

		if (diffsCounts[10] == 1) {
			if (diffsCounts.size() > 1) {
				result += 1;
			}
		}
		else if (diffsCounts[10] > 1) {
			map<int, int> diffCountsCopy = diffsCounts;
			diffCountsCopy[10]--;
			result += (LL)diffsCounts[10] * countPermutations(diffCountsCopy, true);
		}
	}

	result = result % modulo;

	return result;
}

int main()
{
	string as, bs, cs;
	cin >> as;
	cin >> bs;
	cin >> cs;

	vector<int> a = strToVec(as), b = strToVec(bs), c = strToVec(cs);

	int n = a.size();

	vector<int> diffs;
	diffs.resize(n);

	map<int, int> diffsCount;

	for (int i = 0; i < n; i++)
	{
		diffs[i] = a[i] + b[i] - c[i];
		if (!isOk(diffs[i])) {
			cout << 0 << endl;
			return 0;
		}

		if (diffsCount.find(diffs[i]) == diffsCount.end()) {
			diffsCount.insert(make_pair(diffs[i], 0));
		}
		diffsCount[diffs[i]]++;
	}

	cout << countPermutations(diffsCount, false) << endl;
}

