#include <iostream>
#include <sstream>
#include <algorithm>
#include <unordered_map>
#include <vector>
using namespace std;
#define int long long

int fix = -1;

vector<vector<pair<int, int>>> g;
vector <int> ans;
vector<bool> used;
int n;


bool dfs(int i, int path, int count = 1)
{
	used[i] = true;
	ans.push_back(i + 1);
	if (count == n)
	{
		return true;
	}
	for (auto t : g[i])
	{
		int to = t.first, cost = t.second;
		if (cost == path && !used[to])
		{
			if (dfs(to, path, count + 1))
			{
				return true;
			}
		}
	}
	used[i] = false;
	ans.pop_back();
	return false;
}

void solve() {
	cin >> n;
	vector<pair<int, int>> v(n);
	for (int i = 0; i < n; ++i)
	{
		int m, s;
		cin >> m >> s;
		int mi_l, mi;
		cin >> mi_l;
		v[i].first = mi_l;
		while (--m)
		{
			cin >> mi;
			if (fix == -1)
			{
				fix = mi - mi_l;
			}
			else
			{
				if (fix != mi - mi_l)
				{
					cout << "No";
					return;
				}
			}
			mi_l = mi;
		}
		v[i].second = s - mi_l;
	}
	g.resize(n);
	unordered_map<int, int> mp;
	//r_g.resize(n);
	for (int i = 0; i < n; ++i)
	{
		for (int j = i + 1; j < n; ++j)
		{
			++mp[v[i].second + v[j].first];
			++mp[v[j].second + v[i].first];
			g[i].emplace_back(j, v[i].second + v[j].first);
			g[j].emplace_back(i, v[j].second + v[i].first);
		}
	}
	vector<int> true_path;
	if (fix != -1)
	{
		true_path.push_back(fix);
	}
	if (fix != -1)
	{
		for (auto& i : mp)
		{
			if (i.second >= n)
			{
				true_path.push_back(i.first);
			}
		}
	}
	used.resize(n);
	for (auto path : true_path)
	{
		for (int i = 0; i < n; ++i)
		{
			if (dfs(i, path))
			{
				cout << "Yes\n";
				for (int i = 0; i < n; ++i)
				{
					cout << ans[i] << ' ';
				}
				return;
			}
		}
	}
	cout << "No";
	return;
}

signed main() {
	int t = 1;
	while (t--) {
		solve();
	}
}