#include <iostream>
#include <vector>
#include <cassert>
#include <string>
#include <math.h>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>

using namespace std;

#define ll long long
#define pii pair<int, int>
#define mp make_pair
#define pb push_back
#define ft first
#define sd second
#define ld long double

struct edge {
	int to, ind;
	bool used;
	edge() {
		used = false;
	};
};

vector<vector<edge>> gr;

int endd;
pair<vector<int>, bool> dfs(int v) {
	if (gr[v].size() == 0)
		return mp(vector<int>(), v == endd);
	edge endEdge;
	vector<int> end;
	edge cycleEdge;
	vector<int> cycle;
	while (gr[v].size() > 0) {
		edge e = gr[v].back();
		gr[v].pop_back();
		auto next = dfs(e.to);
		if (next.sd) {
			endEdge = e;
			end = next.ft;
		}
		else {
			cycleEdge = e;
			cycle = next.ft;
		}
	}
	if (end.size()) {
		vector<int> ans;
		ans.push_back(cycleEdge.ind);
		for (int ind : cycle)
			ans.pb(ind);
		ans.pb(endEdge.ind);
		for (int ind : end)
			ans.pb(ind);
		return mp(ans, true);
	}
	vector<int> ans;
	ans.push_back(cycleEdge.ind);
	for (int ind : cycle)
		ans.pb(ind);
	return mp(ans, false);
}

void solve() {
	int n;
	cin >> n;
	vector<pii> antenas;
	bool fixed = false;
	int val = -1;
	bool broken = false;
	for (int i = 0; i < n; i++) {
		int m, len;
		cin >> m >> len;
		if (m == 1) {
			int k;
			cin >> k;
			antenas.pb(mp(k, len - k));
		}
		else {
			vector<int> ks(m);
			for (int j = 0; j < m; j++) 
				cin >> ks[j];
			for (int j = 1; j < m; j++) {
				if (!fixed) {
					fixed = true;
					val = ks[j] - ks[j - 1];
				}
				else if (ks[j] - ks[j - 1] != val)
					broken = true;
			}
			antenas.pb(mp(ks[0], len - ks[m - 1]));
		}
	}
	if (broken) {
		cout << "No";
		return;
	}
	if (n == 1) {
		cout << "Yes\n1";
		return;
	}
	/*if (n <= 8) {
		vector<int> perm(n);
		for (int i = 0; i < n; i++)
			perm[i] = i;
		for (int i = 0; i < 8 * 7 * 6 * 5 * 4 * 3 * 2; i++) {
			bool good = true;
			int val1;
			if (fixed)
				val1 = val;
			else
				val1 = antenas[perm[1]].ft + antenas[perm[0]].sd;
			for (int j = 1; j < n; j++)
				if (antenas[perm[j]].ft + antenas[perm[j - 1]].sd != val1) {
					good = false;
					break;
				}
			if (good) {
				cout << "Yes\n";
				for (int i = 0; i < n; i++)
					cout << perm[i] + 1 << ' ';
				return;
			}
			next_permutation(perm.begin(), perm.end());
		}
		cout << "No\n";
		return;
	}*/
	if (fixed) {
		vector<pii> newantenas(n);
		vector<int> beginnings;
		beginnings.reserve(2 * n);
		for (int i = 0; i < n; i++) {
			newantenas[i].ft = antenas[i].ft;
			newantenas[i].sd = val - antenas[i].sd;
			beginnings.push_back(newantenas[i].ft);
			beginnings.push_back(newantenas[i].sd);
		}
		sort(beginnings.begin(), beginnings.end());
		beginnings.resize(unique(beginnings.begin(), beginnings.end()) - beginnings.begin());
		int k = beginnings.size();
		if (k > n + 1) {
			cout << "No";
			return;
		}
		gr.resize(k);
		vector<int> in_deg(k);
		for (int i = 0; i < n; i++) {
			newantenas[i].ft = lower_bound(beginnings.begin(), beginnings.end(), newantenas[i].ft) - beginnings.begin();
			newantenas[i].sd = lower_bound(beginnings.begin(), beginnings.end(), newantenas[i].sd) - beginnings.begin();
			gr[newantenas[i].ft].pb(edge());
			gr[newantenas[i].ft].back().to = newantenas[i].sd;
			gr[newantenas[i].ft].back().ind = i;
			in_deg[newantenas[i].sd]++;
		}
		int start = -1;
		int end = -1;
		for (int i = 0; i < k; i++) {
			int out_deg = gr[i].size();
			if (in_deg[i] == out_deg)
				continue;
			else if (in_deg[i] < out_deg - 1) {
				cout << "No";
				return;
			}
			else if (in_deg[i] > out_deg + 1) {
				cout << "No";
				return;
			}
			else if (in_deg[i] == out_deg - 1)
				if (start != -1) {
					cout << "No";
					return;
				}
				else
					start = i;
			else if (end != -1) {
					cout << "No";
					return;
				}
				else
					end = i;

		}
		if (start == -1)
			if (end == -1) {
				start = 0;
				end = 0;
			}
			else {
				cout << "No";
				return;
			}
		else if (end == -1) {
			cout << "No";
			return;
		}
		vector<int> ans = dfs(start).ft;
		cout << "Yes\n";
		for (int ind : ans) {
			cout << ind + 1 << ' ';
		}
		int zero = 0;
	}
}

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);
	int t = 1;
	//cin >> t;
	while (t--)
		solve();
}