#include <iostream>
#include <vector>
#include <cassert>
#include <string>
#include <math.h>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>

using namespace std;

#define ll long long
#define pii pair<int, int>
#define mp make_pair
#define pb push_back
#define ft first
#define sd second
#define ld long double

struct edge {
	int to, ind;
	bool used;
	edge() {
		used = false;
	};
};

vector<vector<pii>> gr;

int endd;
vector<int> dfs(int v) {
	if (gr[v].size() == 0)
		return vector<int>();
	vector<int> ans(0);
	while (gr[v].size() > 0) {
		pii e = gr[v].back();
		gr[v].pop_back();
		vector<int> next =  dfs(e.ft);
		if (ans.size() == 0)
			swap(ans, next);
		else
			for (int i : next)
				ans.push_back(i);
		ans.push_back(e.sd);
	}
	return ans;
}

void solve() {
	int n;
	cin >> n;
	vector<pii> antenas;
	bool fixed = false;
	int val = -1;
	bool broken = false;
	for (int i = 0; i < n; i++) {
		int m, len;
		cin >> m >> len;
		if (m == 1) {
			int k;
			cin >> k;
			antenas.pb(mp(k, len - k));
		}
		else {
			vector<int> ks(m);
			for (int j = 0; j < m; j++) 
				cin >> ks[j];
			for (int j = 1; j < m; j++) {
				if (!fixed) {
					fixed = true;
					val = ks[j] - ks[j - 1];
				}
				else if (ks[j] - ks[j - 1] != val)
					broken = true;
			}
			antenas.pb(mp(ks[0], len - ks[m - 1]));
		}
	}
	if (broken) {
		cout << "No";
		return;
	}
	if (n == 1) {
		cout << "Yes\n1";
		return;
	}
	/*if (n <= 8) {
		vector<int> perm(n);
		for (int i = 0; i < n; i++)
			perm[i] = i;
		for (int i = 0; i < 8 * 7 * 6 * 5 * 4 * 3 * 2; i++) {
			bool good = true;
			int val1;
			if (fixed)
				val1 = val;
			else
				val1 = antenas[perm[1]].ft + antenas[perm[0]].sd;
			for (int j = 1; j < n; j++)
				if (antenas[perm[j]].ft + antenas[perm[j - 1]].sd != val1) {
					good = false;
					break;
				}
			if (good) {
				cout << "Yes\n";
				for (int i = 0; i < n; i++)
					cout << perm[i] + 1 << ' ';
				return;
			}
			next_permutation(perm.begin(), perm.end());
		}
		cout << "No\n";
		return;
	}*/
	if (fixed) {
		vector<pii> newantenas(n);
		vector<int> beginnings;
		beginnings.reserve(2 * n);
		for (int i = 0; i < n; i++) {
			newantenas[i].ft = antenas[i].ft;
			newantenas[i].sd = val - antenas[i].sd;
			beginnings.push_back(newantenas[i].ft);
			beginnings.push_back(newantenas[i].sd);
		}
		sort(beginnings.begin(), beginnings.end());
		beginnings.resize(unique(beginnings.begin(), beginnings.end()) - beginnings.begin());
		int k = beginnings.size();
		if (k > n + 1) {
			cout << "No";
			return;
		}
		gr.resize(k);
		vector<int> in_deg(k);
		for (int i = 0; i < n; i++) {
			newantenas[i].ft = lower_bound(beginnings.begin(), beginnings.end(), newantenas[i].ft) - beginnings.begin();
			newantenas[i].sd = lower_bound(beginnings.begin(), beginnings.end(), newantenas[i].sd) - beginnings.begin();
			gr[newantenas[i].ft].pb(mp(newantenas[i].sd,i));
			in_deg[newantenas[i].sd]++;
		}
		int start = -1;
		int end = -1;
		for (int i = 0; i < k; i++) {
			int out_deg = gr[i].size();
			if (in_deg[i] == out_deg)
				continue;
			else if (in_deg[i] < out_deg - 1) {
				cout << "No";
				return;
			}
			else if (in_deg[i] > out_deg + 1) {
				cout << "No";
				return;
			}
			else if (in_deg[i] == out_deg - 1)
				if (start != -1) {
					cout << "No";
					return;
				}
				else
					start = i;
			else if (end != -1) {
					cout << "No";
					return;
				}
				else
					end = i;

		}
		if (start == -1)
			if (end == -1) {
				start = 0;
				end = 0;
			}
			else {
				cout << "No";
				return;
			}
		else if (end == -1) {
			cout << "No";
			return;
		}
		endd = end;
		vector<int> ans = dfs(start);
		if (ans.size() < n) {
			cout << "No";
			return;
		}
		reverse(ans.begin(), ans.end());
		cout << "Yes\n";
		for (int ind : ans) {
			cout << ind + 1 << ' ';
		}
		int zero = 0;
		return;
	}
	if (n <= 1000) {
		vector<int>good;
		good.reserve(n * (n - 1));
		for (int i = 0; i < n; i++)
			for (int j = 0; j < n; j++)
				if (i != j)
					good.push_back(antenas[i].sd + antenas[j].ft);
		sort(good.begin(), good.end());
		int i = 0;
		while (i < good.size()) {
			int j = i;
			while (j < good.size() && good[i] == good[j])
				j++;
			if ((j - i) >= n) {
				gr.clear();
				val = good[i];
				vector<pii> newantenas(n);
				vector<int> beginnings;
				beginnings.reserve(2 * n);
				for (int i = 0; i < n; i++) {
					newantenas[i].ft = antenas[i].ft;
					newantenas[i].sd = val - antenas[i].sd;
					beginnings.push_back(newantenas[i].ft);
					beginnings.push_back(newantenas[i].sd);
				}
				sort(beginnings.begin(), beginnings.end());
				beginnings.resize(unique(beginnings.begin(), beginnings.end()) - beginnings.begin());
				int k = beginnings.size();
				if (k > n + 1) {
					i = j;
					continue;
				}
				gr.resize(k);
				vector<int> in_deg(k);
				for (int i = 0; i < n; i++) {
					newantenas[i].ft = lower_bound(beginnings.begin(), beginnings.end(), newantenas[i].ft) - beginnings.begin();
					newantenas[i].sd = lower_bound(beginnings.begin(), beginnings.end(), newantenas[i].sd) - beginnings.begin();
					gr[newantenas[i].ft].pb(mp(newantenas[i].sd, i));
					in_deg[newantenas[i].sd]++;
				}
				int start = -1;
				int end = -1;
				bool br = false;
				for (int i = 0; i < k; i++) {
					int out_deg = gr[i].size();
					if (in_deg[i] == out_deg)
						continue;
					else if (in_deg[i] < out_deg - 1) {
						i = j;
						br = true;
						break;
					}
					else if (in_deg[i] > out_deg + 1) {
						i = j;
						br = true;
						break;
					}
					else if (in_deg[i] == out_deg - 1)
						if (start != -1) {
							i = j;
							br = true;
							break;
						}
						else
							start = i;
					else if (end != -1) {
						i = j;
						br = true;
						break;
					}
					else
						end = i;

				}
				if (br)
					break;
				if (start == -1)
					if (end == -1) {
						start = 0;
						end = 0;
					}
					else {
						i = j;
						continue;
					}
				else if (end == -1) {
					i = j;
					continue;
				}
				endd = end;
				vector<int> ans = dfs(start);
				if (ans.size() < n) {
					i = j;
					continue;
				}
				reverse(ans.begin(), ans.end());
				cout << "Yes\n";
				for (int ind : ans) {
					cout << ind + 1 << ' ';
				}
				int zero = 0;
				return;
			}
			else
				i = j;
		}
		cout << "No";
		return;
	}
}

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);
	int t = 1;
	//cin >> t;
	while (t--)
		solve();
}
/*
7
1 3
2
1 8
6
1 8
5
1 8
4
1 8
3
1 8
2
2 12
1 8
*/
/*
13
1 8 0
1 6 1
1 8 4
1 13 5
1 8 1
1 6 2
1 8 5
1 13 6
1 8 2
1 6 3
1 8 6
1 13 7
2 13 3 12
*/