#include<iostream>
#include<vector>
#include<algorithm>
#include<cassert>
#include<unordered_map>

using namespace std;

void gen(int curr, vector<int>& ans, vector<bool>& used, unordered_map<int, vector<int>>& cntIn, unordered_map<int, vector<int>>& cntOut, int dist, const vector<int>& s, const vector<vector<int>>& x) {
	if (ans[curr + 1] != -1) {
		return;
	}
	int currOut = s[ans[curr]] - x[ans[curr]].back();
	auto& item = cntIn[dist - currOut];
	while (item.back() + 1 < item.size() && used[item[item.back()]]) {
		++item.back();
	}
	if (item.size() == item.back() + 1) {
		assert(false);
	}
	else {
		ans[curr + 1] = item[item.back()];
		used[item[item.back()]] = true;
		gen(curr + 1, ans, used, cntIn, cntOut, dist, s, x);
	}
}

int main()
{
	ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	int n;
	cin >> n;
	vector<int> s(n);
	vector<vector<int>> x(n);
	for (int i = 0; i < n; ++i) {
		int m;
		cin >> m >> s[i];
		x[i].resize(m);
		for (int j = 0; j < m; ++j) {
			cin >> x[i][j];
		}
	}

	int dist = -1;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j + 1 < x[i].size(); ++j) {
			if (dist == -1 || (x[i][j + 1] - x[i][j] == dist)) {
				dist = x[i][j + 1] - x[i][j];
			}
			else {
				cout << "No" << endl;
				return 0;
			}
		}
	}

	if (n <= 8) {
		vector<int> brute(n);
		for (int i = 0; i < n; ++i) {
			brute[i] = i;
		}

		do {
			int currDist = dist;
			bool flag = true;
			for (int i = 1; i < n; ++i) {
				if (dist == -1 && currDist == -1) {
					currDist = s[brute[i - 1]] + x[brute[i]][0] - x[brute[i - 1]].back();
				}
				else if (currDist != s[brute[i - 1]] + x[brute[i]][0] - x[brute[i - 1]].back()) {
					flag = false;
					break;
				}
			}

			if (flag) {
				cout << "Yes" << endl;
				for (int i = 0; i < n; ++i) {
					cout << brute[i] + 1 << " ";
				}
				return 0;
			}

		} while (next_permutation(brute.begin(), brute.end()));
		cout << "No" << endl;
	}
	else {
		assert(dist != -1);
		unordered_map<int, vector<int>> cntIn;
		unordered_map<int, vector<int>> cntOut;
		for (int i = 0; i < n; ++i) {
			cntIn[x[i][0]].push_back(i);
			cntIn[s[i] - x[i].back()].push_back(i);
		}

		int cntBadIn = 0;
		int firstIn = -1;
		int cntBadOut = 0;
		int firstOut = -1;
		for (auto& item : cntIn) {
			if (item.first > dist) {
				cntBadIn += item.second.size();
				firstIn = item.first;
			}
			else if (cntOut[dist - item.first].size() != item.second.size()) {
				cout << "No" << endl;
				return 0;
			}
		}
		if (cntBadIn > 1) {
			cout << "No" << endl;
			return 0;
		}

		for (auto& item : cntOut) {
			if (item.first > dist) {
				cntBadOut += item.second.size();
				firstOut = item.first;
			}
			else if (cntIn[dist - item.first].size() != item.second.size()) {
				cout << "No" << endl;
				return 0;
			}
		}
		if (cntBadOut > 1) {
			cout << "No" << endl;
			return 0;
		}

		for (auto& item : cntIn) {
			item.second.push_back(0);
		}

		for (auto& item : cntOut) {
			item.second.push_back(0);
		}

		vector<int> ans(n, -1);
		vector<bool> used(n, false);
		if (firstOut == -1) {
			ans[0] = cntOut.begin()->second[0];
			++cntOut.begin()->second.back();
			used[0] = true;
		}
		else {
			ans[0] = cntOut[firstOut][0];
			++cntOut[firstOut].back();
			used[ans[0]] = true;
		}
		if (firstIn != -1) {
			ans[n - 1] = cntIn[firstIn][0];
			++cntIn[firstIn].back();
			used[ans[n - 1]] = true;
		}
		gen(0, ans, used, cntIn, cntOut, dist, s, x);
	}
	return 0;
}

