#include "bits/stdc++.h"

#define nl '\n'
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define gsize(x) ((int)(x).size())
#define FAST ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef long long ll;
typedef long double ld;

using namespace std;

const int inf = 1e9;
const ll inf2 = 1e19;

const int maxn = 200005;

// H
ll f1(ll n, ll m, ll x) {
	ll s2 = (1LL + x*m) * x * m / 2LL;
	ll os = n * m * (n * m + 1LL) / 2LL;
	return max(os - s2, s2);
}

// V
ll f2(ll n, ll m, ll x) {
	ll s1 = x * (x + 1LL) / 2LL;
	ll s2 = (s1 + s1 + (n - 1LL) * m * x) * n / 2LL;
	ll os = n * m * (n * m + 1LL) / 2LL;
	return max(s2, os - s2);
}

ll tans = inf2, ans = 0;
ll rs = 0;

// Horizontal cut
void solve1(ll n, ll m) {
	ll lb = 1, ub = n - 1;
	
	while (lb <= ub) {
		ll m1 = lb + (ub - lb) / 3LL, m2 = ub - (ub - lb) / 3LL;
		ll r1 = f1(n, m, m1);
		ll r2 = f1(n, m, m2);
		if (r1 <= r2) {
			if (r1 < tans) {
				tans = r1;
				ans = m1 + 1;
				rs = 0;
			}
			ub = m2 - 1;
		} else {
			if (r2 < tans) {
				tans = r2;
				ans = m2 + 1;
				rs = 0;
			}
			lb = m1 + 1;
		}
	}

	for (int r1 = max(1LL, lb - 5000); r1 < min(n - 1LL, lb + 5000); r1++) {
		ll tr1 = f1(n, m, r1);
		if (tr1 < tans) {
			tans = tr1;
			ans = r1 + 1;
			rs = 0;
		}
	}
}


// Vertical Cut
void solve2(ll n, ll m) {
	ll lb = 1, ub = m - 1;

	while (lb <= ub) {
		ll m1 = lb + (ub - lb) / 3LL, m2 = ub - (ub - lb) / 3LL;
		ll r1 = f2(n, m, m1);
		ll r2 = f2(n, m, m2);
		if (r1 <= r2) {
			if (r1 < tans) {
				tans = r1;
				ans = m1 + 1;
				rs = 1;
			}
			ub = m2 - 1;
		} else {
			if (r2 < tans) {
				tans = r2;
				ans = m2 + 1;
				rs = 1;
			}
			lb = m1 + 1;
		}
	}

	for (int r1 = max(1LL, lb - 5000); r1 < min(m - 1LL, lb + 5000); r1++) {
		ll tr1 = f2(n, m, r1);
		if (tr1 < tans) {
			tans = tr1;
			ans = r1 + 1;
			rs = 1;
		}
	}
}

void solve() {
	ans = -1;
	tans = inf2;
	rs = -1;

	ll n, m;
	cin >> n >> m;

	if (m > 1) solve2(n, m);
	if (n > 1) solve1(n, m);


	if (rs == 0) cout << "H ";
	else cout << "V ";
	cout << ans << nl;
}

int main() {
	FAST;

	int t;
	cin >> t;
	while (t--) solve();
}