#include <iostream>
#define int long long

using namespace std;

int get_h(int pos, int n, int m) {
    int s = n * m * (n * m + 1) / 2;
    return abs(pos * (pos + 1) * n + n * (n - 1) * pos * m - s);
}

int h_search(int n, int m) {
    int l = 0;
    int r = m;
    while (r - l > 2) {
        int m1 = l + (r - l) / 3;
        int m2 = r - (r - l) / 3;

        int a1 = get_h(m1, n, m);
        int a2 = get_h(m2, n, m);

        if (a1 < a2)
            r = m2;
        else
            l = m1;
    }
    int med = (r + l) / 2;
    int a1 = get_h(l, n, m) , a2 = get_h(med, n, m), a3 = get_h(r, n, m);
    if (a1 == min(min(a1, a2), a3))
        return l;
    if (a2 == min(a2, a3))
        return med;
    return r;
}

int get_v(int pos, int n, int m) {
    int s = n * m * (n * m + 1) / 2;
    return abs(pos * m * (pos * m + 1) - s);
}

int v_search(int n, int m) {
    int l = 0;
    int r = n;
    while (r - l > 2) {
        int m1 = l + (r - l) / 3;
        int m2 = r - (r - l) / 3;

        int a1 = get_h(m1, n, m);
        int a2 = get_h(m2, n, m);

        if (a1 < a2)
            r = m2;
        else
            l = m1;
    }
    int med = (r + l) / 2;
    int a1 = get_v(l, n, m), a2 = get_v(med, n, m), a3 = get_v(r, n, m);
    if (a1 == min(min(a1, a2), a3))
        return l;
    if (a2 == min(a2, a3))
        return med;
    return r;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();

    int t, n, m;
    cin >> t;
    while (t--) {
        cin >> n >> m;

        int pos_h = h_search(n, m);
        int f1 = get_h(pos_h, n, m);

        int pos_v = v_search(n, m);
        int f2 = get_v(pos_v, n, m);

        //cout << pos_v << " " << pos_h << endl;
        if (f1 <= f2)
            cout << "V " << pos_h + 1 << endl;
        else
            cout << "H " << pos_v + 1 << endl;
    }

    return 0;
}
