#include <iostream>
#define int long long

using namespace std;

int get_h(int pos, int n, int m) {
    int s = n * m * (n * m + 1) / 2;
    return pos * (pos + 1) * n + n * (n - 1) * pos * m - s;
}

int h_search(int n, int m) {
    int l = 0;
    int r = m;
    while (r - l > 1) {
        int med = (l + r) / 2;
        int a = get_h(med, n, m);
        if (a < 0)
            l = med;
        else
            r = med;
    }
    int a1 = abs(get_h(l, n, m)), a2 = abs(get_h(r, n, m));
    if (a1 < a2)
        return l;
    return r;
}

int get_v(int pos, int n, int m) {
    int s = n * m * (n * m + 1) / 2;
    return pos * m * (pos * m + 1) - s;
}

int v_search(int n, int m) {
    int l = 0;
    int r = n;
    while (r - l > 1) {
        int med = (l + r) / 2;
        int a = get_v(med, n, m);
        if (a < 0)
            l = med;
        else
            r = med;
    }
    int a1 = abs(get_v(l, n, m)), a2 = abs(get_v(r, n, m));
    if (a1 < a2)
        return l;
    return r;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();

    int t, n, m;
    cin >> t;
    while (t--) {
        cin >> n >> m;
        if (n == 1 && m == 1) {
            cout << "V 1" << endl;
            continue;
        }

        int pos_h = h_search(n, m);
        int f1 = get_h(pos_h, n, m);

        int pos_v = v_search(n, m);
        int f2 = get_v(pos_v, n, m);

        //cout << pos_v << " " << pos_h << endl;
        if (abs(f1) <= abs(f2))
            cout << "V " << pos_h + 1 << endl;
        else
            cout << "H " << pos_v + 1 << endl;
    }

    return 0;
}
