#include <iostream>
#include <vector>
#include <set>
#include <cmath>

using namespace std;

int n;
vector <pair <int, char>> p;
set <int> st;
vector <int> pow_;

int len(int num) {
    if (num == 1)
        return 0;
    int c = 0;
    while (num > 0) {
        c++;
        num /= 10;
    }
    return c;
}

int try_min1(int i) {
    return len(p[i - 1].first) + len(p[i + 1].first) + 2 - len(p[i - 1].first + p[i + 1].first);
}

pair <int, int> get_min() {
    int mx = 0;
    int pos = 0;
    for (int i = 1; i < n - 1; i++) {
        if (p[i - 1].second == p[i + 1].second && p[i].first == 1) {
            int dx = try_min1(i);
            if (dx > mx) {
                mx = dx;
                pos = i;
            }
        }
        else if (mx == 0 && st.find(p[i].first) != st.end()) {
            mx = 1;
            pos = i;
        }
    }
    if (st.find(p[0].first) != st.end() && mx == 0) {
        mx = 1;
        pos = 0;
    }
    if (st.find(p[n - 1].first) != st.end() && mx == 0) {
        mx = 1;
        pos = n - 1;
    }
    return make_pair(0, pos);
}

pair <int, int> try_max1(int i) {
    int k = len(p[i].first);
    int a1 = pow_[k];
    int a2 = p[i].first - a1;
    int b1 = pow_[k - 1];
    int b2 = p[i].first - b1;
    if (len(a2) + len(a1) < len(b2) + len(b1)) {
        a1 = b1;
        a2 = b2;
    }
    b1 = pow_[k] + 1;
    b2 = p[i].first - b1;
    if (len(a2) + len(a1) < len(b2) + len(b1)) {
        a1 = b1;
        a2 = b2;
    }
    return make_pair(a1, len(a1) + len(a2) - len(p[i].first) + 2);
}

pair <int, int> get_max() {
    int mx = 0;
    int pos = 0;
    int idx = 0;
    for (int i = 0; i < n; i++) {
        if (p[i].first > 1) {
            auto [j, dx] = try_max1(i);
            if (dx > mx) {
                mx = dx;
                pos = i;
                idx = j;
            }
        }
    }
    return make_pair(idx, pos);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();

    pow_ = {0, 1, 10, 100, 1000, 10000, 100000, 1000000, 10000000, 100000000, 1000000000};
    for (int i = 1; i < 1 << 30; i *= 10)
        st.insert(i);
    string s;
    cin >> s;
    int num = 0;
    for (int i = 0; i < s.size(); i++) {
        if ('0' <= s[i] && s[i] <= '9') {
            num *= 10;
            num += s[i] - '0';
        }
        else {
            if (num == 0)
                num = 1;
            p.push_back(make_pair(num, s[i]));
            num = 0;
        }
    }
    n = p.size();
    vector <int> pref(n + 1);
    for (int i = 0; i < n; i++)
        pref[i + 1] = pref[i] + p[i].first;

    auto [i, j] = get_min();
    cout << "2 " << pref[j] + 1 << endl;
    auto [i1, j1] = get_max();
    cout << "1 " << pref[j1] + i1 << " ";
    char sym = 'A';
    if (p[j1].second == 'A') {
        sym = 'C';
    }
    cout << sym << endl;

    return 0;
}
