#pragma GCC optimize("Ofast,fast-math,unroll-loops")
//#pragma GCC target("avx,avx2,sse,sse2,ssse3,sse3,sse4,abm,popcnt")
#include <bits/stdc++.h>
#define int ll
#define pb emplace_back
#define all(C) (C).begin(), (C).end()
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;

using ll = long long;

template <class T>
ostream& operator<< (ostream &out, const vector <T> &a)
{
    for (auto &i : a)
        out << i << " ";
    return out;
}
template <class T, class U>
ostream& operator<< (ostream &out, const pair <T, U> &a)
{
    out << a.first << " " << a.second;
    return out;
}

struct euler_path_finder
{
    int n;
    vector <vector <pair <int, int>>> g;
    vector <int> ptr;
    vector <int> usede;
    vector <pair <int, int>> es;
    vector <int> indeg, outdeg;
    euler_path_finder() {}
    euler_path_finder(int _n)
    {
        n = _n;
        g.resize(n);
        ptr.resize(n);
        indeg.resize(n);
        outdeg.resize(n);
    }
    void add_edge(int u, int v)
    {
        g[u].pb(v, usede.size());
        usede.pb(0);
        es.pb(u, v);
        outdeg[u]++;
        indeg[v]++;
    }
    vector <int> epth;
    void dfs(int v)
    {
        for (; ptr[v] < g[v].size();)
        {
            usede[g[v][ptr[v]].second] = true;
            ptr[v] += 1;
            dfs(g[v][ptr[v] - 1].first);
        }
        epth.pb(v);
    }
    pair <int, vector <int>> try_find(int low)
    {
        int st = low;
        for (int i = low; i < n; ++i)
            if (outdeg[i] - indeg[i] > outdeg[st] - indeg[st])
                st = i;

        dfs(st);
        if (count(all(usede), 0))
            return {false, vector <int> (0)};
        reverse(all(epth));
        return {true, epth};
    }
};

pair <int, vector <int>> find_perm(int n, vector<int> m, vector <int> s, vector <vector <int>> p, int r)
{
    vector <int> beg(n), ens(n);
    for (int i = 0; i < n; ++i)
        beg[i] = p[i][0], ens[i] = s[i] - p[i].back();
    vector <int> dists;
    for (auto &e : ens)
        dists.pb(e);
    for (auto &b : beg)
    {
        dists.pb(r-b);
    }
    sort(all(dists));
    dists.erase(unique(all(dists)), dists.end());
    int sz = n + dists.size();
    euler_path_finder f(sz);
    for (int i = 0; i < n; ++i)
    {
        int psin = lower_bound(all(dists), r-beg[i]) - dists.begin();
        int psout = lower_bound(all(dists), ens[i]) - dists.begin();
        f.add_edge(n + psin, i);
        f.add_edge(i, n + psout);
    }
    auto tmp = f.try_find(n);
    vector <int> real_perm;
    for (auto &x : tmp.second)
        if (x < n)
            real_perm.pb(x);
    if (real_perm.size() != n)
        return {false, vector <int> (0)};
    for (int i = 1; i < n; ++i)
        if (beg[real_perm[i]] + ens[real_perm[i - 1]] != r)
            return {false, vector <int> (0)};
    return {tmp.first, real_perm};
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    vector <int> m(n), s(n);
    vector <vector <int>> p(n);
    bool more_than_one = false;
    for (int i = 0; i < n; ++i)
    {
        cin >> m[i] >> s[i];
        if (m[i] > 1)
        {
            more_than_one = true;
        }
        p[i].resize(m[i]);
        for (auto &x : p[i])
            cin >> x;
    }
    if (more_than_one)
    {
        int r = -1;
        for (int i = 0; i < n; ++i)
        {
            if (m[i] > 1)
            {
                if (r == -1)
                    r = p[i][1] - p[i][0];
                for (int j = 1; j < m[i]; ++j)
                {
                    if (p[i][j] - p[i][j - 1] != r)
                    {
                        cout << "No";
                        return 0;
                    }
                }
            }
        }
        //dbg(r);
        auto tmp = find_perm(n, m, s, p, r);
        if (!tmp.first)
        {
            cout << "No";
        }
        else
        {
            cout << "Yes\n";
            for (int i = 1; i < n; ++i)
            {
                if (p[tmp.second[i]][0] + (s[tmp.second[i - 1]] - p[tmp.second[i - 1]].back()) != r)
                    assert(1);
            }
            //if (tmp.second.size() != n)
            //    while(true);
            for (auto &i : tmp.second)
                cout << i + 1 << " ";
        }

    }
    else
    {
        assert(1);
        cout << "MNE LEN PISAT ESCHE 2347238 IFOVVVVV";
    }
    return 0;
}
