#include <bits/stdc++.h>

using namespace std;

const int MAXN = 2e5;

vector<pair<int, int>> g[MAXN];
int in[MAXN], out[MAXN], cur[MAXN];
vector<int> answer;

void dfs(int v) {
    while (cur[v] < g[v].size()) {
        int u = g[v][cur[v]].first, id = g[v][cur[v]].second;
        cur[v]++;
        dfs(u);
        answer.emplace_back(id);
    }
}

int n;
vector<int> p[MAXN];
int s[MAXN], first[MAXN], last[MAXN];

void try_solve(int ans) {
    answer.clear();
    for (int i = 0; i < 2 * n; i++) {
        cur[i] = in[i] = out[i] = 0;
        g[i].clear();
    }
    vector<int> vals;
    for (int i = 0; i < n; i++) {
        vals.emplace_back(first[i]);
        vals.emplace_back(ans - last[i]);
        if (ans - last[i] < 0) {
            return 0;
        }
    }
    sort(vals.begin(), vals.end());
    vals.resize(unique(vals.begin(), vals.end()) - vals.begin());

    for (int i = 0; i < n; i++) {
        int v = lower_bound(vals.begin(), vals.end(), first[i]) - vals.begin();
        int u = lower_bound(vals.begin(), vals.end(), ans - last[i]) - vals.begin();
        g[v].emplace_back(u, i + 1);
        out[v]++;
        in[u]++;
    }
    int start = -1, last = -1;
    for (int i = 0; i < vals.size(); i++) {
        if (in[i] < out[i]) {
            if (in[i] + 1 != out[i]) {
                return;
            }
            if (start != -1) {
                return;
            }
            start = i;
        }
        if (in[i] > out[i]) {
            if (in[i] - 1 != out[i]) {
                return;
            }
            if (last != -1) {
                return;
            }
            last = i;
        }
    }
    if (start == -1) {
        start = 0;
    }
    dfs(start);
    if (answer.size() < n) {
        return;
    }
    cout << "Yes\n";
    for (int i = n - 1; i >= 0; i--) {
        cout << answer[i] << ' ';
    }
    cout << '\n';
    exit(0);
}

main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    int ans = -1;
    for (int i = 0; i < n; i++) {
        int m;
        cin >> m;
        cin >> s[i];
        p[i].resize(m);
        for (int j = 0; j < m; j++) {
            cin >> p[i][j];
            if (j > 0) {
                if (ans == -1) {
                    ans = p[i][j] - p[i][j - 1];
                } else if (ans != p[i][j] - p[i][j - 1]) {
                    cout << "No\n";
                    return 0;
                }
            }
        }
        first[i] = p[i][0];
        last[i] = s[i] - p[i][m - 1];
    }
    if (ans != -1) {
        try_solve(ans);
    } else {
        for (int i = 0; i < 200; i++) {
            try_solve(i);
        }
    }
    cout << "No\n";
    return 0;
}
