#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

const int MAXN = 2e5;

vector<pair<int, int>> g[MAXN];
int in[MAXN], out[MAXN], cur[MAXN];
vector<int> answer;

void dfs(int v) {
    while (cur[v] < g[v].size()) {
        int u = g[v][cur[v]].first, id = g[v][cur[v]].second;
        cur[v]++;
        dfs(u);
        answer.emplace_back(id);
    }
}

int n;
vector<int> p[MAXN];
int s[MAXN], first[MAXN], last[MAXN];

gp_hash_table<int, int> id;

void try_solve(int ans) {
    answer.clear();
    id.clear();
    for (int i = 0; i < 2 * n; i++) {
        cur[i] = in[i] = out[i] = 0;
        g[i].clear();
    }
    int sz = 1;
    for (int i = 0; i < n; i++) {
        if (!id[first[i]]) {
            id[first[i]] = sz++;
        }
        if (!id[ans - last[i]]) {
            id[ans - last[i]] = sz++;
        }
    }

    for (int i = 0; i < n; i++) {
        int v = id[first[i]] - 1;
        int u = id[ans - last[i]] - 1;
        g[v].emplace_back(u, i + 1);
        out[v]++;
        in[u]++;
    }
    int start = -1, last = -1;
    for (int i = 0; i < id.size(); i++) {
        if (in[i] < out[i]) {
            if (in[i] + 1 != out[i]) {
                return;
            }
            if (start != -1) {
                return;
            }
            start = i;
        }
        if (in[i] > out[i]) {
            if (in[i] - 1 != out[i]) {
                return;
            }
            if (last != -1) {
                return;
            }
            last = i;
        }
    }
    if (start == -1) {
        start = 0;
    }
    dfs(start);
    if (answer.size() < n) {
        return;
    }
    cout << "Yes\n";
    for (int i = n - 1; i >= 0; i--) {
        cout << answer[i] << ' ';
    }
    cout << '\n';
    exit(0);
}

main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    int ans = -1;
    for (int i = 0; i < n; i++) {
        int m;
        cin >> m;
        cin >> s[i];
        p[i].resize(m);
        for (int j = 0; j < m; j++) {
            cin >> p[i][j];
            if (j > 0) {
                if (ans == -1) {
                    ans = p[i][j] - p[i][j - 1];
                } else if (ans != p[i][j] - p[i][j - 1]) {
                    cout << "No\n";
                    return 0;
                }
            }
        }
        first[i] = p[i][0];
        last[i] = s[i] - p[i][m - 1];
    }
    if (ans != -1) {
        try_solve(ans);
    } else {
        for (int i = 0; i < 200; i++) {
            try_solve(i);
        }
    }
    cout << "No\n";
    return 0;
}
