#include <iostream>
#include <iomanip>
#include <utility>
#include <cstddef>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <cassert>
#include <ctime>
#include <string>
#include <cstring>
#include <queue>
#include <deque>

using namespace std;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

#define int long long
#define ll long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

int FIXED = -1;

struct seg {
    int s;
    int m;
    vector<int> p;
    seg() {}
    void read() {
        cin >> m;
        cin >> s;
        p.resize(m);
        for (int i = 0; i < m; ++i) {
            cin >> p[i];
        }
    }
    int a = -1, b = -1;
    void go() {
        a = p[0], b = s - p.back();
        for (int i = 0; i < (int) p.size() - 1; ++i) {
            if (FIXED == -1) {
                FIXED = p[i + 1] - p[i];
            } else {
                if (FIXED != p[i + 1] - p[i]) {
                    cout << "No\n";
                    exit(0);
                }
            }
        }
    }
};

struct edge {
    int a, b, num;
    edge() {}
    edge(int _a, int _b, int _num) {
        a = _a, b = _b, num = _num;
    }
};

struct graph {
    int n;
    map<int, vector<edge> > g;
    map<int, vector<edge> > g2;
    map<int, int> usd;
    vector<int> eiler_path;
    graph() {}
    graph(int _n) {
        n = _n;
    }
    vector<int> starts;
    void dedge(int a, int b, int c) {
        g[a].push_back(edge(a, b, c));
        g2[b].push_back(edge(b, a, c));
    }

    void dfs(int v) {
        for (; usd[v] < (int) g[v].size();) {
            edge &e = g[v][usd[v]];
            ++usd[e.a];
            dfs(e.b);
            eiler_path.push_back(e.num);
        }
    }

    bool eiler(int n) {
        vector<int> ns;
        for (auto &i : g) {
            if ((int) i.second.size() > (int) g2[i.first].size()) {
                ns.push_back(i.first);
            }
        }
        if (ns.size() > 1) return false;
        if (ns.size() == 0) {
            for (auto &i : g) {
                if (i.second.size() > 0) {
                    ns.push_back(i.first);
                    break;
                }
            }
        }
        dfs(ns[0]);
        if (eiler_path.size() == n) return true;
        return false;
    }


    bool eiler(int v, int n) {
        dfs(v);
        if (eiler_path.size() == n) return true;
        return false;
    }
};

void solve() {
    int n;
    cin >> n;
    vector<seg> v(n);
    for (int i = 0; i < n; ++i) {
        v[i].read();
    }
    for (int i = 0; i < n; ++i) {
        v[i].go();
    }
    if (v.size() == 1) {
        cout << "Yes\n1\n";
        return;
    }
    if (v.size() == 2) {
        cout << "Yes\n1\n2\n";
        return;
    }

    if (n <= 8) {
        vector<int> p(n);
        for (int i = 0; i < n; ++i) {
            p[i] = i;
        }
        do {
            int nfixed = FIXED;
            bool ok = true;
            for (int i = 0; i < n - 1; ++i) {
                if (nfixed == -1) {
                    nfixed = v[p[i]].b + v[p[i + 1]].a;
                } else {
                    if (nfixed != v[p[i]].b + v[p[i + 1]].a) {
                        ok = false;
                        break;
                    }
                }
            }
            if (ok) {
                cout << "Yes\n";
                for (auto i : p) {
                    cout << i + 1 << ' ';
                }
                return;
            }
        } while(next_permutation(all(p)));
        cout << "No\n";
        return;
    }

    if (FIXED != -1) {
        graph g(FIXED + n);
        vector<int> starts, ends;
        for (int i = 0; i < n; ++i) {
            if (FIXED - v[i].b < 0 && FIXED - v[i].a < 0) {
                cout << "No\n";
                return;
            }
            if (FIXED - v[i].b >= 0 && FIXED - v[i].a >= 0) {
                g.dedge(v[i].a, FIXED - v[i].b, i);
            } else {
                if (v[i].a > FIXED) {
                    g.dedge(FIXED + i + 1, FIXED - v[i].b, i);
                } else {
                    g.dedge(FIXED - v[i].a, FIXED + i + 1, i);
                }
            }
        }
        if (g.eiler(n)) {
            cout << "Yes\n";
            reverse(all(g.eiler_path));
            for (auto i : g.eiler_path) {
                cout << i + 1 << ' ';
            }
        } else {
            cout << "No\n";
        }
    }
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}