#include <iostream>
#include <iomanip>
#include <utility>
#include <cstddef>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <cassert>
#include <ctime>
#include <string>
#include <cstring>
#include <queue>
#include <deque>

using namespace std;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

/*const int MM = 2e8;
char mem[MM];
int mpos = 0;

inline void * operator new (size_t n) {
    char *res = mem + mpos;
    mpos += n;
    assert(mpos < MM);
    return (void*) res;
}

inline void operator delete (void *) {}*/

#define int long long
#define ll long losng
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

const int mod = 1e9 + 7;
const int maxN = 2e5 + 123;

int pwr(int a, int b) {
    if (a == 0) return 1LL;
    if (b == 0) {
        return 1LL;
    }
    if (b == 1) {
        return a;
    }
    int aa = pwr(a, b / 2);
    aa = (aa * aa) % mod;
    if (b & 1) {
        aa = (aa * a) % mod;
    }
    return aa;
}

int inv(int x) {
    return pwr(x, mod - 2);
}

void mul(int &a, int b) {
    a = (a * b) % mod;
}

int fac[maxN];
int ifac[maxN];

void count_everything() {
    fac[0] = 1;
    ifac[0] = 1;
    for (int i = 1; i < maxN; ++i) {
        fac[i] = (i * fac[i - 1]) % mod;
        ifac[i] = inv(fac[i]);
    }
}

int A(int n, int k) {
    return ((fac[n] * ifac[n - k]) % mod);
}

int C(int n, int k) {
    return (((fac[n] * ifac[n - k]) % mod) * ifac[k]) % mod;
}


int hm[4];


struct col {
    int a, b, c;
    int typ = -1;
    bool bad = false;
    col() {}
    col(int _a, int _b, int _c) : a(_a), b(_b), c(_c) {
        if (a == 0 || b == 0 || c == 0) bad = true;
        if (a + b == c) {
            typ = 0;
        } else {
            if ((a + b) % 10 == c) {
                typ = 1;
            } else {
                if (a + b + 1 == c) {
                    typ = 2;
                } else {
                    if ((a + b + 1) % 10 == c) {
                        typ = 3;
                    }
                }
            }
        }
        if (typ == -1) {
            cout << "0\n";
            exit(0);
        }
        hm[typ]++;
    }
};

int ans = 0;

void add(int &a, int b) {
    a += b;
    if (a >= mod) a -= mod;
}

void solve() {
    count_everything();
    string a, b, c;
    cin >> a >> b >> c;
    int n = (int) a.size();
    vector<col> cols(n);
    for (int i = 0; i < n; ++i) {
        cols[i] = col(a[i] - '0', b[i] - '0', c[i] - '0');
    }
    bool all_zeros = true;
    for (int i = 0; i < n; ++i) {
        if (!cols[i].bad) {
            all_zeros = false;
            break;
        }
    }
    if (all_zeros) {
        cout << "0\n";
        return;
    }
#ifndef lolipop
    if (n <= 18) {
        vector<vector<int> > dp((1 << n), vector<int>(n, 0));
        for (int i = 0; i < n; ++i) {
            if (cols[i].typ == 0 || cols[i].typ == 1) {
                dp[1 << i][i] = 1;
            }
        }
        for (int mask = 0; mask < (1 << n); ++mask) {
            for (int i = 0; i < n; ++i) {
                if (!((mask >> i) & 1)) continue;
                if (dp[mask][i] == 0) continue;
                int ti = cols[i].typ;
                for (int j = 0; j < n; ++j) {
                    if (((mask >> j) & 1)) continue;
                    int tj = cols[j].typ;
                    if ((ti == 2 && tj == 1) || (ti == 2 && tj == 0) || (ti == 0 && tj == 0) || (ti == 1 && tj == 2) ||
                        (ti == 1 && tj == 3) || (ti == 3 && tj == 3) ||
                        (ti == 3 && tj == 2) || (ti == 0 && tj == 1)) {
                        add(dp[mask | (1 << j)][j], dp[mask][i]);
                    }
                }
            }
        }
        for (int i = 0; i < n; ++i) {
            if ((cols[i].typ == 0 || cols[i].typ == 2) && !cols[i].bad) {
                add(ans, dp[(1 << n) - 1][i]);
            }
        }
        cout << ans << '\n';
        return;
    }
#endif


    if (hm[1] != hm[2]) {
        cout << "0\n";
        return;
    } else {
        if (hm[1] == 0) {
            if (hm[0] == n) {
                ans = fac[n];
            } else {
                cout << "0\n";
                return;
            }
        } else {
            ans = fac[hm[1]];
            mul(ans, fac[hm[1]]);
            mul(ans, fac[hm[3]]);
            mul(ans, C(hm[3] + hm[1] - 1, hm[1] - 1));
            mul(ans, fac[hm[0]]);
            mul(ans, C(hm[1] + hm[0], hm[1]));
        }
    }

    vector<int> bads;
    for (int i = 0; i < n; ++i) {
        if (cols[i].bad) {
            bads.push_back(i);
        }
    }

    for (auto i : bads) {
        if (cols[i].typ == 0) {
            n--;
            hm[0]--;
        }
        if (cols[i].typ == 1 || cols[i].typ == 2) {
            n -= 2;
            hm[1]--;
            hm[2]--;
        }
        if (cols[i].typ == 3) {
            n--;
            hm[3]--;
        }
        int localans = 0;
        if (hm[1] == 0) {
            if (hm[0] == n) {
                localans = fac[n];
            } else {
                localans = 0;
            }
        } else {
            localans = fac[hm[1]];
            mul(localans, fac[hm[1]]);
            mul(localans, fac[hm[3]]);
            mul(localans, C(hm[3] + hm[1] - 1, hm[1] - 1));
            mul(localans, fac[hm[0]]);
            mul(localans, C(hm[1] + hm[0], hm[1]));
        }


        ans = (ans + mod - localans) % mod;
        if (cols[i].typ == 0) {
            n++;
            hm[0]++;
        }
        if (cols[i].typ == 1 || cols[i].typ == 2) {
            n += 2;
            hm[1]++;
            hm[2]++;
        }
        if (cols[i].typ == 3) {
            n++;
            hm[3]++;
        }
    }
    cout << ans << '\n';

}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}