#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ll long long
#define lll __int128_t
#define vi vector<ll>
#define pii pair<ll, lll>
#define vvi vector<vi>
#define all(a) a.begin(), a.end()
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)
#define mp make_pair

const ll INF = 1e9;
const ll inf = 1e18;

using namespace std;

lll all_sum = 0;

lll val_v(lll v, lll n, lll m) {
    return ((v + 1) * v / (lll)2) * n + (n - (lll)1) * n * m * v / (lll)2;
}

lll val_g(lll g, lll n, lll m) {
    return ((m * g + (lll)1) * m * g) / (lll)2;
}

bool comp_v(lll L, lll R, lll n, lll m) {
    return abs(all_sum - (lll)2 * val_v(L, n, m)) <= abs(all_sum - (lll)2 * val_v(R, n, m));
}

bool comp_g(lll L, lll R, lll n, lll m) {
    return abs(all_sum - (lll)2 * val_g(L, n, m)) <= abs(all_sum - (lll)2 * val_g(R, n, m));
}

pii vert_solver(ll n, ll m) {
    ll L = 0, R = m;
    while (R - L > 2) {
        ll l_mid = L + (R - L) / 3;
        ll r_mid = R - (R - L) / 3;
        if (comp_v(l_mid, r_mid, n, m)) R = r_mid;
        else L = l_mid;
    }
    lll best = L;
    for (ll i = L; i <= R; ++i) {
        if (!comp_v(best, i, n, m)) best = i;
    }
    return mp(best, abs(all_sum - (lll)2 * val_v(best, n, m)));
}

pii gor_solver(ll n, ll m) {
    ll L = 0, R = n;
    while (R - L > 2) {
        ll l_mid = L + (R - L) / 3;
        ll r_mid = R - (R - L) / 3;
        if (comp_g(l_mid, r_mid, n, m)) R = r_mid;
        else L = l_mid;
    }
    lll best = L;
    for (ll i = L; i <= R; ++i) {
        if (!comp_g(best, i, n, m)) best = i;
    }
    return mp(best, abs(all_sum - (lll)2 * val_g(best, n, m)));
}

void solve() {
    ll nc, mc; cin >> nc >> mc;
    lll n = nc, m = mc;
    all_sum = val_g(n, n, m);
    auto x = vert_solver(n, m);
    auto y = gor_solver(n, m);
    if (x.second < y.second) {
        cout << "V " << x.first + 1 << "\n";
    } else {
        cout << "H " << y.first + 1 << "\n";
    }
}

int main() {
    srand(time(0));

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#endif
    ll t; cin >> t;
    while (t--)
    solve();

    return 0;
}
