#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <math.h>
#include <random>

using namespace std;

#define x first
#define y second
#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

int mod = 1'000'000'000 + 7;
int pow2(int x, int y) {
    if (y == 0) return 1;
    if (y & 1) return x * pow2(x, y - 1) % mod;
    int t = pow2(x, y >> 1);
    return t * t % mod;
}

vector<int> fact(700001);

// x - amount, y - groups
int get(int x, int y) {
    int ret = fact[x];
    int tmp = fact[x + y - 1] * pow2(fact[y - 1], mod - 2) % mod;
    tmp = tmp * pow2(fact[x], mod - 2) % mod;
    return ret * tmp % mod;
}

int solve(string& a, string& b, string& c) {
    int n = a.length();
    fact[0] = 1;
    for (int i{1}; i < fact.size(); ++i) {
        fact[i] = fact[i - 1] * i % mod;
    }
    vector<pair<int, int>> t(4);
    for (int i{}; i < n; ++i) {
        int t1 = a[i] - '0';
        int t2 = b[i] - '0';
        int t3 = c[i] - '0';
        int ind = 0;
        int sm = (t1 + t2);
        if ((t1 + t2) % 10 != t3) {
            ind += 1;
            sm++;
        }
        if (sm >= 10) ind += 2;
        if (t1 == 0 || t2 == 0 || t3 == 0) t[ind].x++;
        else t[ind].y++;
    }
    if (t[1].x + t[1].y != t[2].x + t[2].y) {
        return 0;
    }
    if (t[3].x + t[3].y != 0 && t[1].x + t[1].y == 0) {
        return 0;
    }
    if (t[1].x + t[1].y == 0) {
        return t[0].y * fact[t[0].x + t[0].y - 1] % mod;
    }
    int ans = 0;
    int gr1 = t[1].x * fact[t[1].x + t[1].y - 1] % mod;
    int spl1 = 0;
    if (t[0].y != 0) {
        spl1 = t[0].y * get(t[0].x + t[0].y - 1, t[1].x + t[1].y + 1) % mod;
    }
    gr1 = spl1 * gr1 % mod;

    int gr2 = t[1].y * fact[t[1].x + t[1].y - 1] % mod;
    int spl2 = get(t[0].x + t[0].y, t[1].x + t[1].y + 1);
    if (t[0].x != 0) {
        spl2 -= t[0].x * get(t[0].x + t[0].y - 1, t[1].x + t[1].y + 1) % mod;
        while (spl2 < 0) spl2 += mod;
    }
    gr2 = spl2 * gr2 % mod;

//    int ans = fact[t[1].x + t[1].y];
//    ans = pow2(ans, 2);
//    ans = ans * get(t[0].x + t[0].y, t[1].x + t[1].y + 1) % mod;

    ans = (gr1 + gr2) % mod * get(t[3].x + t[3].y, t[1].x + t[1].y) % mod;
    return ans;
}

int solve2(string& a, string& b, string& c) {
    int n = a.length();
    int mn = 1;
    for (int i{1}; i < n; ++i) mn *= 10;
    vector<int> ind;
    int ans = 0;
    for (int i{}; i < n; ++i) ind.push_back(i);
    do {
        int x{}, y{}, z{};
        for (auto i : ind) {
            x *= 10;
            y *= 10;
            z *= 10;
            x += (a[i] - '0');
            y += (b[i] - '0');
            z += (c[i] - '0');
        }
        if (x + y != z) continue;
        ans++;
    } while (next_permutation(all(ind)));

    return ans;
}

void gen(string& a, string& b, string& c) {
    int mx = 10000000;
    int n = 8;
    int t1 = mx * (rand() % 5 + 1) + rand() * 130 % mx;
    int t2 = mx * (rand() % 8 + 1) + rand() * 130 % mx;
    if (t1 > t2) swap(t1, t2);
    int t3 = t2 - t1;
    a = "";
    b = "";
    c = "";
    for (int i{}; i < n; ++i, t1 /= 10, t2 /= 10, t3 /= 10) {
        a += ('0' + t1 % 10);
        b += ('0' + t3 % 10);
        c += ('0' + t2 % 10);
    }
}

int32_t main() {
    cin.tie(NULL);
    cout.tie(NULL);
    ios::sync_with_stdio(false);
    string a, b, c;
    cin >> a >> b >> c;
//    for (int i{}; i < 1000; ++i) {
//        gen(a, b, c);
//        if (solve(a, b, c) != solve2(a, b, c)) {
//            cout << a << '\n' << b << '\n' << c << '\n';
//            return 0;
//        } else {
//            cout << i << '\n';
//        }
//    }
    cout << solve(a, b, c);
    return 0;
}