#include <iostream>
#include <map>
#include <array>

#define int long long

const int MOD = 1e9 + 7;

using namespace std;

map <array <int, 5>, int> mem;

int dp(int no, int don, int acc, int donacc, int isdon) {
    if (no < 0 || don < 0 || acc < 0 || donacc < 0)
        return 0;

    if (mem.count({no, don, acc, donacc, isdon}))
        return mem[{no, don, acc, donacc, isdon}];

    if (no + don + acc + donacc == 0) {
        if (isdon)
            return 0;
        else
            return 1;
    }

    int ans = 0;

    if (isdon) {
        if (acc) {
            ans += dp(no, don, acc - 1, donacc, false) * acc;
        }
        if (donacc) {
            ans += dp(no, don, acc, donacc - 1, true) * donacc;
        }
    } else {
        if (no) {
            ans += dp(no - 1, don, acc, donacc, false) * no;
        }
        if (don) {
            ans += dp(no, don - 1, acc, donacc, true) * don;
        }
    }
    ans %= MOD;

    mem[{no, don, acc, donacc, isdon}] = ans;
    return ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    string a, b, c;
    cin >> a >> b >> c;

    int n = a.size();

    int no = 0, don = 0, acc = 0, donacc = 0;
    int nost = 0, donst = 0, accst = 0, donaccst = 0;

    for (int i = 0; i < n; i++) {
        bool d = false, ac = false;

        int res = a[i] - '0' + b[i] - '0';
        int real = c[i] - '0';
        if (res >= 10) {
            d = true;
            res -= 10;
        }
        if (res + 1 == real)
            ac = true;
        else if (res != real) {
            cout << 0 << endl;
            exit(0);
        }

        bool ok = a[i] != '0' && b[i] != '0' && c[i] != '0';

        if (d) {
            if (ac) {
                donacc++, donaccst += ok;
            } else {
                don++, donst += ok;
            }
        } else if (ac)
            acc++, accst += ok;
        else
            no++, nost += ok;
    }

    int ans = 0;
    ans += dp(no - 1, don, acc, donacc, false) * nost;
    ans += dp(no, don - 1, acc, donacc, true) * donst;
    cout << ans % MOD << endl;
    return 0;
}
