#include <iostream>
#include <map>
#include <array>
#define int long long

const int MOD = 1e9 + 7;

using namespace std;

struct state {
    short no, don, donacc;
    bool isdon, donlast;

    state (short a, short b, short c, bool d, bool e): no(a), don(b), donacc(c), isdon(d), donlast(e) {};
    state()=default;
};

bool operator<(const state& a, const state& b) {
    if (a.no != b.no)
        return a.no < b.no;
    else if (a.don != b.don)
        return a.don < b.don;
    else if (a.donacc != b.donacc)
        return a.donacc < b.donacc;
    else if (a.isdon != b.isdon)
        return a.isdon < b.isdon;
    else
        return a.donlast < b.donlast;
}

map <state, int> mem;

int dp(short no, short don, short acc, short donacc, bool isdon, bool donlast) {
    if (no < 0 || don < 0 || acc < 0 || donacc < 0)
        return 0;

    if (mem.count(state(no, don, donacc, isdon, donlast)))
        return mem[state(no, don, donacc, isdon, donlast)];

    if (no + don + acc + donacc == 0) {
        if (isdon != donlast)
            return 0;
        else
            return 1;
    }

    int ans = 0;

    if (isdon) {
        if (acc) {
            ans += dp(no, don, acc - 1, donacc, false, donlast) * acc;
        }
        if (donacc) {
            ans += dp(no, don, acc, donacc - 1, true, donlast) * donacc;
        }
    } else {
        if (no) {
            ans += dp(no - 1, don, acc, donacc, false, donlast) * no;
        }
        if (don) {
            ans += dp(no, don - 1, acc, donacc, true, donlast) * don;
        }
    }
    ans %= MOD;

    mem[state(no, don, donacc, isdon, donlast)] = ans;
    return ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    string a, b, c;
    cin >> a >> b >> c;

    int n = a.size();

    int no = 0, don = 0, acc = 0, donacc = 0;
    int nost = 0, donst = 0, accst = 0, donaccst = 0;

    for (int i = 0; i < n; i++) {
        bool d = false, ac = false;

        int res = a[i] - '0' + b[i] - '0';
        int real = c[i] - '0';
        if (res >= 10) {
            d = true;
            res -= 10;
        }
        if ((res + 1) % 10 == real) {
            ac = true;
            if (res == 9)
                d = true;
        } else if (res != real) {
            cout << 0 << endl;
            exit(0);
        }

        bool ok = a[i] != '0' && b[i] != '0' && c[i] != '0';

        if (d) {
            if (ac) {
                donacc++, donaccst += ok;
            } else {
                don++, donst += ok;
            }
        } else if (ac)
            acc++, accst += ok;
        else
            no++, nost += ok;
    }

    if (don != acc) {
        cout << 0 << endl;
        return 0;
    }

    int ans = 0;
    ans += dp(no - 1, don, acc, donacc, false, false) * nost;
    ans += dp(no, don, acc - 1, donacc, false, true) * accst;
    cout << ans % MOD << endl;
    return 0;
}
