#include <iostream>

const int MOD = 1e9 + 7;

using namespace std;

int DON, DONACC, NO;

long long to_state(short a, short b, short c, bool d, bool e) {
    return ((long long) a * DON * DONACC * 4) + ((long long) b * DONACC * 2 * 2) + ((long long) c * 2 * 2) +
           ((long long) d * 2) + (long long) e;
}

int mem[62500010];


int dp(short no, short don, short acc, short donacc, bool isdon, bool donlast) {
    if (no < 0 || don < 0 || acc < 0 || donacc < 0)
        return 0;

    int state = to_state(no, don, donacc, isdon, donlast);
    if (mem[state] != -1)
        return mem[state];

    if (no + don + acc + donacc == 0) {
        if (isdon != donlast)
            return 0;
        else
            return 1;
    }

    long long ans = 0;

    if (isdon) {
        if (acc) {
            ans += (long long) dp(no, don, acc - 1, donacc, false, donlast) * acc;
        }
        if (donacc) {
            ans += (long long) dp(no, don, acc, donacc - 1, true, donlast) * donacc;
        }

    } else {
        if (no) {
            ans += (long long) dp(no - 1, don, acc, donacc, false, donlast) * no;
        }
        if (don) {
            ans += (long long) dp(no, don - 1, acc, donacc, true, donlast) * don;
        }
    }
    ans %= MOD;

    mem[state] = ans;
    return ans;
}

const int N = 2e5 + 100;
int fac[N];

int pow(long long a, int n) {
    if (n == 0)
        return 1;
    if (n % 2 == 0)
        return pow(a * a, n / 2) % MOD;
    else
        return (long long) a * pow(a, n - 1) % MOD;
}

int C(int n, int k) {
    if (k == 0 || k == n)
        return 1;

    return fac[n] * pow(fac[k], MOD - 2) * pow(fac[n - k], MOD - 2);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    fac[0] = 1;
    for (int i = 1; i < N; i++) {
        fac[i] = ((long long) fac[i - 1] * i) % MOD;
    }

    string a, b, c;
    cin >> a >> b >> c;

    int n = a.size();

    int no = 0, don = 0, acc = 0, donacc = 0;
    int nost = 0, donst = 0, accst = 0, donaccst = 0;

    for (int i = 0; i < n; i++) {
        bool d = false, ac = false;

        int res = a[i] - '0' + b[i] - '0';
        int real = c[i] - '0';
        if (res >= 10) {
            d = true;
            res -= 10;
        }
        if ((res + 1) % 10 == real) {
            ac = true;
            if (res == 9)
                d = true;
        } else if (res != real) {
            cout << 0 << endl;
            exit(0);
        }

        bool ok = a[i] != '0' && b[i] != '0' && c[i] != '0';

        if (d) {
            if (ac) {
                donacc++, donaccst += ok;
            } else {
                don++, donst += ok;
            }
        } else if (ac)
            acc++, accst += ok;
        else
            no++, nost += ok;
    }

    if (don != acc) {
        cout << 0 << endl;
        return 0;
    }

    if (nost == no && accst == acc) {
        int x1 = (long long) C(don + no, don) * fac[no] % MOD;
        int x2 = (long long) C(don + donacc, donacc) * fac[donacc] % MOD;
        cout << x1 * x2 % MOD;
        return 0;
    }

    DON = don, NO = no, DONACC = donacc;
    DON++, NO++, DONACC++;
    fill(mem, mem + 62500010, -1);

    long long ans = 0;
    ans += (long long) dp(no - 1, don, acc, donacc, false, false) * nost;
    ans += (long long) dp(no, don, acc - 1, donacc, false, true) * accst;
    cout << ans % MOD << endl;
    return 0;
}
