#include <iostream>
#define int long long

const int MOD = 1e9 + 7;

using namespace std;

const int N = 2e5 + 100;
int fac[N];

int pow(long long a, int n) {
    if (n == 0)
        return 1;
    if (n % 2 == 0) {
        int x = pow(a, n / 2);
        return ((long long) x * x) % MOD;
    }
    return (a * pow(a, n - 1)) % MOD;
}

int C(int n, int k) {
    if (k == 0 || k == n)
        return 1;

    long long ans = (long long) fac[n] * pow(fac[k], MOD - 2);
    ans %= MOD;
    ans *= pow(fac[n - k], MOD - 2);
    ans %= MOD;
    return ans;
}

int cnt(int no, int don, int acc, int donacc) {
    int x1 = (long long) C(don + no, don) * fac[no] % MOD;
    int x2;
    if (don) {
        x2 = (long long) C(don + donacc - 1, donacc) * fac[donacc] % MOD;
    } else {
        if (donacc)
            x2 = 0;
        else
            x2 = 1;
    }
    x2 = (x2 * fac[don]) % MOD;
    x2 = (x2 * fac[don]) % MOD;
    return x1 * x2 % MOD;
}

int cnt2(int no, int don, int acc, int donacc) {
    int x1 = (long long) C(don + no - 1, don - 1) * fac[no] % MOD;
    int x2;
    if (don) {
        x2 = (long long) C(don + donacc - 1, donacc) * fac[donacc] % MOD;
    } else {
        if (donacc)
            x2 = 0;
        else
            x2 = 1;
    }
    x2 = (x2 * fac[don]) % MOD;
    x2 = (x2 * fac[don]) % MOD;
    return x1 * x2 % MOD;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    fac[0] = 1;
    for (int i = 1; i < N; i++) {
        fac[i] = ((long long) fac[i - 1] * i) % MOD;
    }

    string a, b, c;
    cin >> a >> b >> c;

    int n = a.size();

    int no = 0, don = 0, acc = 0, donacc = 0;
    int nost = 0, donst = 0, accst = 0, donaccst = 0;

    for (int i = 0; i < n; i++) {
        bool d = false, ac = false;

        int res = a[i] - '0' + b[i] - '0';
        int real = c[i] - '0';
        if (res >= 10) {
            d = true;
            res -= 10;
        }
        if ((res + 1) % 10 == real) {
            ac = true;
            if (res == 9)
                d = true;
        } else if (res != real) {
            cout << 0 << endl;
            exit(0);
        }

        bool ok = a[i] != '0' && b[i] != '0' && c[i] != '0';

        if (d) {
            if (ac) {
                donacc++, donaccst += ok;
            } else {
                don++, donst += ok;
            }
        } else if (ac)
            acc++, accst += ok;
        else
            no++, nost += ok;
    }

    if (don != acc) {
        cout << 0 << endl;
        return 0;
    }

    int ans1 = cnt(no - 1, don, acc, donacc) * nost % MOD;
    int ans2 = cnt(no, don, acc, donacc) * accst % MOD;
    cout << (ans1 + ans2) % MOD << endl;
    return 0;
}
