#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4.1,sse4.2")

#include <iostream>
#include <vector>
#include <cmath>
#include <utility>
#include <algorithm>
#include <string>
#include <sstream>

using namespace std;
using ll = long long;
using ii = pair<int, int>;
using vi = vector<int>;
using vii = vector<ii>;
using vvi = vector<vi>;

const int INF = 1e9;

struct Nuc {
    int k;
    char z;
    int sx;
};

int numlen(int n) {
    if (n == 1) return 0;
    return static_cast<int>(log10(n)) + 1;
}

bool isTen(int n) {
    return pow(10, floor(log10(n))) == n;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    string str;
    cin >> str;
    vector<Nuc> v;
    stringstream ss(str);
    char inp;
    int qu = 0;
    int sx = 1;
    while (ss >> inp) {
        if (inp != 'A' && inp != 'G' && inp != 'C' && inp != 'T') {
            qu = qu * 10 + static_cast<int>(inp - '0');
        } else {
            if (qu == 0) {
                v.push_back({1, inp, sx});
                ++sx;
            } else {
                v.push_back({qu, inp, sx});
                sx += qu;
                qu = 0;
            }
        }
    }
    int n = v.size();

    int imp = 0;
    int x = 1;
    for (int i = 0; i < n; ++i) {
        if (v[i].k == 2 || isTen(v[i].k)) {
            if (imp < 1) {
                imp = 1;
                x = v[i].sx;
            }
        }
    }
    for (int i = 0; i < n-2; ++i) {
        if (v[i].z == v[i+2].z && v[i+1].k == 1) {
            int curr = 2 + numlen(v[i].k) + numlen(v[i+2].k) - numlen(v[i].k + v[i+2].k);
            if (imp < curr) {
                imp = curr;
                x = v[i+1].sx;
            }
        }
    }
    cout << "2 " << x << '\n';

    imp = 1;
    x = 0;
    char z = 'A';
    if (v[0].z == 'A') z = 'G';
    for (int i = 0; i < n; ++i) {
        if (v[i].k > 2) {
            int curr1 = 2 + numlen(v[i].k / 2) + numlen(v[i].k - v[i].k / 2) - numlen(v[i].k);
            int curr2 = 2 + numlen(v[i].k - pow(10, numlen(v[i].k) - 1));
            if (curr1 >= curr2) {
                if (imp < curr1) {
                    imp = curr1;
                    x = v[i].sx + v[i].k/2 - 1;
                    z = 'A';
                    if (v[i].z == 'A') z = 'G';
                }
            } else {
                if (imp < curr2) {
                    imp = curr2;
                    x = v[i].sx + pow(10, numlen(v[i].k) - 1) - 1;
                    z = 'A';
                    if (v[i].z == 'A') z = 'G';
                }
            }
        }
    }
    cout << "1 " << x << ' ' << z << '\n';
}
