//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4.1,sse4.2")

#include <iostream>
#include <vector>
#include <cmath>
#include <utility>
#include <algorithm>
#include <string>
#include <sstream>
#include <numeric>
#include <stack>

using namespace std;
using ll = long long;
using ii = pair<int, int>;
using vi = vector<int>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vc = vector<char>;

const int INF = 1e9;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vi m(n);
    vi s(n);
    vvi p(n);
    for (int i = 0; i < n; ++i) {
        cin >> m[i] >> s[i];
        for (int j = 0; j < m[i]; ++j) {
            int inp;
            cin >> inp;
            p[i].push_back(inp);
        }
    }

    int r = -1;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m[i]-1; ++j) {
            int curr = p[i][j+1] - p[i][j];
            if (r == -1) r = curr;
            if (curr != r) {
                cout << "No\n";
                return 0;
            }
        }
    }

    if (r == -1) {
        vi perm(n);
        iota(perm.begin(), perm.end(), 0);
        bool found;
        do {
            found = true;
            int tryDistance = -1;
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m[perm[i]] - 1; ++j) {
                    int curr = p[perm[i]][j + 1] - p[perm[i]][j];
                    if (tryDistance == -1) tryDistance = curr;
                    if (curr != tryDistance) {
                        found = false;
                        goto BREAK;
                    }
                }
                if (i != n - 1) {
                    int curr = p[perm[i + 1]][0] + s[perm[i]] - p[perm[i]][m[perm[i]] - 1];
                    if (tryDistance == -1) tryDistance = curr;
                    if (curr != tryDistance) {
                        found = false;
                        goto BREAK;
                    }
                }
            }
            break;
            BREAK:;
        } while (next_permutation(perm.begin(), perm.end()));

        if (found) {
            cout << "Yes\n";
            for (int i = 0; i < n; ++i) {
                cout << perm[i] + 1 << ' ';
            }
            cout << '\n';
        } else {
            cout << "No\n";
        }
    } else {
        vvi g(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (s[i] - p[i][m[i]-1] + p[j][0] == r) {
                    g[i].push_back(j);
                }
            }
        }

        vc used(n, false);
        auto dfs = [&g, n](int v, int len, vc &used, stack<int> &st, auto &rec) {
            used[v] = true;
            st.push(v);
            if (len + 1 == n) {
                return -1;
            }
            for (auto to : g[v]) {
                if (!used[to]) {
                    int ret = rec(to, len + 1, used, st, rec);
                    if (ret == -1) return -1;
                }
            }
            used[v] = false;
            st.pop();
        };

        for (int i = 0; i < n; ++i) {
            stack<int> st;
            int ret = dfs(i, 0, used, st, dfs);
            if (ret == -1) {
                cout << "Yes\n";
                vi ans;
                while (!st.empty()) {
                    ans.push_back(st.top());
                    st.pop();
                }
                for (int j = 0; j < n; ++j) {
                    cout << ans[j] << ' ';
                }
                cout << '\n';
                return 0;
            }
        }
        cout << "No\n";
        /*for (int i = 0; i < n; ++i) {
            used[i] = true;
            st.push(i);
            while (!st.empty()) {
                int v = st.top();
                for (auto to : g[v]) {
                    if (!used[to]) {
                        st.push(to);
                    }
                }
            }
        }*/
    }
}
