#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4.1,sse4.2")

#include <iostream>
#include <vector>
#include <cmath>
#include <utility>
#include <algorithm>
#include <string>
#include <sstream>

using namespace std;
using ll = long long;
using ii = pair<int, int>;
using vi = vector<int>;
using vii = vector<ii>;
using vvi = vector<vi>;

const int INF = 1e9;

struct Col {
    ll a;
    ll b;
    ll c;
    ll id;
    bool valid;
    bool lead;
    bool takes;
    bool gives;
    Col() = default;
    Col(ll aa, ll bb, ll cc): a{aa}, b{bb}, c{cc} {
        static ll idc = 0;
        id = idc++;
        if (a == 0 || b == 0 || c == 0) {
            lead = true;
        } else {
            lead = false;
        }
        valid = true;
        if (a + b == c) {
            takes = false;
            gives = false;
        } else if (a + b + 1 == c) {
            takes = true;
            gives = false;
        } else if (a + b == c + 10) {
            takes = false;
            gives = true;
        } else if (a + b + 1 == c + 10) {
            takes = true;
            gives = true;
        } else {
            valid = takes = gives = false;
        }
    }
};

bool operator<(const Col &a, const Col &b) {
    return a.id < b.id;
    /*if (a.a != b.a) {
        return a.a < b.a;
    } else if (a.b != b.b) {
        return a.b < b.b;
    } else {
        return a.c < b.c;
    }*/
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll m = static_cast<ll>(1e9+7);

    string sa, sb, sc;
    cin >> sa >> sb >> sc;
    stringstream ssa(sa);
    stringstream ssb(sb);
    stringstream ssc(sc);
    ll n = sa.size();
    vector<Col> cols(n);
    for (ll i = 0; i < n; ++i) {
        char a, b, c;
        ssa >> a;
        ssb >> b;
        ssc >> c;
        cols[i] = {a - '0', b - '0', c - '0'};
        if (!cols[i].valid) {
            cout << "0\n";
            return 0;
        }
    }

    ll count = 0;
    do {
        if (cols[0].lead) continue;
        if (cols[n-1].takes) continue;
        bool lastGives = cols[n-1].gives;
        bool found = true;
        for (ll i = n-2; i >= 0; --i) {
            if (lastGives != cols[i].takes) {
                found = false;
                break;
            } else {
                lastGives = cols[i].gives;
            }
        }
        if (found) ++count;
        count %= m;
    } while (next_permutation(cols.begin(), cols.end()));

    cout << count << '\n';
}
