#include <iostream>
#include <vector>
#include <string>

using namespace std;

bool is_a_power_of_10(int n) {
    while (n > 1) {
        if (n % 10 != 0) return false;
        n /= 10;
    }
    return true;
}

int strlen(int n) {
    if (n == 1) return 1;
    int len = 1;
    while (n > 0) {
        len += 1;
        n /= 10;
    }
    return len;
}

int first_digit(int n) {
    while (n > 10) {
        n /= 10;
    }
    return n;
}

int second_digit(int n) {
    while (n > 100) {
        n /= 10;
    }
    return n % 10;
}

int onlyfirst(int n) {
    int d = first_digit(n);
    while (d <= n / 10) {
        d *= 10;
    }
    return d;
}

pair<int, int> maxlg(int n) {
    if (n == 1) return {2, 0};
    if (n == 2) return {1, 1};
    if (n == 3) return {2, 1};
    if (n < 10) return {3, n / 2};
    if (n == 10) return {2, 5};
    if (n == 11) return {2, 5};
    int len = strlen(n);
    if (first_digit(n) == 1) {
        if (second_digit(n) >= 2) {
            return {len + 1 + len - 1, onlyfirst(n)};
        }
        return {len - 1 + 1 + len - 1, n / 2};
    }
    return {len + 1 + len, n / 2};
}

int findmin(const vector<pair<int, char>>& a, const vector<int>& starts) {
    int n = a.size();
    int ans = 1;
    int econ = 0;
    for (int i = 1; i + 1 < n; ++i) {
        if (a[i].first == 1 && a[i - 1].second == a[i + 1].second) {
            int plen = strlen(a[i - 1].second) + 1 + strlen(a[i + 1].second);
            int nlen = strlen(a[i - 1].second + a[i + 1].second);
            if (plen - nlen > econ) {
                econ = plen - nlen;
                ans = starts[i];
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (is_a_power_of_10(a[i].first) && econ < 1) {
            econ = 1;
            ans = starts[i];
        }
    }
    return ans;
}

pair<int, char> findmax(const vector<pair<int, char>>& a, const vector<int>& starts) {
    int n = (int) a.size();
    int ans = 0; char ansc = 'A';
    int add = 1;
    if (a[0].second == 'A') ansc = 'C';
    for (int i = 0; i < n; ++i) {
        auto [cadd, cut] = maxlg(a[i].first);
        if (cadd > add) {
            add = cadd;
            ans = starts[i] + cut;
            ansc = 'A';
            if (a[i].second == 'A') ansc = 'C';
        }
    }
    return make_pair(ans, ansc);
}

signed main() {
    string s; cin >> s;
    vector<pair<int, char>> a = {{0, '$'}};
    for (char c : s) {
        if (c >= '0' && c <= '9') {
            a.back().first *= 10;
            a.back().first += c - '0';
        } else {
            a.back().second = c;
            a.push_back(make_pair(0, '$'));
        }
    }
    a.pop_back();
    for (int i = 0; i < a.size(); ++i) {
        if (a[i].first == 0) {
            a[i].first = 1;
        }
    }
    int n = (int) a.size();
    vector<int> starts (n, 0);
    for (int i = 0; i < n - 1; ++i) {
        starts[i + 1] = starts[i] + a[i].first;
    }
    cout << "2 " << findmin(a, starts) + 1 << '\n';
    pair<int, char> ansmax = findmax(a, starts);
    cout << "1 " << ansmax.first << ' ' << ansmax.second << '\n';
}