#include <iostream>
#include <vector>
#include <string>

using namespace std;

typedef long long ll;

const int mod = 1'000'000'007;

int mul(const int& a, const int& b) {
    ll c = 1ll * a * b;
    if (c >= mod) {
        c %= mod;
    }
    return c;
}

int fact(int x) {
    int res = 1;
    for (int i = 1; i <= x; ++i) {
        res = mul(res, i);
    }
    return res;
}

int tmul(int x, int y) {
    int res = 1;
    for (int i = x; i <= y; ++i) {
        res = mul(res, i);
    }
    return res;
}

int binpow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        return binpow(mul(a, a), n / 2);
    }
    return mul(a, binpow(a, n - 1));
}

int rev(int r) {
    return binpow(r, mod - 2);
}

int C(int n, int k) {
    return mul(tmul(n - k + 1, n), rev(fact(k)));
}

signed main() {
    string sa, sb, sc; cin >> sa >> sb >> sc;
    int n = (int) sa.size();
    vector<int> a (n), b (n), c (n);
    for (int i = 0; i < n; ++i) {
        a[i] = sa[i] - '0';
        b[i] = sb[i] - '0';
        c[i] = sc[i] - '0';
    }
    vector<bool> to (n, false), from (n, false);
    for (int i = 0; i < n; ++i) {
        int k = (10 + c[i]) - (a[i] + b[i]);
        if (k / 10 == 0) {
            from[i] = true;
        }
        if (k % 10 == 1) {
            to[i] = true;
        }
        if (k != 0 && k != 1 && k != 10 && k != 11) {
            cout << 0 << '\n';
            return 0;
        }
    }
    int segcnt = 0;
    int cnt [2][2];
    cnt[0][0] = cnt[0][1] = cnt[1][0] = cnt[1][1] = 0;
    for (int i = 0; i < n; ++i) {
        cnt[from[i]][to[i]] += 1;
    }
    if (cnt[0][1] != cnt[1][0]) {
        cout << 0 << '\n';
        return 0;
    }
    cout << cnt[0][0] << ' ' << cnt[0][1] << ' ' << cnt[1][0] << ' ' << cnt[1][1] << '\n';
    int seg1cnt = cnt[0][1], seg0cnt = cnt[0][1] + 1;
    int p0 = C(cnt[0][0] + seg0cnt - 1, cnt[0][0]);
    int p1 = C(cnt[1][1] + seg1cnt - 1, cnt[1][1]);
    int ans0 = mul(p0, mul(fact(cnt[0][0]), fact(cnt[0][1])));
    int ans1 = mul(p1, mul(fact(cnt[1][1]), fact(cnt[1][0])));
    cout << mul(ans0, ans1) << '\n';
}