#include <iostream>
#include <cmath>

using namespace std;

#define INF 1e9;
#define LINF 1e18;

int64_t t, n, m;

inline int64_t sum0(int64_t n) {
	return (n*(n+1)) / 2;
}

inline int64_t sumd(int64_t s, int64_t e) {
	return sum0(e) - sum0(s);
}

inline int64_t V_cut1(int64_t p) {
	//cout << sum0(p - 1) << ' ' << sumd(p-1, m) << ' ';
	return abs(sum0(p - 1) - sumd(p-1, m));
}

inline int64_t V_sum(int64_t p) {
	int64_t sum = 0;
	//p -= 1;
	sum += sum0(p-1) * n;
	sum += ((n * (n - 1)) / 2) * (p - 1) * m;
	return sum;
}

inline int64_t V_sum(int s, int e) {
	return V_sum(e) - V_sum(s);
}

inline int64_t H_sum(int64_t p) {
	int64_t sum = 0;
	//p -= 1;
	sum += ((m*(m+1))/2)*(p-1);
	sum += (((p-1)*(p-2))/2) * m * m;
	//sum += ((n * (n - 1)) / 2) * (p - 1) * m;
	return sum;
}

inline int64_t H_sum(int s, int e) {
	return H_sum(e) - H_sum(s);
}

int main() {
	//n = 2000;
	//m = 2000;

	//cout << H_sum(2001);
	cin >> t;
	for (int i = 0; i < t; i++) {
		cin >> n >> m;
		//n = i / 101;
		//m = i % 101;
		//n = 1;
		//m = 10000+i;

		int64_t mind = LINF;
		int minp = 0;
		char minr = 0;

		if (n != 1) {
			{
				int s = 1;
				int e = m + 1;
				/*if (m > 1000) {
					//s = m * 0.45;
					//e = m * 0.55;
				}*/
				for (int i = 0; i < 100; i++) {
					int t1 = (2 * s + e) / 3;
					int t2 = (s + 2 * e) / 3;
					int64_t v1 = abs(V_sum(t1) - V_sum(t1, m + 1));// V_cut1(t1);
					int64_t v2 = abs(V_sum(t2) - V_sum(t2, m + 1));// V_cut1(t2);
					//cout << t1 << ':' << v1 << ' ' << t2 << ':' << v2 << '\n';
					if (v1 < v2) {
						e = t2;
					}
					else if (v2 < v1) {
						s = t1;
					}
					else {
						s = t1;
						e = t2;
					}
					if (s == e)break;
				}
				//int64_t mind = LINF;
				//int minp = s;
				for (int q = s; q <= e; q++) {
					int64_t val = abs(V_sum(q) - V_sum(q, m + 1));
					if (val < mind) {
						mind = val;
						minp = q;
						minr = 'V';
					}
				}
			}
			if (n > 1) {
				int s = 1;
				int e = n + 1;
				for (int i = 0; i < 100; i++) {
					int t1 = (2 * s + e) / 3;
					int t2 = (s + 2 * e) / 3;
					int64_t v1 = abs(H_sum(t1) - H_sum(t1, n + 1));// V_cut1(t1);
					int64_t v2 = abs(H_sum(t2) - H_sum(t2, n + 1));// V_cut1(t2);
					//cout << t1 << ':' << v1 << ' ' << t2 << ':' << v2 << '\n';
					if (v1 < v2) {
						e = t2;
					}
					else if (v2 < v1) {
						s = t1;
					}
					else {
						s = t1;
						e = t2;
					}
					if (s == e)break;
				}
				//int64_t mind = LINF;
				//int minp = s;
				for (int q = s; q <= e; q++) {
					int64_t val = abs(H_sum(q) - H_sum(q, n + 1));
					if (val < mind) {
						mind = val;
						minp = q;
						minr = 'H';
					}
				}
			}
		}

		int64_t smind = mind;
		int sminp = minp;
		char sminr = minr;

		if (n == 1) {
			mind = LINF;
			long double t = m * m + m;
			minp = round(sqrt(8*t+4)/4-0.500004)+1;
			minr = 'V';
		}

		/*for (int q = 1; q <= m+1; q++) {
			int64_t val = abs(V_sum(q) - V_sum(q, m+1));
			//cout << val << '-' << V_sum(q) << ':' << V_sum(q, m+1) << ' ';
			if (val < mind) {
				mind = val;
				minp = q;
				minr = 'V';
			}
		}
		//cout << '\n';
		for (int q = 1; q <= n+1; q++) {
			int64_t val = abs(H_sum(q) - H_sum(q, n + 1));
			//cout << val << '-' << V_sum(q) << ':' << V_sum(q, m+1) << ' ';
			if (val < mind) {
				mind = val;
				minp = q;
				minr = 'H';
			}
		}
		//cout << '\n';*/
		cout << minr << ' ' << minp << '\n';

		if (minr != sminr || minp != sminp) {
			//cout << n << ' ' << m << ' ' << minr << ' ' << minp << ' ' << sminr << ' ' << sminp << '\n';
		}

		/*if (n == 1) {
			int s = 1;
			int e = m;
			for (int i = 0; i < 100; i++) {
				int t1 = (2 * s + e) / 3;
				int t2 = (s + 2 * e) / 3;
				int64_t v1 = V_cut1(t1);
				int64_t v2 = V_cut1(t2);
				//cout << t1 << ':' << v1 << ' ' << t2 << ':' << v2 << '\n';
				if (v1 < v2) {
					e = t2;
				}
				else if(v2 < v1){
					s = t1;
				}
				else {
					s = t1;
					e = t2;
				}
				if (s == e)break;
			}
			int64_t mind = LINF;
			int minp = s;
			for (int q = s; q <= e; q++) {
				int64_t val = V_cut1(q);
				if (val < mind) {
					mind = val;
					minp = q;
				}
			}
			//cout << s << ' ' << e << ' ';
			cout << "V " << minp << '\n';
		}
		else cout << "err";*/
	}
	return 0;
}