#include <iostream>
#include <vector>
#include <string.h>
#include <string>
#include <algorithm>
#include <map>

using namespace std;

struct RLE {
	int64_t num_prev;
	int len;
	char c;
	RLE() :num_prev(0), len(0), c(0) {}
	RLE(int64_t p, int l, char code) :num_prev(p), len(l), c(code) {}
	bool operator<(const RLE& item) {
		return len < item.len;
	}
};

char codes[] = { 'A','G','C','T' };
map<char, char> shift = { {'A', 'G'}, {'G','C'},{'C','T'},{'T', 'G'} };

vector<RLE> dat;
vector<char> raw;
char str[100001];
int n = 0;

inline bool check1(int val) {
	if (to_string(val)[0] == '1' && to_string(val - 1)[0] == '9' && val % 10 == 0 && (val - 1) % 10 == 9)return 1;
	else return 0;
}

inline bool check2(int addr, char c) {
	if (addr < 0 || addr >= dat.size())return true;
	else return (dat[addr].c != c);
}

int cmd = 0;
int cmd_x = 0;
char cmdZ = 0;

inline char getNext(bool zero=0) {
	static int pos = 0;
	if (zero) {
		pos = 0;
		return 0;
	}
	char c = 0;

	int rawLen = raw.size();
	if (cmd == 1)rawLen++;
	else if (cmd == 2)rawLen--;
	
	if (pos < rawLen) {
		if (cmd == 1) {
			if (pos > cmd_x)c = raw[pos - 1];
			else if (pos < cmd_x)c = raw[pos];
			else c = cmdZ;
		}
		else if (cmd == 2) {
			if (pos >= cmd_x - 1)c = raw[pos + 1];
			else c = raw[pos];
		}
		else if (cmd == 3) {
			if (pos + 1 == cmd_x)c = cmdZ;
			else c = raw[pos];
		}
		else c = raw[pos];
	}

	pos++;
	return c;
}

int get_RLE_len() {
	int len = -1;
	char p = raw[0];
	int cl = 0;
	char i = 1;
	getNext(1);
	while(i > 0) {
		i = getNext();
		//cout << i;
		if (p != i) {
			len++;
			if (cl > 1) {
				len += to_string(cl).length();
				//cout << cl;
			}
			//cout << p;
			//len += cl;
			cl = 0;
		}
		cl++;
		p = i;
	}
	len++;
	if (cl > 1) {
		len += to_string(cl).length();
		//cout << cl;
	}
	//cout << p;
	//len += cl;
	cl = 0;
	return len;
}

int main() {
	cin >> str;
	n = strlen(str);
	dat.reserve(n);
	char* endstr = str + n;
	int64_t sum = 0;
	for (char* s = str; s < endstr; s++) {
		char c = *s;
		int l = 0;
		while (c >= '0' && c <= '9') {
			l *= 10;
			l += c - '0';
			c = *(++s);
		}
		if (l < 1)l = 1;
		dat.push_back(RLE(sum, l, c));
		sum += l;
	}

	raw.reserve((dat.end() - 1)->num_prev + (dat.end() - 1)->len);
	for (auto i : dat) {
		for (int q = 0; q < i.len; q++)raw.push_back(i.c);
	}
	int mina = 2;
	int minx = 0;
	char minZ = 0;
	int minv = 0;

	int maxa = 2;
	int maxx = 0;
	char maxZ = 0;
	int maxv = 0;

	for (int i = 0; i < raw.size(); i++) {
		for (int q = 0; q < 3; q++) {
			if (q != 1) {
				cmd = q + 1;
				cmd_x = i + 1;
				for (int w = 0; w < 4; w++) {
					cmdZ = codes[w];
					int val = n - get_RLE_len();
					if (val >= minv) {
						minv = val;
						mina = cmd;
						minx = cmd_x;
						minZ = cmdZ;
					}
					if (-val >= maxv) {
						maxv = -val;
						maxa = cmd;
						maxx = cmd_x;
						maxZ = cmdZ;
					}
				}
			}
		}
	}

	cout << mina << ' ' << minx;
	if (mina != 2)cout << ' ' << minZ << '\n';
	else cout << '\n';

	cout << maxa << ' ' << maxx;
	if (maxa != 2)cout << ' ' << maxZ << '\n';
	else cout << '\n';

	/*
	int mina = 2;
	int minx = 0;
	char minZ = 0;
	int minv = (dat[0].len == 1 || dat[0].len == 2 || (check1(dat[0].len)))?1:0;
	for (int i = 1; i < dat.size(); i++) {
		if (dat[i].len == 2 || (check1(dat[i].len))) {
			if (minv < 1) {
				mina = 2;
				minx = dat[i].num_prev+1;
				minv = 1;
			}
		}
		else if (dat[i].len == 1) {
			if (i < dat.size()-1 && dat[i - 1].c == dat[i + 1].c) {
				int val = 2;
				val += (to_string(dat[i - 1].len).length() + to_string(dat[i + 1].len).length()) - to_string(dat[i - 1].len + dat[i + 1].len).length();
				if (minv < val) {
					minv = val;
					mina = 2;
					minx = dat[i].num_prev + 1;
				}
			}
			else {
				if (minv < 1) {
					mina = 2;
					minx = dat[i].num_prev + 1;
					minv = 1;
				}
			}
		}
	}
	cout << mina << ' ' << minx;
	if (mina != 2)cout << ' ' << minZ << '\n';
	else cout << '\n';

	int maxa = 2;
	int maxx = 0;
	char maxZ = 0;
	int maxv = 0;

	auto item_addr = max_element(dat.begin(), dat.end());
	int item_num = item_addr - dat.begin();
	auto item = *item_addr;
	maxa = 1;
	maxx = item.num_prev + item.len / 2;
	for (int i = 0; i < 4; i++) {
		if (check2(item_num - 1, codes[i]) && check2(item_num + 1, codes[i]) && check2(item_num, codes[i]))maxZ = codes[i];
	}
	//maxZ = shift[item.c];

	cout << maxa << ' ' << maxx;
	if (maxa != 2)cout << ' ' << maxZ << '\n';
	else cout << '\n';*/
}