#include <iostream>
#include <vector>
#include <string>

#define int long long

using namespace std;

int n, m;

int col_cnt(int i) {
    return (n * m) * (n * m + 1) / 2 - (n * i * (i + 1) + m * n * (n - 1) * i);
}

vector<int> search_col() {
    int l = 0;
    int r = m + 1;
    while (l + 1 < r) {
        int mid = (l + r) / 2;
        if (col_cnt(mid) < 0) {
            r = mid;
        } else {
            l = mid;
        }
    }
    return {l, r};
}

int row_cnt(int i) {
    return (n * m) * (n * m + 1) / 2 - (m * m * i * (i - 1) + m * (m + 1) * i);
}


vector<int> search_row() {
    int l = 0;
    int r = n + 1;
    while (l + 1 < r) {
        int mid = (l + r) / 2;
        if (row_cnt(mid) < 0) {
            r = mid;
        } else {
            l = mid;
        }
    }
    return {l, r};
}

void query() {
    cin >> n >> m;
    vector<pair<vector<int>,string>> options;
    for (int idx: search_col()) {
        options.push_back({{abs(col_cnt(idx)), 0, idx}, "V " + to_string(idx + 1)});
    }
    for (int idx: search_row()) {
        options.push_back({{abs(row_cnt(idx)), 1, idx}, "H " + to_string(idx + 1)});
    }
    cout << min(min(options[0], options[1]), min(options[2], options[3])).second << '\n';
}

signed main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        query();
    }
}
