#include <iostream>
#include <vector>
#include <string>

#define int long long

using namespace std;


vector<vector<int>> g;
int n;

vector<int> why_dfs(int v, int cnt, vector<int> &used) {
    if (cnt == n) {
        return {v};
    }
    used[v] = true;
    for (auto u: g[v]) {
        if (!used[u]) {
            auto ans = why_dfs(u, cnt + 1, used);
            if (!ans.empty()) {
                ans.push_back(v);
                return ans;
            }
        }
    }
    return {};
}


signed main() {
    cin >> n;
    vector<pair<int,int>> parts(n);
    int interval = -1;
    for (int i = 0; i < n; ++i) {
        int m, s;
        cin >> m >> s;
        int first;
        cin >> first;
        int last = first;
        for (int j = 1; j < m; ++j) {
            int p;
            cin >> p;
            if (interval == -1) {
               interval = p - last;
            } else if (interval != p - last) {
                cout << "No\n";
                return 0;
            }
            last = p;
        }
        parts[i] = {first, s - last};
    }

    if (interval == -1) {
        cout << "No\n";
        return 0;
    }

    g.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i != j && parts[i].second + parts[j].first == interval) {
                g[i].push_back(j);
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        vector<int> used(n);
        auto ans = why_dfs(i, 1, used);
        if (!ans.empty()) {
            cout << "Yes\n";
            for (int j = n - 1; j >= 0; --j) {
                cout << ans[j] + 1 << " ";
            }
            cout << "\n";
            return 0;
        }
    }

    cout << "No\n";
}
