#include <iostream>
#include <vector>
#include <string>
#include <map>

#define int long long

using namespace std;


int n;
vector<pair<int,int>> parts;
map<int,vector<int>> pstarts;
map<int,vector<int>> pends;
vector<int> dfs_ans;


bool dfs(int v, int cnt, int interval, vector<bool> &used) {
    if (cnt == n) {
        dfs_ans = {v};
        return true;
    }
    used[v] = true;
    for (auto u: pstarts[interval - parts[v].second]) {
        if (!used[u]) {
            if (dfs(u, cnt + 1, interval, used)) {
                dfs_ans.push_back(v);
                return true;
            }
        }
    }
    return false;
}



bool check(int interval) {
    for (int i = 0; i < n; ++i) {
        vector<bool> used(n);
        bool val = dfs(i, 1, interval, used);
        if (val) {
            cout << "Yes\n";
            for (int j = n - 1; j >= 0; --j) {
                cout << dfs_ans[j] + 1 << " ";
            }
            cout << "\n";
            return true;
        }
    }
    return false;
}


signed main() {
    cin >> n;
    int interval = -1;
    parts.resize(n);
    for (int i = 0; i < n; ++i) {
        int m, s;
        cin >> m >> s;
        int first;
        cin >> first;
        int last = first;
        for (int j = 1; j < m; ++j) {
            int p;
            cin >> p;
            if (interval == -1) {
               interval = p - last;
            } else if (interval != p - last) {
                cout << "No\n";
                return 0;
            }
            last = p;
        }
        parts[i] = {first, s - last};
        pstarts[first].push_back(i);
        pends[s - last].push_back(i);
    }

    if (interval == -1) {
        for (interval = 0; interval <= 10000; ++interval) {
            if (check(interval)) return 0;
        }
    } else {
        if (check(interval)) return 0;
    }

    cout << "No\n";
}
