#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;

typedef long long ll;

ll n, m, s;

ll calc_hor(ll k) {
    if ( k == 0 ) return s;
    ll tp = ((k * (k - 1)) / 2) * m * m + ((m * (m + 1))/2) * k;
    return s - 2 * tp;
}

ll calc_ver(ll k) {
    if ( k == 0 ) return s;
    ll tp = ((n * (n - 1)) / 2) * m * k + ((k * (k + 1))/2) * n;
    return s - 2 * tp;
}

pair<ll, ll> bin_hor() {
    ll left = 0;
    ll right = n;

    while ( right - left > 1 ) {
        ll mid = (left + right) / 2;

        if ( calc_hor(mid) < 0 ) {
            right = mid;
        } else {
            left = mid;
        }
    }

    if ( abs(calc_hor(left)) <= abs(calc_hor(right)) ) return {calc_hor(left), left};
    else return {-calc_hor(right), right};
}

pair<ll, ll> bin_ver() {
    ll left = 0;
    ll right = m;

    while ( right - left > 1 ) {
        ll mid = (left + right) / 2;

        if ( calc_ver(mid) < 0 ) {
            right = mid;
        } else {
            left = mid;
        }
    }

    if ( abs(calc_ver(left)) <= abs(calc_ver(right)) ) return {calc_ver(left), left};
    else return {-calc_ver(right), right};
}

pair<string, ll> solve() {
    s = ((n * (n - 1)) / 2) * m * m + ((m * (m + 1))/2) * n;

    pair<ll, ll> hor = bin_hor();
    pair<ll, ll> ver = bin_ver();

    if ( ver.first <= hor.first ) return {"V", ver.second + 1};
    else return {"H", hor.second + 1};
}

int main() {
    int t;
    cin >> t;
    for ( int i = 0; i < t; ++i ) {
        cin >> n >> m;
        pair<string, ll> ans = solve();

        cout << ans.first << " " << ans.second << endl;
    }

    cin >> t;
    return 0;
}
