#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
const ll INF = 1e18;

#define len first
#define gene second

string agct = "AGCT";

vector<pair<ll, int>> genes;
vector<ll> pref;
ll L = 0;

pair<ll, string> ansmax;
pair<ll, string> ansmin;

int digits(ll x) {
    if ( x <= 1 ) return 0;
    int res = 0;
    while ( x > 0 ) {
        x = x / 10;
        res++;
    }
    return res;
}

pair<ll, int> long_cut(ll x) {
    if ( x == 2 ) return {1, 2};

    ll p = 1;
    pair<int, ll> res = {1 + digits(x - 2), 1};

    while ( p < x ) {
        res = max(res, {digits(p) + digits(x - p), p});
        p = p * 10;
    }

    return {res.second, res.first};
}

int main() {
    string _s;
    cin >> _s;

    genes = vector<pair<ll, int>>(0);
    pref = {0};
    L = 0;

    string number = "";
    int gn = -1;
    char ch;

    for ( int i = 0; i < _s.size(); ++i ) {
        ch = _s[i];
        if ( ch == 'A' ) {
            gn = 0;
        } else if ( ch == 'G' ) {
            gn = 1;
        } else if ( ch == 'C' ) {
            gn = 2;
        } else if ( ch == 'T' ) {
            gn = 3;
        } else {
            number += ch;
        }

        if ( gn != -1 ) {
            if ( number == "" ) number = "0";
            genes.push_back({stoi(number), gn});
            pref.push_back(pref.back() + genes.back().first);

            number = "";
            gn = -1;
        }
    }
    L = _s.size();

    ansmin = {INF, ""};
    ansmax = {-1, ""};
    //bad transform for minimum?
    //replace
    for ( int i = 0; i < genes.size(); ++i ) {
        if ( genes[i].len > 2 ) {
            pair<ll, int> cut = long_cut(genes[i].len - 1);
            //L - |Nx| + |a1b| + |ABC|
            ll new_len = L - digits(genes[i].len) - 1 + cut.second + 3;
            string trans = "3 " + to_string(pref[i] + cut.first + 1) + " " + agct[(genes[i].gene + 1)%4];
            ansmax = max(ansmax, {new_len, trans});
        }
        if ( genes[i].len == 1 ) {
            for ( int g = 0; g < 4; ++g ) {
                if ( g == genes[i].gene ) continue;

                bool eq_left = (i != 0) && (g == genes[i - 1].gene);
                bool eq_right = (i != genes.size() - 1 ) && (g == genes[i + 1].gene);

                ll new_len = L;
                string trans = "3 " + to_string(pref[i] + 1) + " " + agct[g];

                if ( (!eq_left) && (!eq_right) ) {

                } else if ( eq_left && (!eq_right) ) {
                    new_len -= digits(genes[i - 1].len) + 2;
                    new_len += digits(genes[i - 1].len + 1) + 1;
                } else if ( (!eq_left) && eq_right ) {
                    new_len -= digits(genes[i + 1].len) + 2;
                    new_len += digits(genes[i + 1].len + 1) + 1;
                } else {
                    new_len -= digits(genes[i - 1].len) + digits(genes[i + 1].len) + 3;
                    new_len += digits(genes[i - 1].len + genes[i + 1].len + 1) + 1;
                }

                ansmax = max(ansmax, {new_len, trans});
                ansmin = min(ansmax, {new_len, trans});
                continue;
            }

            {
                for ( int g = 0; g < 4; ++g ) {
                    if ( g == genes[i].gene ) continue;

                    bool eq_left = (i != 0) && (genes[i - 1].gene == g);

                    ll new_len = L;
                    string trans = "3 " + to_string(pref[i] + 1) + " " + agct[g];

                    if ( eq_left ) {
                        new_len -= digits(genes[i - 1].len) + digits(genes[i].len) + 2;
                        new_len += digits(genes[i - 1].len + 1) + digits(genes[i].len - 1) + 2;
                    }

                    ansmin = min(ansmin, {new_len, trans});
                    ansmax = max(ansmax, {new_len, trans});
                }
            }

            {
                for ( int g = 0; g < 4; ++g ) {
                    if ( g == genes[i].gene ) continue;

                    bool eq_right = (i != genes.size() - 1) && (genes[i + 1].gene == g);

                    ll new_len = L;
                    string trans = "3 " + to_string(pref[i] + genes[i].len) + " " + agct[g];

                    if ( eq_right ) {
                        new_len -= digits(genes[i + 1].len) + digits(genes[i].len) + 2;
                        new_len += digits(genes[i + 1].len + 1) + digits(genes[i].len - 1) + 2;
                    }

                    ansmin = min(ansmin, {new_len, trans});
                    ansmax = max(ansmax, {new_len, trans});
                }
            }
        }
    }

    //delete
    for ( int i = 0; i < genes.size(); ++i ) {
        string trans = "2 " + to_string(pref[i] + 1);
        if ( genes[i].len > 1 ) {
            ll new_len = L - digits(genes[i].len) + digits(genes[i].len - 1);
            ansmin = min(ansmin, {new_len, trans});
        } else {
            bool eq = (i != 0) && (i != genes.size() - 1) && (genes[i - 1].gene == genes[i + 1].gene);

            if ( !eq ) {
                ll new_len = L - 1;
                ansmin = min(ansmin, {new_len, trans});
            } else {
                ll new_len = L - digits(genes[i - 1].len) - digits(genes[i + 1].len) - 3;
                new_len += digits(genes[i - 1].len + genes[i + 1].len) + 1;
                ansmin = min(ansmin, {new_len, trans});
            }
        }
    }

    //add
    //inside block
    for ( int i = 0; i < genes.size(); ++i ) {
        if ( genes[i].len <= 2 ) continue;

        pair<ll, int> cut = long_cut(genes[i].len);
        ll new_len = L - digits(genes[i].len) - 1;
        new_len += cut.second + 3;
        string trans = "1 " + to_string(pref[i] + cut.first) + " " + agct[(genes[i].gene + 1)%4];

        ansmax = max(ansmax, {new_len, trans});

        new_len = L - digits(genes[i].len);
        new_len += digits(genes[i].len + 1);
        trans = "1 " + to_string(pref[i] + cut.first) + " " + agct[(genes[i].gene)%4];
        ansmax = max(ansmax, {new_len, trans});
    }

    //between blocks
    for ( int i = 0; i <= genes.size(); ++i ) {
        for ( int g = 0; g < 4; ++g ) {
            bool eq_left = (i != 0) && (g == genes[i - 1].gene);
            bool eq_right = (i != genes.size()) && (g == genes[i].gene);
            ll new_len = L;
            string trans = "1 " + to_string(pref[i]) + " " + agct[g];
            if ( (!eq_left) && (!eq_right) ) {
                new_len += 1;
            } else if ( eq_left ) {
                new_len -= digits(genes[i - 1].len);
                new_len += digits(genes[i - 1].len + 1);
            } else {
                new_len -= digits(genes[i + 1].len);
                new_len += digits(genes[i + 1].len + 1);
            }

            ansmax = max(ansmax, {new_len, trans});
        }
    }

    cout << ansmin.second << endl;
    cout << ansmax.second << endl;

    return 0;
}
