#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
const ll mod = 1e9 + 7;
const int fact_sz = 2e5 + 20;

ll fact[fact_sz];
ll inv_fact[fact_sz];

ll bin_pow(ll x, ll p) {
    if ( p == 0 ) return 1;
    if ( p == 1 ) return x % mod;

    ll sq = bin_pow(x, p / 2);
    sq = ( sq * sq ) % mod;

    if ( p % 2 == 0 ) return sq;
    else return (sq * x) % mod;
}

ll inv(ll x) { return bin_pow(x, mod - 2); }

void init_fact() {
    fact[0] = 1;
    for ( int i = 0; i < fact_sz - 1; ++i ) fact[i + 1] = (fact[i] * (i + 1)) % mod;

    for ( int i = 0; i < fact_sz; ++i ) inv_fact[i] = inv(fact[i]);
}

ll binom(ll n, ll m) {
    ll res = fact[n];
    res = (res * inv_fact[m]) % mod;
    res = (res * inv_fact[n - m]) % mod;
    return res;
}

ll calc_block(ll s, ll n, ll k0, ll k1) {
    ll res = 1;

    if ( k0 == 0 && (n - s) == 0 ) {}
    else if ( k0 > 0 && (n - s) >= k0 ) res = (res * binom(n - s - 1, k0 - 1)) % mod;
    else { res = 0; }

    if ( k1 == 0 && s == 0 ) {}
    else if ( k1 > 0 && s >= k1 ) res = (res * binom(s - 1, k1 - 1)) % mod;
    else { res = 0; }

    return res;
}

ll cnt(ll x, ll y, ll z, ll w, ll c, ll n) {
    ll s = y + w;
    if ( (x + y) != (n - c - s) ) return 0;
    if ( (x + z) != (n - s) ) return 0;
    if ( (z + w) != (c + s) ) return 0;
    ll s0 = n - 1 - s;

    ll k0 = (n + 1) - (c + s) - x;
    if ( ((n + 1 - c - s) > 0) && ((1 > k0) || (k0 > (n + 1 - c - s))) ) return 0;
    if ( k0 < 0 ) return 0;

    ll k1;

    if ( c == 0 ) k1 = k0 - 1;
    else k1 = k0;

    if ( ( (c + s) > 0 ) && ((1 > k1) || (k1 > (c + s))) ) return 0;
    if ( k1 < 0 ) return 0;

    ll res;

    if ( k0 != k1 ) res = calc_block(s + c, n + 1, k0, k1);
    else res = (calc_block(s + c, n + 1, k0, k1)) % mod;

    res = (res * fact[x]) % mod;
    res = (res * fact[y]) % mod;
    res = (res * fact[z]) % mod;
    res = (res * fact[w]) % mod;

    return res;
}

int main() {
    init_fact();

    string na, nb, nc;
    int n;

    cin >> na >> nb >> nc;
    n = na.size();

    //convert to digits
    vector<int> a(n); vector<int> b(n); vector<int> c(n);
    for ( int i = 0; i < n; ++i ) {
        a[i] = na[i] - '0';
        b[i] = nb[i] - '0';
        c[i] = nc[i] - '0';
    }

    //calc from and to
    vector<bool> from(n, false);
    vector<bool> to(n, false);

    for ( int i = 0; i < n; ++i ) {
        if ( (c[i] - a[i] - b[i] + 100) % 10 == 0 ) {
            to[i] = false;
        } else if ( (c[i] - a[i] - b[i] + 100) % 10 == 1 ) {
            to[i] = true;
        } else {
            cout << 0 << endl;
            return 0;
        }
    }

    for ( int i = 0; i < n; ++i ) {
        if ( c[i] == (a[i] + b[i] + to[i]) ) {
            from[i] = false;
        } else {
            from[i] = true;
        }
    }

    int x, y, z, w;
    x = 0; y = 0; z = 0; w = 0;

    for ( int i = 0; i < n; ++i ) {
        if ( !to[i] && !from[i] ) x++;
        else if ( !to[i] && from[i] ) y++;
        else if ( to[i] && !from[i] ) z++;
        else w++;
    }

    int starter_t0 = 0;
    int starter_t1 = 0;

    for ( int i = 0; i < n; ++i ) {
        if ( from[i] ) continue;
        if ( a[i] == 0 || b[i] == 0 || c[i] == 0 ) continue;

        if ( to[i] ) starter_t1++;
        else starter_t0++;
    }

    if ( starter_t0 + starter_t1 == 0 ) {
        cout << 0 << endl;
        return 0;
    }

    for ( int i = 0; i <= n; ++i ) {
        if ( i == n ) {
            cout << 0 << endl;
            return 0;
        } else if ( !to[i] ) {
            break;
        }
    }

    ll ans = 0;

    ans += (starter_t0 * cnt(x - 1, y, z, w, 0, n - 1)) % mod;
    ans += (starter_t1 * cnt(x, y - 1, z, w, 1, n - 1)) % mod;

    ans = ans % mod;

    cout << ans << endl;

    return 0;
}
