#include <bits/stdc++.h>

using namespace std;

int digit_count(long long n) {
        int res = 0;
        while (n > 0) {
                n /= 10;
                ++res;
        }
        return res;
}

long long repeat_n(int digit, int n) {
        long long res = 0;
        for (int i = 0; i < n; ++i) {
                res = res * 10 + digit;
        }
        return res;
}

template <int i>
int ith_digit(long long n) {
        int cnt = digit_count(n);
        for (int j = 0; j < cnt - i; ++j) {
                n /= 10;
        }
        return n % 10;
}

long long first_i_digits(long long n, int i) {
        int cnt = digit_count(n);
        for (int j = 0; j < cnt - i; ++j) {
                n /= 10;
        }
        return n;
}

long long power_of_10(int p) {
        long long res = 1;
        for (int i = 0; i < p; ++i) {
                res *= 10;
        }
        return res;
}

long long concatenate(long long a, long long b, int b_length = -1) {
        if (b_length == -1) {
                b_length = digit_count(b);
        }
        return a * power_of_10(b_length) + b;
}

long long transform(int length, long long mask, tuple<int, int> allowed_digits) {
        long long res = 0;
        for (int i = 0; i < length; ++i) {
                res *= 10;
                if (mask & (1 << i)) {
                        res += get<1>(allowed_digits);
                } else {
                        res += get<0>(allowed_digits);
                }
        }
        return res;
}

int main() {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        long long n;
        bool in_the_mood;
        cin >> n;
        cin >> in_the_mood;
        long long candidate = n;
        assert(n >= 10 || !in_the_mood);
        vector<long long> all_possible;
        int number_length = digit_count(n);
        for (int length = number_length; length < number_length + 1; ++length) {
                for (int first_digit = 0; first_digit <= 9; ++first_digit) {
                        if (in_the_mood) {
                        for (int second_digit = first_digit + 1; second_digit <= 9; ++second_digit) {
                                for (int mask = 0; mask < (1ll << length); ++mask) {
                                        all_possible.push_back(transform(length, mask, {first_digit, second_digit}));
                                }
                        }
                        } else {
                                all_possible.push_back(repeat_n(first_digit, length));
                        }
                }
        }
        sort(all_possible.begin(), all_possible.end());
        cout << *lower_bound(all_possible.begin(), all_possible.end(), n) << '\n';
}
