#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> lpair;
typedef vector<ll> lvec;
#define TEST "D1"
const ll INF = 1e9;

#pragma GCC optimize(-O3)

const ll mod = 1e9 + 7;

ll pw(ll a, ll n) {
    ll res = 1;
    while (n) {
        if (n % 2) res = res * a % mod;
        a = a * a % mod;
        n /= 2;
    }
    return res;
}

ll rev(ll a) {
    return pw(a, mod - 2);
}

lvec fact;

void init(ll n) {
    fact.resize(n, 1);
    for (ll i = 2; i < n; i ++) fact[i] = fact[i - 1] * i % mod;
}

ll mult(initializer_list<ll> v) {
    ll res = 1;
    for(auto el : v) res = res * el % mod;
    return res;
}

ll C(ll n, ll k) {
    return mult({fact[n], rev(fact[k]), rev(fact[n - k])});
}

ll n_sum_of_k(ll n, ll k) {
    if (n == 0) return 1;
    if (k == 0) return 0;
    return C(n + k - 1, k - 1);
}

ll solve(ll p, ll mid, ll fill) {
    if(fill < 0) return 0;
    ll ans =  mult({fact[p], fact[p], n_sum_of_k(mid, p), fact[mid],  n_sum_of_k(fill, p + 1), fact[fill]});
    if (ans < 0) ans += mod;
    return ans;
}

ll slv(ll p, ll mid, ll fill) {
    if (p <= 0) return 0;
    ll ans =  mult({fact[p - 1], fact[p], n_sum_of_k(mid, p), fact[mid],  n_sum_of_k(fill, p), fact[fill]});
    if (ans < 0) ans += mod;
    return ans;
}

void epic_fail() {
    cout << 0;
    exit(0);
}

bool eq(ll a, ll b) {
    return (a-b) % 10 == 0;
}

int main() {
#if defined(LOCAL) && defined(TEST)
    if (!freopen(TEST ".in", "r", stdin)) cerr << "!!!Check input files!!!\n\n\n";
#endif
    string a, b ,c;
    cin >> a >> b >> c;
    ll n = a.size();
    init(2 * n);
    ll left = 0, right = 0, middle = 0, filler = 0, spoiled_left = 0, spoiled_fill = 0;
    for(ll i = 0; i < n; i ++) {
        bool asks, gives;
        ll x = a[i] - '0', y = b[i] - '0', z = c[i] - '0';
        if (eq(x + y, z - 1)) asks = true;
        else if (eq(x + y, z)) asks = false;
        else epic_fail();
        gives = x + y + (asks?1:0) > 9;
        if (asks) {
            if (gives) middle++;
            else left++;
        } else {
            if (gives) right++;
            else filler ++;
        }
        if (x == 0 || y == 0 || z == 0) {
           if (asks && !gives) spoiled_left ++;
           if (!asks && !gives) spoiled_fill ++;
        }
    }
    if (left != right) epic_fail();
    ll ans = solve(left, middle, filler) - solve(left, middle, filler - 1) * spoiled_fill;
    ans -= spoiled_left * slv(left, middle, filler);
    ans %= mod;
    if (ans < 0) ans += mod;
    cout << ans;
}