#include <iostream>
#include "vector"
#include "algorithm"
#include "cmath"
#include "string"
#include "map"
using namespace std;
void dfs1(int v, vector<pair<int, int>> &ans, map<int, vector<pair<int, int>>> &g){
    if (g[v].empty())
        return;
    int x = g[v].back().first;
    ans.push_back({x, g[v].back().second});
    g[v].pop_back();
    dfs1(x, ans, g);
}
void dfs2(int v, vector<int> &ans, map<int, vector<pair<int, int>>> &g){
    if (g[v].empty())
        return;
    if (g[v].back().second != -1)
        ans.push_back(g[v].back().second);
    int x = g[v].back().first;
    g[v].pop_back();
    dfs2(x, ans, g);
}
bool solve(vector<pair<int, int>> blocks, int k){
    map<int, int> outcnt, incnt;
    map<int, vector<pair<int, int>>> g;
    int pos = 0;
    for (auto [l, r] : blocks){
        outcnt[k-l]++;
        g[k - l].push_back({r, pos});
        incnt[r]++;
        pos++;
    }
    while (incnt[k] < outcnt[k] and outcnt[0] < incnt[0]) {
        outcnt[0]++;
        incnt[k]++;
        g[0].push_back({k, -1});
    }
    if (incnt[k] - outcnt[k] == 2 or incnt[0] - outcnt[0] == 2){
        outcnt[0]++;
        incnt[k]++;
        g[0].push_back({k, -1});
    }
    int start;
    int morein = 0, moreout = 0;
    for (auto [key, val] : g){
        start = key;
        if (abs(incnt[key] - outcnt[key]) > 1)
            return false;
        if (incnt[key] > outcnt[key])
            morein++;
        if (incnt[key] < outcnt[key])
            moreout++;
    }
    if (moreout > 1 or morein > 1)
        return false;
    for (auto [key, val] : g){
        if (incnt[key] < outcnt[key])
            start = key;
    //    cout << key << ' ' << incnt[key] << ' ' << outcnt[key] << endl;
    //    for (auto i : val)
    //        cout << i.first << ' ' << i.second << endl;
    //    cout << "!!" << endl;
    }
    //cout << "ST " << start << endl;
    vector<pair<int, int>> ans1;
    dfs1(start, ans1, g);
    //for (auto i : ans1){
    //    cout << "ANS1 " << i.first << ' ' << i.second << endl;
    //}
    vector<int> ans;
    dfs2(start, ans, g);
    for (auto [x, edge] : ans1){
        if (edge != -1){
            ans.push_back(edge);
        }
        dfs2(x, ans, g);
    }
    if (ans.size() == blocks.size()){
        cout << "Yes\n";
        for (auto i : ans)
            cout << i + 1 << ' ';
        exit(0);
    }
}
bool solve(vector<pair<int, pair<int, int>>> perm, int k){
    for (int i = 1; i < perm.size(); ++i) {
        if (perm[i].second.first + perm[i - 1].second.second != k){
            if (k == 0)
                k = perm[i].second.first + perm[i - 1].second.second;
            else
                return false;
        }
    }
    return true;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);cout.tie(nullptr);
    int n;
    cin >> n;
    int k = 0;
    vector<pair<int, pair<int, int>>> blocks(n);
    for (int i = 0; i < n; ++i) {
        int m, r;
        cin >> m >> r;
        vector<int> elems(m);
        for (auto &elem : elems) {
            cin >> elem;
        }
        for (int j = 1; j < m; ++j) {
            if (elems[j] - elems[j - 1] != k){
                if (k == 0)
                    k = elems[j] - elems[j - 1];
                else{
                    cout << "No";
                    return 0;
                }
            }
        }
        blocks[i].first = i;
        blocks[i].second.first = elems[0];
        blocks[i].second.second = r - elems.back();
        //cout << blocks[i].first << ' ' << blocks[i].second << endl;
    }
    //cout << "KK" << k << "KK\n";
    if (solve(blocks, k)){
        cout << "Yes\n";
        for (auto i : blocks)
            cout << i.first + 1 << ' ';
        return 0;
    }
    while (next_permutation(blocks.begin(), blocks.end())){
        if (solve(blocks, k)){
            cout << "Yes\n";
            for (auto i : blocks)
                cout << i.first + 1 << ' ';
            return 0;
        }
    }
    if (solve(blocks, k)){
        cout << "Yes\n";
        for (auto i : blocks)
            cout << i.first + 1 << ' ';
        return 0;
    }
    cout << "No";
}
