#include <iostream>
#include "vector"
#include "algorithm"
#include "cmath"
#include "string"
#include "random"
using namespace std;
typedef long long ll;
#define all(x) (x).begin(), (x).end()
const ll mod = 1e9 + 7;
ll pow(ll a, ll b){
    ll res = 1;
    while (b){
        if (b & 1){
            res *= a;
            res %= mod;
        }
        a *= a;
        a %= mod;
        b /= 2;
    }
    return res;
}

pair<int, int> numopr(int a, int b, int c){
    bool give, need, first;
    need = ((a + b + 1) % 10 == c);
    give = (a + b + need >= 10);
    first = (a == 0) or (b == 0) or (c == 0);
    if ((a + b + need) % 10 != c){
        return {-1, -1};
    }
    return {give * 2 + need, first};
}
ll inv(ll x){
    return pow(x, mod - 2);
}
vector<ll> fac;
ll Cnk(ll n, ll k){
    return ((((fac[n] * inv(fac[k])) % mod) * inv(fac[n - k])) % mod);
}
ll solve(string a, string b, string c){
    int n = a.size();
    fac.assign(n + 1, 1);
    for (int i = 1; i <= n; ++i) {
        fac[i] = fac[i-1] * i;
        fac[i] %= mod;
    }
    ll cnt = 0;
    vector<int> elems(4);
    for (int i = 0; i < n; ++i) {
        pair<int, int> k = numopr(a[i] - '0', b[i] - '0', c[i] - '0');
        if (k.first == -1)
            return 0;
        elems[k.first]++;
        if (k.first / 2 == 0 and k.second)
            cnt++;
    }
    if (elems[1] == 0 and elems[3] != 0){
        return 0;
    }
    //cout << elems[0] << ' ' << elems[1] << ' ' << elems[2] << ' ' << elems[3] << ' ' << cnt << endl;
    if (elems[2] != elems[1]){
        return 0;
    }
    ll res;
    if (elems[2] > 0)
        res = Cnk(elems[2] + elems[3] - 1, elems[2] - 1) * fac[elems[3]] % mod;
    else
        res = 1;
    //cout << res << endl;
    res *= fac[elems[2]];
    res %= mod;
    //cout << res << endl;
    ll v = elems[2] + elems[0];
    res *= (v - cnt) * fac[v - 1] % mod;
    res %= mod;
    //cout << res << endl;
    if (res < 0)
        res += mod;
    return res;
}
bool test(vector<pair<pair<int, int>, int>> abc){
    if (abc[0].first.first == 0 or abc[0].first.second == 0 or abc[0].second == 0)
        return 0;
    int res = 0;
    while (!abc.empty()){
        res += abc.back().first.first + abc.back().first.second - abc.back().second;
        abc.pop_back();
        if (res % 10)
            return 0;
        res /= 10;
    }
    return res == 0;
}
ll solve2(string a, string b, string c){
    int n = a.size();
    vector<pair<pair<int, int>, int>> abc(n);
    for (int i = 0; i < n; ++i) {
        abc[i] = {{a[i] - '0', b[i]-'0'}, c[i]-'0'};
    }
    sort(all(abc));
    int res = test(abc);
    while (next_permutation(all(abc))){
        res += test(abc);
    }
    return res;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);cout.tie(nullptr);
    string a, b, c;
    cin >> a >> b >> c;
    cout << solve(a,b,c);
}
