//#pragma GCC optimize("Ofast,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("section-anchors")
//#pragma GCC optimize("profile-values,profile-reorder-functions,tracer")
//#pragma GCC optimize("vpt")
//#pragma GCC optimize("rename-registers")
//#pragma GCC optimize("move-loop-invariants")
//#pragma GCC optimize("unswitch-loops")
//#pragma GCC optimize("function-sections")
//#pragma GCC optimize("data-sections")
//#pragma GCC optimize("branch-target-load-optimize")
//#pragma GCC optimize("branch-target-load-optimize2")
//#pragma GCC optimize("btr-bb-exclusive")


#include <iostream>
#include <vector>

#define INF 1e9
#define INF_LL 1e18
#define endl '\n'

using namespace std;

typedef int64_t ll;

ll cprs(ll a, ll b) {
    if (a == 1ll) {
        return b * (b + 1ll) / 2ll;
    } else {
        return cprs(1, b) - cprs(1, a - 1);
    }
}

ll ch(ll x, ll n, ll m) {
    ll a = cprs(1, m * x), b = cprs(m * x + 1, m * n);
    if (a > b) swap(a, b);
    return b - a;
}

ll cv(ll x, ll n, ll m) {
    ll mfac = cprs(1, n - 1) * m;
    // right
    ll lft = (m - x);
    ll sm = mfac + (x + 1) * n;
    ll rightsum = sm * lft + cprs(1, lft - 1) * n;
    // left
    sm = mfac + n;
    ll leftsum = sm * x + cprs(1, x - 1) * n;

    if (rightsum < leftsum) swap(rightsum, leftsum);

    return rightsum - leftsum;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int q; cin >> q;
    while (q--) {
        ll n, m; cin >> n >> m;
        pair<char, ll> ans;
        ll mn = INF_LL;
        for (ll i = 1; i < m; ++i) {
            ll tmp = cv(i, n, m);
            if (tmp < mn) {
                mn = tmp;
                ans = {'V', i};
            }
        }
        for (ll i = 1; i < n; ++i) {
            ll tmp = ch(i, n, m);
            if (tmp < mn) {
                ans = {'H', i};
            }
        }
        cout << ans.first << " " << ans.second  + 1 << endl;
    }
    return 0;
}

//5
//1 3
//4 7
//1 10
//3 3
//3 5