//#pragma GCC optimize("Ofast,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("section-anchors")
//#pragma GCC optimize("profile-values,profile-reorder-functions,tracer")
//#pragma GCC optimize("vpt")
//#pragma GCC optimize("rename-registers")
//#pragma GCC optimize("move-loop-invariants")
//#pragma GCC optimize("unswitch-loops")
//#pragma GCC optimize("function-sections")
//#pragma GCC optimize("data-sections")
//#pragma GCC optimize("branch-target-load-optimize")
//#pragma GCC optimize("branch-target-load-optimize2")
//#pragma GCC optimize("btr-bb-exclusive")


#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

#define INF 1e9
#define INF_LL 1e18
#define endl '\n'

using namespace std;

typedef int64_t ll;

ll cprs(ll a, ll b) {
    if (a <= 1) {
        return b * (b + 1ll) / 2ll;
    } else {
        return cprs(1, b) - cprs(1, a - 1);
    }
}

ll ch(ll x, ll ak, ll n, ll m) {
    ll a = cprs(1, m * x), b = ak - a;
    if (a > b) swap(a, b);
    return b - a;
}

ll cv(ll x, ll a, ll n, ll m) {
    ll mfac = cprs(1, n - 1) * m;

    // left
    ll sm = mfac + n;
    ll leftsum = sm * x + cprs(1, x - 1) * n;

    ll rightsum = a - leftsum;

    if (rightsum < leftsum) swap(rightsum, leftsum);

    return rightsum - leftsum;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int q; cin >> q;
    while (q--) {
        ll n, m; cin >> n >> m;
        ll allsum = cprs(1, n * m);
        pair<char, ll> ans;
        ll mn = INF_LL;
        for (ll i = 1; i < m; ++i) {
            ll tmp = cv(i, allsum, n, m);
            if (tmp < mn) {
                mn = tmp;
                ans = {'V', i};
            }
        }
        for (ll i = 1; i < n; ++i) {
            ll tmp = ch(i, allsum, n, m);
            if (tmp < mn) {
                ans = {'H', i};
                mn = tmp;
            }
        }
        cout << ans.first << " " << ans.second  + 1 << endl;
    }
    return 0;
}

//signed main() {
//    int q; cin >> q;
//    while (q--) {
//        ll n, m; cin >> n >> m;
//        vector<vector<ll>> ar(n, vector<ll>(m));
//        ll allsum = 0;
//        for (int i = 0; i < n; ++i) {
//            iota(ar[i].begin(), ar[i].end(), i * m + 1);
//            for (auto& it : ar[i]) allsum += it;
//        }
//        ll mx = INF_LL;
//        pair<char, ll> ans;
//        for (int i = 0; i < m - 1; ++i) {
//            ll sumleft = 0;
//            for (auto& it : ar) {
//                for (int j = 0; j <= i; ++j) sumleft += it[j];
//            }
//            ll sumright = allsum - sumleft;
//            if (sumleft > sumright) swap(sumleft, sumright);
//            ll res = sumright - sumleft;
//            if (mx > res) {
//
//            }
//        }
//        for (int i = 0; i < n - 1; ++i) {
//            ll sumdown = 0;
//            for (int j = 0; j <= i; ++j) {
//                for (auto& it : ar[j]) sumdown += it;
//            }
//            ll sumup = allsum - sumdown;
//            if (sumdown > sumup) swap(sumdown, sumup);
//            ll res = sumup - sumdown;
//            if (mx > res) {
//                mx = res;
//                ans = {'H', i + 2};
//            }
//        }
//    }
//}
//5
//1 3
//4 7
//1 10
//3 3
//3 5