//#pragma GCC optimize("Ofast,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("section-anchors")
//#pragma GCC optimize("profile-values,profile-reorder-functions,tracer")
//#pragma GCC optimize("vpt")
//#pragma GCC optimize("rename-registers")
//#pragma GCC optimize("move-loop-invariants")
//#pragma GCC optimize("unswitch-loops")
//#pragma GCC optimize("function-sections")
//#pragma GCC optimize("data-sections")
//#pragma GCC optimize("branch-target-load-optimize")
//#pragma GCC optimize("branch-target-load-optimize2")
//#pragma GCC optimize("btr-bb-exclusive")


#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

#define INF 1e9
#define INF_LL 1e18
#define endl '\n'

using namespace std;

typedef int64_t ll;

ll cprs(ll a, ll b) {
    if (a <= 1) {
        return b * (b + 1ll) / 2ll;
    } else {
        return cprs(1, b) - cprs(1, a - 1);
    }
}

ll ch(ll x, ll ak, ll n, ll m) {
    ll a = cprs(1, m * x), b = ak - a;
    if (a > b) swap(a, b);
    return b - a;
}

ll cv(ll x, ll a, ll n, ll m) {
    ll mfac = cprs(1, n - 1) * m;

    // left
    ll sm = mfac + n;
    ll leftsum = sm * x + cprs(1, x - 1) * n;

    ll rightsum = a - leftsum;

    if (rightsum < leftsum) swap(rightsum, leftsum);

    return rightsum - leftsum;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int q; cin >> q;
    while (q--) {
        ll n, m; cin >> n >> m;
        ll allsum = cprs(1, n * m);
        pair<char, ll> ans;
        ll mn = INF_LL;
        if (m > 1) {
            ll l = 1, r = m;
            for (int z = 0; z < 70; ++z) {
                ll dist = (r - l) / 3;
                ll lm = l + dist,
                        rm = r - dist;
                if (lm > rm) swap(lm, rm);
                ll fres = cv(lm, allsum, n, m), bres = cv(rm, allsum, n, m);
                if (fres > bres) {
                    l = lm;
                } else {
                    r = rm;
                }
            }
            for (ll i = max<ll>(l - 2ll, 1); i < min<ll>(m, l + 2ll); ++i) {
                ll tmp = cv(i, allsum, n, m);
                if (tmp < mn) {
                    mn = tmp;
                    ans = {'V', i};
                }
            }
        }
        if (n > 1) {
            ll l = 1, r = n;
            for (int z = 0; z < 70; ++z) {
                ll dist = (r - l) / 3;
                ll lm = l + dist,
                        rm = r - dist;
                if (lm > rm) swap(lm, rm);
                ll fres = ch(lm, allsum, n, m), bres = ch(rm, allsum, n, m);
                if (fres > bres) {
                    l = lm;
                } else {
                    r = rm;
                }
            }
            for (ll i = max<ll>(l - 2ll, 1); i < min<ll>(n, l + 2ll); ++i) {
                ll tmp = ch(i, allsum, n, m);
                if (tmp < mn) {
                    ans = {'H', i};
                    mn = tmp;
                }
            }
        }
//
//        for (ll i = 1; i < m; ++i) {
//            ll tmp = cv(i, allsum, n, m);
//            if (tmp < mn) {
//                mn = tmp;
//                ans = {'V', i};
//            }
//        }
//        for (ll i = 1; i < n; ++i) {
//            ll tmp = ch(i, allsum, n, m);
//            if (tmp < mn) {
//                ans = {'H', i};
//                mn = tmp;
//            }
//        }
        cout << ans.first << " " << ans.second  + 1 << endl;
    }
    return 0;
}
//
//5
//1 3
//4 7
//1 10
//3 3
//3 5