//#pragma GCC optimize("Ofast,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("section-anchors")
//#pragma GCC optimize("profile-values,profile-reorder-functions,tracer")
//#pragma GCC optimize("vpt")
//#pragma GCC optimize("rename-registers")
//#pragma GCC optimize("move-loop-invariants")
//#pragma GCC optimize("unswitch-loops")
//#pragma GCC optimize("function-sections")
//#pragma GCC optimize("data-sections")
//#pragma GCC optimize("branch-target-load-optimize")
//#pragma GCC optimize("branch-target-load-optimize2")
//#pragma GCC optimize("btr-bb-exclusive")


#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>

#define INF 1e9
#define INF_LL 1e18
#define endl '\n'

using namespace std;

typedef int64_t ll;

int m_encode(string& b) {
    vector<pair<char, int>> kk;
    for (auto& it : b) {
        if (kk.empty() || kk.back().first != it) {
            kk.push_back({it, 1});
        } else {
            kk[kk.size() - 1].second++;
        }
    }
    string ans;
    for (auto& it : kk) {
        ans += (it.second > 1 ? to_string(it.second) : "") + string(1, it.first);
    }
    return (int)ans.size();
}

bool is_num(char x) {
    return ('0' <= x && x <= '9');
}

string m_decode(string& s) {
    string ans;
    int prv = -1, len = 0;
    for (int i = 0; i < s.size(); ++i) {
        if (!is_num(s[i])) {
            int ln = 0;
            if (prv != -1) {
                ln = stoi(s.substr(prv, len));
            } else {
                ln = 1;
            }
            len = 0;
            prv = -1;
            ans += string(ln, s[i]);
        } else {
            if (prv == -1) {
                prv = i;
                len = 1;
            }
            else
                len++;
        }
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    string m; cin >> m;
    m = m_decode(m);
//    cout << m;

    string mnmv, mxmv;
    int mn = INF, mx = 0;
    // remove
    for (int i = 0; i < m.size(); ++i) {
        string kk = m;
        kk.erase(kk.begin() + i);
        string cumov = "2 " + to_string(i + 1);

        int rs = m_encode(kk);
        if (rs > mx) {
            mx = rs;
            mxmv = cumov;
        }
        if (rs < mn) {
            mn = rs;
            mnmv = cumov;
        }
    }

    // insert
    for (int i = 0; i <= m.size(); ++i) {
        vector<char> kek = {'A', 'G', 'C', 'T'};
        for (auto& it : kek) {
            string cumov = "1 " + to_string(i) + " " + string(1, it);
            string kk = m;
            kk.insert(kk.begin() + i, it);

            int rs = m_encode(kk);
            if (rs > mx) {
                mx = rs;
                mxmv = cumov;
            }
            if (rs < mn) {
                mn = rs;
                mnmv = cumov;
            }
        }
    }

    // set
    for (int i = 0; i < m.size(); ++i) {
        vector<char> kek = {'A', 'G', 'C', 'T'};
        for (auto& it : kek) {
            string cumov = "3 " + to_string(i + 1) + " " + string(1, it);
            string kk = m;
            kk[i] = it;

            int rs = m_encode(kk);
            if (rs > mx) {
                mx = rs;
                mxmv = cumov;
            }
            if (rs < mn) {
                mn = rs;
                mnmv = cumov;
            }
        }
    }
    cout << mnmv << endl << mxmv;
    return 0;
}
//5AC5A2C