#include <iostream>
#include <vector>
#define int long long

using namespace std;

void fastIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

const int INF = 1e18;

int sum(int n) {
    if (n < 0) return 0;
    return n * (n + 1) / 2;
}

int getHorizontal(int n, int m, int k) {
    if (k <= 0 || k >= n) return INF;
    return sum(n * m) - 2 * sum(k * m);
}
int sumOneCol(int n, int m) {
    return m * sum(n - 1) + n;
}

int getVertical(int n, int m, int k) {
    if (k <= 0 || k >= m) return INF;
    int res = sumOneCol(n, m) * m + n * sum(m - 1) - 2 * (sumOneCol(n, m) * k + n * sum(k - 1));
    return res;

}

signed main() {
    int t; cin >> t;
    while (t--) {
        int n, m; cin >> n >> m;
        int vans = INF, v = -1;
        int l = 0, r = m;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            //cout << "VANS " << n << ' ' << m << ' ' << mid << " IS " << getVertical(n,m,mid) << endl;
            if (getVertical(n,m,mid) >= 0) {
                l = mid;
            } else {
                r = mid;
            }
        }
        vans = l, v = abs(getVertical(n, m, l));
        if (abs(getVertical(n, m, l + 1)) < v) {
            vans = l + 1; v = abs(getVertical(n, m, l + 1));
        }
        //cout << l << ' ' << v << ' ' << getVertical(n,m,l+1) << endl;
        int hans = INF, h = -1;
        l = 0, r = n;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            //cout << "HANS " << n << ' ' << m << ' ' << mid << " IS " << getHorizontal(n,m,mid) << endl;
            if (getHorizontal(n, m, mid) >= 0) {
                l = mid;
            } else {
                r = mid;
            }
        }
        hans = l; h = abs(getHorizontal(n,m,l));
        if (abs(getHorizontal(n,m,l+1)) < h) {
            hans = l + 1;
            h=abs(getHorizontal(n,m,l+1));
        }
        if (v < h) {
            cout << "V " << vans + 1<< endl;
        } else {
            cout << "H " << hans + 1 << endl;
        }
    }
}