#include <iostream>
#include <vector>
#include <set>

using namespace std;

template <class T>
inline bool relaxMax(T &value, const T& new_value) {
    if (new_value > value) {
        value = new_value;
        return true;
    }
    return false;
}

template <class T>
inline bool relaxMin(T &value, const T& new_value) {
    if (new_value < value) {
        value = new_value;
        return true;
    }
    return false;
}

struct Block {
    int capacity;
    char c;
    explicit Block() {}
    Block(int n, char cc) {capacity = n; c = cc; }
    const int getLength() {
        if (capacity == 1) return 1;
        return 2;
    }
};
const int INF = 1e9 + 2281337;

char getChar(string s, set<char> banned) {
    for (char c : s) {
        if (banned.find(c) == banned.end()) return c;
    }
    return ' ';
}

int main() {
    string str; cin >> str;
    int totalSum = 0;
    int n = str.length();
    int ptr = 0;
    vector<Block> blocks;
    while (ptr < n) {
        if ('2' <= str[ptr] && str[ptr] <= '9') {
            int capacity = str[ptr] - '0';
            ptr++;
            char c = str[ptr];
            blocks.push_back({capacity, c});
            ptr++;
            totalSum += capacity;
        } else {
            int capacity = 1;
            char c = str[ptr];
            ptr++;
            blocks.push_back({capacity, c});
            totalSum += capacity;
        }
    }
    int maxLengthAdding = 1;
    char ansAdding = getChar("ACGT", {blocks.begin()->c});
    int ansAddingIndex = 0;
    // Adding external char
    int m = blocks.size();
    int prefSum = 0;
    for (Block block : blocks) {
        if (block.capacity <= 2) continue;
        if (block.capacity >= 4) {
            if (relaxMax(maxLengthAdding, 3))  {
                ansAdding = getChar("ACGT", {block.c});
                ansAddingIndex = prefSum + 2;
            }
        } else if (block.capacity == 3) {
            if (relaxMax(maxLengthAdding, 2)) {
                ansAdding = getChar("ACGT", {block.c});
                ansAddingIndex = prefSum + 1;
            }
        }
        prefSum += block.capacity;
    }
    prefSum = blocks[0].capacity;
    // Deleting external char
    int minLengthDeleting = 0;
    int ansDeleting = 0;
    for (int i = 1; i < m - 1; i++) {
        if (blocks[i].capacity == 1) {
            if (blocks[i - 1].c == blocks[i + 1].c) {
                if (relaxMax(minLengthDeleting, blocks[i - 1].getLength() + blocks[i + 1].getLength() + 1 - 2)) {
                    ansDeleting = prefSum;
                }
            } else {
                if (relaxMax(minLengthDeleting, 1)) {
                    ansDeleting = prefSum;
                }
            }
        }
        prefSum += blocks[i].capacity;
    }
    cout << 2 << ' ' << ansDeleting + 1 << endl;
    cout << 1 << ' ' << ansAddingIndex << ' ' << ansAdding << endl;
}