#include <iostream>
#include <vector>
#include <set>

int digNum(int n) {
    if (n <= 1) return 0;
    int cnt = 0;
    while (n > 0) {
        n /= 10;
        cnt += 1;
    }
    return cnt;
}

template <class T>
inline bool relaxMax(T &value, const T& new_value) {
    if (new_value > value) {
        value = new_value;
        return true;
    }
    return false;
}

int pow10(int p) {
    if (p == 0) return 1;
    return pow10(p - 1) * 10;
}

std::pair<int, int> maxDiv(int capacity) {
    int ans = 0, ind = -1;
    for (int i = 1; i < capacity; i++) {
        if (relaxMax(ans, digNum(i) + digNum(capacity - i) + 2 - digNum(capacity))) {
            ind = i;
        }
    }
    return {ind, ans};
}

std::pair<int, int> maxDivClever(int capacity) {
    int ans = 0, ind = -1;
    if (relaxMax(ans, digNum(1) + digNum(capacity - 1) + 2 - digNum(capacity))) ind = 1;
    if (relaxMax(ans, digNum(2) + digNum(capacity - 2) + 2 - digNum(capacity))) ind = 2;
    for (int p = 1; pow10(p) < capacity; p++) {
        if (relaxMax(ans, digNum(pow10(p)) + digNum(capacity - pow10(p)) + 2 - digNum(capacity))) {
            ind = pow10(p);
        }
    }
    if (relaxMax(ans, digNum(capacity / 2) + digNum(capacity - capacity / 2) + 2 - digNum(capacity))) ind = capacity / 2;
    return {ind, ans};
}

using namespace std;

template <class T>
inline bool relaxMin(T &value, const T& new_value) {
    if (new_value < value) {
        value = new_value;
        return true;
    }
    return false;
}

struct Block {
    int capacity;
    char c;
    explicit Block() {}
    Block(int n, char cc) {capacity = n; c = cc; }
    const int getLength() {
        return digNum(capacity);
    }
};
const int INF = 1e9 + 2281337;

char getChar(string s, set<char> banned) {
    for (char c : s) {
        if (banned.find(c) == banned.end()) return c;
    }
    return ' ';
}

int main() {
    string str; cin >> str;
    int n = str.length();
    int ptr = 0;
    vector<Block> blocks;
    while (ptr < n) {
        int capacity = 0;
        while ('0' <= str[ptr] && str[ptr] <= '9') {
            int newDigit = str[ptr] - '0';
            capacity *= 10;
            capacity += newDigit;
            ptr++;
        }
        if (capacity == 0) capacity = 1;
        char c = str[ptr];
        blocks.push_back({capacity, c});
        ptr++;
    }
    int maxLengthAdding = 1;
    char ansAdding = getChar("ACGT", {blocks.begin()->c});
    int ansAddingIndex = 0;
    // Adding external char
    int m = blocks.size();
    int prefSum = 0;
    for (Block block : blocks) {
        if (relaxMax(maxLengthAdding, maxDivClever(block.capacity).second)) {
            ansAdding = getChar("ACGT", {block.c});
            ansAddingIndex = prefSum + maxDivClever(block.capacity).first;
        }
        prefSum += block.capacity;
    }
    prefSum = blocks[0].capacity;
    // Deleting external char
    int minLengthDeleting = (blocks.begin()->capacity <= 2 ? 1 : 0);
    int ansDeleting = 0;
    for (int i = 1; i < m - 1; i++) {
        if (blocks[i].capacity == 1) {
            if (blocks[i - 1].c == blocks[i + 1].c) {
                if (relaxMax(minLengthDeleting, blocks[i - 1].getLength() + blocks[i + 1].getLength() + 1 - digNum(blocks[i - 1].capacity + blocks[i + 1].capacity))) {
                    ansDeleting = prefSum;
                }
            } else {
                if (relaxMax(minLengthDeleting, 1)) {
                    ansDeleting = prefSum;
                }
            }
        } else if (blocks[i].capacity == 2) {
            if (relaxMax(minLengthDeleting, 1)) {
                ansDeleting = prefSum;
            }
        }
        prefSum += blocks[i].capacity;
    }
    if (relaxMax(minLengthDeleting, (blocks.back().capacity <= 2 ? 1 : 0))) {
        ansDeleting = prefSum;
    }
    cout << 2 << ' ' << ansDeleting + 1 << endl;
    cout << 1 << ' ' << ansAddingIndex << ' ' << ansAdding << endl;
}