#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Stick {
    int length;
    vector<int> seps;
    explicit Stick() {
        length = 0;
    }
    Stick(int length, vector<int> &seps) {
        this->length = length;
        this->seps = seps;
    }
};

bool operator<(pair<Stick, int> a, pair<Stick, int> b) {
    return a.second < b.second;
}

bool check(const vector<Stick> &sticks) {
    vector<int> coords;
    int pref = 0;
    for (const Stick &stick : sticks) {
        for (const int &i : stick.seps) {
            coords.push_back(i + pref);
        }
        pref += stick.length;
    }
    sort(coords.begin(), coords.end());
    if (coords.size() == 1) return true;
    int dist = coords[1] - coords[0];
    for (int i = 2; i < (int) coords.size(); i++) {
        if (coords[i] - coords[i - 1] != dist) return false;
    }
    return true;
}

int main() {
    int n; cin >> n;
    vector<pair<Stick, int>> orderedSticks;
    for (int i = 0; i < n; i++) {
        int len, sz; cin >> sz >> len;
        vector<int> coords(sz);
        for (int &j : coords) cin >> j;
        orderedSticks.push_back({Stick(len, coords), i});
    }
    do {
        vector<Stick> currentSticks;
        for (int i = 0; i < n; i++) {
            currentSticks.push_back(orderedSticks[i].first);
        }
        if (check(currentSticks)) {
            cout << "Yes" << endl;
            for (auto i : orderedSticks) {
                cout << i.second + 1 << ' ';
            }
            cout << endl;
            return 0;
        }
    } while (next_permutation(orderedSticks.begin(), orderedSticks.end()));
    cout << "No" << endl;
}