#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

typedef long long ll;

using namespace std;

ll findAllSame(ll x) {
    string strNum = to_string(x);
    int n = strNum.length();
    char f = strNum[0];
    bool flag = true;
    for (int i = 1; i < n; i++) {
        if (strNum[i] != f) {
            flag = false;
        }
    }
    if (flag) {
        return x;
    }
    char nextChar = strNum[0];
    int dig = nextChar - '0';
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        ans *= 10;
        ans += dig;
    }
    if (ans < x) {
        dig = (int) nextChar - '0';
        dig++;
        ans = 0;
        for (int i = 0; i < n; i++) {
            ans *= 10;
            ans += dig;
        }
    }
    return ans;
}

bool check(ll x) {
    string strNum = to_string(x);
    int n = strNum.length();
    if (n == 1) return true;
    int cnt1 = 0, cnt2 = 0;
    for (int i = 0; i < n; i++) {
        if (strNum[i] == strNum[0]) cnt1++;
        if (strNum[i] == strNum[1]) cnt2++;
    }
    return cnt1 >= n - 1 || cnt2 >= n - 1;
}

ll strToInt(string &s) {
    return stoll(s);
}

vector<ll> allNumbers(int n, int k) {
    string s;
    for (int i = 0; i < n; i++) s += k + '0';
    vector<ll> res;
    if (k == 0) {
        for (int d = 1; d <= 9; d++) {
            s[0] = d + '0';
//            cout << s << endl;
            res.push_back(strToInt(s));
        }
        return res;
    }
    for (int i = 0; i < n; i++) {
        for (int d = 0; d <= 9; d++) {
            if (i == 0 && d == 0) continue;
            s[i] = d + '0';
            res.push_back(strToInt(s));
            s[i] = k + '0';
        }
    }
    return res;
}

vector<ll> allRes(int n) {
    vector<ll> res;
    for (int d = 0; d <= 9; d++) {
        vector<ll> a = allNumbers(n, d);
        for (const ll &x : a) res.push_back(x);
    }
    return res;
}

ll neEblanFind(ll x) {
    string s = to_string(x);
    int n = s.length();
    vector<ll> a1 = allRes(n);
//    for (ll y : a1) cout << y << endl;
    sort(a1.begin(), a1.end());
    a1.resize(unique(a1.begin(), a1.end()) - a1.begin());
    ll ans = 1e18 - 1;
    if (upper_bound(a1.begin(), a1.end(), x - 1) != a1.end()) {
        ans = min(ans, *upper_bound(a1.begin(), a1.end(), x - 1));
    }
    return ans;
}

ll stupidFind(ll x) {
    for (ll y = x;;y++) {
        if (check(y)) return y;
    }
}

int main() {
    ll x; cin >> x;
    int k; cin >> k;
    if (k == 0) {
        cout << findAllSame(x) << endl;
    } else {
        cout << neEblanFind(x) << endl;
    }
}