#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

string bin(int x) {
    string s;
    for (int i = 0; i < 3; i++) {
        if (x % 2 == 1) s += '1';
        else s += '0';
        x /= 2;
    }
    reverse(s.begin(), s.end());
    return s;
}

struct State {
    vector<int> numbers;
    int now;
    map<int, vector<int>> traverse = {{0b000, {0b000, 0b100, 0b001}},
                                            {0b001, {0b011, 0b110, 0b010}},
                                            {0b010, {0b000, 0b100, 0b001}},
                                            {0b011, {0b001, 0b000, 0b100}},
                                            {0b100, {0b000, 0b100, 0b001}},
                                            {0b110, {0b000, 0b100, 0b001}},
                                            {0b111, {0b000, 0b001, 0b010, 0b011, 0b100, 0b110}}};
    State(vector<int> x, int y) {
        numbers = x;
        now = y;
    }
    vector<pair<int, State>> nextStates() {
        vector<pair<int, State>> result;
        for (int i : traverse[now]) {
            numbers[i] -= 1;
            result.push_back({numbers[i] + 1, State(numbers, i)});
            numbers[i] += 1;
        }
        return result;
    }
    void display() {
        cout << "DISPLAYING STATE" << endl;
        cout << "0b000 " << numbers[0b000] << endl;
        cout << "0b001 " << numbers[0b001] << endl;
        cout << "0b010 " << numbers[0b010] << endl;
        cout << "0b011 " << numbers[0b011] << endl;
        cout << "0b100 " << numbers[0b100] << endl;
        cout << "0b110 " << numbers[0b110] << endl;
        cout << "NOW " << bin(now) << endl;
        cout << "ENDED" << endl;
    }
};

bool operator<(State a, State b) {
    return make_pair(a.numbers, a.now) < make_pair(b.numbers, b.now);
}

map<State, int> answer;

const int MOD = 1e9 + 7;

int mul(int a, int b) {
    return (long long) ((long long) a * (long long) b) % (long long) MOD;
}

int calc(State state, int k, int n) {
    for (int i : state.numbers) {
        if (i < 0) {
            return 0;
        }
    }
    if (answer.find(state) == answer.end()) {
        bool empty = true;
        for (int i : state.numbers) {
            if (i > 0) empty = false;
        }
        if (empty) {
            answer[state] = ((state.now == 0b100 || state.now == 0b110) && k == n);
        } else {
            vector<pair<int, State>> t = state.nextStates();
            int ans = 0;
            for (auto x : t) {
                ans += mul(x.first, calc(x.second, k + 1, n));
                ans %= MOD;
            }
            answer[state] = ans;
        }
//        state.display();
//        cout << "ANSWER FOR STATE ABOVE IS " << answer[state] << endl;
    }
    return answer[state];
}

int main() {
//    State state = State({0, 1, 1, 0, 1, 0, 1}, 0b001);
//    state.display();
//    for (auto x : state.nextStates()) {
//        x.second.display();
//    }
    string s1, s2, s3; cin >> s1 >> s2 >> s3;
    int n = s1.length();
    int a = 0, b = 0, c = 0, d = 0;
    int can_a = 0, can_c = 0;
    for (int i = 0; i < n; i++) {
        int u = s1[i] - '0', v = s2[i] - '0', w = s3[i] - '0';
        if (u + v == w) {
            if (u != 0 && v != 0) can_a++;
            else a++;
        }
        if (u + v + 1 == w) {
            if (u != 0 && v != 0) can_c++;
            else c++;
        }
        if (u + v == w + 10) {
            b++;
        }
        if (u + v + 1 == w + 10) d++;
    }
    vector<int> numbers = {a, b, c, d, can_a, 0, can_c, 0, 0};
    cout << calc(State(numbers, 0b111), 0, n) << endl;
}