#include <iostream>
#include <vector>
#include <string>

using namespace std;

using ll = long long;
using ull = unsigned long long;

template <typename T>
pair<ll, ll> ternary(T func, ll l, ll r) {
    while (r - l > 1) {
        ll d = (r - l + 1);
        ll l1 = l + d / 3;
        ll r1 = r - d / 3;
        ll f_l1 = func(l1);
        ll f_r1 = func(r1);
        if (f_l1 >= f_r1) {
            l = l1;
        }
        else {
            r = r1;
        }
    }
    return {l, r};
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    int t;
    cin >> t;
    while (t--) {
        ll n, m;
        cin >> n >> m;

        ll table_sum = n*m * (n*m + 1) / 2;
        auto row_sum = [&](int r) {
            return m*r * (m*r + 1) / 2;
        };
        auto row_func = [&](int r) {
            return abs(2 * row_sum(r - 1) - table_sum);
        };

        auto col_sum = [&](int c) {
            return (n*c * (c + 1) + n*m * c * (n - 1)) / 2;
        };


        auto col_func = [&](int c) {
            return abs(2 * col_sum(c - 1) - table_sum);
        };

        auto row_p = ternary(row_func, 1, n);
        auto col_p = ternary(col_func, 1, m);
        ll r_opt = row_p.first;
        if (row_func(row_p.second) < row_func(r_opt)) {
            r_opt = row_p.second;
        }
        ll c_opt = col_p.first;
        if (col_func(col_p.second) < col_func(c_opt)) {
            c_opt = col_p.second;
        }
        if (col_func(c_opt) <= row_func(r_opt)) {
            cout << "V " << c_opt << "\n";
        }
        else {
            cout << "H " << r_opt << "\n";
        }
    }

    return 0;
}
