#include <iostream>
#include <vector>
#include <string>

#define sz(a) (int)(a).size()
#define all(a) begin(a), end(a)

using namespace std;

using ll = long long;
using ull = unsigned long long;

struct Option {
    int t;
    int x;
    char z;
    int dlt;

    bool operator>(const Option& other) const {
        return dlt > other.dlt;
    }
    bool operator<(const Option& other) const {
        return dlt < other.dlt;
    }
};


ostream& operator<<(ostream& out, Option& option) {
    out << option.t << " " << option.x << " ";
    if (option.t != 2) {
        out << option.z << " ";
    }
    return out;
}

char neq(char c) {
    if (c == 'A') {
        return 'G';
    }
    return 'A';
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    string s;
    cin >> s;

    vector<pair<char, int>> a;
    for (int i = 0; i < sz(s); ++i) {
        int cnt;
        if (isdigit(s[i])) {
            cnt = s[i] - '0';
            ++i;
            while (isdigit(s[i])) {
                cnt *= 10;
                cnt += s[i] - '0';
            }
        }
        else {
            cnt = 1;
        }
        a.emplace_back(s[i], cnt);
    }

//    for (int i = 0; i < sz(a); ++i) {
//        cout << a[i].first << " " << a[i].second << "\n";
//    }

    vector<int> pref(sz(a));
    pref[0] = 0;
    for (int i = 1; i < sz(a); ++i) {
        pref[i] = pref[i - 1] + a[i - 1].second;
    }

    Option  min_ans = {2, 1, ' ', 0};

    for (int i = 0; i < sz(a); ++i) {
        Option option = min_ans;
        if (i > 0 && i < sz(a) - 1 && a[i - 1].first == a[i + 1].first && a[i].second == 1) {
            option = {2, pref[i] + 1, ' ',  -3};
        }
        else if (a[i].second == 2) {
            option = {2, pref[i] + 1, ' ', -1};
        }
        min_ans = min(min_ans, option);
    }

    Option max_ans = {1, 0, neq(a[0].first), +1};

    for (int i = 0; i < sz(a); ++i) {
        Option option = max_ans;
        if (a[i].second == 2) {
            option = {1, pref[i] + 1, neq(a[i].first), +1};
        }
        else if (a[i].second == 3) {
            option = {1, pref[i] + 1, neq(a[i].first), +2};
        }
        else if (a[i].second >= 4) {
            option = {1, pref[i] + 2, neq(a[i].first), +3};
        }
        max_ans = max(max_ans, option);
    }


    cout << min_ans << "\n" << max_ans;

    return 0;
}
