#include <iostream>
#include <vector>
#include <string>

#define sz(a) (int)(a).size()
#define all(a) begin(a), end(a)

using namespace std;

using ll = long long;
using ull = unsigned long long;


struct Option {
    int t;
    int x;
    char z;
    int dlt;

    Option(int t, int x, int dlt) : t(t), x(x), dlt(dlt) {}
    Option(int t, int x, int z, int dlt) : t(t), x(x), z(z), dlt(dlt) {}

    bool operator>(const Option& other) const {
        return dlt > other.dlt;
    }
    bool operator<(const Option& other) const {
        return dlt < other.dlt;
    }
};


ostream& operator<<(ostream& out, Option& option) {
    out << option.t << " " << option.x << " ";
    if (option.t != 2) {
        out << option.z << " ";
    }
    return out;
}


string code(vector<pair<char, int>>& a) {
    string res;
    for (int i = 0; i < sz(a); ++i) {
        if (a[i].second > 1) {
            res += to_string(a[i].second);
        }
        res += a[i].first;
    }
    return res;
}

string code(string& s) {
    string res;
    for (int i = 0; i < sz(s);) {
        int cnt = 1;
        char c = s[i];
        ++i;
        while (s[i] == c) {
            ++cnt;
            ++i;
        }
        if (cnt > 1) {
            res += to_string(cnt);
        }
        res += c;
    }
    return res;
}

string decode(string& s) {
    string res;
    for (int i = 0; i < sz(s); ++i) {
        int cnt;
        if (isdigit(s[i])) {
            cnt = s[i] - '0';
            ++i;
            while (isdigit(s[i])) {
                cnt *= 10;
                cnt += s[i] - '0';
                ++i;
            }
        }
        else {
            cnt = 1;
        }
        res += string(cnt, s[i]);
    }
    return res;
}

vector<pair<char, int>> decode_in_vec(string& s) {
    vector<pair<char, int>> a;
    for (int i = 0; i < sz(s); ++i) {
        int cnt;
        if (isdigit(s[i])) {
            cnt = s[i] - '0';
            ++i;
            while (isdigit(s[i])) {
                cnt *= 10;
                cnt += s[i] - '0';
                ++i;
            }
        }
        else {
            cnt = 1;
        }
        a.emplace_back(s[i], cnt);
    }
    return a;
}

vector<char> letters = {'A', 'G', 'C', 'T'};


int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    string s;
    cin >> s;


    string t = decode(s);

    Option min_ans(0, 0, 1e9);
    Option max_ans(0, 0, -1e9);

    int n = sz(t);

    for (int i = 0; i < n; ++i) {
        for (char c : letters) {
            string p = t;
            p.insert(p.begin() + i, c);
            string cmp = code(p);
            Option option(1, i, c, sz(cmp));
            min_ans = min(min_ans, option);
            max_ans = max(max_ans, option);
        }
    }

    for (int i = 0; i < n; ++i) {
        string p = t;
        p.erase(i, 1);
        string cmp = code(p);
        Option option(2, i + 1, sz(cmp));
        min_ans = min(min_ans, option);
        max_ans = max(max_ans, option);
    }

    for (int i = 0; i < n; ++i) {
        string p = t;
        for (char c : letters) {
            if (c != s[i]) {
                p[i] = s[i];
                string cmp = code(p);
                Option option(1, i, c, sz(cmp));
                min_ans = min(min_ans, option);
                max_ans = max(max_ans, option);
            }
        }
    }


    cout << min_ans << "\n" << max_ans;


}
