#include <iostream>
#include <vector>
#include <string>

#define sz(a) (int)(a).size()
#define all(a) begin(a), end(a)
#define F first
#define S second

using namespace std;

using ll = long long;
using ull = unsigned long long;


struct Option {
    int t;
    int x;
    char z;
    int dlt;

    Option(int t, int x, int dlt) : t(t), x(x), dlt(dlt) {}
    Option(int t, int x, int z, int dlt) : t(t), x(x), z(z), dlt(dlt) {}

    bool operator>(const Option& other) const {
        return dlt > other.dlt;
    }
    bool operator<(const Option& other) const {
        return dlt < other.dlt;
    }
};


ostream& operator<<(ostream& out, Option& option) {
    out << option.t << " " << option.x << " ";
    if (option.t != 2) {
        out << option.z << " ";
    }
    return out;
}


string code(vector<pair<char, int>>& a) {
    string res;
    for (int i = 0; i < sz(a); ++i) {
        if (a[i].second > 1) {
            res += to_string(a[i].second);
        }
        res += a[i].first;
    }
    return res;
}

string code(string& s) {
    string res;
    for (int i = 0; i < sz(s);) {
        int cnt = 1;
        char c = s[i];
        ++i;
        while (s[i] == c) {
            ++cnt;
            ++i;
        }
        if (cnt > 1) {
            res += to_string(cnt);
        }
        res += c;
    }
    return res;
}

string decode(string& s) {
    string res;
    for (int i = 0; i < sz(s); ++i) {
        int cnt;
        if (isdigit(s[i])) {
            cnt = s[i] - '0';
            ++i;
            while (isdigit(s[i])) {
                cnt *= 10;
                cnt += s[i] - '0';
                ++i;
            }
        }
        else {
            cnt = 1;
        }
        res += string(cnt, s[i]);
    }
    return res;
}

vector<pair<char, int>> decode_in_vec(string& s) {
    vector<pair<char, int>> a;
    for (int i = 0; i < sz(s); ++i) {
        int cnt;
        if (isdigit(s[i])) {
            cnt = s[i] - '0';
            ++i;
            while (isdigit(s[i])) {
                cnt *= 10;
                cnt += s[i] - '0';
                ++i;
            }
        }
        else {
            cnt = 1;
        }
        a.emplace_back(s[i], cnt);
    }
    return a;
}

vector<char> letters = {'A', 'G', 'C', 'T'};


int len(int n) {
    if (n == 1)
        return 0;
    int l = 0;
    while (n > 0) {
        ++l;
        n /= 10;
    }
    return l;
}

char neq(char c) {
    if (c == 'A') {
        return 'G';
    }
    return 'A';
}


int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    string s;
    cin >> s;

    Option min_ans(0, 0, 1e9);
    Option max_ans(0, 0, -1e9);


    vector<pair<char, int>> a = decode_in_vec(s);


     vector<int> pref(sz(a));
    pref[0] = 0;
    for (int i = 1; i < sz(a); ++i) {
        pref[i] = pref[i - 1] + a[i - 1].second;
    }

    int n = sz(a);

    for (int i = 0; i < n; ++i) {
        {
            char c = neq(a[i].F);
            int dlt = 1;
            int prv = 0;
            if (i != 0) {
                prv = pref[i - 1];
            }
            Option option(1, prv, c, dlt);
            min_ans = min(min_ans, option);
            max_ans = max(max_ans, option);
        }
        for (int j = 1; j < a[i].S; ++j) {
            char c = neq(a[i].F);
            int cur_len = len(a[i].F) + 1;
            int new_len = len(j) + 1 + 1 + len(a[i].S - j) + 1;
            int dlt = cur_len - new_len;
            int prv = 0;
            if (i != 0) {
                prv = pref[i - 1];
            }
            Option option(1, prv + j, c, dlt);
            min_ans = min(min_ans, option);
            max_ans = max(max_ans, option);
        }
    }
    {
        char c = neq(a.back().F);
        int prv = pref.back() + a.back().S;
        int dlt = 1;
        Option option(1, prv, c, dlt);
        min_ans = min(min_ans, option);
        max_ans = max(max_ans, option);
    }

    for (int i = 0; i < n; ++i) {
        int dlt;
        if (i != 0) {
            prv = pref[i - 1];
        }
        if (a[i].S == 1) {
            dlt = -1;
        }
        else {
            dlt = len(a[i].S) - len(a[i].S - 1);
        }
        Option option(2, prv + 1, dlt);
        min_ans = min(min_ans, option);
        max_ans = max(max_ans, option);
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 1; j < a[i].S - 1; ++j) {
            char c = neq(a[i].F);
            int cur_len = len(a[i].F) + 1;
            int new_len = len(j - 1) + 1 + len(a[i].S - j - 1) + 1 + 1;
            int dlt = cur_len - new_len;
            int prv = 0;
            if (i != 0) {
                prv = pref[i - 1];
            }
            prv += j;
            Option option(3, prv + 1, dlt);
            min_ans = min(min_ans, option);
            max_ans = max(max_ans, option);
        }
    }

    cout << min_ans << "\n" << max_ans;

}
