#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<int> solve1(vector<int> len, vector<vector<int> > a)
{
    vector<int> p(len.size());
    iota(p.begin(), p.end(), 0);
    while (1)
    {
        vector<int> positions;
        int L = 0;
        for (int i = 0; i < len.size(); i++)
        {
            for (auto e : a[p[i]])
                positions.push_back(e + L);
            L += len[p[i]];
        }
        int t = 1;
        for (int i = 0; i + 2 < positions.size(); i++)
        {
            if (positions[i + 2] - positions[i + 1] != positions[i + 1] - positions[i])
                t = 0;
        }
        if (t)
            return p;
        if (!next_permutation(p.begin(), p.end()))
            break;
    }
    return {};
}

struct FindTour{
    vector<int> fr, to, used;
    vector<vector<int> > g;
    vector<int> pnt;
    vector<int> res;
    map<pair<int, int>, vector<int> > mm;
    FindTour(int _n)
    {
        g.resize(_n);
        pnt.resize(_n);
    }
    void AddEdge(int f, int t)
    {
        fr.push_back(f);
        to.push_back(t);
        used.push_back(0);
        mm[{f, t}].push_back(fr.size() - 1);
        g[f].push_back(fr.size() - 1);
    }
    void dfs(int v)
    {
        //res.push_back(v);
        for (; pnt[v] < g[v].size(); pnt[v]++)
        {
            int e = g[v][pnt[v]];
            if (!used[e])
            {
                used[e] = 1;
                //res.push_back(e);
                dfs(to[e]);
                res.push_back(v);
                //res.push_back(e);
            }
        }
    }
    vector<int> Tour()
    {
        int n = g.size();
        vector<int> in(n), out(n);
        for (int i = 0; i < fr.size(); i++)
        {
            out[fr[i]]++;
            in[to[i]]++;
        }
        vector<int> st, fn;
        for (int i = 0; i < n; i++)
        {
            if (abs(in[i] - out[i]) >= 2) return {};
            if (in[i] < out[i]) st.push_back(i);
            if (out[i] < in[i]) fn.push_back(i);
        }
        if (st.size() > 1 || fn.size() > 1)
        {
            return {};
        }
        int fl = 0;
        if (st.size())
        {
            AddEdge(fn[0], st[0]);
            fl = 1;
        }
        dfs(0);
        if (res.size() == 0) return {};
        reverse(res.begin(), res.end());
        vector<int> res2;
        for (int i = 0; i < res.size(); i++)
        {
            int F = res[i], T = res[(i + 1) % res.size()];
            res2.push_back(mm[{F, T}].back());
            mm[{F, T}].pop_back();
        }
        res = res2;
        if (res.size() != fr.size())
        {
            return {};
        }
        if (!fl)
        {
            return res;
        }
        if (fl)
        {
            vector<int> kek;
            int pos = 0;
            for (int i = 0; i < res.size(); i++) if (res[i] + 1 == fr.size()) pos = i;
            for (int i = pos + 1; i < res.size(); i++) kek.push_back(res[i]);
            for (int i = 0; i < pos; i++) kek.push_back(res[i]);
            return kek;
        }
    }
};

vector<int> solve2(vector<int> len, vector<vector<int> > a, int d)
{
    int n = len.size();
    map<int, int> nodes;
    int it = 0;
    vector<int> fr, to;
    for (int i = 0; i < n; i++)
    {
        int B = a[i][0];
        int E = len[i] - a[i].back();
        int F, T;
        if (nodes.find(B) == nodes.end())
        {
            nodes[B] = it++;
        }
        if (nodes.find(d - E) == nodes.end())
        {
            nodes[d - E] = it++;
        }
        F = nodes[B];
        T = nodes[d - E];
        fr.push_back(F);
        to.push_back(T);
    }
    FindTour T(it);
    for (int i = 0; i < n; i++)
    {
        T.AddEdge(fr[i], to[i]);
    }
    vector<int> res = T.Tour();
    return res;
}

int main()
{
    if (0)
    {
        FindTour T(7);
        T.AddEdge(3, 4); // 1
        T.AddEdge(4, 3); // 2
        T.AddEdge(4, 4);
        T.AddEdge(1, 4); // 4
        T.AddEdge(4, 2);
        T.AddEdge(0, 2); // 6
        T.AddEdge(2, 5);
        T.AddEdge(2, 3); // 8
        T.AddEdge(5, 0);
        T.AddEdge(0, 1); // 10
        T.AddEdge(3, 0);
        T.AddEdge(0, 6); // 12
        vector<int> res = T.Tour();
        cout << res.size() << "\n";
        for (auto e : res)
            cout << e + 1 << " ";
        cout << "\n";
        return 0;
    }
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> len(n);
    vector<vector<int> > a(n);
    int total = 0;
    for (int i = 0; i < n; i++)
    {
        int m;
        cin >> m >> len[i];
        total += m;
        a[i] = vector<int>(m);
        for (int j = 0; j < m; j++)
        {
            cin >> a[i][j];
        }
    }
    if (total > n)
    {
        set<int> dc;
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j + 1 < a[i].size(); j++)
            {
                dc.insert(a[i][j + 1] - a[i][j]);
            }
        }
        if (dc.size() > 1)
        {
            cout << "No\n";
            return 0;
        }
        int d = *dc.begin();
        vector<int> ans = solve2(len, a, d);
        if (ans.size() == 0)
        {
            cout << "No\n";
            return 0;
        }
        cout << "Yes" << "\n";
        for (auto e : ans)
            cout << e + 1 << " ";
        return 0;
    }
    assert(total == n);
    cout << "No\n";
}
