#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

bool check(vector<int> &aa, vector<int> &bb, vector<int> &cc) {
    if (aa[0] == 0 || bb[0] == 0 || cc[0] == 0) {
        return false;
    }
    int last = 0;
    for (int i = aa.size() - 1; i >= 0; i--) {
        if (aa[i] + bb[i] + last != cc[i]) {
            return false;
        }
        last = 0;
        if (aa[i] + bb[i] + last > 9) {
            last = 1;
        }
    }
    return true;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    string a, b, c;
    cin >> a >> b >> c;
    int n = a.size();
    vector<int> aa(n);
    vector<int> bb(n);
    vector<int> cc(n);
    for (int i = 0; i < n; i++) {
        aa[i] = (int) (a[i] - '0');
        bb[i] = (int) (b[i] - '0');
        cc[i] = (int) (c[i] - '0');
    }
    vector<int> out(n, 0);
    vector<int> in(n, 0);
    vector<int> inout(n, 0);
    vector<int> zero(n, 0);
    vector<int> outh;
    vector<int> inh;
    vector<int> inh_not_zero;
    vector<int> not_zero;
    vector<int> inouth;
    vector<int> zeroh;

    long long n_out = 0, n_in = 0, n_all = 0, n_noth = 0;
    for (int i = 0; i < n; i++) {
        if (aa[i] == 0 || bb[i] == 0 || cc[i] == 0) {
            zero[i] = 1;
            zeroh.push_back(i);
        }
        if (aa[i] + bb[i] == 9 && (aa[i] + bb[i]) % 10 == cc[i] - 1) {
            inout[i] = 1;
            inouth.push_back(i);
        }
        if (aa[i] + bb[i] > 9) {
            if ((aa[i] + bb[i]) % 10 != cc[i] && ((aa[i] + bb[i]) % 10) + 1 != cc[i]) {
                cout << 0;
                return 0;
            }
            out[i] = 1;
            if (inout[i] == 0) {
                outh.push_back(i);
            }
            n_out++;
        }
        if ((aa[i] + bb[i]) % 10 == cc[i] - 1) {
            in[i] = 1;
            n_in++;
            if (inout[i] == 0) {
                if (zero[i] == 0) {
                    inh_not_zero.push_back(i);
                }
                inh.push_back(i);
            }
        } else if ((aa[i] + bb[i]) % 10 != cc[i] && (aa[i] + bb[i]) % 10 == cc[i] - 1) {
            cout << 0;
            return 0;
        }
        if (zero[i] == 0 && in[i] == 0 && out[i] == 0 && inout[i] == 0) {
            not_zero.push_back(i);
        }
    }
    if (n_in < n_out) {
        cout << 0;
        return 0;
    }
    vector<int> used(n, 0);
    int now = 0;
    if (inh_not_zero.size() != 0) {
        used[inh_not_zero[inh_not_zero.size() - 1]] = 1;
        swap(aa[now], aa[inh_not_zero[inh_not_zero.size() - 1]]);
        swap(bb[now], bb[inh_not_zero[inh_not_zero.size() - 1]]);
        swap(cc[now], cc[inh_not_zero[inh_not_zero.size() - 1]]);
        now++;
    } else {
        swap(aa[now], aa[not_zero[not_zero.size() - 1]]);
        swap(bb[now], bb[not_zero[not_zero.size() - 1]]);
        swap(cc[now], cc[not_zero[not_zero.size() - 1]]);
    }
    now++;
    while (inh.size() > 0) {
        if (used[inh[inh.size() - 1]]) {
            inh.pop_back();
        }
        swap(aa[now], aa[inh[inh.size() - 1]]);
        swap(bb[now], bb[inh[inh.size() - 1]]);
        swap(cc[now], cc[inh[inh.size() - 1]]);
        inh.pop_back();
        now++;
        if (outh.size() > 0) {
            while (inouth.size() > 0) {
                swap(aa[now], aa[inouth[inouth.size() - 1]]);
                swap(bb[now], bb[inouth[inouth.size() - 1]]);
                swap(cc[now], cc[inouth[inouth.size() - 1]]);
                now++;
                inouth.pop_back();
            }
            swap(aa[now], aa[outh[outh.size() - 1]]);
            swap(bb[now], bb[outh[outh.size() - 1]]);
            swap(cc[now], cc[outh[outh.size() - 1]]);
            outh.pop_back();
            now++;
        } else {
            cout << 0;
            return 0;
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) {
                continue;
            }
            swap(aa[i], aa[j]);
            swap(bb[i], bb[j]);
            swap(cc[i], cc[j]);
            if (check(aa, bb, cc)) {
                ans++;
            }
            swap(aa[i], aa[j]);
            swap(bb[i], bb[j]);
            swap(cc[i], cc[j]);
        }
    }
    cout << ans;
}