#include <bits/stdc++.h>

using namespace std;

int encode_length(int num) {
	if(num == 1) {
		return 0;
	}
	int c = 0;
	while(num) {
		c++;
		num /= 10;
	}
	return c;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	string s;
	cin >> s;

	vector< pair<int, char> > blocks;

	char prev = '\0';
	int curcnt = 0;
	for(char c: s) {
		if(isdigit(c)) {
			if(isdigit(prev)) {
				curcnt = curcnt * 10 + (c - '0');
			} else {
				curcnt = c - '0';
			}
		} else {
			if(!isdigit(prev)) {
				curcnt = 1;
			}
			blocks.emplace_back(curcnt, c);
		}
		prev = c;
	}

	int mindiff = 1000000000;
	int maxdiff = -1000000000;
	tuple<int, int, char> minbest{0, 0, '?'};
	tuple<int, int, char> maxbest{0, 0, '?'};

	int prefsize = 0;
	for(int i = 0; i < blocks.size(); i++) {
		auto [x, c] = blocks[i];

		// Replace
		if(x == 1) {
			// Replace single char
			for(char newc: {'A', 'C', 'T', 'G'}) {
				if(newc == c) {
					continue;
				}

				bool matchleft = i > 0 && blocks[i - 1].second == newc;
				bool matchright = i < blocks.size() - 1 && blocks[i + 1].second == newc;

				if(matchleft && matchright) {
					int diff = -encode_length(blocks[i - 1].first) - 1 - 1 - encode_length(blocks[i + 1].first) - 1 + encode_length(blocks[i - 1].first + 1 + blocks[i + 1].first) + 1;
					if(diff < mindiff) {
						mindiff = diff;
						minbest = {3, prefsize, newc};
					}
					if(false && diff > maxdiff) {
						maxdiff = diff;
						maxbest = {3, prefsize, newc};
					}
				} else if(matchleft) {
					int diff = -encode_length(blocks[i - 1].first) - 1 + encode_length(blocks[i - 1].first + 1);
					if(diff < mindiff) {
						mindiff = diff;
						minbest = {3, prefsize, newc};
					}
					if(false && diff > maxdiff) {
						maxdiff = diff;
						maxbest = {3, prefsize, newc};
					}
				} else if(matchright) {
					int diff = -encode_length(blocks[i + 1].first) - 1 + encode_length(blocks[i + 1].first + 1);
					if(diff < mindiff) {
						mindiff = diff;
						minbest = {3, prefsize, newc};
					}
					if(false && diff > maxdiff) {
						maxdiff = diff;
						maxbest = {3, prefsize, newc};
					}
				}
			}
		} else {
			// Replace in block
			for(char newc: {'A', 'C', 'T', 'G'}) {
				if(newc == c) {
					continue;
				}

				// Replace left
				int diff = -encode_length(x) + encode_length(x - 1);
				if(i > 0 && blocks[i - 1].second == newc) {
					diff += -encode_length(blocks[i - 1].first) + encode_length(blocks[i - 1].first + 1);
				} else {
					diff++;
				}
				if(diff < mindiff) {
					mindiff = diff;
					minbest = {3, prefsize, newc};
				}
				if(false && diff > maxdiff) {
					maxdiff = diff;
					maxbest = {3, prefsize, newc};
				}

				// Replace right
				diff = -encode_length(x) + encode_length(x - 1);
				if(i < blocks.size() - 1 && blocks[i + 1].second == newc) {
					diff += -encode_length(blocks[i + 1].first) + encode_length(blocks[i + 1].first + 1);
				} else {
					diff++;
				}
				if(diff < mindiff) {
					mindiff = diff;
					minbest = {3, prefsize + x - 1, newc};
				}
				if(false && diff > maxdiff) {
					maxdiff = diff;
					maxbest = {3, prefsize + x - 1, newc};
				}

				// Replace inbetween
				for(int pos: {1, 2, 9, 10, 99, 100, 999, 1000, 9999, 10000, 99999, 100000, 999999, 1000000, 9999999, 10000000, 99999999, 100000000, 999999999, 1000000000, x - 3, x - 2, x - 1}) {
					if(pos < 1 || pos >= x) {
						continue;
					}

					int diff = -encode_length(x) - 1 + encode_length(pos) + 1 + encode_length(x - pos - 1) + 1 + 1;
					if(diff < mindiff) {
						mindiff = diff;
						minbest = {3, prefsize + pos, newc};
					}
					if(false && diff > maxdiff) {
						maxdiff = diff;
						maxbest = {3, prefsize + pos, newc};
					}
				}
			}
		}

		// Delete
		if(x == 1) {
			// Delete single char
			if(i > 0 && i < blocks.size() - 1 && blocks[i - 1].second == blocks[i + 1].second) {
				int diff = -encode_length(blocks[i - 1].first) - 1 - 1 - encode_length(blocks[i + 1].first) - 1 + encode_length(blocks[i - 1].first + blocks[i + 1].first) + 1;
				if(diff < mindiff) {
					mindiff = diff;
					minbest = {2, prefsize, ' '};
				}
				if(false && diff > maxdiff) {
					maxdiff = diff;
					maxbest = {2, prefsize, ' '};
				}
			} else {
				int diff = -1;
				if(diff < mindiff) {
					mindiff = diff;
					minbest = {2, prefsize, ' '};
				}
				if(false && diff > maxdiff) {
					maxdiff = diff;
					maxbest = {2, prefsize, ' '};
				}
			}
		} else {
			// Delete inbetween
			int diff = -encode_length(x) + encode_length(x - 1);
			if(diff < mindiff) {
				mindiff = diff;
				minbest = {2, prefsize, ' '};
			}
			if(false && diff > maxdiff) {
				maxdiff = diff;
				maxbest = {2, prefsize, ' '};
			}
		}

		// Insert to the left
		for(char newc: {'A', 'C', 'T', 'G'}) {
			if(newc == c) {
				int diff = -encode_length(x) + encode_length(x + 1);
				if(diff < mindiff) {
					mindiff = diff;
					minbest = {1, prefsize - 1, newc};
				}
				if(diff > maxdiff) {
					maxdiff = diff;
					maxbest = {1, prefsize - 1, newc};
				}
			} else if(i > 0 && newc == blocks[i - 1].second) {
				continue;
			} else {
				int diff = 1;
				if(diff < mindiff) {
					mindiff = diff;
					minbest = {1, prefsize - 1, newc};
				}
				if(diff > maxdiff) {
					maxdiff = diff;
					maxbest = {1, prefsize - 1, newc};
				}
			}
		}

		// Insert inbetween
		for(char newc: {'A', 'C', 'T', 'G'}) {
			if(newc == c) {
				continue;
			}

			for(int pos: {1, 2, 9, 10, 99, 100, 999, 1000, 9999, 10000, 99999, 100000, 999999, 1000000, 9999999, 10000000, 99999999, 100000000, 999999999, 1000000000, x - 2, x - 1}) {
				if(pos < 1 || pos >= x) {
					continue;
				}

				int diff = -encode_length(x) - 1 + encode_length(pos) + 1 + 1 + encode_length(x - pos) + 1;
				if(diff < mindiff) {
					mindiff = diff;
					minbest = {1, prefsize + pos - 1, newc};
				}
				if(diff > maxdiff) {
					maxdiff = diff;
					maxbest = {1, prefsize + pos - 1, newc};
				}
			}
		}

		prefsize += x;
	}

	cerr << mindiff << "/" << maxdiff << endl;
	cout << get<0>(minbest) << " " << get<1>(minbest) + 1 << " " << get<2>(minbest) << endl;
	cout << get<0>(maxbest) << " " << get<1>(maxbest) + 1 << " " << get<2>(maxbest) << endl;

	return 0;
}