#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MOD = 1000000007;

int fastpow(int a, int n) {
	if(n == 0) {
		return 1;
	}
	if(n == 1) {
		return a;
	}
	int x = fastpow(a, n / 2);
	x = x * x % MOD;
	if(n % 2 == 1) {
		x = x * a % MOD;
	}
	return x;
}

int c(int n, int k) {
	int ans = 1;
	for(int i = n - k + 1; i <= n; i++) {
		ans *= i;
		ans %= MOD;
	}
	int div = 1;
	for(int i = 1; i <= k; i++) {
		div *= i;
		div %= MOD;
	}
	return ans * fastpow(div, MOD - 2) % MOD;
}

int numseparat(int num, int n) {
	if(n == 0) {
		return num == 0;
	}
	return c(num + n - 1, n - 1);
}

signed main() {
	string a, b, c;
	cin >> a >> b >> c;

	int n = a.size();

	string s(n, '#');
	string carry(n, '#');
	string d(n, '#');
	for(int i = 0; i < n; i++) {
		a[i] -= '0';
		b[i] -= '0';
		c[i] -= '0';
		s[i] = a[i] + b[i];
		carry[i] = (10 + c[i] - s[i]) % 10;
		if(carry[i] > 1) {
			cout << 0 << endl;
			return 0;
		}
		d[i] = s[i] + carry[i] >= 10;
	}

	int ans = 0;

	for(int first = 0; first < n; first++) {
		if(!(!d[first] && a[first] != 0 && b[first] != 0 && c[first] != 0)) {
			continue;
		}

		vector< pair<int, int> > edges;
		for(int i = 0; i < n; i++) {
			edges.emplace_back(d[i], carry[i]);
		}

		vector< pair<int, int> > order;
		int cnt_by_type[4];
		memset(cnt_by_type, 0, sizeof(cnt_by_type));
		for(int i = 0; i < n; i++) {
			if(i != first) {
				cnt_by_type[edges[i].first * 2 + edges[i].second]++;
				if(edges[i].first != edges[i].second) {
					order.push_back(edges[i]);
				}
			}
		}
		sort(order.begin(), order.end());

		int localans = 0;

		if(order.size() == 0) {
			localans = carry[first] == 0;
		} else {
			if(carry[first] == 0) {
				// 0 -> 1 -> 0 -> 1 -> 0
				localans = cnt_by_type[1] == cnt_by_type[2];
			} else {
				// 1 -> 0 -> 1 -> 0
				localans = cnt_by_type[1] + 1 == cnt_by_type[2];
			}
		}

		for(int x: cnt_by_type) {
			for(int i = 1; i <= x; i++) {
				localans *= i;
				localans %= MOD;
			}
		}

		int to[2];
		to[0] = to[1] = 0;
		to[carry[first]]++;
		for(int i = 0; i < order.size(); i++) {
			to[order[i].second]++;
		}
		int coeff = numseparat(cnt_by_type[0], to[0]) * numseparat(cnt_by_type[3], to[1]) % MOD;

		localans *= coeff;
		localans %= MOD;

		ans += localans;
	}

	ans %= MOD;

	cout << ans << endl;

	return 0;
}