#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MOD = 1000000007;

int fastpow(int a, int n) {
	if(n == 0) {
		return 1;
	}
	if(n == 1) {
		return a;
	}
	int x = fastpow(a, n / 2);
	x = x * x % MOD;
	if(n % 2 == 1) {
		x = x * a % MOD;
	}
	return x;
}

int factorial(int n) {
	int ans = 1;
	for(int i = 1; i <= n; i++) {
		ans = ans * i % MOD;
	}
	return ans;
}

int c(int n, int k) {
	int ans = 1;
	for(int i = n - k + 1; i <= n; i++) {
		ans *= i;
		ans %= MOD;
	}
	return ans * fastpow(factorial(k), MOD - 2) % MOD;
}

map<pair<int, int>, int> cache;
int numseparat(int num, int n) {
	if(n == 0) {
		return num == 0;
	}
	if(cache.count({num, n})) {
		return cache[{num, n}];
	}
	return cache[{num, n}] = c(num + n - 1, n - 1);
}

signed main() {
	string a, b, c;
	cin >> a >> b >> c;

	int n = a.size();

	string s(n, '#');
	string carry(n, '#');
	string d(n, '#');
	for(int i = 0; i < n; i++) {
		a[i] -= '0';
		b[i] -= '0';
		c[i] -= '0';
		s[i] = a[i] + b[i];
		carry[i] = (10 + c[i] - s[i]) % 10;
		if(carry[i] > 1) {
			cout << 0 << endl;
			return 0;
		}
		d[i] = s[i] + carry[i] >= 10;
	}

	int ans = 0;

	vector<int> edges(n);
	for(int i = 0; i < n; i++) {
		edges[i] = d[i] * 2 + carry[i];
	}

	int to[2];
	to[0] = to[1] = 0;
	for(int i = 0; i < n; i++) {
		if(edges[i] == 1 || edges[i] == 2) {
			to[edges[i] % 2]++;
		}
	}

	int cnt_by_type[4];
	memset(cnt_by_type, 0, sizeof(cnt_by_type));
	for(int i = 0; i < n; i++) {
		cnt_by_type[edges[i]]++;
	}

	int cbtfactorial = 1;
	for(int i = 0; i < 4; i++) {
		cbtfactorial *= factorial(cnt_by_type[i]);
		cbtfactorial %= MOD;
	}

	for(int first = 0; first < n; first++) {
		if(!(!d[first] && a[first] != 0 && b[first] != 0 && c[first] != 0)) {
			continue;
		}

		int local_cnt_by_type[4];
		memcpy(local_cnt_by_type, cnt_by_type, sizeof(cnt_by_type));
		local_cnt_by_type[edges[first]]--;

		int localans;
		if(carry[first] == 0) {
			// 0 -> 1 -> 0 -> 1 -> 0
			localans = local_cnt_by_type[1] == local_cnt_by_type[2];
		} else {
			// 1 -> 0 -> 1 -> 0
			localans = local_cnt_by_type[1] + 1 == local_cnt_by_type[2];
		}

		if(!localans) {
			continue;
		}

		localans = cbtfactorial;

		localans *= fastpow(cnt_by_type[edges[first]], MOD - 2);
		localans %= MOD;

		int localto[2];
		localto[0] = to[0];
		localto[1] = to[1];
		localto[carry[first]]++;
		if(edges[first] == 1 || edges[first] == 2) {
			localto[edges[first] % 2]--;
		}
		int coeff = numseparat(local_cnt_by_type[0], localto[0]) * numseparat(local_cnt_by_type[3], localto[1]) % MOD;

		localans *= coeff;
		localans %= MOD;

		ans += localans;
	}

	ans %= MOD;

	cout << ans << endl;

	return 0;
}