#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using int128 = __int128;

#define len(a) int((a).size())
#define all(a) (a).begin(), (a).end()
#define forn(i, l, r) for (int i = (l); i < (r); i++)

#ifdef LOCAL
#include "/home/olymp/codes/debug.h"
#else
#define dbg(...)
#endif

const int128 INF = int128(1e30);

inline int128 getSum(ll x) {
	return int128(x) * (x + 1) / 2;
}

inline int128 myAbs(int128 x) {
	if (x < 0) return -x;
	return x;
}

inline array<int128, 3> solveCol(ll n, ll m) {
	int128 sumAll = getSum(n * m);

	auto solve = [&](ll mid) {
		int128 base = getSum(mid);
		int128 step = int128(m) * mid;
		int128 sumDown = getSum(n - 1) * step + int128(n) * base;
		return sumDown;
	};

	ll l = 0, r = m;
	while (r - l > 1) {
		ll mid = (l + r) / 2;
		if (solve(mid) * 2 <= sumAll) l = mid;
		else r = mid;
	}

	auto get = [&](ll val) {
		int128 sumDown = solve(val);
		return array<int128, 3>{myAbs(sumAll - 2 * sumDown), 1, val};
	};

	array<int128, 3> ans{INF, INF, INF};
	if (l) ans = min(ans, get(l));
	if (l + 1 != m) ans = min(ans, get(l + 1));
	// dbg("solveCol", ans);
	return ans;
}

inline array<int128, 3> solveRow(ll n, ll m) {
	int128 sumAll = getSum(n * m);

	auto solve = [&](ll mid) {
		return getSum(mid * m);
	};

	ll l = 0, r = n;
	while (r - l > 1) {
		ll mid = (l + r) / 2;
		if (solve(mid) * 2 <= sumAll) l = mid;
		else r = mid;
	}

	auto get = [&](ll val) {
		int128 sumDown = solve(val);
		return array<int128, 3>{myAbs(sumAll - 2 * sumDown), 0, val};
	};

	array<int128, 3> ans{INF, INF, INF};
	if (l) ans = min(ans, get(l));
	if (l + 1 != n) ans = min(ans, get(l + 1));
	// dbg("solveRow", ans);
	return ans;
}

void solve() {
	ll n, m;
	cin >> n >> m;

	auto ans = min(solveCol(n, m), solveRow(n, m));
	assert(ans[0] != INF);

	if (ans[1] == 1) cout << "V ";
	else if (ans[1] == 0) cout << "H ";
	else assert(false);
	cout << ll(ans[2]) + 1 << '\n';
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int t;
	cin >> t;
	while (t--) solve();
}
