#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define len(a) int((a).size())
#define all(a) (a).begin(), (a).end()
#define forn(i, l, r) for (int i = (l); i < (r); i++)

#ifdef LOCAL
#include "/home/olymp/codes/debug.h"
#else
#define dbg(...)
#endif

inline void gg() {
	cout << "No\n";
	exit(0);
}

void dfsEuler(int v, vector<vector<pair<int, int>>> &g, vector<int> &euler, vector<char> &used) {
	while (len(g[v])) {
		auto [u, id] = g[v].back();
		g[v].pop_back();
		if (used[id]) continue;

		used[id] = 1;
		dfsEuler(u, g, euler, used);
		// euler.push_back(u);
		euler.push_back(v);
	}
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n;
	cin >> n;
	vector<pair<int, int>> a;
	int del = -1;
	forn (i, 0, n) {
		int m, s;
		cin >> m >> s;
		vector<int> positions(m);
		forn (j, 0, m) cin >> positions[j];
		a.emplace_back(positions[0], s - positions.back());
		if (m == 1) continue;

		forn (j, 1, m) {
			int cur = positions[j] - positions[j - 1];
			if (del == -1) del = cur;
			else if (del != cur) gg();
		}
	}

	// auto brute = [&]() {
	// 	vector<int> perm(n);
	// 	iota(all(perm), 0);
	// 	do {
	// 		bool ok = true;
	// 		int curVal = -1;
	// 		forn (i, 1, n) {
	// 			int cur = perm[i];
	// 			int prev = perm[i - 1];
	// 			int x = a[cur].first + a[prev].second;
	// 			if (del != -1) ok &= (x == del);
	// 			else if (curVal == -1) curVal = x;
	// 			else ok &= (curVal == x);
	// 		}
	// 		if (ok) {
	// 			cout << "Yes\n";
	// 			forn (i, 0, n) cout << perm[i] + 1 << " \n"[i == n - 1];
	// 			exit(0);
	// 		}
	// 	} while (next_permutation(all(perm)));
	// 	gg();
	// };
	// if (n <= 8) brute();

	auto check = [&](vector<int> &perm, int del) {
		if (len(perm) != n) return;

		bool correct = true;
		forn (i, 1, n) {
			int cur = perm[i];
			int prev = perm[i - 1];
			int x = a[prev].second + a[cur].first;
			correct &= (x == del);
			if (!correct) break;
		}

		if (correct) {
			cout << "Yes\n";
			forn (i, 0, n) cout << perm[i] + 1 << " \n"[i == n - 1];
			exit(0);
		}
	};

	auto solveFixed = [&](int del) {
		dbg("start checking", del);

		map<int, vector<int>> classes;
		forn (i, 0, n) classes[a[i].first].push_back(i);
		int nClasses = len(classes);

		map<int, int> index;
		int curIndex = n;
		for (auto [cl, vec] : classes) {
			index[cl] = curIndex;
			curIndex++;
		}

		vector<vector<pair<int, int>>> g(n + nClasses);
		int curId = 0;
		auto addEdge = [&](int v, int u) {
			g[v].emplace_back(u, curId);
			g[u].emplace_back(v, curId);
			dbg(v, u);
			curId++;
		};

		forn (i, 0, n) {
			int sec = a[i].second;
			if (sec > del) continue;
			if (classes.find(del - sec) == classes.end()) continue;
			addEdge(i, index[del - sec]);
		}

		forn (i, 0, n) {
			int fir = a[i].first;
			if (fir > del) continue;
			addEdge(index[fir], i);
		}

		vector<int> odd;
		forn (i, 0, n + nClasses) {
			if (len(g[i]) % 2) odd.push_back(i);
		}
		assert(len(odd) % 2 == 0);
		if (len(odd) > 2) return;

		int ver = -1;
		if (len(odd) == 2) {
			int v = odd[0];
			int u = odd[1];
			addEdge(v, u);
			dbg("dop", v, u);
			ver = v;
		}

		vector<int> euler;
		vector<char> used(curId);
		forn (i, 0, n) dfsEuler(i, g, euler, used);

		if (ver != -1) {
			rotate(euler.begin(), find(all(euler), ver), euler.end());
		}
		if (!len(euler)) euler = {0};

		vector<int> ord;
		forn (i, 0, len(euler)) {
			if (euler[i] < n) ord.push_back(euler[i]);
		}

		dbg(euler);
		dbg(ord);

		check(ord, del);
		reverse(all(ord));
		check(ord, del);

		dbg("finish checking", del);
	};

	if (del != -1) solveFixed(del);
	else {
		map<int, int> cnt;
		forn (i, 0, n) {
			forn (j, 0, n) {
				if (i != j) cnt[a[i].first + a[j].second]++;
			}
		}
		for (auto [x, num] : cnt) {
			// if (num >= n - 1) solveFixed(x);
			solveFixed(x);
		}
		solveFixed(0);
	}
	gg();
}
