#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define len(a) int((a).size())
#define all(a) (a).begin(), (a).end()
#define forn(i, l, r) for (int i = (l); i < (r); i++)

#ifdef LOCAL
#include "/home/olymp/codes/debug.h"
#else
#define dbg(...)
#endif

const vector<int> p3{13, 9, 27, 81, 243, 729, 2187, 6561, 19683, 59049, 177147};

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

inline int r(int l, int r) {
	return l + rng() % (r - l + 1);
}

vector<vector<int>> prec{
	{0, 0, 1, 2, 2, 3, 3, 3, 1, 1},
	{0, 1, 1, 1, 2, 2, 3, 1, 1, 2},
	{1, 1, 2, 1, 1, 2, 2, 3, 1, 3},
	{1, 2, 2, 2, 1, 1, 2, 2, 3, 3},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
};

void bruteSolve(int n, int m, int c) {
	vector<int> pc(n * m + 1, 1);
	forn (i, 1, n * m + 1) pc[i] = pc[i - 1] * c;

	auto getBit = [&](int mask, int bit) {
		return (mask / pc[bit]) % c;
	};

	forn (mask, 0, pc.back()) {
		vector<vector<int>> grid(n, vector<int>(m));
		forn (i, 0, n) {
			forn (j, 0, m) grid[i][j] = getBit(mask, i * m + j);
		}

		bool ok = true;
		forn (i, 0, n) {
			forn (j, 0, m) {
				forn (ii, i + 1, n) {
					forn (jj, j + 1, m) {
						if (grid[i][j] == grid[ii][j] && grid[i][j] == grid[ii][jj] && grid[i][j] == grid[i][jj]) {
							ok = false;
							break;
						}
					}
					if (!ok) break;
				}
				if (!ok) break;
			}
			if (!ok) break;
		}
		if (!ok) continue;

		forn (i, 0, n) {
			forn (j, 0, m) cout << grid[i][j] + 1 << " \n"[j == m - 1];
		}
		exit(0);
	}
	assert(false);
}

vector<int> solve(vector<pair<int, int>> &edges, vector<int> &masks, int m) {
	shuffle(all(masks), rng);
	for (auto mask : masks) {
		vector<int> cur(m);
		forn (i, 0, m) cur[i] = (mask / p3[i]) % 3;
		bool ok = true;
		for (auto [i, j] : edges) {
			if (cur[i] == cur[j]) {
				ok = false;
				break;
			}
		}
		if (ok) return cur;
	}
	assert(false);
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, m, c;
	cin >> n >> m >> c;

	if (c == 2) bruteSolve(n, m, c);

	vector<int> masks(p3[m]);
	iota(all(masks), 0);

	vector<pair<int, int>> edges;
	forn (i, 0, n) {
		vector<int> cur = solve(edges, masks, m);
		assert(len(cur) == m);
		forn (j, 0, m) {
			forn (k, j + 1, m) {
				if (cur[j] != cur[k]) continue;
				edges.emplace_back(j, k);
			}
		}
		forn (j, 0, m) cout << cur[j] + 1 << " \n"[j == m - 1];
	}
}
