#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

void solve();

int main()
{
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);

	int t; cin >> t;
	while (t--)
        solve();
    return 0;
}

ll n, m, total, first_col;

ll fhor(ll i)
{
    ll fs = i * (m * m + m) / 2 + i * (i - 1) * m * m / 2;
    ll sd = total - fs;
    return abs(fs - sd);
}

ll hor()
{
    ll l = 0, r = n;
    while (r - l > 2) {
        ll m1 = l + (r - l) / 3,
           m2 = r - (r - l) / 3;
        if (fhor(m1) < fhor(m2))
            r = m2;
        else
            l = m1;
    }
    ll best = l;
    for (ll i = l; i <= r; i++)
        if (fhor(best) > fhor(i))
            best = i;
    return best;
}

ll fver(ll i)
{
    ll fs = first_col * i + i * (i - 1) * n / 2;
    ll sd = total - fs;
    return abs(fs - sd);
}

ll ver()
{
    ll l = 0, r = m;
    while (r - l > 2) {
        ll m1 = l + (r - l) / 3,
           m2 = r - (r - l) / 3;
        if (fver(m1) < fver(m2))
            r = m2;
        else
            l = m1;
    }
    ll best = l;
    for (ll i = l; i <= r; i++)
        if (fver(best) > fver(i))
            best = i;
    return best;
}

void solve()
{
    cin >> n >> m;
    total = n * (m * m + m) / 2 + n * (n - 1) * m * m / 2;
    first_col = n * (2 + m * (n - 1)) / 2;
    //cout << total << '\n';
    ll Hor = hor(),
       Ver = ver();
    //cout << Hor << ' ' << Ver << ' ' << fhor(Hor) << ' ' << fver(Ver) << '\n';
    if (fhor(Hor) < fver(Ver))
        cout << "H " << Hor + 1 << '\n';
    else
        cout << "V " << Ver + 1 << '\n';
}
