#include <algorithm>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

#define ft first
#define sd second

typedef long long ll;

int len(int n)
{
    return n == 0 ? -1 : n == 1 ? 0 : to_string(n).size();
}

string RLE(string s)
{
    s += '#';
    string res = "";
    int cur = 0;
    for (int i = 0; i < s.size(); i++) {
        if (cur == 0 || s[i] == s[i - 1])
            cur += 1;
        else {
            if (cur > 1)
                res += to_string(cur);
            res += s[i - 1];
            cur = 1;
        }
    }
    return res;
}

vector<char> chars {'A', 'C', 'G', 'T'};

pair<int, int> dumb(string s, string rle)
{
    pair<int, int> res{0, 0};
    for (int pos = 0; pos < s.size(); pos++) {
        for (int action = 1; action <= 3; action++) {
            if (action == 1) {
                for (auto z : chars) {
                    string tmp = s.substr(0, pos) + z + s.substr(pos);
                    string cur = RLE(tmp);
                    if (cur.size() < rle.size())
                        res.ft = max(res.ft, int(rle.size()) - int(cur.size()));
                    else
                        res.sd = max(res.sd, int(cur.size()) - int(rle.size()));
                }
            }
            else if (action == 2) {
                string tmp = s.substr(0, pos) + s.substr(pos + 1);
                string cur = RLE(tmp);
                if (cur.size() < rle.size())
                        res.ft = max(res.ft, int(rle.size()) - int(cur.size()));
                    else
                        res.sd = max(res.sd, int(cur.size()) - int(rle.size()));
            }
            else if (action == 3) {
                for (auto z : chars) {
                    string tmp = s.substr(0, pos) + z + s.substr(pos + 1);
                    string cur = RLE(tmp);
                    if (cur.size() < rle.size())
                        res.ft = max(res.ft, int(rle.size()) - int(cur.size()));
                    else
                        res.sd = max(res.sd, int(cur.size()) - int(rle.size()));
                }
            }
        }
    }
    return res;
}

int main()
{
	int test = 1;
	while (test--) {
        //int ssize = rand() % 100 + 1;
        //string t = "";
        //for (int i = 0; i < ssize; i++) {
        //    int amount = rand() % 10 + 1;
        //    int ch = rand() % 4;
        //    for (int j = 0; j < amount; j++)
        //        t += chars[ch];
        //}

        string s; cin >> s;
        //pair<int, int> dumbest = dumb(t, s);
        vector<pair<int, char>> a;
        int n = s.size(),
            cur = 0,
            i = 0;
        vector<int> pref(n + 1, 0);
        for (int i = 0; i <= n; i++)
            pref[i] = 0;
        while (i < n) {
            while (isdigit(s[i]))
                cur = 10 * cur + s[i++] - '0';
            cur = cur == 0 ? 1 : cur;
            a.push_back({cur, s[i]});
            pref[a.size()] = pref[a.size() - 1] + cur;
            cur = 0;
            i++;
        }

        // find min
        ll best = 0;
        pair<int, pair<int, char>> min_res;
        for (int i = 0; i < a.size(); i++) {
            // delete one
            int del_one = len(a[i].ft) + 1 - (len(a[i].ft - 1) + 1);
            if (del_one >= best) {
                best = del_one;
                min_res = {2, {pref[i] + 1, ' '}};
            }

            // unite neighbors
            //if (i == 1)
                //cout << a[i - 1].sd << ' ' << a[i + 1].sd << '\n';
            if (i != 0 && i != n && a[i].ft == 1 && a[i - 1].sd == a[i + 1].sd) {
                int unite_neighbors = len(a[i - 1].ft) + 1 + 1 + len(a[i + 1].ft) + 1 - (len(a[i - 1].ft + a[i + 1].ft) + 1);
                //cout << i << ' ' << len(a[i - 1].ft) + 1 + 1 + len(a[i + 1].ft) + 1 << ' ' << (len(a[i - 1].ft + 1 + a[i + 1].ft) + 1) << '\n';
                if (unite_neighbors >= best) {
                    best = unite_neighbors;
                    //cout << i << ' ' << a[i - 1].ft << ' ' << a[i - 1].sd << '\n';
                    min_res = {2, {pref[i] + 1, ' '}};
                }
            }

            // that's all for now...
        }
        ll best1 = best;
        //find max
        best = 0;
        pair<int, pair<int, char>> max_res;
        for (int i = 0; i < a.size(); i++) {
            // insert one
            int insert_one = len(a[i].ft + 1) + 1 - (len(a[i].ft) + 1);
            if (insert_one >= best) {
                best = insert_one;
                max_res = {1, {pref[i], a[i].sd}};
            }

            // split in two
            if (a[i].ft > 1) {
                int l, r;
                if (a[i].ft > 11 && a[i].ft < 20) {
                    l = 2;
                    r = a[i].ft - 2;
                }
                else {
                    l = a[i].ft / 2;
                    r = a[i].ft - l;
                }
                int split = len(l) + 1 + 1 + len(r) + 1 - (len(a[i].ft) + 1);
                //cout << i << ' ' << l << ' ' << r << ' ' << split << ' ' << pref[i] << '\n';
                if (split >= best) {
                    best = split;
                    max_res = {1, {pref[i] + l, a[i].sd == 'A' ? 'C' : 'A'}};
                }
            }
        }
        cout << min_res.ft << ' ' << min_res.sd.ft << ' ' << min_res.sd.sd << '\n';
        cout << max_res.ft << ' ' << max_res.sd.ft << ' ' << max_res.sd.sd << '\n';
	}
    return 0;
}

