#include <iostream>
#include <vector>
#include <bitset>
#include <map>

using namespace std;

bool check(vector<int> &a, int dist = -1) {
    if (a.size() <= 2)
        return true;
    if (dist == -1)
        dist = a[1] - a[0];
    for (int i = 1; i < a.size(); i++)
        if (a[i] - a[i - 1] != dist)
            return false;
    return true;
}

int n;
bitset<8> used;
vector<vector<int>> segments;
vector<int> len, cur, correct;
bool req()
{
    //cout << used[0] << '\n';
    if (used.count() == n) {

        //for (auto i : cur) {
        //    cout << i << ' ';
        //}
        //cout << '\n';    //exit(0);
        int dist = segments[cur[1]].front() + (len[cur[0]] - segments[cur[0]].back());
        for (int i = 1; i < n; i++)
            if (segments[cur[i]].front() + (len[cur[i - 1]] - segments[cur[i - 1]].back()) != dist || !check(segments[cur[i]], dist))
                return false;
        correct = cur;
        return true;
    }
    bool res = false;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            used[i] = 1;
            cur.push_back(i);
            res = res || req();
            cur.pop_back();
            used[i] = 0;
        }
    }
    return res;
}

int main()
{
    cin >> n;
    for (int i = 0; i < n; i++) {
        int m, s; cin >> m >> s;
        len.push_back(s);
        vector<int> seg;
        for (int j = 0; j < m; j++) {
            int s; cin >> s;
            seg.push_back(s);
        }
        if (!check(seg)) {
            cout << "NO";
            return 0;
        }
        segments.push_back(seg);
    }
    if (req()) {
        cout << "YES\n";
        for (auto i : correct)
            cout << i + 1 << ' ';
    }
    else
        cout << "NO";
}
