#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#include <bits/stdc++.h>
using namespace std;

#define endl '\n'

typedef long long ll;
typedef long double ldb;

vector<vector<pair<int, int>>> g;

vector<int> path;

void dfs(int v) {
	while (!g[v].empty()) {
		auto e = g[v].back();
		g[v].pop_back();
		dfs(e.first);
		path.push_back(e.second);
	}
}


void solve(vector<pair<int, int>> arr, int dist) {
	int n = arr.size();
	vector<pair<int, pair<int, int>>> edges(n);
	for (int i = 0; i < n; i++) {
		edges[i].first = i;
		edges[i].second = {arr[i].first, dist - arr[i].second};
		if (!(0 <= edges[i].second.first && edges[i].second.first <= dist)) {
			edges[i].second.first = dist + 1;
		}
		if (!(0 <= edges[i].second.second && edges[i].second.second <= dist)) {
			edges[i].second.second = dist + 2;
		}
	}
	map<int, int> coord;
	for (auto e : edges) {
		coord[e.second.first] = 0;
		coord[e.second.second] = 0;
	}
	int cur = 0;
	for (auto &el : coord) {
		el.second = cur++;
	}
	for (auto &e : edges) {
		e.second.first = coord[e.second.first];
		e.second.second = coord[e.second.second];
	}
	g.clear();
	g.resize(cur);
	vector<int> in(cur);
	for (int i = 0; i < cur; i++) {
		in[i] = -(int)g[i].size();
	}
	for (auto &e : edges) {
		g[e.second.first].push_back({e.second.second, e.first});
		in[e.second.second]++;
	}
	for (int i = 0; i < cur; i++) {
		in[i] -= (int)g[i].size();
	}
	int start = min_element(in.begin(), in.end()) - in.begin();
	path.clear();
	dfs(start);
	reverse(path.begin(), path.end());
	if (path.size() < n)
		return;
	for (int i = 1; i < n; i++) {
		if (arr[path[i - 1]].second + arr[path[i]].first != dist) {
			return;
		}
	}
	cout << "Yes" << endl;
	for (int el : path) {
		cout << el + 1 << " ";
	}
	cout << endl;
	exit(0);
}

signed main() {
	auto start = clock();
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector<pair<int, int>> arr(n);
	int mnneed = INT_MAX;
	int mxneed = -1;
	for(int i = 0; i < n; i++) {
		int k;
		cin >> k;
		int s;
		cin >> s;
		vector<int> arr2(k);
		for (int i = 0; i < k; i++) {
			cin >> arr2[i];
		}
		for (int i = 1; i < k; i++) {
			int ln = arr2[i] - arr2[i - 1];
			mxneed = max(mxneed, ln);
			mnneed = min(mnneed, ln);
		}
		arr[i] = {arr2[0], s - arr2.back()};
	}
	if (mxneed != -1) {
		if (mxneed != mnneed) {
			cout << "No" << endl;
			return 0;
		}
		solve(arr, mnneed);
		cout << "No" << endl;
		return 0;
	}
	if (n == 1) {
		cout << "Yes" << endl;
		cout << 1 << endl;
		return 0;
	}
	set<int> was;
	for (int j = 1; j < n; j++) {
		int cnt = arr[0].second + arr[j].first;
		if (!was.count(cnt)) {
			solve(arr, cnt);
			was.insert(cnt);
		}
		cnt = arr[0].first + arr[j].second;
		if (!was.count(cnt)) {
			solve(arr, cnt);
			was.insert(cnt);
		}
	}

	cout << "No" << endl;
}
