#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

const int MOD = 1e9 + 7;

int add(int a, int b) {
	return (a + b) % MOD;
}
int sub(int a, int b) {
	return (a - b + MOD) % MOD;
}
int mul(int a, int b) {
	return (1LL * a * b) % MOD;
}

vector<int> factmemo;

int fact(int n) {
	if (n < 0)
		return 0;
	if (n < (int) factmemo.size())
		return factmemo[n];
	if (n == 0) {
		factmemo.push_back(1);
		return 1;
	}
	int fn = fact(n - 1);
	factmemo.push_back(mul(fn, n));
	return factmemo[n];
}

int pow(int a, int b) {
	int ans = 1;
	while (b) {
		if (b & 1)
			ans = mul(ans, a);
		b >>= 1;
		a = mul(a, a);
	}
	return ans;
}

int rev(int a) {
	return pow(a, MOD - 2);
}

int divv(int a, int b) {
	return mul(a, rev(b));
}

int C(int n, int k) {
	return divv(fact(n), mul(fact(k), fact(n - k)));
}

int C_(int n, int k) {
	return C(n + k - 1, n);
}

int A(int n, int k) {
	return divv(fact(n), fact(n - k));
}

map<pair<int, int>, int> memo;

int solve(int n, int k) {
	if (n == 0)
		return 1;
	if (k == 0)
		return 0;
	if (k == 1) {
		return fact(n);
	}
	//return mul(mul(fact(n), fact(k)), C_(n, k));
	if (memo.count({n, k}))
		return memo[{n, k}];
	int ans = 0;
	int ank = 1; 
	for (int m = 0; m <= n; m++) {
		ans = add(ans, mul(ank, solve(n - m, k - 1)));
		ank = mul(ank, n - m);
	}
	memo[{n, k}] = ans;
	return ans;
}

int solve2(int n, int k) {
	if (n == 0)
		return 1;
	int ans = 0;
	for (int m = 1; m <= k && m <= n; m++) {
		int cnt1 = C(k, m);
		int cnt2 = fact(n);
		int cnt3 = C_(n - m, m);
		ans = add(ans, mul(mul(cnt1, cnt2), cnt3));
	}
	return ans;
	//return mul(mul(fact(n), fact(k)), C_(n, k));
	if (memo.count({n, k}))
		return memo[{n, k}];
	//int ans = 0;
	int ank = 1; 
	for (int m = 0; m <= n; m++) {
		ans = add(ans, mul(ank, solve(n - m, k - 1)));
		ank = mul(ank, n - m);
	}
	memo[{n, k}] = ans;
	assert(ans == mul(mul(fact(n), fact(k)), C_(n, k)));
	return ans;
}

void check() {
	for (int n = 0; n <= 1000; n++) {
		for (int k = 0; k <= 1000; k++) {
			assert(solve(n, k) == solve2(n, k));
		}
	}
}

signed main() {
	//solve2(2, 2);
	//check();
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	string a, b, c;
	cin >> a >> b >> c;
	int n = a.size();
	int in = 0;
	int out = 0;
	int inout = 0;
	int cntnzero = 0;
	bool bad = 0;
	for (int i = 0; i < n; i++) {
		a[i] -= '0';
		b[i] -= '0';
		c[i] -= '0';
		int sm = a[i] + b[i];
		if ((a[i] + b[i]) % 10 != c[i]) {
			in++;
			sm++;
		}
		if (sm >= 10) {
			out++;
		}
		if (sm >= 10 && (a[i] + b[i]) % 10 != c[i]) {
			inout++;
		}
		if (!(sm >= 10)) {
			if (a[i] != 0 && b[i] != 0)
				cntnzero++;
		}
		if ((a[i] + b[i]) % 10 != c[i] && (a[i] + b[i] + 1) % 10 != c[i])
			bad = 1;
	}
	int cnto = n - (out);
	int ans = mul(cntnzero, fact(cnto - 1));
	in -= inout;
	out -= inout;
	if (bad || in != out) {
		ans= 0;
	} else {
		int ans2 = solve2(inout, in);
		ans2 = mul(ans2, fact(in));
		ans = mul(ans, ans2);
	}
	cout << ans << endl;
}
