//#pragma comment(linker, "/SUBSYSTEM:windows /ENTRY:mainCRTStartup")
#ifdef _MSC_VER
	#define _CRT_SECURE_NO_WARNINGS
	#include <__msvc_all_public_headers.hpp>	
	#include <Windows.h>
#else
	#define _MSC_VER 2000
	#include <bits/stdc++.h>
	#pragma GCC optimize("Ofast")
	#pragma GCC optimize("fast-math")
	#pragma GCC optimize ("unroll-loops")
	#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#endif

#define nl					"\n"
#define len(Q)				(int)Q.size()
#define all(Q)				Q.begin(), Q.end()

using namespace std;

template <typename T> ostream &operator <<(ostream &out, vector <T> &a)
{
	for (auto &p : a)
		out << p << " ";
	return out;
}
template <typename T> istream &operator >>(istream &inp, vector <T> &a)
{
	for (auto &p : a)
		inp >> p;
	return inp;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout.precision(20);
	srand((signed)time(NULL));

	string aq, bq, cq;
	cin >> aq >> bq >> cq;

	vector <int> a, b, c, d;

	for (int i = 0; i < len(a); i++)
	{
		int a1 = aq[i] - '0', b1 = bq[i] - '0', c1 = cq[i] - '0';
		if (a1 + b1 == c1)
			a.push_back(i);
		else if (a1 + b1 + 1 == c1)
			c.push_back(i);
		else if (a1 + b1 == c1 + 10)
			b.push_back(i);
		else if (a1 + b1 == c1 + 9)
			d.push_back(i);
		else
		{
			cout << 0 << nl;
			return 0;
		}
	}
	
	bool cona = false, conb = false;
	for (auto &p : a)
	{
		if (a[p] != '0' && b[p] != '0')
			cona = true;
	}
	for (auto &p : c)
	{
		if (a[p] != '0' && b[p] != '0')
			conb = true;
	}
	if (!cona && !conb)
	{
		cout << 0 << nl;
		return 0;
	}

	int dp[4][18][18][18][18];
	for (int i = 0; i < 4; i++)
	{
		for (int j = 0; j < 18; j++)
		{
			for (int k = 0; k < 18; k++)
			{
				for (int l = 0; l < 18; l++)
				{
					for (int m = 0; m < 18; m++)
						dp[i][j][k][l][m] = 0;
				}
			}
		}
	}

	if (cona)
		dp[0][1][0][0][0] = 1;
	if (conb)
		dp[2][0][0][1][0] = 1;
	
	for (int i = 0; i < len(a); i++)
	{
		for (int j = 0; j < len(b); j++)
		{
			for (int k = 0; k < len(c); k++)
			{
				for (int l = 0; l < len(d); l++)
				{
					if (i > 0)
						dp[0][i][j][k][l] = dp[0][i - 1][j][k][l] + dp[1][i - 1][j][k][l];
					if (j > 0)
						dp[1][i][j][k][l] = dp[2][i][j - 1][k][l] + dp[3][i][j - 1][k][l];
					if (k > 0)
						dp[2][i][j][k][l] = dp[0][i][j][k - 1][l] + dp[1][i][j][k - 1][l];
					if (l > 0)
						dp[3][i][j][k][l] = dp[2][i][j][k][l - 1] + dp[3][i][j][k][l - 1];
				}
			}
		}
	}

	cout << dp[0][len(a) - 1][len(b) - 1][len(c) - 1][len(d) - 1] + dp[1][len(a) - 1][len(b) - 1][len(c) - 1][len(d) - 1] + dp[2][len(a) - 1][len(b) - 1][len(c) - 1][len(d) - 1] + dp[3][len(a) - 1][len(b) - 1][len(c) - 1][len(d) - 1];

	if (_MSC_VER < 1920)
		system("Pause");
	return 0;
}