#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>
#include <string>
#include <set>
#include <map>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
typedef long long ll;
typedef long double ld;

const ll INF = 1e9 * 1e9 + 100, SZ = 1e5;

tuple<ll, ll, ll> hor(ll n, ll m, ll i) {
	ll sumAll = (n * m + 1) * (n * m) / 2;
	tuple<ll, ll, ll> ret = { 0, 0, i + 1 };

	ll n2 = i;
	ll x = (m * n2 + 1) * (m * n2) / 2;
	get<0>(ret) = abs((sumAll - x) - x);

	return ret;
}

tuple<ll, ll, ll> ver(ll n, ll m, ll i) {
	ll sumAll = (n * m + 1) * (n * m) / 2;
	tuple<ll, ll, ll> ret = { 0, 1, i + 1 };

	ll m2 = i;
	ll x = (m2 * n + 1) * (m2 * n) / 2 + ((i * ((m - i) * (n - 1)) * (n) / 2));
	get<0>(ret) = abs((sumAll - x) - x);

	return ret;
}

void sol() {
	ll n, m, sumAll = 0;
	cin >> n >> m;

	sumAll = (n * m + 1) * (n * m) / 2;

	tuple<ll, ll, ll> ans = { INF, INF, INF };
	ll l = 0, r = n - 1;

	while (r - l > 4) {
		ll mid = (l + r) / 2;
		if (hor(n, m, mid) > hor(n, m, mid + 1)) {
			l = mid;
		} else {
			r = mid + 1;
		}
	}

	for (int i = l; i <= r; i++) {
		ans = min(ans, hor(n, m, i));
	}

	l = 0, r = m - 1;

	while (r - l > 4) {
		ll mid = (l + r) / 2;
		if (ver(n, m, mid) > ver(n, m, mid + 1)) {
			l = mid;
		}
		else {
			r = mid + 1;
		}
	}

	for (int i = l; i <= r; i++) {
		ans = min(ans, ver(n, m, i));
	}

	if (get<1>(ans) == 0) {
		cout << "H ";
	}
	else {
		cout << "V ";
	}

	cout << get<2>(ans) << "\n";
}

int main() {
	fastInp;

	ll t;
	cin >> t;

	while (t--) {
		sol();
	}

	return 0;
}