#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

typedef long long ll;
typedef long double ld;

const ll SZ = 1e5 + 100;
ll n;

map<ll, vector<pair<ll, ll>>> ins, ins2, ins3;
map<ll, vector<ll>> bad, good;
map<ll, ll> outt, outt2, cnt;
vector<pair<ll, ll>> vec;
ll gt[SZ];

void check3(ll d) {
	bad.clear();
	good.clear();
	vector<ll> to(n, -1), par(n, -1);
	for (int i = 0; i < n; i++) {
		if (vec[i].first + vec[i].second == d) {
			ll lft = d - vec[i].second;
			bad[vec[i].first].push_back(i);
		}
		else {
			ll lft = d - vec[i].second;
			good[vec[i].first].push_back(i);
		}
	}

	
	for (int i = 0; i < n; i++) {
		ll lft = d - vec[i].second;
		if (bad[lft].size() == 0) continue;
		ll ind = bad[lft].back();

		if (ind != i) {
			bad[lft].pop_back();
			to[i] = ind;
			par[ind] = i;
			continue;
		}
	
		if (bad[lft].size() >= 2) swap(bad[lft][bad[lft].size() - 1], bad[lft][bad[lft].size() - 2]);

		ind = bad[lft].back();

		if (ind != i) {
			bad[lft].pop_back();
			to[i] = ind;
			par[ind] = i;
			continue;
		}
	}

	for (int i = 0; i < n; i++) {
		ll lft = d - vec[i].second;
		if (to[i] != -1) continue;
		if (good[lft].size() == 0) continue;
		ll v = good[lft].back();
		good[lft].pop_back();
		to[i] = v;
		par[v] = i;
	}

	ll cnt = 0, st = 0;

	set<ll> s;
	for (int i = 0; i < n; i++) {
		if (to[i] == -1) {
			cnt++;
			st = i;
		}

		s.insert(par[i]);
	}

	if (s.size() != n) {
		return;
	}
	
	vector<ll> ans;
	ll v = st;
	ans.push_back(st);
	
	while (par[v] != -1) {
		v = par[v];
		ans.push_back(v);
	}

	reverse(ans.begin(), ans.end());
	cout << "Yes\n";
	for (auto c : ans) cout << c + 1 << " ";

	exit(0);
}

set<ll> st;

void brute() {
	vector<ll> perm;
	for (int i = 0; i < n; i++) perm.push_back(i);

	do {
		bool f = 1;
		ll pr = -1;
		for (int i = 0; i < perm.size() - 1; i++) {
			ll v = perm[i], u = perm[i + 1];
			if (pr == -1 || vec[v].second + vec[u].first == pr) {
				pr = vec[v].second + vec[u].first;
				
			}
			else {
				f = 0;
			}
		}

		if (st.size() == 1 && pr != -1 && pr != (*st.begin())) f = 0;
		if (f) {
			cout << "Yes\n";
			for (auto c : perm) cout << c + 1 << " ";

			exit(0);
		}
	} while (next_permutation(perm.begin(), perm.end()));

	cout << "No";
	exit(0);
}

int main() {
	fastInp;
	
	cin >> n;

	for (int i = 0; i < n; i++) {
		ll m, s;
		cin >> m >> s;
		vector<ll> ps(m);
		for (auto &cur : ps) cin >> cur;

		for (int i = 0; i < ps.size() - 1; i++) {
			st.insert(ps[i + 1] - ps[i]);
		}
		ins[ps[0]].push_back({ s - ps.back(), i });
		outt[s - ps.back()]++;
		gt[i] = s - ps.back();
		cnt[ps[0]]++;

		vec.push_back({ ps[0], s - ps.back() });
	}

	ins2 = ins;
	outt2 = outt;
	if (st.size() > 1) {
		cout << "No";
		return 0;
	}

	/*if (n <= 8) {
		brute();
	}*/
	if (st.size() == 1) {
		check3(*(st.begin()));
	}
	else {
		for (int i = 0; i < 110; i++) {
			check3(i);
		}
	}

	cout << "No";

	return 0;
}


/*
3
1 7
3
1 8
6
2 8
1 6

4
1 5
0
1 0
0
1 3
3
1 0
0

4
1 5
2
1 3
2
1 5
4
1 6
4
*/