#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

typedef long long ll;
typedef long double ld;

const ll SZ = 1e5 + 100;

ll grid[12][12];

void tle() {
	tle();
}

bool check(ll n, ll m) {
	for (int i = 0; i < n; i++) {
		for (int i2 = i + 1; i2 < n; i2++) {
			for (int j = 0; j < m; j++) {
				for (int j2 = j + 1; j2 < m; j2++) {
					if (grid[i][j] == grid[i2][j] && grid[i2][j] == grid[i2][j2] && grid[i2][j2] == grid[i][j2]) return false;
				}
			}
		}
	}

	return true;
}

ll n, m, c;
void out() {
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cout << grid[i][j] + 1 << " ";
		}
		cout << "\n";
	}

	cout << "\n";
}

void hands() {
	cin >> n >> m;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) cin >> grid[i][j];
	}

	if (check(n, m)) {
		cout << "good";
	}
	else {
		cout << "bad";
	}

	cout << "\n";
}

ll K = 40;

vector<vector<ll>> st = {
	{0, 0, 0, 1, 1, 1, 2, 2, 2, 2},
	{2, 2, 0, 0, 0, 1, 1, 1, 1, 2},
	{1, 2, 2, 2, 0, 0, 0, 0, 1, 1},
	{1, 1, 1, 2, 2, 2, 2, 0, 0, 0},
	{2, 1, 2, 0, 1, 0, 1, 2, 0, 1},
	{1, 0, 2, 0, 1, 2, 0, 1, 2, 0}
};

//, {2, 0, 2, 0, 1, 2, 0, 1, 2, 1}

void fll() {
	ll n = st.size(), m = st[0].size();

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			grid[i][j] = st[i][j];
		}
	}
}
void kek() {
	ll n = st.size(), m = st[0].size();

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			grid[i][j] = st[i][j];
		}
	}

	vector<ll> perm;
	for (int i = 0; i < 10; i++) perm.push_back(i);
	do {
		for (int i = n; i < n + 1; i++) {
			for (int j = 0; j < m; j++) {
				grid[i][j] = grid[i - 3][perm[j]];
			}
		}

		if (check(n + 1, m)) {
			cout << "good\n";
			for (auto c : perm) cout << c << " ";
			cout << "";
			cout << "\n";
			for (int j = 0; j < m; j++) {
				cout << grid[n][j] << " ";
			}
			/*cout << "\n";
			for (int j = 0; j < m; j++) {
				cout << grid[n + 1][j] << " ";
			}*/
			/*cout << "\n";
			for (int j = 0; j < m; j++) {
				cout << grid[n + 2][j] << " ";
			}*/
			cout << "";
		}
	} while (next_permutation(perm.begin(), perm.end()));
}
int main() {
	fastInp;

	//kek();
	cin >> n >> m >> c;

	if (c == 2) {
		ll pw = (1ll << (n * m));

		for (int i = 0; i < pw; i++) {
			ll c = 0;
			for (int k = 0; k < n; k++) {
				for (int j = 0; j < m; j++) {
					grid[k][j] = (i >> c) & 1;
					c++;
				}
			}
			if (check(n, m)) {
				out();
				return 0;
			}
		}
	}
	fll();
	
	if (n <= 6 || m <= 6) {
		if (n <= 6) {
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < m; j++) cout << grid[i][j] << " ";
				cout << "\n";
			}
		}
		else {
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < m; j++) cout << grid[j][i] << " ";
				cout << "\n";
			}
		}
		return 0;
	}
	bool f = 0;
	if (n > m) {
		swap(n, m);
		f = 1;
	}

	set<ll> lft[3];
	vector<ll> l2[12];
	for (int i = 0; i < n; i++) {
		for (int t = 0; t < c; t++) {
			lft[t].insert(i);
			l2[i].push_back(t);
		}
		random_shuffle(l2[i].begin(), l2[i].end());
	}
	ll c1 = 0;
	for (int j = 0; j < m; j++) {
		vector<bool> used(n);
		for (int t = 0; t < c; t++) {
			if (lft[t].size() != n) {
				ll v = 0;
				for (int k = 0; k < n; k++) {
					if (lft[t].find(k) == lft[t].end()) v = k;
				}
				grid[v][j] = t;
				used[v] = 1;
			}
		}
		for (int i = 0; i < n; i++) {
			if (used[i]) continue;

			lft[l2[i][0]].erase(i);
			grid[i][j] = (l2[i][0]);
			l2[i].erase(l2[i].begin());
			
			c1++;
			c1 %= c;
		}
	}

	if (f) {
		swap(n, m);
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			ll i1 = i, j1 = j;
			if (f) swap(i1, j1);

			cout << grid[i1][j1] + 1 << " ";
		}
		cout << "\n";
	}

	return 0;
}

/*

*/