#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <ctime>
#include <map>
#include <random>
#include <iomanip>
#include <cmath>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <bitset>
#include <deque>
#include <utility>
#include <fstream>

using namespace std;

const int MAX_MEM = 2e8;
int mpos = 0;
char mem[MAX_MEM];
inline void * operator new( size_t n ) {
    char *res = mem + mpos;
    mpos += n;
    assert(mpos <= MAX_MEM);
    return (void *)res;
}
inline void operator delete ( void * ) { }


/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("vpt")*/


#define int long long

const int MAXN = 1e5 + 10;


struct SHT{
    int len, cnp;
    vector<int> pos;
    SHT(int len = 0, int cnp = 0, vector<int> pos = {})
    {
        this->len = len;
        this->cnp = cnp;
        this->pos = pos;
    }
};


vector<pair<int, int>> gr[MAXN];
int used[MAXN];

vector<int> ans;

int top_sort(int v, int w, int cnt)
{
    used[v] = 1;
    cnt--;
    if (cnt == 0)
    {
        ans.push_back(v);
        return w;
    }
    for (auto e : gr[v])
    {
        if (used[e.second] == 0 && (w == -1 || w == e.first))
        {
            int nw = top_sort(e.second, e.first, cnt);
            if (nw != -1)
            {
                ans.push_back(v);
                return nw;
            }
        }
    }
    used[v] = 0;
    return -1;
}


int32_t main()
{
    int n; cin >> n;
    vector<SHT> all;
    for (int i = 0; i < n; i++)
    {
        int m, s; cin >> m >> s;
        vector<int> p(m);
        for (int j = 0; j < m; j++)
            cin >> p[j];
        all.push_back(SHT(s, m, p));
    }
    int was = -1;
    bool correct = true;
    for (int i = 0; i < n; i++)
        for (int j = 1; j < all[i].cnp; j++)
        {
            if (was == -1)
                was = all[i].pos[j] - all[i].pos[j - 1];
            else if (was != all[i].pos[j] - all[i].pos[j - 1])
                correct = false;
        }
    if (!correct)
    {
        cout << "No" << endl;
        return 0;
    }
    vector<int> perm;
    for (int i = 1; i < n + 1; i++)
        perm.push_back(i);
    int nwas = was;
    do {
        correct = true;
        was = -1;
        for (int i = 0; i < n - 1; i++)
        {
            int nw = perm[i] - 1, nx = perm[i + 1] - 1;
            int sz = (all[nw].len - all[nw].pos[(int)all[nw].pos.size() - 1]) + all[nx].pos[0];
            if ((was != -1 && was != sz) && (nwas != -1 || nwas != sz))
            {
                correct = false;
                break;
            }
            if (was == -1)
                was = sz;
        }
        if (correct)
        {
            cout << "Yes" << endl;
            for (auto v : perm)
                cout << v << " ";
            cout << endl;
            return 0;
        }
    } while (next_permutation(perm.begin(), perm.end()));

    cout << "No" << endl;

    /*set<int> was_w;
    for (int i = 0; i < n; i++)
    {
        for (int j = i + 1; j < n; j++)
        {
            pair<int, int> p1 = {all[i].pos[0], all[i].len - all[i].pos.back()}, p2 = {all[j].pos[0], all[j].len - all[j].pos.back()};
            gr[i].push_back({p1.second + p2.first, j});
            gr[j].push_back({p2.second + p1.first, i});
        }
    }

    for (int i = 0; i < n; i++)
        sort(gr[i].begin(), gr[i].end());

    for (int i = 0; i < n; i++)
    {
        int w = top_sort(i, -1, n);
        bool corr_loc = true;
        for (int j = 0; j < n; j++)
        {
            if (used[j] == 0)
                corr_loc = false;
            used[j] = 0;
        }
        if (corr_loc && (was == -1 || was == w))
        {
            reverse(ans.begin(), ans.end());
            cout << "Yes" << endl;
            for (auto v : ans)
                cout << v + 1 << " ";
            cout << endl;
            return 0;
        }
        ans.clear();
    }
    cout << "No" << endl;*/
    return 0;
}
