#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <ctime>
#include <map>
#include <random>
#include <iomanip>
#include <cmath>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <bitset>
#include <deque>
#include <utility>
#include <fstream>

using namespace std;

/*const int MAX_MEM = 2e8;
int mpos = 0;
char mem[MAX_MEM];
inline void * operator new( size_t n ) {
    char *res = mem + mpos;
    mpos += n;
    assert(mpos <= MAX_MEM);
    return (void *)res;
}
inline void operator delete ( void * ) { }*/


/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("vpt")*/


#define int long long

const int MAXN = 1e5 + 100;


struct SHT{
    int len, cnp;
    vector<int> pos;
    SHT(int len = 0, int cnp = 0, vector<int> pos = {})
    {
        this->len = len;
        this->cnp = cnp;
        this->pos = pos;
    }
};


struct Graph{
    int n;
    vector<vector<int>> to;
    Graph(int n)
    {
        this->n = n;
        this->to.resize(n);
    }
};


struct DSU{
    int n, cnt;
    vector<int> parent, rnk;
    DSU(int n)
    {
        this->n = n;
        this->cnt = n;
        this->parent.resize(n);
        this->rnk.resize(n);
        for (int i = 0; i < n; i++)
            parent[i] = i;
    }
    int get_parent(int v){
        if (parent[v] == v)
            return v;
        return parent[v] = get_parent(parent[v]);
    }
    void unite(int v, int u)
    {
        u = get_parent(u);
        v = get_parent(v);
        if (u != v)
        {
            if (rnk[u] < rnk[v])
                swap(u, v);
            parent[v] = u;
            if (rnk[u] == rnk[v])
                rnk[u]++;
            cnt--;
        }
    }
};


int used[MAXN];
vector<Graph> gr;
vector<DSU> ald;
vector<int> ans, tsort;


void top_sort(int v, int num)
{
    used[v] = 1;
    for (auto u : gr[num].to[v])
        if (used[u] == 0)
            top_sort(u, num);
    tsort.push_back(v);
}


bool check_dfs(int v, int num, int cnt)
{
    used[v] = 1;
    cnt--;
    if (cnt == 0)
    {
        ans.push_back(v);
        return true;
    }
    for (auto u : gr[num].to[v])
    {
        if (used[u] == 0)
        {
            bool fl = check_dfs(u, num, cnt);
            if (fl)
            {
                ans.push_back(v);
                return true;
            }
        }
    }
    used[v] = 0;
    return false;
}


int32_t main()
{
    int n, sum = 0; cin >> n;
    vector<SHT> all;
    for (int i = 0; i < n; i++)
    {
        int m, s; cin >> m >> s;
        sum += m;
        vector<int> p(m);
        for (int j = 0; j < m; j++)
            cin >> p[j];
        all.push_back(SHT(s, m, p));
    }
    int was = -1;
    bool correct = true;
    for (int i = 0; i < n; i++)
        for (int j = 1; j < all[i].cnp; j++)
        {
            if (was == -1)
                was = all[i].pos[j] - all[i].pos[j - 1];
            else if (was != all[i].pos[j] - all[i].pos[j - 1])
                correct = false;
        }
    if (!correct)
    {
        cout << "No" << endl;
        return 0;
    }
    if (n <= 8)
    {
        vector<int> perm;
        for (int i = 1; i < n + 1; i++)
            perm.push_back(i);
        int nwas = was;
        do {
            correct = true;
            was = -1;
            for (int i = 0; i < n - 1; i++) {
                int nw = perm[i] - 1, nx = perm[i + 1] - 1;
                int sz = (all[nw].len - all[nw].pos[(int) all[nw].pos.size() - 1]) + all[nx].pos[0];
                if ((was != -1 && was != sz) || (nwas != -1 && nwas != sz)) {
                    correct = false;
                    break;
                }
                if (was == -1)
                    was = sz;
            }
            if (correct) {
                cout << "Yes" << endl;
                for (auto v : perm)
                    cout << v << " ";
                cout << endl;
                return 0;
            }
        } while (next_permutation(perm.begin(), perm.end()));

        cout << "No" << endl;
        return 0;
    }
    else if (n == 1)
    {
        cout << "Yes" << endl;
        cout << 1 << endl;
        return 0;
    }
    else
    {
        vector<int> diff_w;
        diff_w.reserve(1e6 + 1000);
        gr.reserve(1e4);
        for (int i = 0; i < n; i++)
            for (int j = i + 1; j < n; j++)
            {
                pair<int, int> p1 = {all[i].pos[0], all[i].len - all[i].pos.back()}, p2 = {all[j].pos[0], all[j].len - all[j].pos.back()};
                diff_w.push_back(p1.second + p2.first);
                diff_w.push_back(p2.second + p1.first);
            }
        sort(diff_w.begin(), diff_w.end());
        diff_w.erase(unique(diff_w.begin(), diff_w.end()), diff_w.end());
        map<int, int> mp;
        for (int i = 0; i < diff_w.size(); i++) {
            ald.push_back(DSU(n));
        }

        for (int i = 0; i < n; i++)
            for (int j = i + 1; j < n; j++)
            {
                pair<int, int> p1 = {all[i].pos[0], all[i].len - all[i].pos.back()}, p2 = {all[j].pos[0], all[j].len - all[j].pos.back()};
                ald[mp[p1.second + p2.first]].unite(i, j);
                ald[mp[p2.second + p1.first]].unite(i, j);
            }

        while (true)
            n++;
        vector<int> shd(diff_w.size());
        for (int i = 0; i < diff_w.size(); i++)
            if (ald[i].cnt == 1)
                shd[i] = 1;

        vector<int> ndiff;
        for (int i = 0; i < diff_w.size(); i++)
            if (shd[i] == 1)
                ndiff.push_back(diff_w[i]);
        diff_w = ndiff;
        set<int> ww;
        for (int i = 0; i < diff_w.size(); i++)
        {
            ww.insert(diff_w[i]);
            mp[diff_w[i]] = i;
            gr.push_back(Graph(n));
        }

        for (int i = 0; i < n; i++)
            for (int j = i + 1; j < n; j++)
            {
                pair<int, int> p1 = {all[i].pos[0], all[i].len - all[i].pos.back()}, p2 = {all[j].pos[0], all[j].len - all[j].pos.back()};
                if (ww.find(p1.second + p2.first) != ww.end())
                    gr[mp[p1.second + p2.first]].to[i].push_back(j);
                if (ww.find(p2.second + p1.first) != ww.end())
                    gr[mp[p2.second + p1.first]].to[j].push_back(i);
            }

        for (int i = 0; i < diff_w.size(); i++)
            if (shd[i] == 1 && (was == -1 || diff_w[i] == was))
            {
                for (int j = 0; j < n; j++)
                    if (used[j] == 0)
                        top_sort(j, i);
                for (int j = 0; j < n; j++)
                    used[j] = 0;
                reverse(tsort.begin(), tsort.end());
                for (int j = 0; j < tsort.size(); j++)
                {
                    if (check_dfs(tsort[j], i, n))
                    {
                        reverse(ans.begin(), ans.end());
                        cout << "Yes" << endl;
                        for (int j = 0; j < n; j++)
                            cout << ans[j] + 1 << " ";
                        cout << endl;
                        return 0;
                    }
                }
                tsort.clear();
            }
        cout << "No" << endl;
    }
    /*
     *
     * set<int> was_w;
    for (int i = 0; i < n; i++)
    {
        for (int j = i + 1; j < n; j++)
        {
            pair<int, int> p1 = {all[i].pos[0], all[i].len - all[i].pos.back()}, p2 = {all[j].pos[0], all[j].len - all[j].pos.back()};
            gr[i].push_back({p1.second + p2.first, j});
            gr[j].push_back({p2.second + p1.first, i});
        }
    }

    for (int i = 0; i < n; i++)
        sort(gr[i].begin(), gr[i].end());

    for (int i = 0; i < n; i++)
    {
        int w = top_sort(i, -1, n);
        bool corr_loc = true;
        for (int j = 0; j < n; j++)
        {
            if (used[j] == 0)
                corr_loc = false;
            used[j] = 0;
        }
        if (corr_loc && (was == -1 || was == w) && w != -1)
        {
            reverse(ans.begin(), ans.end());
            cout << "Yes" << endl;
            for (auto v : ans)
                cout << v + 1 << " ";
            cout << endl;
            return 0;
        }
        ans.clear();
    }
    cout << "No" << endl;*/
    return 0;
}
