#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <stack>
#include <deque>
#include <queue>
#include <algorithm>
#include <cmath>
#include <random>
#include <time.h>
#include <chrono>
#include <functional>
#include <iomanip>
#include <istream>
#include <ostream>
#include <limits>
#include <cassert>

using namespace std;

template<typename T1, typename T2> bool chkmin(T1& x, const T2& y) {if (y < x) {x = y; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& x, const T2& y) {if (x < y) {x = y; return 1;} return 0;}

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) {
		out << k << " ";
	}
	return out;
}

template<typename T> ostream& operator<< (ostream& out, const pair<T, T>& a) {
	out << "{" << a.first << ", " << a.second << "}";
	return out;
}

template<typename T> istream& operator>> (istream& in, vector<T>& a) {
	for (auto& k : a) {
		in >> k;
	}
	return in;
}

template<typename T> istream& operator>> (istream& in, pair<T, T>& a) {
	in >> a.first >> a.second;
	return in;
}

#define int long long 
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define ld long double
#define pii pair<int, int>

// #pragma GCC optimize("Ofast,unroll-loops,fast-math")
// #pragma GCC target("avx2")

#define time ((ld)clock() / (ld)CLOCKS_PER_SEC)

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
	const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 10;
#else
	#define dbg(x)
	const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 179;
#endif

mt19937 gen(chrono::high_resolution_clock().now().time_since_epoch().count());

int sum(int x) {
	return x * (x + 1) / 2;
}

int sum(int l, int r) {
	return sum(r) - sum(l - 1);
}

int count_rows(int n, int m, int x) {
	return abs(sum((x - 1) * m) - (sum(n * m) - sum((x - 1) * m)));
}

pii solve_rows(int n, int m) {
	int l = 1, r = n;
	while (r - l > 2) {
		int mid1 = l + (r - l) / 3;
		int mid2 = r - (r - l) / 3;
		if (count_rows(n, m, mid1) < count_rows(n, m, mid2)) {
			r = mid2;
		} else {
			l = mid1;
		}
	}
	int ans = INF, ansx = -1;
	for (int i = l; i <= r; i++) {
		if (chkmin(ans, count_rows(n, m, i))) {
			ansx = i;
		}
	}
	return {ans, ansx};
}

int count_columns(int n, int m, int y) {
	int s1 = sum(y - 1) * n + sum(n - 1) * m * (y - 1);
	int s2 = sum(y, m) * n + sum(n - 1) * m * (m - y + 1);
	return abs(s1 - s2);
}

pii solve_columns(int n, int m) {
	int l = 1, r = m;
	while (r - l > 2) {
		int mid1 = l + (r - l) / 3;
		int mid2 = r - (r - l) / 3;
		if (count_columns(n, m, mid1) < count_columns(n, m, mid2)) {
			r = mid2;
		} else {
			l = mid1;
		}
	}
	int ans = INF, ansy = -1;
	for (int i = l; i <= r; i++) {
		if (chkmin(ans, count_columns(n, m, i))) {
			ansy = i;
		}
	}
	return {ans, ansy};
}

void solve() {
	int n, m;
	cin >> n >> m;
	pii ansr = solve_rows(n, m);
	pii ansc = solve_columns(n, m);
	// cout << n << " " << m << "\n";
	// dbg(ansr);
	// dbg(ansc);
	if (ansc.first <= ansr.first) {
		cout << "V " << ansc.second << "\n";
	} else {
		cout << "H " << ansr.second << "\n";
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int q = 1;
	cin >> q;
	while (q--) {
		solve();
	}
}	
/*
5
1 3
4 7 
1 10
3 3 
3 5
-> 
V 3
V 5
V 8
H 3
V 4
*/