#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <stack>
#include <deque>
#include <queue>
#include <algorithm>
#include <cmath>
#include <random>
#include <time.h>
#include <chrono>
#include <functional>
#include <iomanip>
#include <istream>
#include <ostream>
#include <limits>
#include <cassert>

using namespace std;

template<typename T1, typename T2> bool chkmin(T1& x, const T2& y) {if (y < x) {x = y; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& x, const T2& y) {if (x < y) {x = y; return 1;} return 0;}

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) {
		out << k << " ";
	}
	return out;
}

template<typename T> ostream& operator<< (ostream& out, const pair<T, T>& a) {
	out << "{" << a.first << ", " << a.second << "}";
	return out;
}

template<typename T> istream& operator>> (istream& in, vector<T>& a) {
	for (auto& k : a) {
		in >> k;
	}
	return in;
}

template<typename T> istream& operator>> (istream& in, pair<T, T>& a) {
	in >> a.first >> a.second;
	return in;
}

#define int long long 
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define ld long double
#define pii pair<int, int>

// #pragma GCC optimize("Ofast,unroll-loops,fast-math")
// #pragma GCC target("avx2")

#define time ((ld)clock() / (ld)CLOCKS_PER_SEC)

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
	const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 10;
#else
	#define dbg(x)
	const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 179;
#endif

mt19937 gen(chrono::high_resolution_clock().now().time_since_epoch().count());

const int N = 1e5 + 10;

string s;

int n, l;
int sz[N];
char c[N];

int preflen[N], suflen[N];

int pref(int x) {
	if (x < 0) return 0;
	return preflen[x];
}

int suf(int x) {
	if (x >= n) return 0;
	return suflen[x];
}

int preflenlong[N], suflenlong[N];

int preflong(int x) {
	if (x < 0) return 0;
	return preflenlong[x];
}

int suflong(int x) {
	if (x >= n) return 0;
	return suflenlong[x];
}

int len1, len2;
string op1, op2;

const int cansz = 12;
const vector<int> can = {1, 2, 10, 100, 1000, 10000, 100000, 1000000, 10000000, 100000000ll, 1000000000ll, 10000000000ll};
const vector<char> alp = {'A', 'C', 'G', 'T'};

int numlen(int x) {
	assert(x > 0);
	if (x == 1) return 0;
	int ans = 0;
	while (x > 0) {
		x /= 10;
		ans++;
	}
	return ans;
}

void solve_insert(char ch) {
	int curlen;
	// в начало строки
	if (ch == c[0]) {
		curlen = suf(1) + numlen(sz[0] + 1) + 1;
		if (chkmax(len2, curlen)) {
			op2 = "1 0 ";
			op2.pb(ch);
			// dbg(op2);
			// dbg("1 0 " + ch);
		}
	} else {
		curlen = suf(0) + 1;
		if (chkmax(len2, curlen)) {
			op2 = "1 0 ";
			op2.pb(ch);
			// dbg(op2);
		}
	}
	// в конец строки
	if (ch == c[n - 1]) {
		curlen = pref(n - 2) + numlen(sz[n - 1] + 1) + 1;
		if (chkmax(len2, curlen)) {
			op2 = "1 " + to_string(l) + " ";
			op2.pb(ch);
			// dbg(op2);
		}
	} else {
		curlen = pref(n - 1) + 1;
		if (chkmax(len2, curlen)) {
			op2 = "1 " + to_string(l) + " ";
			op2.pb(ch);
			// dbg(op2);
		}
	}
	for (int i = 1; i < n; i++) { // между блоками
		curlen = pref(i - 2) + suf(i + 1);
		if (ch != c[i - 1] && ch != c[i]) {
			curlen = pref(n - 1) + 1;
			if (chkmax(len2, curlen)) {
				op2 = "1 ";
				op2 += to_string(preflong(i - 1)) + " ";
				op2.pb(ch);
				// dbg(op2);
			}
		} else if (ch == c[i - 1] && ch != c[i]) {
			curlen += numlen(sz[i - 1] + 1) + 1;
			curlen += numlen(sz[i]) + 1;
			if (chkmax(len2, curlen)) {
				op2 = "1 ";
				op2 += to_string(preflong(i - 1)) + " ";
				op2.pb(ch);
				// dbg(op2);
			}
		} else if (ch != c[i - 1] && ch == c[i]) {
			curlen += numlen(sz[i - 1]) + 1;
			curlen += numlen(sz[i] + 1) + 1;
			if (chkmax(len2, curlen)) {
				op2 = "1 ";
				op2 += to_string(preflong(i - 1)) + " ";
				op2.pb(ch);
				// dbg(op2);
			}
		}
	}
	for (int i = 0; i < n; i++) {
		if (sz[i] < 2 || ch == c[i]) continue;
		for (auto leave : can) {
			if (leave >= sz[i]) break;
			curlen = pref(i - 1) + suf(i + 1);
			curlen += numlen(leave) + 1 + 1 + numlen(sz[i] - leave) + 1;
			if (chkmax(len2, curlen)) {
				op2 = "1 " + to_string(preflong(i - 1) + leave) + " ";
				op2.pb(ch);
				// dbg(op2);
			}
		}
	}
}

void solve_delete() {
	int curlen;
	// удалить первый символ
	if (sz[0] == 1) {
		curlen = suf(1);
		if (chkmin(len1, curlen)) {
			op1 = "2 1";
		}
	} else {
		curlen = suf(1) + numlen(sz[0] - 1) + 1;
		if (chkmin(len1, curlen)) {
			op1 = "2 1";
		}
	}
	// удалить последний
	if (sz[n - 1] == 1) {
		curlen = pref(n - 2);
		// dbg(curlen);
		if (chkmin(len1, curlen)) {
			op1 = "2 " + to_string(l);
		}
	} else {
		curlen = pref(n - 2) + numlen(sz[n - 1] - 1) + 1;
		if (chkmin(len1, curlen)) {
			op1 = "2 " + to_string(l);
		}
	}

	for (int i = 1; i < n - 1; i++) { // удалить в блоке
		if (sz[i] == 1) {
			if (c[i - 1] == c[i + 1]) {
				curlen = pref(i - 2) + suf(i + 2) + numlen(sz[i - 1] + sz[i + 1]) + 1;
				if (chkmin(len1, curlen)) {
					op1 = "2 " + to_string(preflong(i - 1) + 1);
				}
			} else {
				curlen = pref(i - 1) + suf(i + 1);
				if (chkmin(len1, curlen)) {
					op1 = "2 " + to_string(preflong(i - 1) + 1);
				}
			}
		} else {
			curlen = pref(i - 1) + suf(i + 1) + numlen(sz[i] - 1) + 1;
			if (chkmin(len1, curlen)) {
				op1 = "2 " + to_string(preflong(i - 1) + 1);
			}
		}
	}
}

void solve_change(char ch) {
	int curlen;
	// меняем блоки длины 1
	for (int i = 0; i < n; i++) {
		if (sz[i] == 1 && ch != c[i]) {
			if (i > 0 && ch == c[i - 1]) {
				curlen = pref(i - 2) + suf(i + 1) + numlen(sz[i - 1] + 1) + 1;
				if (chkmin(len1, curlen)) {
					op1 = "3 " + to_string(preflong(i)) + " ";
					op1.pb(ch);
				}
				if (chkmax(len2, curlen)) {
					op2 = "3 " + to_string(preflong(i)) + " ";
					op2.pb(ch);
				}
			} else if (i < n - 1 && ch == c[i + 1]) {
				curlen = pref(i - 1) + suf(i + 2) + numlen(sz[i + 1] + 1) + 1;
				if (chkmin(len1, curlen)) {
					op1 = "3 " + to_string(preflong(i)) + " ";
					op1.pb(ch);
				}
				if (chkmax(len2, curlen)) {
					op2 = "3 " + to_string(preflong(i)) + " ";
					op2.pb(ch);
				}
			} else if (i > 0 && ch == c[i - 1] && i < n - 1 && ch == c[i + 1]) {
				curlen = pref(i - 2) + suf(i + 2) + numlen(sz[i - 1] + sz[i + 1] + 1) + 1;
				if (chkmin(len1, curlen)) {
					op1 = "3 " + to_string(preflong(i)) + " ";
					op1.pb(ch);
				}
				if (chkmax(len2, curlen)) {
					op2 = "3 " + to_string(preflong(i)) + " ";
					op2.pb(ch);
				}
			} else {
				curlen = pref(n - 1);
				if (chkmin(len1, curlen)) {
					op1 = "3 " + to_string(preflong(i)) + " ";
					op1.pb(ch);
				} 
				if (chkmax(len2, curlen)) {
					op2 = "3 " + to_string(preflong(i)) + " ";
					op2.pb(ch);
				}
			}
		}
	}
	// меняем слева от блока
	for (int i = 0; i < n; i++) {
		if (sz[i] > 1 && ch != c[i]) {
			if (i > 0 && ch == c[i - 1]) {
				curlen = pref(i - 2) + suf(i + 1) + numlen(sz[i - 1] + 1) + 1 + numlen(sz[i] - 1) + 1;
				if (chkmin(len1, curlen)) {
					op1 = "3 " + to_string(preflong(i - 1) + 1) + " ";
					op1.pb(ch);
				}
				if (chkmax(len2, curlen)) {
					op2 = "3 " + to_string(preflong(i - 1) + 1) + " ";
					op2.pb(ch);
				}
			} else {
				curlen = pref(i - 1) + suf(i + 1) + numlen(sz[i] - 1) + 1 + 1;
				if (chkmin(len1, curlen)) {
					op1 = "3 " + to_string(preflong(i - 1) + 1) + " ";
					op1.pb(ch);
				}
				if (chkmax(len2, curlen)) {
					op2 = "3 " + to_string(preflong(i - 1) + 1) + " ";
					op2.pb(ch);
				}
			}
		}
	}
	// меняем справа от блока
	for (int i = 0; i < n; i++) {
		if (sz[i] > 1 && ch != c[i]) {
			if (i < n - 1 && ch == c[i + 1]) {
				curlen = pref(i - 1) + suf(i + 2) + numlen(sz[i] - 1) + 1 + numlen(sz[i + 1] + 1) + 1;
				if (chkmin(len1, curlen)) {
					op1 = "3 " + to_string(preflong(i)) + " ";
					op1.pb(ch);
				}
				if (chkmax(len2, curlen)) {
					op2 = "3 " + to_string(preflong(i)) + " ";
					op2.pb(ch);
				}
			} else {
				curlen = pref(i - 1) + suf(i + 1) + numlen(sz[i] - 1) + 1 + 1;
				if (chkmin(len1, curlen)) {
					op1 = "3 " + to_string(preflong(i)) + " ";
					op1.pb(ch);
				}
				if (chkmax(len2, curlen)) {
					op2 = "3 " + to_string(preflong(i)) + " ";
					op2.pb(ch);
				}
			}
		}
	}
}

string unpack(string s) {
	int ind = 0;
	int ssz = s.size();
	string ans;
	while (ind < ssz) {
		int k = 1;
		if (s[ind] >= '0' && s[ind] <= '9') {
			k = s[ind] - '0';
			ind++;
			while (ind < ssz && s[ind] >= '0' && s[ind] <= '9') {
				k = k * 10 + s[ind] - '0';
				ind++;
			}
		}
		for (int i = 0; i < k; i++) {
			ans.pb(s[ind]);
		}
		ind++;
	}
	return ans;
}

string pack(string s) {
	int ind = 0;
	int ssz = s.size();
	string ans;
	while (ind < ssz) {
		int cnt = 1;
		ind++;
		while (ind < ssz && s[ind] == s[ind - 1]) {
			cnt++;
			ind++;
		}
		if (cnt > 1) {
			ans += to_string(cnt);
		}
		ans.pb(s[ind - 1]);
	}
	return ans;
}

int getlen(string op) {
	int num = 0;
	for (int i = 2; i < (int)op.size() && op[i] >= '0' && op[i] <= '9'; i++) {
		num = num * 10 + op[i] - '0';
	}
	// dbg(op);
	// dbg(num);
	if (op[0] == '1') {
		string s1;
		for (int i = 0; i < num; i++) {
			s1.pb(s[i]);
		}
		s1.pb(op.back());
		for (int i = num; i < s.size(); i++) {
			s1.pb(s[i]);
		}
		s1 = pack(s1);
		return s1.size();
	} else if (op[0] == '2') {
		string s1;
		for (int i = 0; i < s.size(); i++) {
			if (i + 1 == num) continue;
			s1.pb(s[i]);
		}
		s1 = pack(s1);
		return s1.size();
	} else {
		string s1 = s;
		s1[num - 1] = op.back();
		s1 = pack(s1);
		return s1.size();
	}
	return -1;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> s;
	int ssz = s.size();
	int ind = 0;
	n = 0;
	while (ind < ssz) {
		int cnt = 1;
		if (s[ind] >= '0' && s[ind] <= '9') {
			cnt = s[ind] - '0';
			ind++;
			while (ind < n && s[ind] >= '0' && s[ind] <= '9') {
				cnt = cnt * 10 + s[ind];
				ind++;
			}
		}
		sz[n] = cnt;
		c[n] = s[ind];
		n++;
		ind++;
	}
	s = unpack(s);
	for (int i = 0; i < n; i++) {
		l += sz[i];
	}

	preflen[0] = numlen(sz[0]) + 1;
	for (int i = 1; i < n; i++) {
		preflen[i] = preflen[i - 1] + numlen(sz[i]) + 1;
	}
	suflen[n - 1] = numlen(sz[n - 1]) + 1;
	for (int i = n - 2; i >= 0; i--) {
		suflen[i] = suflen[i + 1] + numlen(sz[i]) + 1;
	}

	preflenlong[0] = sz[0];
	for (int i = 1; i < n; i++) {
		preflenlong[i] = preflenlong[i - 1] + sz[i];
	}
	suflenlong[n - 1] = sz[n - 1];
	for (int i = n - 2; i >= 0; i--) {
		suflenlong[i] = suflenlong[i + 1] + sz[i];
	}

	len1 = INF;
	len2 = 0;

	for (int i = 0; i < 4; i++) {
		solve_insert(alp[i]);
	}
	solve_delete();
	for (int i = 0; i < 4; i++) {
		solve_change(alp[i]);
	}

	// cout << len1 << " " << op1 << "\n";
	// cout << len2 << " " << op2 << "\n";
	if (getlen(op1) != len1 || getlen(op2) != len2) {
		assert(s.size() <= 7);
		dbg(getlen(op1));
		dbg(getlen(op2));
		cout << "BAD\n";
	}
	// cout << len1 << " " << len2 << "\n";
	cout << op1 << "\n" << op2 << "\n";
}	
/*
5AC5A2C

3T2GT
correct :
2 7
wrong :
4 7

A2CAC
correct :
3 6
wrong :
4 6

*/