#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <stack>
#include <deque>
#include <queue>
#include <algorithm>
#include <cmath>
#include <random>
#include <time.h>
#include <chrono>
#include <functional>
#include <iomanip>
#include <istream>
#include <ostream>
#include <limits>
#include <cassert>

using namespace std;

template<typename T1, typename T2> bool chkmin(T1& x, const T2& y) {if (y < x) {x = y; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& x, const T2& y) {if (x < y) {x = y; return 1;} return 0;}

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) {
		out << k << " ";
	}
	return out;
}

template<typename T> ostream& operator<< (ostream& out, const pair<T, T>& a) {
	out << "{" << a.first << ", " << a.second << "}";
	return out;
}

template<typename T> istream& operator>> (istream& in, vector<T>& a) {
	for (auto& k : a) {
		in >> k;
	}
	return in;
}

template<typename T> istream& operator>> (istream& in, pair<T, T>& a) {
	in >> a.first >> a.second;
	return in;
}

#define int long long 
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define ld long double
#define pii pair<int, int>

// #pragma GCC optimize("Ofast,unroll-loops,fast-math")
// #pragma GCC target("avx2")

#define time ((ld)clock() / (ld)CLOCKS_PER_SEC)

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
	const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 10;
#else
	#define dbg(x)
	const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 179;
#endif

mt19937 gen(chrono::high_resolution_clock().now().time_since_epoch().count());

const int N = 2e5 + 10;

int n;
int m[N], s[N];
vector<int> a[N];
vector<pii> g[N];
int from[N], to[N];
int in[N], out[N];

void stupid() {
	vector<int> p(n);
	iota(all(p), 0);
	do {
		vector<int> d;
		int len = 0;
		bool ok = 1;
		int sz = 0;
		for (int i = 0; i < n; i++) {
			for (auto k : a[p[i]]) {
				d.pb(len + k);
				sz++;
				if (sz >= 3 && d[sz - 1] - d[sz - 2] != d[sz - 2] - d[sz - 3]) {
					ok = 0;
					break;
				}
			}
			len += s[p[i]];
		}
		if (ok) {
			cout << "Yes\n";
			for (auto k : p) {
				cout << k + 1 << " ";
			}
			cout << "\n";
			exit(0);
		}
	} while (next_permutation(all(p)));
	cout << "No\n";
	exit(0);
}

vector<int> tour;

int used[N];

void dfs(int v) {
	used[v] = 1;
	for (auto[u, id] : g[v]) {
		if (!used[u]) {
			dfs(u);
		}
		tour.pb(id);
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	int mx = 1;
	int dist = -1;
	for (int i = 0; i < n; i++) {
		cin >> m[i] >> s[i];
		chkmax(mx, m[i]);
		a[i].resize(m[i]);
		for (int j = 0; j < m[i]; j++) {
			cin >> a[i][j];
			if (j == 1 && dist == -1) {
				dist = a[i][j] - a[i][j - 1];
			}
			if (j >= 1 && a[i][j] - a[i][j - 1] != dist) {
				cout << "No\n";
				return 0;
			}
		}
	}
	if (mx == 1) {
		stupid();
		return 0;
	}
	vector<int> d;
	for (int i = 0; i < n; i++) {
		d.pb(a[i][0]);
		d.pb(dist - (s[i] - a[i].back()));
		from[i] = a[i][0];
		to[i] = dist - (s[i] - a[i].back());
	}
	sort(all(d));
	d.resize(unique(all(d)) - d.begin());
	int dsz = d.size();
	for (int i = 0; i < n; i++) {
		from[i] = lower_bound(all(d), from[i]) - d.begin();
		to[i] = lower_bound(all(d), to[i]) - d.begin();
		g[to[i]].pb({from[i], i});
		out[to[i]]++, in[from[i]]++;
	}
	vector<int> st, fn;
	for (int i = 0; i < dsz; i++) {
		if (abs(out[i] - in[i]) > 1) {
			cout << "No\n";
			return 0;
		} else if (out[i] > in[i]) {
			st.pb(i);
		} else if (in[i] > out[i]) {
			fn.pb(i);
		}
	}
	if (st.size() > 1 || fn.size() > 1) {
		cout << "No\n";
		return 0;
	}
	if (st.empty()) {
		st.pb(0);
	}
	dfs(st[0]);
	if (tour.size() < n) {
		cout << "No\n";
		return 0;
	}
	cout << "Yes\n";
	for (auto k : tour) {
		cout << k + 1 << " ";
	}
	cout << "\n";
}	
/*
3
1 7
3 
1 8
6
2 8
1 6
-> Yes 
2 1 3

1
1 7
5
-> Yes 
1

1
3 10
2 5 9
-> No

3
1 5 
3
1 3 
3
1 6
3
-> No

4
1 5
0
1 0
0
1 3
3
1 0
0
-> Yes
3 2 4 1
*/