#include <bits/stdc++.h>
#define int long long

using namespace std;

mt19937 rnd(time(nullptr));

struct Node {
    int x, y, sz = 1, g;
    Node * left = nullptr;
    Node * right = nullptr;
    Node(int xx) {
        y = rnd();
        g = xx;
    }
};

int size(Node* kek) {
    if (kek == nullptr) return 0;
    return kek->sz;
}

void upd(Node * kek) {
    if (kek == nullptr) kek->sz = 0;
    else if (kek->left == nullptr && kek->right == nullptr) kek->sz = 1;
    else if (kek->left == nullptr) kek->sz = kek->right->sz + 1;
    else if (kek->right == nullptr) kek->sz = kek->left->sz + 1;
    else kek->sz = kek->left->sz + kek->right->sz + 1;
}

Node * merge(Node * a, Node * b) {
    if (a == nullptr) return b;
    if (b == nullptr) return a;
    if (a->y > b->y) {
        a->right = merge(a->right, b);
        upd(a);
        return a;
    }
    else {
        b->left = merge(a, b->left);
        upd(b);
        return b;
    }
}

pair <Node*, Node*> split(Node * a, int val) {
    if (a == nullptr) return {nullptr, nullptr};
    if (size(a->left) + 1 <= val) {
        auto res = split(a->right, val - size(a->left) - 1);
        a->right = res.first;
        upd(a);
        return {a, res.second};
    }
    else {
        auto res = split(a->left, val);
        a->left = res.second;
        upd(a);
        return {res.first, a};
    }
}

Node * insert(Node * a, int val) {
    Node * newnode = new Node(val);
    auto res = split(a, val);
    return merge(merge(res.first, newnode), res.second);
}

void output(Node * t) {
    if (t == nullptr) return;
    output (t->left);
    cout << t->g << " ";
    output(t->right);
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int k, a, x, b, y;
    cin >> k >> a >> x >> b >> y;
    int res1 = 0, res2 = 0;
    if (k - a > 0)
        res1 = x * (k - a);
    if (k - a - b > 0)
        res1 += y * (k - a - b);
    if (k - b > 0)
        res2 = y * (k - b);
    if (k - a - b > 0)
        res2 += x * (k - a - b);
    cout << max(res1, res2) << "\n";
    return 0;
}
