#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <map>

#define fi first
#define se second

using namespace std;

typedef pair <int, int> pii;
typedef vector <int> vi;
typedef vector <vi> vvi;

vector <vector <pair <int, int>>> g;
vector <int> f, ans;

void dfs(int v) {
  for (; f[v] < (int)g[v].size();) {
    int u = g[v][f[v]].fi;
    int id = g[v][f[v]].se;
    f[v]++;
    dfs(u);
    ans.push_back(id);
  }
}

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  vi l(n), r(n);
  vi tmp;
  {
    for (int i = 0; i < n; i++) {
      int m, s;
      cin >> m >> s;
      vector<int> a(m);
      for (int j = 0; j < m; j++)
        cin >> a[j];
      for (int j = 0; j + 1 < m; j++)
        tmp.push_back(a[j + 1] - a[j]);
      l[i] = a[0], r[i] = s - a.back();
    }
    sort(tmp.begin(), tmp.end());
    if (tmp.size() > 0 && tmp[0] != tmp.back()) {
      cout << "No\n";
      return 0;
    }
  }
  if (n == 1) {
    cout << "Yes\n";
    cout << 1;
    return 0;
  }
  if (n <= 8) {
    vi p(n);
    iota(p.begin(), p.end(), 0);
    do {
      vi x;
      for (int i = 0; i + 1 < n; i++)
        x.push_back(r[p[i]] + l[p[i + 1]]);
      int mi = *min_element(x.begin(), x.end());
      int ma = *max_element(x.begin(), x.end());
      if (mi != ma || (!tmp.empty() && mi != tmp[0]))
        continue;
      cout << "Yes\n";
      for (auto &now : p)
        cout << now + 1 << ' ';
      return 0;
    } while (next_permutation(p.begin(), p.end()));
    cout << "No";
    return 0;
  }
  for (int i = 0; i < n; i++)
    l[i] = tmp[0] - l[i];
  int cnt = 0;
  {
    map<int, int> allx;
    for (int i = 0; i < n; i++)
      allx[l[i]] = allx[r[i]] = 0;
    for (auto &now : allx)
      now.second = cnt++;
    for (int i = 0; i < n; i++)
      l[i] = allx[l[i]], r[i] = allx[r[i]];
  }
  g.resize(cnt);
  for (int i = 0; i < n; i++) {
    int u = l[i], v = r[i];
    g[u].push_back({v, i});
  }
  f.resize(cnt);
  vi degin(cnt), degout(cnt);
  vi s;
  for (int i = 0; i < cnt; i++) {
    degout[i] = g[i].size();
    for (auto id : g[i])
      degin[id.fi]++;
  }
  for (int i = 0; i < cnt; i++)
    if (degout[i] > degin[i])
      s.push_back(i);
  if (s.size() > 1) {
    cout << "No\n";
    return 0;
  }
  f.resize(cnt);
  if (s.empty())
    s.push_back(0);
  dfs(s[0]);
  if (ans.size() != n) {
    cout << "No\n";
    return 0;
  }
  for (int i = 0; i + 1 < n; i++)
    if (l[ans[i]] != r[ans[i + 1]]) {
      cout << "No\n";
      return 0;
    }
  cout << "Yes\n";
  reverse(ans.begin(), ans.end());
  for (auto &now : ans)
    cout << now + 1 << ' ';
  return 0;
}