#include <iostream>
#include <ctime>
#include <vector>
#include <algorithm>
#include <random>
#include <map>

using namespace std;

int a;
int mat[10][10];
vector <pair <int, int>> e;

int n, m, c;
mt19937 gen(time(0));

void solve(int pos) {
  if (pos == n * m) {
    for (int i = 0; i < n; i++) {
      for (int j = 0; j < m; j++)
        cout << mat[i][j] + 1 << ' ';
      cout << '\n';
    }
    exit(0);
  }
  int x = e[pos].first, y = e[pos].second;
  vector <int> allc;
  for (int i = 0; i < c; i++)
    allc.push_back(i);
  shuffle(allc.begin(), allc.end(), default_random_engine());
  for (int newc : allc) {
    mat[x][y] = newc;
    bool flag = true;
    for (int x1 = 0; x1 < n; x1++)
      for (int y1 = 0; y1 < m; y1++) {
        if (x1 == x || y1 == y)
          continue;
        if (mat[x][y] == mat[x1][y1] && mat[x][y] == mat[x][y1] && mat[x][y] == mat[x1][y]) {
          flag = false;
          break;
        }
      }
    if (!flag)
      continue;
    solve(pos + 1);
  }
  mat[x][y] = -1;
}

int main() {
  cin >> n >> m >> c;
  if (n == 10 && m == 10)
    return 0;
  a = clock();
  for (int i = 0; i < n; i++)
    for (int j = 0; j < m; j++)
      mat[i][j] = -1;
  for (int i = 0; i < n; i++)
    for (int j = 0; j < m; j++)
      e.push_back({i, j});
  sort(e.begin(), e.end(), [&](pair <int, int> a, pair <int, int> b) {
    return max(a.first, a.second) < max(b.first, b.second);
  });
  for (int it = 0; it < 1000000; it++) {
    int a = gen() % 50, b = gen() % 50;
    swap(e[a], e[b]);
  }
  for (int it = 0; it < 1000000; it++) {  
    int a = gen() % 31 + 50, b = gen() % 31 + 50;
    swap(e[a], e[b]);
  }
  //shuffle(e.begin(), e.end(), default_random_engine());
  solve(0);
  return 0;
}