#include <iostream>
#include <map>
#include <string>
#include <vector>

using namespace std;

typedef long long ll;

const ll MOD = 1e9 + 7;

int A = 0, B = 0, C = 0, D = 0, A0 = 0, B0 = 0, C0 = 0, D0 = 0;

map <pair <char, vector <int>>, ll> dp;

ll solve(char c, vector <int> arr) {
  if (dp.find({c, arr}) != dp.end())
    return dp[{c, arr}];
  if (arr[0] > A || arr[1] > B || arr[2] > C || arr[3] > D)
    return 0;
  ll res = 0;
  if (c == 'A' || c == 'B') {
    res += solve('A', {arr[0] + 1, arr[1], arr[2], arr[3]});
    res += solve('C', {arr[0], arr[1], arr[2] + 1, arr[3]});
  }
  if (c == 'C' || c == 'D') {
    res += solve('B', {arr[0], arr[1] + 1, arr[2], arr[3]});
    res += solve('D', {arr[0], arr[1], arr[2], arr[3] + 1});
  }
  return dp[{c, arr}] = res * arr[c - 'A'];
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  vector <int> a, b, c;
  {
    string A, B, C;
    cin >> A >> B >> C;
    n = A.size();
    for (char ch : A)
      a.push_back(ch - '0');
    for (char ch : B)
      b.push_back(ch - '0');
    for (char ch : C)
      c.push_back(ch - '0');
  }
  for (int i = 0; i < n; i++) {
    int x = a[i], y = b[i], s = c[i];
    if (x + y == s) {
      A++;
      if (!x || !y || !s)
        A0++;
    }
    if (x + y + 1 == s) {
      B++;
      if (!x || !y || !s)
        B0++;
    }
    if (x + y - 10 == s) {
      C++;
      if (!x || !y || !s)
        C0++;
    }
    if (x + y - 9 == s) {
      D++;
      if (!x || !y || !s)
        D0++;
    }
  }
  dp[{'A', {A, B, C, D}}] = A - A0;
  dp[{'B', {A, B, C, D}}] = B - B0;
  dp[{'C', {A, B, C, D}}] = C - C0;
  dp[{'D', {A, B, C, D}}] = D - D0;
  ll res = 0;
  res += solve('A', {1, 0, 0, 0});
  res += solve('B', {0, 1, 0, 0});
  res += solve('C', {0, 0, 1, 0});
  res += solve('D', {0, 0, 0, 1});
  cout << res;
  return 0;
}