#include <iostream>
#include <map>
#include <string>
#include <vector>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;

const ll MOD = 1e9 + 7;

int A = 0, B = 0, C = 0, D = 0, A0 = 0, B0 = 0, C0 = 0, D0 = 0;

map <pair <char, pair <pii, pii>>, ll> dp;

ll solve(char c, int _a, int _b, int _c, int _d) {
  pair <char, pair <pii, pii>> st = {c, {{_a, _b}, {_c, _d}}};
  if (dp.find(st) != dp.end())
    return dp[st];
  if (_a > A || _b > B || _c > C || _d > D)
    return 0;
  ll res = 0;
  if (c == 'A' || c == 'B') {
    res += solve('A', _a + 1, _b, _c, _d);
    res += solve('C', _a, _b, _c + 1, _d);
  }
  if (c == 'C' || c == 'D') {
    res += solve('B', _a, _b + 1, _c, _d);
    res += solve('D', _a, _b, _c, _d + 1);
  }
  if (c == 'A')
    res *= _a;
  if (c == 'B')
    res *= _b;
  if (c == 'C')
    res *= _c;
  if (c == 'D')
    res *= _d;
  return dp[st] = res % MOD;
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  vector <int> a, b, c;
  {
    string A, B, C;
    cin >> A >> B >> C;
    n = A.size();
    for (char ch : A)
      a.push_back(ch - '0');
    for (char ch : B)
      b.push_back(ch - '0');
    for (char ch : C)
      c.push_back(ch - '0');
  }
  for (int i = 0; i < n; i++) {
    int x = a[i], y = b[i], s = c[i];
    if (x + y == s) {
      A++;
      if (!x || !y || !s)
        A0++;
    }
    if (x + y + 1 == s) {
      B++;
      if (!x || !y || !s)
        B0++;
    }
    if (x + y - 10 == s) {
      C++;
      if (!x || !y || !s)
        C0++;
    }
    if (x + y - 9 == s) {
      D++;
      if (!x || !y || !s)
        D0++;
    }
  }
  if (A + B + C + D != n) {
    cout << 0;
    return 0;
  }
  dp[{'A', {{A, B}, {C, D}}}] = A - A0;
  dp[{'B', {{A, B}, {C, D}}}] = B - B0;
  ll res = 0;
  res += solve('A', 1, 0, 0, 0);
  res += solve('C', 0, 0, 1, 0);
  cout << res % MOD;
  return 0;
}