#include <iostream>
#include <string>
#include <vector>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <vvi> v3i;
typedef vector <v3i> v4i;
typedef vector <v4i> v5i;

const ll MOD = 1e9 + 7;

int A = 0, B = 0, C = 0, D = 0, A0 = 0, B0 = 0, C0 = 0, D0 = 0;

v5i dp;

ll fact[300'001], _fact[300'001];

ll binp(ll a, ll p) {
  if (!p)
    return 1;
  if (p & 1)
    return a * binp(a, p - 1) % MOD;
  ll x = binp(a, p / 2);
  return x * x % MOD;
}

void init() {
  fact[0] = _fact[0] = 1;
  for (int i = 1; i <= 300'000; i++)
    fact[i] = (fact[i - 1] * i) % MOD;
  _fact[300'000] = binp(fact[300'000], MOD - 2);
  for (int i = 299'999; i >= 1; i--)
    _fact[i] = (_fact[i + 1] * (i + 1)) % MOD;
}

ll cnk(ll n, ll k) {
  if (n < 0 || k < 0 || n - k < 0)
    return 0;
  ll res = fact[n];
  res *= _fact[k];
  res %= MOD;
  res *= _fact[n - k];
  res %= MOD;
  return res;
}

ll solve(char c, int _a, int _b, int _c, int _d) {
  if (_a > A || _b > B || _c > C || _d > D)
    return 0;
  auto &now = dp[c - 'A'][_a][_b][_c][_d];
  if (now != -1)
    return now;
  ll res = 0;
  if (c == 'A' || c == 'B') {
    res += solve('A', _a + 1, _b, _c, _d);
    res += solve('C', _a, _b, _c + 1, _d);
  }
  if (c == 'C' || c == 'D') {
    res += solve('B', _a, _b + 1, _c, _d);
    res += solve('D', _a, _b, _c, _d + 1);
  }
  if (c == 'A')
    res *= _a;
  if (c == 'B')
    res *= _b;
  if (c == 'C')
    res *= _c;
  if (c == 'D')
    res *= _d;
  return now = res % MOD;
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  init();
  int n;
  vector <int> a, b, c;
  {
    string A, B, C;
    cin >> A >> B >> C;
    n = A.size();
    for (char ch : A)
      a.push_back(ch - '0');
    for (char ch : B)
      b.push_back(ch - '0');
    for (char ch : C)
      c.push_back(ch - '0');
  }
  for (int i = 0; i < n; i++) {
    int x = a[i], y = b[i], s = c[i];
    if (x + y == s) {
      A++;
      if (!x || !y || !s)
        A0++;
    }
    if (x + y + 1 == s) {
      B++;
      if (!x || !y || !s)
        B0++;
    }
    if (x + y - 10 == s) {
      C++;
      if (!x || !y || !s)
        C0++;
    }
    if (x + y - 9 == s) {
      D++;
      if (!x || !y || !s)
        D0++;
    }
  }
  if (A + B + C + D != n) {
    cout << 0;
    return 0;
  }
  if (C > B || abs(C - B) > 1) {
    cout << 0;
    return 0;
  }
  ll mult = fact[D];
  if (D)
    mult *= cnk(C + D - 1, D);
  mult %= MOD;
  D = 0;
  dp.resize(4, v4i(A + 1, v3i(B + 1, vvi(C + 1, vi(D + 1, -1)))));
  dp[0][A][B][C][D] = A - A0;
  dp[1][A][B][C][D] = B - B0;
  ll res = 0;
  res += solve('A', 1, 0, 0, 0);
  res += solve('C', 0, 0, 1, 0);
  cout << res * mult % MOD;
  return 0;
}