#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <functional>


#define abs _abs

template<typename T>
T _abs(T val) {
	return (val < 0) ? (-val) : val;
}

struct ans_t {
	char ch;
	int64_t x, dlt;

	ans_t(char ch = '-', int64_t x = -1, int64_t dlt = 1e18) : ch(ch), x(x), dlt(dlt) {
		;
	}

	bool operator<(const ans_t &other)const {
		if (dlt != other.dlt) {
			return dlt < other.dlt;
		}
		if (ch != other.ch) {
			return (ch < other.ch) xor (!('V' < 'H'));
		}
		return x < other.x;
	}
};

int64_t func(int64_t a, int64_t d, int64_t c) {
	return (2 * a + d * (c - 1)) * c / 2;
}

int64_t vSum(int64_t x, int64_t n, int64_t m) {
	return func(1, m, n) * x + func(0, n, x);
}

int64_t hSum(int64_t x, int64_t n, int64_t m) {
	return func(1, 1, n) * x + func(0, m * m, x);
}

ans_t vGet(int64_t x, int64_t n, int64_t m) {
	return ans_t('V', x, std::max(vSum(x, n, m), func(1, 1, n * m) - vSum(x, n, m)));
}

ans_t hGet(int64_t x, int64_t n, int64_t m) {
	return ans_t('H', x, std::max(hSum(x, n, m), func(1, 1, n * m) - hSum(x, n, m)));
}


void solve() {
	int64_t n, m;
	std::cin >> n >> m;

	ans_t ans;

	//{
	//	int64_t beg = 0, end = n;
	//	while (beg + 5 < end) {
	//		int64_t m1 = beg + (end - beg) / 3, m2 = end - (end - beg) / 3;
	//		if (hGet(m1, n, m) < hGet(m2, n, m)) {
	//			end = m2;
	//		} else {
	//			beg = m1;
	//		}
	//	}
	//	for (int64_t i = beg; i <= end; i++) {
	//		ans = std::min(ans, hGet(i, n, m));
	//	}
	//}
	//{
	//	int64_t beg = 0, end = m;
	//	while (beg + 5 < end) {
	//		int64_t m1 = beg + (end - beg) / 3, m2 = end - (end - beg) / 3;
	//		if (vGet(m1, n, m) < vGet(m2, n, m)) {
	//			end = m2;
	//		} else {
	//			beg = m1;
	//		}
	//	}
	//	for (int64_t i = beg; i <= end; i++) {
	//		ans = std::min(ans, vGet(i, n, m));
	//	}
	//}
	//

	for (int64_t i = 0; i <= n; i++) {
		ans = std::min(ans, hGet(i, n, m));
	}
	for (int64_t i = 0; i <= m; i++) {
		ans = std::min(ans, vGet(i, n, m));
	}

	std::cout << ans.ch << " " << ans.x + 1 << '\n';
}


int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int t;
	std::cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}

/*
5
1 3
4 7
1 10
3 3
3 5

*/