#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <functional>


const std::vector<char> chr = { 'A', 'C', 'G', 'T' };

int len(int val) {
	int res = 0;
	while (val > 0) {
		res++;
		val /= 10;
	}
	return res;
}

struct ans_t {
	char type;
	char ch;
	int x, dlt;

	ans_t(char type = '-', char ch = '-', int x = -1, int dlt = -1) : type(type), ch(ch), x(x), dlt(dlt) {
		;
	}

	friend std::ostream &operator<<(std::ostream &out, const ans_t &val) {
		out << val.type << ' ' << val.x;
		if (val.ch != '-') {
			out << ' ' << val.ch;
		}
		return out;
	}
};

ans_t minMerge(ans_t l, ans_t r) {
	if (l.type == '-') {
		return r;
	}
	if (r.type == '-') {
		return l;
	}
	return ((l.dlt < r.dlt) ? l : r);
}

ans_t maxMerge(ans_t l, ans_t r) {
	if (l.type == '-') {
		return r;
	}
	if (r.type == '-') {
		return l;
	}
	return ((l.dlt < r.dlt) ? r : l);
}



int32_t main() {
#ifdef VS
	freopen("test.in", "r", stdin);
#endif // VS

	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::vector<std::pair<int, char>> vec;

	while (true) {
		int l;
		std::cin >> l;
		if (std::cin.fail()) {
			l = 1;
			std::cin.clear();
		}
		char ch;
		if (std::cin >> ch) {
			vec.push_back({ l, ch });
		} else {
			break;
		}
	}

	ans_t min, max;

	for (char ch : chr) {
		if (ch != vec.front().second) {
			min = minMerge(min, ans_t('1', ch, 0, 1));
			max = maxMerge(max, ans_t('1', ch, 0, 1));
		}
	}

	int s = 0;
	for (int i = 0; i < vec.size(); i++) {
		if (vec[i].first == 1) {
			if (((i > 0) && (i + 1 < vec.size())) && (vec[i - 1].second == vec[i + 1].second)) {
				min = minMerge(min, ans_t('2', '-', s + 1, len(vec[i - 1].first + vec[i + 1].first) - len(vec[i - 1].first) - len(vec[i + 1].first) - 1 - 1));
			} else {
				min = minMerge(min, ans_t('2', '-', s + 1, -1));
			}
			for (char ch : chr) {
				if ((ch != vec[i].second) && ((i == 0) || (ch != vec[i - 1].second)) && ((i == (vec.size() - 1)) || (ch != vec[i + 1].second))) {
					max = maxMerge(max, ans_t('1', ch, s + 1, 1));
					break;
				}
			}
		} else {
			min = minMerge(min, ans_t('2', '-', s + 1, len(vec[i].first - 1) - len(vec[i].first)));
			for (char ch : chr) {
				if ((ch != vec[i].second) && ((i == 0) || (ch != vec[i - 1].second)) && ((i == (vec.size() - 1)) || (ch != vec[i + 1].second))) {
					int a = vec[i].first / 2;
					int b = vec[i].first - a;
					max = maxMerge(max, ans_t('1', ch, s + 1 + vec[i].first / 2, 1 + len(a) + (a != 1) + len(b) + (b != 1)
						- len(vec[i].first) - (vec[i].first != 1)));
					break;
				}
			}
		}
		s += vec[i].first;
	}

	std::cerr << min.dlt << " " << max.dlt << "\n";
	std::cout << min << '\n' << max << '\n';

	return 0;
}
/*
5AC5A2C

*/