#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <functional>



const std::vector<char> chr = { 'A', 'C', 'G', 'T' };
const std::vector<int> bUl1Sh1T = { (int)1e0, 2, (int)1e1, (int)1e2, (int)1e3, (int)1e4, (int)1e5, (int)1e6, (int)1e7, (int)1e8, (int)1e9 };

int len(int val) {
	int res = 0;
	while (val > 0) {
		res++;
		val /= 10;
	}
	return res;
}

struct ans_t {
	char type;
	char ch;
	int x, dlt;

	ans_t(char type = '-', char ch = '-', int x = -1, int dlt = -1) : type(type), ch(ch), x(x), dlt(dlt) {
		;
	}

	friend std::ostream &operator<<(std::ostream &out, const ans_t &val) {
		out << val.type << ' ' << val.x;
		if (val.ch != '-') {
			out << ' ' << val.ch;
		}
		return out;
	}
};

ans_t minMerge(ans_t l, ans_t r) {
	if (l.type == '-') {
		return r;
	}
	if (r.type == '-') {
		return l;
	}
	return ((l.dlt < r.dlt) ? l : r);
}

ans_t maxMerge(ans_t l, ans_t r) {
	if (l.type == '-') {
		return r;
	}
	if (r.type == '-') {
		return l;
	}
	return ((l.dlt < r.dlt) ? r : l);
}



int32_t main() {
#ifdef VS
	freopen("test.in", "r", stdin);
#endif // VS

	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::vector<std::pair<int, char>> vec;

	while (true) {
		int l;
		std::cin >> l;
		if (std::cin.fail()) {
			l = 1;
			std::cin.clear();
		}
		char ch;
		if (std::cin >> ch) {
			vec.push_back({ l, ch });
		} else {
			break;
		}
		if (vec.size() > 1) {
			if (vec.rbegin()[0].second == vec.rbegin()[1].second) {
				exit(235);
			}
		}
	}

	ans_t min, max;

	int s = 0;
	for (int i = 0; i < vec.size(); i++) {
		if (vec[i].first == 1) {
			if (((i > 0) && ((i + 1) < vec.size())) && (vec[i - 1].second == vec[i + 1].second)) {
				int a = vec[i - 1].first;
				int b = vec[i + 1].first;
				min = minMerge(min, ans_t('2', '-', s + 1, len(a + b) + 1 - len(a) * (a > 1) - 1 - len(b) * (b > 1) - 1 - 1));
			} else {
				min = minMerge(min, ans_t('2', '-', s + 1, -1));
			}
			max = maxMerge(max, ans_t('1', vec[i].second, s, 1));
		} else {
			min = minMerge(min, ans_t('2', '-', s + 1, len(vec[i].first - 1) - (vec[i].first == 2) - len(vec[i].first)));
			for (char ch : chr) {
				if ((ch != vec[i].second) && ((i == 0) || (ch != vec[i - 1].second)) && ((i == (vec.size() - 1)) || (ch != vec[i + 1].second))) {
					max = maxMerge(max, ans_t('1', ch, s, 1));
					for (int a : bUl1Sh1T) {
						if (a >= vec[i].first) {
							break;
						}
						int b = vec[i].first - a;
						max = maxMerge(max, ans_t('1', ch, s + a, 1 + len(a) * (a > 1) + 1 + len(b) * (b > 1) + 1
							- len(vec[i].first) - 1));
					}
				}
			}
		}
		s += vec[i].first;
	}

	std::cerr << min.dlt << " " << max.dlt << "\n";
	std::cout << min << '\n' << max << '\n';

	return 0;
}
/*
5AC5A2C

*/