#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <functional>

struct Data {
	int a, b;
	int num;
};

void comp(std::vector<int *> &vec) {
	if (vec.empty()) {
		return;
	}
	std::sort(vec.begin(), vec.end(), [](int *a, int *b) {return (*a) < (*b); });
	int l = *vec[0];
	*vec[0] = 0;
	for (int i = 1; i < vec.size(); i++) {
		int r = *vec[i];
		*vec[i] = (*vec[i - 1]) + std::min(1, r - l);
		l = r;
	}
}

void dfs(int v, std::vector<std::vector<std::pair<int, int>>> &gr, std::vector<int> &res) {
	while (!gr[v].empty()) {
		auto e = gr[v].back();
		gr[v].pop_back();
		dfs(e.first, gr, res);
		res.push_back(e.second);
	}
}

void func(std::vector<Data> vec) {
	int n = vec.size();
	{
		static std::vector<int *> help;
		help.clear();
		for (int i = 0; i < n; i++) {
			help.insert(help.end(), { &vec[i].a, &vec[i].b });
		}
		comp(help);
	}

	n = 3 * n + 5;
	static std::vector<std::vector<std::pair<int, int>>> gr;
	static std::vector<int> in, out;

	if (gr.size() < n) {
		gr.resize(n);
		in.resize(n);
		out.resize(n);
	}
	for (int i = 0; i < n; i++) {
		gr[i].clear();
		in[i] = out[i] = 0;
	}
	for (auto [a, b, num] : vec) {
		gr[a].push_back({ b, num });
		out[a]++;
		in[b]++;
	}

	int cntl = 0, cntg = 0;
	for (int i = 0; i < n; i++) {
		if (((in[i] - out[i]) > 1) || ((in[i] - out[i]) < -1)) {
			return;
		}
		cntl += in[i] < out[i];
		cntg += in[i] > out[i];
	}
	
	if ((cntl > 1) || (cntg > 1)) {
		return;
	}
	if (cntl != cntg) {
		exit(2352);
	}

	std::vector<int> res;
	if (cntl == 0) {
		for (int i = 0; i < n; i++) {
			if (out[i] > 0) {
				dfs(i, gr, res);
				std::reverse(res.begin(), res.end());
				if (res.size() == vec.size()) {
					std::cout << "Yes\n";
					for (int i = 0; i < res.size(); i++) {
						std::cout << res[i] + 1 << " \n"[i == (vec.size() - 1)];
					}
					exit(0);
				}
				break;
			}
		}
		return;
	} else {
		for (int i = 0; i < n; i++) {
			if (out[i] > in[i]) {
				dfs(i, gr, res);
				std::reverse(res.begin(), res.end());
				if (res.size() == vec.size()) {
					std::cout << "Yes\n";
					for (int i = 0; i < res.size(); i++) {
						std::cout << res[i] + 1 << " \n"[i == (vec.size() - 1)];
					}
					exit(0);
				}
				break;
			}
		}
		return;
	}
}


constexpr int MAXN = 1e5 + 5;

int n, dlt = -1;
Data input[MAXN];


int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int mx = 0;
	std::cin >> n;
	for (int i = 0; i < n; i++) {
		int m, s;
		std::cin >> m >> s;
		mx = std::max(mx, s);
		std::vector<int> vec(m);
		for (int &v : vec) {
			std::cin >> v;
		}
		input[i] = { vec.front(), s - vec.back(), i };
		for (int i = 1; i < m; i++) {
			if (dlt == -1) {
				dlt = vec[i] - vec[i - 1];
			} else if (dlt != (vec[i] - vec[i - 1])) {
				std::cout << "No\n";
				exit(0);
			}
		}
	}
	if (n == 1) {
		std::cout << "Yes\n1\n";
		exit(0);
	}



	if (dlt != -1) {
		std::vector<Data> vec(input, input + n);
		int help = 2 * n;
		for (int i = 0; i < n; i++) {
			vec[i].b = dlt - input[i].b;
			if (vec[i].b < 0) {
				vec[i].b = help++;
			}
		}
		func(std::vector<Data>(vec));

		std::cout << "No\n";
		exit(0);
	}
	if (n <= 1000) {
		for (int j = 0; j < 2; j++) {
			for (int i = 0; i < n; i++) {
				if (i == j) {
					continue;
				}
				int dlt = input[i].b + input[j].a;
				std::vector<Data> vec(input, input + n);
				int help = 2 * n;
				for (int i = 0; i < n; i++) {
					vec[i].b = dlt - input[i].b;
					if (vec[i].b < 0) {
						vec[i].b = help++;
					}
				}
				func(std::vector<Data>(vec));
			}
		}
	}

	if (mx <= 100) {
		for (int dlt = 0; dlt <= 200; dlt++) {
			std::vector<Data> vec(input, input + n);
			int help = 2 * n;
			for (int i = 0; i < n; i++) {
				vec[i].b = dlt - input[i].b;
				if (vec[i].b < 0) {
					vec[i].b = help++;
				}
			}
			func(std::vector<Data>(vec));
		}
		std::cout << "No\n";
		exit(0);
	}

	std::cout << "No\n";

	return 0;
}
/*
3
1 7
3
1 8
6
2 8
1 6



4
1 5
0
1 0
0
1 3
3
1 0
0


4
1 2 
1
1 2 
1
1 2
1
2 3
1 2


*/