#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <functional>

#include <random>

std::mt19937 rnd(4323643);
constexpr int MAXN = 10;

int data[MAXN][MAXN];
int n, m, c;
int cnt;
std::vector<std::pair<std::pair<char, char>, std::pair<char, char>>> vec;


int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n >> m >> c;

	for (char x1 = 0; x1 < n; x1++) {
		for (char x2 = x1 + 1; x2 < n; x2++) {
			for (char y1 = 0; y1 < m; y1++) {
				for (char y2 = y1 + 1; y2 < m; y2++) {
					vec.push_back({ {x1, y1}, {x2, y2} });
				}
			}
		}
	}

	for (uint32_t it = 0; ; it++) {
		if (it % 1024 == 0) {
			bool may = true;

			for (auto [a, b] : vec) {
				auto [x1, y1] = a; auto [x2, y2] = b;
				may = may && !(data[x1][y1] == data[x1][y2] && data[x1][y1] == data[x2][y1] && data[x1][y1] == data[x2][y2]);
			}
			if (may) {
				break;
			}
		}

		char x1 = rnd() % n, x2 = (x1 + rnd() % (n - 1) + 1) % n, y1 = rnd() % m, y2 = (y1 + rnd() % (m - 1) + 1) % m;
		if (data[x1][y1] == data[x1][y2] && data[x1][y1] == data[x2][y1] && data[x1][y1] == data[x2][y2]) {
			switch (rnd() % 4) {
			case(0):
				data[x1][y1] = (data[x1][y1] + 1 + rnd() % (c - 1)) % c;
				break;
			case(1):
				data[x1][y2] = (data[x1][y2] + 1 + rnd() % (c - 1)) % c;
				break;
			case(2):
				data[x2][y1] = (data[x2][y1] + 1 + rnd() % (c - 1)) % c;
				break;
			case(3):
				data[x2][y2] = (data[x2][y2] + 1 + rnd() % (c - 1)) % c;
				break;
			default:
				exit(2523);
			}
		} else {
			cnt++;
			if (cnt > 0) {
				cnt = 0;
				std::shuffle(vec.begin(), vec.end(), rnd);
				for (auto [a, b] : vec) {
					auto [x1, y1] = a; auto [x2, y2] = b;
					if (data[x1][y1] == data[x1][y2] && data[x1][y1] == data[x2][y1] && data[x1][y1] == data[x2][y2]) {
						switch (rnd() % 4) {
						case(0):
							data[x1][y1] = (data[x1][y1] + 1 + rnd() % (c - 1)) % c;
							break;
						case(1):
							data[x1][y2] = (data[x1][y2] + 1 + rnd() % (c - 1)) % c;
							break;
						case(2):
							data[x2][y1] = (data[x2][y1] + 1 + rnd() % (c - 1)) % c;
							break;
						case(3):
							data[x2][y2] = (data[x2][y2] + 1 + rnd() % (c - 1)) % c;
							break;
						default:
							exit(2523);
						}
						break;
					}
				}
				cnt = 0;
			}
		}

	}

	for (char i = 0; i < n; i++) {
		for (char j = 0; j < m; j++) {
#ifndef VS
			data[i][j]++;
#endif // !VS
			std::cout << (int)data[i][j];
#ifndef VS
			std::cout << " ";
#endif // !VS

		}
		std::cout << "\n";
}

	return 0;
}