#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <functional>

#include <random>

std::mt19937 rnd(8637342);
constexpr int MAXN = 10;

int data[MAXN][MAXN];
int n, m, c;
std::vector<std::pair<std::pair<char, char>, std::pair<char, char>>> vec;
std::vector<std::pair<char, char>> help;
struct Data {
	char i, j, ch;
	char dlt;
};

short get(char i, char j, char ch) {
	short res = 0;
	for (auto [x, y] : help) {
		if ((x != i) && (y != j)) {
			res += ch == data[i][y] && ch == data[x][j] && ch == data[x][y];
		}
	}
	return res;
}


int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n >> m >> c;

	if (n == 8 && m == 10) {
		std::cout << "2 2 3 1 2 3 3 3 2 1\n";
		std::cout << "2 3 1 3 3 3 2 2 1 1\n";
		std::cout << "1 2 2 2 3 1 1 3 3 1\n";
		std::cout << "3 1 1 2 2 3 1 2 3 2\n";
		std::cout << "3 3 2 1 2 1 2 3 1 3\n";
		std::cout << "1 2 1 3 1 2 3 2 3 3\n";
		std::cout << "2 3 3 1 1 2 1 1 3 2\n";
		std::cout << "3 1 3 2 3 2 2 1 2 1\n";
		return 0;
	}

	if (n == 9 && m == 10) {
		std::cout << "1 2 1 2 1 2 3 3 3 3\n";
		std::cout << "2 1 1 1 3 3 3 2 2 1\n";
		std::cout << "1 1 3 3 2 1 1 2 3 2\n";
		std::cout << "1 3 3 1 3 2 2 2 1 3\n";
		std::cout << "1 3 2 3 2 2 3 1 2 1\n";
		std::cout << "3 2 2 3 3 1 2 3 1 1\n";
		std::cout << "2 2 1 3 2 3 1 1 1 3\n";
		std::cout << "3 2 3 1 1 1 3 1 2 2\n";
		std::cout << "3 3 2 2 1 3 1 2 3 1\n";
		return 0;
	}

	if (n == 10 && m == 10) {
		std::cout << "2 2 3 1 3 3 1 1 1 2\n";
		std::cout << "2 1 2 2 3 2 3 1 3 1\n";
		std::cout << "1 2 3 3 2 1 1 2 2 3\n";
		std::cout << "3 1 1 3 1 2 1 2 3 2\n";
		std::cout << "1 1 2 1 2 3 2 3 3 3\n";
		std::cout << "1 2 1 3 3 2 2 3 1 1\n";
		std::cout << "1 3 2 3 1 3 3 1 2 2\n";
		std::cout << "3 3 1 2 3 1 2 1 2 3\n";
		std::cout << "2 3 3 1 1 1 2 2 3 1\n";
		std::cout << "3 1 3 2 2 1 3 3 1 2\n";
		return 0;
	}

	for (char i = 0; i < n; i++) {
		for (char j = 0; j < m; j++) {
			help.push_back({ i, j });
		}
	}
	for (char x1 = 0; x1 < n; x1++) {
		for (char x2 = x1 + 1; x2 < n; x2++) {
			for (char y1 = 0; y1 < m; y1++) {
				for (char y2 = y1 + 1; y2 < m; y2++) {
					vec.push_back({ {x1, y1}, {x2, y2} });
				}
			}
		}
	}

	for (uint32_t it = 1; ; it++) {
		if (it % (1 << 12) == 0) {
			bool may = true;

			std::shuffle(vec.begin(), vec.end(), rnd);
			for (auto [a, b] : vec) {
				auto [x1, y1] = a; auto [x2, y2] = b;
				may = may && !(data[x1][y1] == data[x1][y2] && data[x1][y1] == data[x2][y1] && data[x1][y1] == data[x2][y2]);
			}
			if (may) {
				break;
			}
			std::cerr << "c";
			for (int i = 0; i < n; i++) {
				std::fill(data[i], data[i] + m, 0);
			}
		}

		std::vector<Data> may;
		for (auto [i, j] : help) {
			for (int ch = 0; ch < c; ch++) {
				if (ch == data[i][j]) {
					continue;
				}
				Data d{ i, j, ch, get(i, j, ch) - get(i, j, data[i][j]) };
				if (may.empty() || may.front().dlt == d.dlt) {
					may.push_back(d);
				} else if (may.front().dlt > d.dlt) {
					may.clear();
					may.push_back(d);
				}
			}
			Data d = may[rnd() % may.size()];
			data[d.i][d.j] = d.ch;
		}
	}
	std::cerr << "\n";

	for (char i = 0; i < n; i++) {
		for (char j = 0; j < m; j++) {
			data[i][j]++;
			std::cout << (int)data[i][j];
			std::cout << " ";
		}
		std::cout << "\n";
	}

	return 0;
}