#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <functional>


constexpr int64_t mod = 1e9 + 7;
constexpr int MAXN = 2e2 + 5;


void add(int &a, int b) {
	a += b;
	a = a - (a >= mod) * mod;
}

int dp[2][MAXN][MAXN][MAXN][4];
int _fact[MAXN];

int fact(int i) {
	if (_fact[i] == 0) {
		if (i == 0) {
			_fact[i] = 1;
		} else {
			_fact[i] = (fact(i - 1) * 1ll * i) % mod;
		}
	}
	return _fact[i];
}

constexpr double MEM = (sizeof(dp)) * 1.0 / (1 << 20);


int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::string a, b, c;
	std::cin >> a >> b >> c;
	int n = a.size();

	std::for_each(a.begin(), a.end(), [](char &ch) {ch -= '0'; });
	std::for_each(b.begin(), b.end(), [](char &ch) {ch -= '0'; });
	std::for_each(c.begin(), c.end(), [](char &ch) {ch -= '0'; });

	int cnt[4] = { 0, 0, 0, 0 };// { 00, 01, 10, 11 }
	for (int i = 0; i < n; i++) {
		if ((a[i] + b[i]) % 10 == c[i]) {
			if ((a[i] + b[i]) >= 10) {
				cnt[1]++;
			} else {
				cnt[0]++;
			}
		} else if ((a[i] + b[i] + 1) % 10 == c[i]) {
			if ((a[i] + b[i] + 1) >= 10) {
				cnt[3]++;
			} else {
				cnt[2]++;
			}
		} else {
			std::cout << "0\n";
			return 0;
		}
	}

	dp[1][1][0][0][0] = dp[1][0][1][0][1] = 1;

	for (int k = 1; k < n; k++) {
		for (int a = 0; a <= cnt[0]; a++) {
			if (a > k) {
				break;
			}
			for (int b = 0; b <= cnt[1]; b++) {
				if ((a + b) > k) {
					break;
				}
				for (int c = 0; c <= cnt[2]; c++) {
					if ((a + b + c) > k) {
						break;
					}
					int d = k - a - b - c;
					for (int l = 0; l < 4; l++) {
						dp[(k + 1) % 2][a][b][c][l] = 0;
					}
				}
			}
		}
		for (int a = 0; a <= cnt[0]; a++) {
			if (a > k) {
				break;
			}
			for (int b = 0; b <= cnt[1]; b++) {
				if ((a + b) > k) {
					break;
				}
				for (int c = 0; c <= cnt[2]; c++) {
					if ((a + b + c) > k) {
						break;
					}
					int d = k - a - b - c;
					for (int l = 0; l < 4; l++) {
						int v = dp[k % 2][a][b][c][l];
						if (v) {
							int xxx(0);
						}
						if (l == 0 || l == 2) {
							add(dp[(k + 1) % 2][a + 1][b][c][0], v);
							add(dp[(k + 1) % 2][a][b + 1][c][1], v);
						} else {
							add(dp[(k + 1) % 2][a][b][c + 1][2], v);
							add(dp[(k + 1) % 2][a][b][c][3], v);
						}
					}
				}
			}
		}
	}

	int64_t res = dp[n % 2][cnt[0]][cnt[1]][cnt[2]][0] + dp[n % 2][cnt[0]][cnt[1]][cnt[2]][2];
	res %= mod;

	res *= fact(cnt[0]);
	res %= mod;
	res *= fact(cnt[1]);
	res %= mod;
	res *= fact(cnt[2]);
	res %= mod;
	res *= fact(cnt[3]);
	res %= mod;

	std::cout << res << '\n';

	return 0;
}