//#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <functional>


constexpr int64_t mod = 1e9 + 7;
constexpr int MAXN = 200 + 1;


int64_t power(int64_t base, int64_t exp) {
	int64_t res = 1;
	for (int64_t k = 0; (1ll << k) <= exp; k++) {
		if ((exp >> k) & 1) {
			res = (res * base) % mod;
		}
		base = (base * base) % mod;
	}
	return res;
}

int64_t mul(int64_t a, int64_t b) {
	return (a * b) % mod;
}

void add(int &a, int b) {
	a += b;
	a = a - (a >= mod) * mod;
}

int dp[2][MAXN][MAXN][MAXN][4];
int _fact[MAXN];

int fact(int i) {
	if (i < 0) {
		return 0;
	}
	if (_fact[i] == 0) {
		if (i == 0) {
			_fact[i] = 1;
		} else {
			_fact[i] = (fact(i - 1) * 1ll * i) % mod;
		}
	}
	return _fact[i];
}

int C(int n, int k) {
	return mul(fact(n), mul(power(fact(k), mod - 2), power(fact(n - k), mod - 2)));
}

constexpr double MEM = (sizeof(dp) + sizeof(_fact)) * 1.0 / (1 << 20);


int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::string a, b, c;
	std::cin >> a >> b >> c;
	int n = a.size();

	std::for_each(a.begin(), a.end(), [](char &ch) {ch -= '0'; });
	std::for_each(b.begin(), b.end(), [](char &ch) {ch -= '0'; });
	std::for_each(c.begin(), c.end(), [](char &ch) {ch -= '0'; });

	int cnt[4] = { 0, 0, 0, 0 };// { 00, 01, 10, 11 }
	int cnth0 = 0, cnth1 = 0;
	for (int i = 0; i < n; i++) {
		if ((a[i] + b[i]) % 10 == c[i]) {
			if ((a[i] + b[i]) >= 10) {
				cnt[1]++;
			} else {
				cnt[0]++;
				cnth0 += a[i] == 0 || b[i] == 0;
			}
		} else if ((a[i] + b[i] + 1) % 10 == c[i]) {
			if ((a[i] + b[i] + 1) >= 10) {
				cnt[3]++;
			} else {
				cnt[2]++;
				cnth1 += a[i] == 0 || b[i] == 0;
			}
		} else {
			std::cout << "0\n";
			return 0;
		}
	}

	dp[1][1][0][0][0] = dp[1][0][1][0][1] = 1;

	for (int k = 1; k < n; k++) {
		for (int a = 0; a <= cnt[0]; a++) {
			if (a > k) {
				break;
			}
			for (int b = 0; b <= cnt[1]; b++) {
			    if ((a + b) > k) {
					break;
				}
				for (int c = 0; c <= cnt[2]; c++) {
					if ((a + b + c) > k) {
						break;
					}
					int d = k - a - b - c;
					for (int l = 0; l < 4; l++) {
						dp[(k + 1) % 2][a][b][c][l] = 0;
					}
				}
			}
		}
		for (int a = 0; a <= cnt[0]; a++) {
			if (a > k) {
				break;
			}
			for (int b = 0; b <= cnt[1]; b++) {
				if ((a + b) > k) {
					break;
				}
				for (int c = 0; c <= cnt[2]; c++) {
					if ((a + b + c) > k) {
						break;
					}
					int d = k - a - b - c;
					for (int l = 0; l < 4; l++) {
						int v = dp[k % 2][a][b][c][l];

						if (l == 0 || l == 2) {
							add(dp[(k + 1) % 2][a + 1][b][c][0], v);
							add(dp[(k + 1) % 2][a][b + 1][c][1], v);
						} else {
							add(dp[(k + 1) % 2][a][b][c + 1][2], v);
							add(dp[(k + 1) % 2][a][b][c][3], v);
						}
					}
				}
			}
		}
	}

	int64_t res0 = dp[n % 2][cnt[0]][cnt[1]][cnt[2]][0];
	int64_t res1 = dp[n % 2][cnt[0]][cnt[1]][cnt[2]][2];

	res0 = mul(res0, mul(cnt[0] - cnth0, fact(cnt[0] - 1)));
	res0 = mul(res0, fact(cnt[2]));

	res1 = mul(res1, mul(cnt[2] - cnth1, fact(cnt[2] - 1)));
	res1 = mul(res1, fact(cnt[0]));

	int64_t res = res0 + res1;

	res = mul(res, fact(cnt[1]));
	res = mul(res, fact(cnt[3]));

	std::cout << res << '\n';

	return 0;
}