#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <assert.h>
#include <random>
#include <ctime>
#define int long long
//#define x first
//#define y second

using namespace std;

const int MOD = (int)(1e9) + 7;
const int SZ = 1000;
vector<int> _fact(SZ, -1);
int ncr[SZ][SZ];

int pow(int x, int y) {
    if (y == 0)
        return 1;
    int m = pow(x, y / 2);
    if (y % 2)
        return (m * m * x) % MOD;
    else
        return (m * m) % MOD;
}

int get_fact(int x);

int fact(int x) {
    if (x == 0)
        return 1;
    return (get_fact(x - 1) * x) % MOD;
}

int get_fact(int x) {
    if (_fact[x] == -1)
        _fact[x] = fact(x);
    return _fact[x];
}

int fact(int x, int y) {
    if (x == y)
        return 1;
    return (x * fact(x - 1, y)) % MOD;
}

int getncr(int x, int y) {
    return ncr[x][y];
}


int solve(string s1, string s2, string s3) {
    int n = s1.size();
    int w = 0;
    int wz = 0;
    int x = 0;
    int z = 0;
    int y = 0;
    int yz = 0;
    assert(n < 1000);
    for (int i = 0; i < n; ++i) {
        int a = s1[i] - '0', b = s2[i] - '0', c = s3[i] - '0';
        if (a + b == c) {
            ++w;
            if (a == 0 || b == 0 || c == 0)
                ++wz;
        }
        else if (a + b == c + 10) {
            ++x;
        }
        else if (a + b + 1 == c) {
            ++y;
            if (a == 0 || b == 0 || c == 0)
                ++yz;
        }
        else if (a + b + 1 == c + 10) {
            ++z;
        }
        else {
            return 0;
        }
    }
    if (y != x || (z > 0 && x == 0) || (w + y) == 0)
    {
        return 0;
    }
    memset(ncr, 0, sizeof(ncr));
    ncr[0][0] = 1;
    for (int i = 1; i <= n; ++i)
    {
        ncr[i][0] = 1;
        for (int j = 1; j <= n; ++j)
        {
            ncr[i][j] = ncr[i - 1][j - 1] + ncr[i - 1][j];
            if (ncr[i][j] >= MOD)
                ncr[i][j] -= MOD;
        }
    }
    int distrz;
    if (z == 0 && x == 0)
        distrz = 1;
    else
        distrz = getncr(z + x - 1, x - 1);
    int pw = (distrz * getncr(w - 1 + y, y)) % MOD;
    int py = (distrz * getncr(w - 1 + y, w)) % MOD;
    int tdistr = (get_fact(z) * get_fact(x)) % MOD;
    int ans = 0;
    if (w - wz != 0)
        ans += ((((pw * tdistr) % MOD * (w - wz)) % MOD * get_fact(w - 1)) % MOD * get_fact(y)) % MOD;
    if (y - yz != 0)
        ans += ((((py * tdistr) % MOD * (y - yz)) % MOD * get_fact(y - 1)) % MOD * get_fact(w)) % MOD;
    return ans;
}

int32_t main()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    string s1, s2, s3;
    cin >> s1 >> s2 >> s3;
    cout << solve(s1, s2, s3) << '\n';
}