#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

auto cmp = [](pair<int, int> a, pair<int, int> b) { return a > b; };

int n, * m, * s;
int** p;
set<pair<int, int>> start;
pair<int, int>* finish;

bool check(int dist)
{
	int cnt_fail = 0;
	int* next = new int[n];
	for (int i = 0; i < n; i++)
	{
		int f = s[i] - p[i][m[i] - 1];
		int need = dist - f;
		auto it = lower_bound(start.begin(), start.end(), make_pair(need, 0));
		if (it != start.end() && it->first == need && it->second != i)
		{
			next[i] = it->second;
			start.erase(it);
			continue;
		}
		if (f == 0)
		{
			need = 0;
			it = lower_bound(start.begin(), start.end(), make_pair(need, 0));
			if (it != start.end() && it->first == 0 && it->second != i)
			{
				next[i] = it->second;
				start.erase(it);
				continue;
			}
		}
		cnt_fail++;
		next[i] = -1;
	}
	if (cnt_fail > 1)
	{
		return false;
	}
	int i = (start.size() > 0 ? start.begin()->second : 0);
	cout << "Yes" << "\n";
	cout << i + 1 << " ";
	while (next[i] != -1)
	{
		i = next[i];
		cout << i + 1 << " ";
	}
	cout << "\n";
	return true;
}

void create_start()
{
	for (int i = 0; i < n; i++)
		start.insert({ p[i][0], i });
}

int main()
{
	cin >> n;
	m = new int[n];
	s = new int[n];
	p = new int* [n];
	//start = new pair<int, int>[n];
	finish = new pair<int, int>[n];
	for (int i = 0; i < n; i++)
	{
		cin >> m[i] >> s[i];
		p[i] = new int[m[i]];
		for (int j = 0; j < m[i]; j++)
		{
			cin >> p[i][j];
		}
		start.insert({ p[i][0], i });
		finish[i] = { s[i] - p[i][m[i] - 1], i };
	}
	sort(finish, finish + n, cmp);
	int dist = -1;
	for (int i = 0; i < n; i++)
	{
		if (m[i] == 1)
			continue;
		for (int j = 0; j < m[i] - 1; j++)
		{
			int d = p[i][j + 1] - p[i][j];
			if (dist != -1 && d != dist)
			{
				cout << "No" << "\n";
				return 0;
			}
			dist = d;
		}
	}
	if (dist != -1)
	{
		if (!check(dist))
		{
			cout << "No" << "\n";
		}
		return 0;
	}
	map<int, int> cnt;
	int i = 0;
	set<int> d;
	for (auto p : start)
	{
		for (int j = max(i - 1, 0); j <= min(i + 1, n - 1); j++)
		{
			d.insert(p.first + finish[j].first);
		}
		i++;
		for (int el : d)
			cnt[el]++;
		d.clear();
	}
	vector<int> dists;
	int need = n - 1 - cnt[0];
	for (auto el : cnt)
	{
		if (el.second >= need)
			dists.push_back(el.first);
	}
	for (int dist : dists)
	{
		if (check(dist))
			return 0;
		create_start();
	}
	cout << "No" << "\n";
}
