#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

auto cmp = [](pair<int, int> a, pair<int, int> b) { return a > b; };

int n, * m, * s;
int** p;
map<int, vector<int>> start;
pair<int, int>* finish;

bool check(int dist)
{
	int cnt_fail = 0;
	int* next = new int[n];
	map<int, vector<int>> finish;
	for (int i = 0; i < n; i++)
	{
		int f = s[i] - p[i][m[i] - 1];
		int need = dist - f;
		finish[need].push_back(i);
		next[i] = -1;
		/*auto it = start.lower_bound(make_pair(need, 0));
		if (it != start.end() && it->second == i)
			it++;
		if (it != start.end() && it->first == need && it->second != i)
		{
			next[i] = it->second;
			start.erase(it);
			continue;
		}
		cnt_fail++;
		next[i] = -1;*/
	}
	vector<int> s1, f1, p;
	for (auto el : start)
	{
		vector<int>& s = el.second;
		vector<int>& f = finish[el.first];
		int i = 0, j = 0;
		while (i < s.size() || j < f.size())
		{
			if (i < s.size() && j < f.size() && s[i] == f[j])
			{
				p.push_back(i);
				i++, j++;
			}
			else if (j == f.size() || (i < s.size() && s[i] < f[j]))
			{
				s1.push_back(s[i]);
				i++;
			}
			else
			{
				f1.push_back(f[j]);
				j++;
			}
		}
		for (int i = 0; i + 1 < p.size(); i++)
		{
			next[p[i]] = p[i + 1];
		}
		if (p.size() > 0 && s1.size() > 0)
		{
			next[s1.back()] = p[0];
			s1.pop_back();
		}
		if (p.size() > 0 && f1.size() > 0)
		{
			next[p.back()] = f1.back();
			f1.pop_back();
		}
		for (int i = 0; i < s1.size() && i < f1.size(); i++)
		{
			next[s1[i]] = f1[i];
		}
		s1.clear(), f1.clear(), p.clear();
	}
	int st = 0;
	int* true_next = new int[n];
	bool* used = new bool[n];
	for (int i = 0; i < n; i++)
	{
		true_next[i] = -1;
		used[i] = 0;
	}
	for (int i = 0; i < n; i++)
	{
		cnt_fail += (next[i] == -1);
		if (next[i] == -1)
			st = i;
		else
			true_next[next[i]] = i;
	}
	if (cnt_fail > 1)
	{
		return false;
	}
	int i = st;
	vector<int> order;
	while (i != -1 && !used[i])
	{
		used[i] = 1;
		order.push_back(i);
		i = true_next[i];
	}
	if (order.size() != n)
		return false;
	cout << "Yes" << "\n";
	for (int el : order)
		cout << el + 1 << " ";
	cout << "\n";
	return true;
}

void create_start()
{
	for (int i = 0; i < n; i++)
		start[p[i][0]].push_back(i);
}

int main()
{
	cin >> n;
	m = new int[n];
	s = new int[n];
	p = new int* [n];
	//start = new pair<int, int>[n];
	finish = new pair<int, int>[n];
	for (int i = 0; i < n; i++)
	{
		cin >> m[i] >> s[i];
		p[i] = new int[m[i]];
		for (int j = 0; j < m[i]; j++)
		{
			cin >> p[i][j];
		}
		start[p[i][0]].push_back(i);
		finish[i] = { s[i] - p[i][m[i] - 1], i };
	}
	sort(finish, finish + n, cmp);
	int dist = -1;
	for (int i = 0; i < n; i++)
	{
		if (m[i] == 1)
			continue;
		for (int j = 0; j < m[i] - 1; j++)
		{
			int d = p[i][j + 1] - p[i][j];
			if (dist != -1 && d != dist)
			{
				cout << "No" << "\n";
				return 0;
			}
			dist = d;
		}
	}
	if (dist != -1)
	{
		if (!check(dist))
		{
			cout << "No" << "\n";
		}
		return 0;
	}
	map<int, int> cnt;
	int i = 0;
	set<int> d;
	for (auto p : start)
	{
		for (int j = max(i - 1, 0); j <= min(i + 1, n - 1); j++)
		{
			d.insert(p.first + finish[j].first);
		}
		i++;
		for (int el : d)
			cnt[el]++;
		d.clear();
	}
	vector<int> dists;
	for (auto el : cnt)
	{
		if (el.second >= n - 1)
			dists.push_back(el.first);
	}
	for (int dist : dists)
	{
		if (check(dist))
			return 0;
		create_start();
	}
	cout << "No" << "\n";
}
