#include <iostream>
#include <vector>

using namespace std;

int n, m, c;
bool** good;
int* p;

/*int mpow(int a, int n)
{
	if (n == 0)
		return 1;
	if (n == 1)
		return a;
	int p = mpow(a, n / 2);
	p *= p;
	p *= mpow(a, n % 2);
	return p;
}*/

void build_p()
{
	p = new int[n + 1];
	p[0] = 1;
	for (int i = 1; i <= n; i++)
	{
		p[i] = p[i - 1] * c;
	}
}

vector<int> masks;

void next()
{
	if (masks.size() == m)
		return;
	bool ok;
	for (int mask = 0; mask < p[n]; mask++)
	{
		ok = true;
		for (int last_mask : masks)
		{
			if (!good[last_mask][mask])
			{
				ok = false;
				break;
			}
		}
		if (!ok)
			continue;
		masks.push_back(mask);
		next();
		if (masks.size() == m)
			return;
		masks.pop_back();
	}
}

int main()
{
	bool rev = false;
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	cin >> n >> m >> c;
	if (n > m)
	{
		swap(n, m);
		rev = true;
	}
	build_p();
	int mx = p[n];
	good = new bool* [mx]; 
	int* cnt = new int[c];
	for (int mask1 = 0; mask1 < mx; mask1++)
	{
		good[mask1] = new bool[mx];
		for (int mask2 = 0; mask2 < mx; mask2++)
		{
			for (int i = 0; i < c; i++)
				cnt[i] = 0;
			for (int i = 0; i < n; i++)
			{
				int e1 = mask1 % p[i + 1] / p[i], e2 = mask2 % p[i + 1] / p[i];
				if (e1 == e2)
					cnt[e1]++;
			}
			good[mask1][mask2] = true;
			for (int i = 0; i < c; i++)
			{
				if (cnt[i] > 1)
					good[mask1][mask2] = false;
			}
		}
	}
	next();
	if (masks.size() == 0)
	{
		cout << -1 << "\n";
		return 0;
	}
	int** a = new int* [n];
	for (int i = 0; i < n; i++)
	{
		a[i] = new int[m];
	}
	for (int j = 0; j < m; j++)
	{
		for (int i = 0; i < n; i++)
		{
			a[i][j] = masks[j] % p[i + 1] / p[i] + 1;
		}
	}
	if (rev)
	{
		for (int j = 0; j < m; j++)
		{
			for (int i = 0; i < n; i++)
			{
				cout << a[i][j] << " ";
			}
			cout << "\n";
		}
		return 0;
	}
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			cout << a[i][j] << " ";
		}
		cout << "\n";
	}
}
