#include <iostream>
#include <string>

using namespace std;

const int MOD = 1e9 + 7;

int cnt[4], start_cnt[4];
bool step[4][4];

int get_type(int x, int y, int z)
{
	bool was, will;
	if ((x + y) % 10 == z)
		was = false;
	else if ((x + y + 1) % 10 == z)
		was = true;
	else
		return -1;
	will = (x + y + was >= 10);
	return was * 2 + will;
}


int next(int last)
{
	int ans = 0, sum = 0;
	for (int i = 0; i < 4; i++)
	{
		sum += cnt[i];
		if (cnt[i] > 0 && last != -1 && step[last][i])
		{
			cnt[i]--;
			int nx = next(i);
			cnt[i]++;
			ans += (nx * 1ll * cnt[i]) % MOD;
			ans %= MOD;
		}
		else if (last == -1 && start_cnt[i] > 0)
		{
			cnt[i]--;
			int nx = next(i);
			cnt[i]++;
			ans += (nx * 1ll * start_cnt[i]) % MOD;
			ans %= MOD;
		}
	}
	if (sum == 0)
	{
		return 1;
	}
	return ans;
}

int main()
{
	for (int i = 0; i < 4; i++)
	{
		cnt[i] = 0;
		start_cnt[i] = 0;
		for (int j = 0; j < 4; j++)
		{
			step[i][j] = (i % 2 == j / 2);
		}
	}

	string a, b, c;
	cin >> a >> b >> c;
	int n = a.size();
	for (int i = 0; i < n; i++)
	{
		int type = get_type(a[i] - '0', b[i] - '0', c[i] - '0');
		if (type == -1)
		{
			cout << 0 << "\n";
			return 0;
		}
		cnt[type]++;
		if (a[i] != '0' && b[i] != '0' && c[i] != '0')
		{
			start_cnt[type]++;
		}
	}
	int ans = next(-1);
	ans %= MOD;
	cout << ans << "\n";
}
