#include <iostream>
#include <string>

using namespace std;

const int MOD = 1e9 + 7;

int cnt[4], start_cnt[4];
bool step[4][4];

int get_type(int x, int y, int z)
{
	bool was, will;
	if ((x + y) % 10 == z)
		was = false;
	else if ((x + y + 1) % 10 == z)
		was = true;
	else
		return -1;
	will = (x + y + was >= 10);
	return will * 2 + was;
}


int next(int last)
{
	int ans = 0, sum = 0;
	for (int i = 0; i < 4; i++)
	{
		sum += cnt[i];
		if (cnt[i] > 0 && last != -1 && step[last][i])
		{
			cnt[i]--;
			int nx = next(i);
			cnt[i]++;
			ans += (nx * 1ll * cnt[i]) % MOD;
			ans %= MOD;
		}
		else if (last == -1 && i / 2 == 0 && start_cnt[i] > 0)
		{
			cnt[i]--;
			int nx = next(i);
			cnt[i]++;
			ans += (nx * 1ll * start_cnt[i]) % MOD;
			ans %= MOD;
		}
	}
	if (sum == 0)
	{
		return 1 - last % 2;
	}
	return ans;
}

int get_cnt(int n, int k)
{
	int cnt = 1;
	for (int i = 0; i < k; i++)
	{
		cnt = (cnt * 1ll * (0ll + n - i)) % MOD;
	}
	return cnt;
}

int fact(int n)
{
	int f = 1;
	for (int i = 1; i <= n; i++)
	{
		f = (f * 1ll * i) % MOD;
	}
	return f;
}

int main()
{
	for (int i = 0; i < 4; i++)
	{
		cnt[i] = 0;
		start_cnt[i] = 0;
		for (int j = 0; j < 4; j++)
		{
			step[i][j] = (i % 2 == j / 2);
		}
	}

	string a, b, c;
	cin >> a >> b >> c;
	int n = a.size();
	for (int i = 0; i < n; i++)
	{
		int type = get_type(a[i] - '0', b[i] - '0', c[i] - '0');
		if (type == -1)
		{
			cout << 0 << "\n";
			return 0;
		}
		cnt[type]++;
		if (a[i] != '0' && b[i] != '0' && c[i] != '0')
		{
			start_cnt[type]++;
		}
	}
	if (n <= 18)
	{
		int ans = next(-1);
		ans %= MOD;
		cout << ans << "\n";
	}
	else
	{
		if (cnt[1] != cnt[2])
		{
			cout << 0 << "\n";
			return 0;
		}
		int m = cnt[1];
		if (cnt[3] > 0 && m == 0)
		{
			cout << 0 << "\n";
			return 0;
		}
		int ans = get_cnt(m + cnt[0], cnt[0]);
		if (m > 0)
		{
			ans = (ans * 1ll * get_cnt(m - 1 + cnt[3], cnt[3])) % MOD;
		}
		int f = fact(m);
		int ff = (f * 1ll * f) % MOD;
		ans = (ans * 1ll * ff) % MOD;
		cout << ans << "\n";
	}
}
