#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

long long factorial(long long n ){
    long long sum = 0;
    for (long long i = 0;i<n;++i){
        sum+=i;
    }
    return sum;
}

long long sumleft(long long x, long long y, long long m){
    return factorial(y)*x*(m-1)+factorial(m)*y;
}

long long sumright (long long x, long long y, long long m){
    return factorial(y)*x*(x-m+1)+(factorial(x+1)-factorial(m))*y;
}

long long sumup(long long x, long long y, long long m){
    return factorial(x+1)*(m-1)+factorial(m-1)*x*x;
}

long long sumdown(long long x, long long y, long long m){
    return factorial(x+1)*(y-m+1)+(factorial(y)-factorial(m-1))*x*x;
}

long long* vertbinsearch(long long x, long long y){
    long long l = 1;
    long long r = x+1;
    long long* out = new long long[2];
    while ((r-l)>1){
        long long m = l+(r-l)/2;
        long long m1 = m+1;
        long long ml = sumleft(x,y,m);
        long long mr = sumright(x,y,m);
        long long m1l = sumleft(x,y,m1);
        long long m1r = sumright(x,y,m1);
        if (m1r==m1l){
            out[0] = m1;
            out[1] = 0;
            return out;
        }
        if (mr==ml){
            out[0] = m;
            out[1] = 0;
            return out;
        }
        if (abs(mr-ml)>abs(m1r-m1l)){
            if (mr>ml){
                l=m;
            }
            else{
                r=m;
            }
        }
        else{
            if (m1r>m1l){
                l=m;
            }
            else{
                r=m;
            }
        }
    }
    out[0] = r;
    out[1] = ((sumleft(x,y,r)-sumright(x,y,r))>0?(sumleft(x,y,r)-sumright(x,y,r)):-(sumleft(x,y,r)-sumright(x,y,r)));
    return out;
}

long long* horbinsearch(long long x, long long y){
    long long l = 1;
    long long r = y+1;
    long long* out = new long long[2];
    while ((r-l)>1){
        long long m = l+(r-l)/2;
        long long m1 = m+1;
        long long ml = sumup(x,y,m);
        long long mr = sumdown(x,y,m);
        long long m1l = sumup(x,y,m1);
        long long m1r = sumdown(x,y,m1);
        if (m1r==m1l){
            out[0] = m1;
            out[1] = 0;
            return out;
        }
        if (mr==ml){
            out[0] = m;
            out[1] = 0;
            return out;
        }
        if (abs(mr-ml)>abs(m1r-m1l)){
            if (mr>ml){
                l=m;
            }
            else{
                r=m;
            }
        }
        else{
            if (m1r>m1l){
                l=m;
            }
            else{
                r=m;
            }
        }
    }
    out[0] = r;
    out[1] = ((sumup(x,y,r)-sumdown(x,y,r))>0?(sumup(x,y,r)-sumdown(x,y,r)):-(sumup(x,y,r)-sumdown(x,y,r)));
    return out;
}

void schet(long long x, long long y){
    long long* raznvert = vertbinsearch(x,y);
    long long* raznhor = horbinsearch(x,y);
    if (raznvert[1]>raznhor[1]){
        cout<<"H "<<raznhor[0]<<endl;
    }
    else{
        cout<<"V "<<raznvert[0]<<endl;
    }
}

int main()
{
    long long n;
    cin>>n;
    for (long long i = 0; i<n; ++i){
        long long x,y;
        cin>>y>>x;
        schet(x,y);
    }
}
