#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <time.h>
#define all(x) x.begin(), x.end()
#define mp make_pair
//#define int ll

typedef long long ll;
typedef long double ld;
using namespace std;
const ll INF = 1e9 + 7, N = 3e5 + 5;

ll MOD(ll x) { x %= INF; if (x < 0) { x += INF; } return x; }


struct edge {
	int v, u, f, c;
	edge(int v_, int u_, int f_, int c_) {
		v = v_, u = u_, f = f_, c = c_;
	}
};


ll n, m, k, d = -1, s, t;
vector<edge> E;
vector<int> graph[N], dist(N, INF);

bool bfs() {
	dist.assign(N, INF);

	queue<int> q;
	dist[s] = 0;
	q.push(s);
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (int ui : graph[v]) {
			edge e = E[ui];
			int u = e.u;
			if (dist[u] > dist[v] + 1 && e.f < e.c) {
				dist[u] = dist[v] + 1;
				q.push(u);
			}
		}
	}
	
	return dist[t] != INF;
}


void saturate(int i, int val) {
	E[i].f += val;
	E[i ^ 1].f -= val;
}


int dfs(int v, int minC) {
	if (v== t) {
		return minC;
	}

	for (int ui : graph[v]) {
		edge e = E[ui];
		if (dist[e.v] + 1 == dist[e.u]) {
			int flow = dfs(e.u, min(minC, e.c - e.f));
			if (flow) {
				saturate(ui, flow);
				return flow;
			}
		}

	}
	return 0;
}





signed main()
{
	//srand(time(NULL));
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	cin >> n;

	s = 2 * n, t = s + 1;

	vector<pair<int, int>> arr(n);

	for (int i = 0; i < n; i++) {
		ll len;
		cin >> m >> len;
		vector<int> tmp(m);
		for (int j = 0; j < m; j++) {
			cin >> tmp[j];
			if (j && d != -1 && tmp[j] - tmp[j - 1] != d) {
				cout << "No";
				return 0;
			}
			if (j && d == -1) {
				d = tmp[j] - tmp[j - 1];
			}
		}

		arr[i] = mp(tmp[0], len - tmp.back());
	}

	if (d == -1) {
		map<int, int> cntD;

		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (i == j) continue;

				cntD[arr[i].second + arr[j].first]++;
			}
		}


		ll maxi = 0, lid = -1;
		for (auto p : cntD) {
			if (maxi <= p.second) {
				maxi = p.second;
				lid = p.first;
			}
		}

		d = lid;
	}


	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (i == j) continue;

			if (arr[i].second + arr[j].first == d) {
				graph[i].push_back(E.size());
				E.push_back(edge(i, j + n, 0, 1));
				graph[j + n].push_back(E.size());
				E.push_back(edge(j + n, i, 0, 0));
			}
		}
	}

	for (int i = 0; i < n; i++) {
		graph[s].push_back(E.size());
		E.push_back(edge(s, i, 0, 1));
		graph[i].push_back(E.size());
		E.push_back(edge(i, s, 0, 0));

		graph[i + n].push_back(E.size());
		E.push_back(edge(i + n, t, 0, 1));
		graph[t].push_back(E.size());
		E.push_back(edge(t, i + n, 0, 0));
	}


	while (bfs()) {
		//used.assign(N, false);
		while (dfs(s, INF)) {
			//used.assign(N, false);
		}
	}

	int cnt = 0;
	for (auto e : E) {
		if (e.v == s) {
			cnt += e.f;
		}
	}

	if (cnt >= n - 1) {
		cout << "Yes\n";

		vector<int> ans(n, -1);
		vector<bool> used(n);

		for (auto e : E) {
			if (e.v < n && e.f == 1) {
				ans[e.v] = e.u - n;
				used[e.u - n] = true;
			}
		}

		int vv = -1;
		for (int i = 0; i < n; i++) {
			if (!used[i]) {
				vv = i;
				break;
			}
		}

		if (cnt >= n) {
			vv = 0;
		}

		for (int i = 0; i < n - 1; i++) {
			cout << vv + 1 << " ";
			vv = ans[vv];
		}
		cout << vv + 1;


	}
	else {
		cout << "No";
		return 0;
	}

}