#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

ll check(ll x, ll n, ll m) {
	ll tmp1 = x * (x + 1) / 2;
	ll tmp2 = m * (m + 1) / 2 - tmp1;
	ll r1 = tmp1 - tmp2;
	ll r2 = r1 + (x - (m - x)) * m * (n - 1);
	if ((r2 > r1 && abs(r2) > abs(r1)) || (r1 == r2 && r1 >= 0))
		return 1;
	return -1;
}

ll segsum(ll l, ll r) {
	ll tmp1 = r * (r + 1) / 2;
	ll tmp2 = l * (l - 1) / 2;
	return tmp1 - tmp2;
}

int main() {
	int t;
	cin >> t;
	for (int q = 0; q < t; ++q) {
		ll n, m;
		cin >> n >> m;
		ll full = segsum(1, n * m);
		char D;
		ll ansx, mn = 4e18;


		// 
		ll l = 0, r = m;
		while (r - l > 1) {
			ll mid = (r + l) / 2;
			if (check(mid, n, m) < 0)
				l = mid;
			else
				r = mid;
		}
		ll tmpl = 0;
		for (int i = 0; i < n; ++i) {
			tmpl += segsum(i * m + 1, i * m + l);
		}

		ll tmpr = 0;
		for (int i = 0; i < n; ++i) {
			tmpr += segsum(i * m + 1, i * m + r);
		}

		if (abs(tmpr - (full - tmpr)) < abs(tmpl - (full - tmpl))) {
			ansx = r + 1;
			mn = abs(tmpr - (full - tmpr));
			D = 'V';
		}
		else {
			ansx = l + 1;
			mn = abs(tmpl - (full - tmpl));
			D = 'V';
		}

		// 
		l = 0, r = n;
		while (r - l > 1) {
			ll mid = (r + l) / 2;
			ll tmp = segsum(1, m * mid);
			if (tmp - (full - tmp) < 0)
				l = mid;
			else
				r = mid;
		}
		tmpl = segsum(1, l * m), tmpr = segsum(1, r * m);
		if (abs(tmpl - (full - tmpl)) < mn) {
			ansx = l + 1;
			mn = abs(tmpl - (full - tmpl));
			D = 'H';
		}
		if (abs(tmpr - (full - tmpr)) < mn) {
			ansx = r + 1;
			mn = abs(tmpr - (full - tmpr));
			D = 'H';
		}
		cout << D << " " << ansx;
	}
}