#pragma GCC optimize("O3")
#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <unordered_set>
#include <utility>
#include <algorithm>
#include <cassert>
#define int long long
#define pb push_back
#define eb emplace_back
#define all(z) z.begin(), z.end()
#define rall(z) z.rbegin(), z.rend()
#define pass (void)0
using namespace std;
using pii = pair<int, int>;
using vi = vector<int>;
using vvi = vector<vector<int>>;
using vvb = vector<vector<bool>>;
using vb = vector<bool>;


inline int lb(const vi &a, int x)
{
    return lower_bound(all(a), x) - a.begin();
}


constexpr int N{100000};
int s[N];
int l[N], r[N];


vector<pii> E[2*N];
int pw[2*N];
bool used[N];


void run(vi &a, int v)
{
    if (E[v].size() == 0)
        return;

    int u = E[v].back().first, id = E[v].back().second;
    E[v].pop_back();

    a.pb(id);
    run(a, u);
}


inline bool solve(int n, int d, vi &p)
{
    fill_n(used, n, false);
    for (int i = 0; i < 2*n; i++)
    {
        E[i].clear();
        pw[i] = 0;
    }

    vi pos;
    pos.reserve(2*n);
    for (int i = 0; i < n; i++)
    {
        pos.pb(l[i]);
        pos.pb(d - r[i]);
    }

    sort(all(pos));
    pos.erase(unique(all(pos)), pos.end());
    int m = pos.size();

    for (int i = 0; i < n; i++)
    {
        int u = lb(pos, l[i]);
        int v = lb(pos, d - r[i]);
        E[u].eb(v, i);
        pw[u]--, pw[v]++;
    }

    /*for (int i = 0; i < m; i++)
        cout << pos[i] << ' ' << pw[i] << '\n';*/

    int cneg = 0, cpos = 0;
    int stv = 0;
    for (int i = 0; i < m; i++)
    {
        if (pw[i] < 0)
            stv = i;
        cneg += pw[i] < 0;
        cpos += pw[i] > 0;
    }

    if (cneg > 1 || cpos > 1 || cneg != cpos)
        return false;

    p.clear();
    run(p, stv);
    return true;
}


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    int d = -1;

    for (int i = 0; i < n; i++)
    {
        int m;
        cin >> m >> s[i];

        vi p(m);
        for (int j = 0; j < m; j++)
            cin >> p[j];

        if (m >= 2)
        {
            if (d == -1)
                d = p[1] - p[0];
            for (int j = 0; j < m-1; j++)
                if (p[j+1] - p[j] != d)
                {
                    cout << "No";
                    return 0;
                }
        }

        /*if (p[0] > d || p[m-1] < s[i]-d)
        {
            cout << "No";
            return 0;
        }*/

        l[i] = p[0], r[i] = s[i] - p[m-1];
    }

    if (n == 1)
    {
        cout << "Yes\n1";
        return 0;
    }

    /*cout << "l r\n";
    for (int i = 0; i < n; i++)
    {
        cout << l[i] << ' ' << r[i] << '\n';
    }
    cout << "---\n";*/

    vi ans;
    ans.reserve(n);

    if (d != -1)
    {
        if (solve(n, d, ans))
        {
            cout << "Yes\n";
            for (int i = 0; i < n; i++)
                cout << ans[i]+1 << ' ';
            assert(ans.size() == n);
        }
        else
            cout << "No\n";

        return 0;
    }

    vi vars;
    vars.reserve(2*n);
    vars.pb(r[0] + l[1]);
    vars.pb(r[1] + l[0]);
    for(int i = 2; i < n; i++)
    {
        vars.pb(r[0] + l[i]);
        vars.pb(r[1] + l[i]);
    }

    sort(all(vars));
    vars.erase(unique(all(vars)), vars.end());

    for (int dvar : vars)
    {
        //cout << "var " << dvar << ":\n";
        if (solve(n, dvar, ans))
        {
            cout << "Yes\n";
            for (int i = 0; i < n; i++)
                cout << ans[i]+1 << ' ';
            assert(ans.size() == n);
            return 0;
        }
    }

    cout << "No\n";


    return 0;
}
/*
3
1 7 3
1 8 6
2 8 1 6

1
1 7 5

1
3 10 2 5 9

3
1 5 3
1 3 3
1 6 3

4
1 5 0
1 0 0
1 3 3
1 0 0
*/
