#pragma GCC optimize("O3")
#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <algorithm>
#define all(z) z.begin(), z.end()
#define rall(z) z.rbegin(), z.rend()
#define pb push_back
#define eb emplace_back
#define int long long
#define pass (void)0;
using namespace std;
using vi = vector<int>;
using vb = vector<bool>;
using vvi = vector<vector<int>>;
using vvb = vector<vector<bool>>;
using pii = pair<int, int>;


constexpr int mod{1000000007};


inline int add(int a, int b)
{
    return (a + b) % mod;
}

inline int sub(int a, int b)
{
    return ((a - b) % mod + mod) % mod;
}

inline int mul(int a, int b)
{
    return (a * b) % mod;
}


inline int binpow(int x, int n)
{
    int res = 1;
    while (n)
    {
        if (n & 1)
            res = mul(res, x);
        x = mul(x, x);
        n >>= 1;
    }
    return res;
}


constexpr int N{100000};
int fact[N+1];

inline void fact_calc(int n)
{
    fact[0] = 1;
    for (int i = 1; i <= n; i++)
        fact[i] = fact[i-1] * i;
}

inline int inv(int x)
{
    return binpow(x, mod-2);
}

inline int C(int n, int k)
{
    if (k > n)
        return 0;
    return mul(mul(fact[n], inv(fact[k])), inv(fact[n-k]));
}

inline int split(int n, int k)
{
    int res = 1;
    for (int i = 2; i <= k; i++)
        res = add(res, C(n-1, i-1));
    res = mul(res, fact[n]);
    return res;
}


int a[2][2];
int nz[2][2];


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    {
        string sa, sb, sc;
        cin >> sa >> sb >> sc;
        n = sa.size();

        for (int pos = 0; pos < n; pos++)
        {
            int d1 = sa[pos] - '0';
            int d2 = sb[pos] - '0';
            int d3 = sc[pos] - '0';

            int i = 0, j = 0; // i - need, j - give
            if (d3 == d1+d2)
                i = j = 0;
            else if (d3 == d1+d2+1)
                i = 1;
            else if (d3 == d1+d2-10)
                j = 1;
            else if (d3 == d1+d2-10+1)
                i = j = 1;
            else
            {
                cout << "0";
                return 0;
            }

            a[i][j]++;
            if (d1 == 0 || d2 == 0 || d3 == 0)
                nz[i][j]++;
        }
    }

    fact_calc(n);

    int a00{a[0][0]}, a01{a[0][1]}, a10{a[1][0]}, a11{a[1][1]};
    //cout << a00 << ' ' << a01 << '\n' << a10 << ' ' << a11 << '\n';

    if (a01 != a10)
    {
        cout << "0";
        return 0;
    }
    int k = a01;

    int ans = mul(mul(mul(split(a11, k), fact[k]), fact[k]), split(a00, k+1));
    cout << ans;

    return 0;
}
/*
19243
19132
38375
*/
