#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;
const int Prime = 1e9 + 7;

vector<int> fac;
vector<int> unfac;

long long bin(long long x, long long n){
    if (n == 0){
        return 1;
    }
    if (n % 2 == 0){
        long long res = bin(x, n / 2);
        return (res * res) % Prime;
    }
    else{
        return (bin(x, n - 1) * x) % Prime;
    }
}

long long C(int n, int k) {
    return (((fac[n] * unfac[n - k]) % Prime) * unfac[k]) % Prime;
}

int main(){
    string a1, b1, c1;
    getline(cin, a1);
    getline(cin, b1);
    getline(cin, c1);
    int n = a1.size();
    fac.resize(n + 1);
    unfac.resize(n + 1);
    fac[0] = 1;
    for (int i = 1; i < n + 1; ++i) {
        fac[i] = fac[i - 1] * i;
        fac[i] %= Prime;
    }
    unfac[n] = bin(fac[n], Prime - 2);
    for (int i = n - 1; i >= 0; --i){
        unfac[i] = unfac[i + 1] * (i + 1);
        unfac[i] %= Prime;
    }
    vector<int> a(n);
    vector<int> b(n);
    vector<int> c(n);
    for (int i = 0; i < n; ++i) {
        a[i] = a1[i] - '0';
        b[i] = b1[i] - '0';
        c[i] = c1[i] - '0';
    }
    vector<int> ab(n);
    for (int i = 0; i < n; ++i) {
        ab[i] = a[i] + b[i];
    }

    vector<bool> p(n, false); // plus есть перенос
    for (int i = 0; i < n; ++i) {
        if (ab[i] % 10 == (c[i] + 1) % 10){
            p[i] = true;
        }
        if (!p[i] && ab[i] % 10 != c[i]){
            cout << 0 << endl;
            return 0;
        }
    }
    vector<bool> m(n, false); // minus нужен перенос
    for (int i = 0; i < n; ++i) {
        if (ab[i] + p[i] >= 10){
            m[i] = true;
        }
    }
    vector<bool> first_zero(n, false);
    for (int i = 0; i < n; ++i) {
        if (a[i] == 0 || b[i] == 0 || c[i] == 0){
            first_zero[i] = true;
        }
    }
    int cnt_1 = 0;
    int cnt_2 = 0;
    int cnt_3 = 0;
    int cnt_4_0 = 0;
    int cnt_4 = 0;
    for (int i = 0; i < n; ++i) {
        if (m[i] && p[i]){
            if (first_zero[i]){
                cnt_4_0++;
            }
            else{
                cnt_4++;
            }
        }
        else if (m[i] && !p[i]){
            cnt_3++;
        }
        else if (!m[i] && p[i]){
            cnt_2++;
        }
        else if (!m[i] && !p[i]){
            cnt_1++;
        }
    }
    if (cnt_2 != cnt_3){
        cout << 0 << endl;
        return 0;
    }
    else{
        long long ans = 1;
        ans *= fac[cnt_1];
        ans %= Prime;
        ans *= fac[cnt_2];
        ans %= Prime;
        ans *= fac[cnt_3];
        ans %= Prime;
        ans *= fac[cnt_4];
        ans %= Prime;
        ans *= C(cnt_1 + cnt_2, cnt_2);
        ans %= Prime;
        ans *= C(max(cnt_4 + cnt_2 - 1, 0), max(cnt_2 - 1, 0));
        ans %= Prime;
        cout << ans << endl;
    }
}
