#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>


using namespace std;


long long n, m;


long long get_vertical_summ(int l, int r) {
	long long bg = l * m + 1;
	long long nd = r * m;
	return (nd - bg + 1) * (nd + bg) / 2;
}


long long get_vertical_abs(int x) {
	return abs(get_vertical_summ(0, x) - get_vertical_summ(x, n));
}


pair<int, long long> get_vertical_res() {
	int l = 0;
	int r = n;
	while (l + 1 < r) {
		int tm = (l + r) / 2;
		if (get_vertical_abs(tm) > get_vertical_abs(tm + 1)) {
			l = tm;
		}
		else {
			r = tm;
		}
	}
	return make_pair(r + 1, get_vertical_abs(r));
}


long long get_horiz_summ(int l, int r) {
	long long x = (r - l) * (r + l + 1) / 2;
	long long res = x * n;
	long long bg = 0;
	long long nd = (n - 1) * m;
	res += (n * (bg + nd) / 2) * (r - l);
	return res;
}


long long get_horiz_abs(int x) {
	return abs(get_horiz_summ(0, x) - get_horiz_summ(x, m));
}


pair<int, long long> get_horiz_res() {
	int l = 0;
	int r = m;
	while (l + 1 < r) {
		int tm = (l + r) / 2;
		if (get_horiz_abs(tm) > get_horiz_abs(tm + 1)) {
			l = tm;
		}
		else {
			r = tm;
		}
	}
	return make_pair(r + 1, get_horiz_abs(r));
}


void print_res() {
	pair<int, long long> vres = { 0, 4e18 };
	if (n > 1) {
		vres = get_vertical_res();
	}
	pair<int, long long> hres = { 0, 4e18 };
	if (m > 1) {
		hres = get_horiz_res();
	}
	if (vres.second < hres.second) {
		cout << "H " << vres.first << "\n";
	}
	else {
		cout << "V " << hres.first << "\n";
	}
}


int32_t main() {
	int t;
	cin >> t;
	while (t--) {
		cin >> n >> m;
		print_res();
	}
	return 0;
}

/*
5
1 3
4 7
1 10
3 3
3 5
*/