#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <unordered_map>


using namespace std;


int n;
vector<int> m;
vector<int> s;
vector<vector<int>> a;
unordered_map<int, vector<int>> bg;
unordered_map<int, vector<int>> nd;
vector<bool> used;
vector<int> x;
int ln;
bool good = false;


void dfs(int v, int ln) {
	used[v] = true;
	while (!bg[ln - (s[v] - a[v][m[v] - 1])].empty()) {
		int to = bg[ln - (s[v] - a[v][m[v] - 1])].back();
		bg[ln - (s[v] - a[v][m[v] - 1])].pop_back();
		if (!used[to]) {
			dfs(to, ln);
		}
	}
	x.push_back(v);
}


bool ok(int ln) {
	int nln = -1;
	for (int i = 1; i < n; ++i) {
		if (nln == -1 || nln == (s[x[i - 1]] - a[x[i - 1]].back()) + a[x[i]][0]) {
			nln = (s[x[i - 1]] - a[x[i - 1]].back()) + a[x[i]][0];
		}
		else {
			return false;
		}
	}
	return ln == -1 || nln == -1 || ln == nln;
}


void get_perm() {
	bool stp = true;
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			stp = false;
			used[i] = true;
			x.push_back(i);
			get_perm();
			if (good) {
				return;
			}
			x.pop_back();
			used[i] = false;
		}
	}
	if (stp) {
		good = ok(ln);
	}
}


bool try_solve_with_len(int ln) {
	x.resize(0);
	bg.clear();
	nd.clear();
	for (int i = 0; i < n; ++i) {
		bg[a[i][0]].push_back(i);
		nd[ln - (s[i] - a[i][m[i] - 1])].push_back(i);
	}
	int first = -1;
	for (int i = 0; i < n; ++i) {
		int prev = a[i][0];
		if ((bg[prev].size() - 1 == nd[prev].size())) {
			first = i;
		}
	}
	if (first == -1) {
		first = 0;
	}
	used.assign(n, false);
	dfs(first, ln);
	reverse(x.begin(), x.end());
	return ok(ln);
}


int main() {
	cin >> n;
	m.resize(n);
	s.resize(n);
	a.resize(n);
	ln = -1;
	for(int i = 0; i < n; ++i) {
		cin >> m[i] >> s[i];
		a[i].resize(m[i]);
		for (int j = 0; j < m[i]; ++j) {
			cin >> a[i][j];
			if (j != 0) {
				if (ln == -1) {
					ln = a[i][j] - a[i][j - 1];
				}
				else if (ln != a[i][j] - a[i][j - 1]) {
					cout << "No" << "\n";
					return 0;
				}
			}
		}
	}
	if (n <= 8) {
		used.resize(n, false);
		get_perm();
		if (good) {
			cout << "Yes" << "\n";
			for (auto c : x) {
				cout << c + 1 << " ";
			}
			cout << "\n";
		}
		else {
			cout << "No" << "\n";
		}
	}
	else if (ln != -1) {
		if (!try_solve_with_len(ln)) {
			cout << "No" << "\n";
		}
		else {
			cout << "Yes" << "\n";
			for (auto c : x) {
				cout << c + 1 << " ";
			}
		}
	}
	else {
		for (int ln = 1; ln <= 200; ++ln) {
			if (try_solve_with_len(ln)) {
				cout << "Yes" << "\n";
				for (auto c : x) {
					cout << c + 1 << " ";
				}
				return 0;
			}
		}
		cout << "No" << "\n";
	}
	return 0;
}


/*
4
2 10
3 8
1 7
3
1 8
6
2 8
1 6



Yes
2 1 3
*/


/*
4
1 5
0
1 0
0
1 3
3
1 0
0
*/