#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


struct col {
	int nd;
	int gv;
};


const long long mod = 1e9 + 7;
string a, b, c;
int n;


struct gcdex_res {
	long long x;
	long long y;
	long long d;

	gcdex_res(long long x, long long y, long long d) : x(x), y(y), d(d) {}
};


gcdex_res gcdex(long long a, long long b) {
	if (b == 0) {
		return gcdex_res(1, 0, a);
	}
	auto res = gcdex(b, a % b);
	return gcdex_res(res.y, res.x - (a / b) * res.y, res.d);
}


long long get_reversed_elem(long long x) {
	return ((gcdex(x, mod).x % mod) + mod) % mod;
}


long long div_by_mod(long long a, long long b) {
	return (a * get_reversed_elem(b)) % mod;
}


long long C(long long n, long long k) {
	long long res = 1;
	for (int i = n - k + 1; i <= n; ++i) {
		res = (res * i);
	}
	for (int i = 1; i <= k; ++i) {
		res = div_by_mod(res, i);
	}
	return res;
}


long long factor(int x) {
	long long res = 1;
	for (int i = 1; i <= x; ++i) {
		res = (res * i) % mod;
	}
	return res;
}


int main() {
	cin >> a >> b >> c;
	n = a.size();
	int who_nd = 0;
	int who_dont_nd = 0;
	int who_gv = 0;
	int who_dont_gv = 0;
	int ac = 0;
	int bc = 0;
	int cc = 0;
	int dc = 0;
	for (int i = 0; i < n; ++i) {
		int x = a[i] - '0';
		int y = b[i] - '0';
		int z = c[i] - '0';
		col r;
		if ((x + y) % 10 == z) {
			r.nd = 0;
			who_dont_nd += 1;
		}
		else if((x + y + 1) % 10 == z){
			r.nd = 1;
			who_nd += 1;
		}
		else {
			cout << 0 << "\n";
			return 0;
		}
		if ((x + y + r.nd) >= 10) {
			r.gv = 1;
			who_gv += 1;
		}
		else {
			r.gv = 0;
			who_dont_gv += 1;
		}
		if (r.gv == 0 && r.nd == 0) {
			dc += 1;
		}
		else if (r.gv == 0 && r.nd == 1) {
			cc += 1;
		}
		else if (r.gv == 1 && r.nd == 0) {
			bc += 1;
		}
		else if (r.gv == 1 && r.nd == 1) {
			ac += 1;
		}
	}
	if (who_gv != who_nd || who_dont_gv != who_dont_nd) {
		cout << 0 << "\n";
		return 0;
	}
	int per = who_nd;
	long long res = (((((((factor(ac) * factor(bc)) % mod) * factor(cc)) % mod) * factor(dc)) % mod) * C(n - 1, per)) % mod;
	cout << res << "\n";
	return 0;
}


/*
1881
2322
3114
*/


/*
123
123
246
*/


/*
01211
12099
23300
*/


/*
121
214
999
*/