#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


struct col {
	int nd;
	int gv;
	bool can_end;
};


const long long mod = 1e9 + 7;
string a, b, c;
int n;
vector<col> clmns;
vector<bool> used;
vector<col> x;
int res = 0;


struct gcdex_res {
	long long x;
	long long y;
	long long d;

	gcdex_res(long long x, long long y, long long d) : x(x), y(y), d(d) {}
};


bool ok() {
	if (x[0].nd == 1 || (!(x[x.size() - 1].can_end))) {
		return false;
	}
	for (int i = 0; i < n - 1; ++i) {
		if (x[i].gv != x[i + 1].nd) {
			return false;
		}
	}
	return true;
}


void count_res_slow() {
	bool fnd = false;
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			fnd = true;
			used[i] = true;
			x.push_back(clmns[i]);
			count_res_slow();
			x.pop_back();
			used[i] = false;
		}
	}
	if (!fnd) {
		res += ok();
	}
}


gcdex_res gcdex(long long a, long long b) {
	if (b == 0) {
		return gcdex_res(1, 0, a);
	}
	auto res = gcdex(b, a % b);
	return gcdex_res(res.y, res.x - (a / b) * res.y, res.d);
}


long long get_reversed_elem(long long x) {
	return ((gcdex(x, mod).x % mod) + mod) % mod;
}


long long div_by_mod(long long a, long long b) {
	return (a * get_reversed_elem(b)) % mod;
}


long long C(long long n, long long k) {
	long long res = 1;
	for (int i = n - k + 1; i <= n; ++i) {
		res = (res * i);
	}
	for (int i = 1; i <= k; ++i) {
		res = div_by_mod(res, i);
	}
	return res;
}


long long factor(int x) {
	long long res = 1;
	for (int i = 1; i <= x; ++i) {
		res = (res * i) % mod;
	}
	return res;
}





int main() {
	cin >> a >> b >> c;
	n = a.size();
	int who_nd = 0;
	int who_dont_nd = 0;
	int who_gv = 0;
	int who_dont_gv = 0;
	int ac = 0;
	int bc = 0;
	int cc = 0;
	int dc = 0;
	bool find_zero = false;
	clmns.resize(n);
	for (int i = 0; i < n; ++i) {
		int x = a[i] - '0';
		int y = b[i] - '0';
		int z = c[i] - '0';
		if (x == 0 || y == 0 || z == 0) {
			find_zero = true;
		}
		col r;
		if ((x + y) % 10 == z) {
			r.nd = 0;
			who_dont_nd += 1;
		}
		else if((x + y + 1) % 10 == z){
			r.nd = 1;
			who_nd += 1;
		}
		else {
			cout << 0 << "\n";
			return 0;
		}
		if ((x + y + r.nd) >= 10) {
			r.gv = 1;
			who_gv += 1;
		}
		else {
			r.gv = 0;
			who_dont_gv += 1;
		}
		r.can_end = (x != 0) && (y != 0) && (z != 0) && (r.gv == 0);
		if (r.gv == 0 && r.nd == 0) {
			dc += 1;
		}
		else if (r.gv == 0 && r.nd == 1) {
			cc += 1;
		}
		else if (r.gv == 1 && r.nd == 0) {
			bc += 1;
		}
		else if (r.gv == 1 && r.nd == 1) {
			ac += 1;
		}
		clmns[i] = r;
	}
	used.resize(n, false);
	if (who_gv != who_nd || who_dont_gv != who_dont_nd) {
		cout << 0 << "\n";
		return 0;
	}
	if (find_zero) {
		count_res_slow();
		cout << res << "\n";
	}
	else{
		if (ac < 0 || bc < 0 || cc < 0 || dc < 0) {
			return 0;
		}
		const int x = 200;
		int dp[x][x][x][x][4];
		dp[0][0][1][0][1] = 1;
		dp[0][0][0][1][2] = 1;
		for (int ac1 = 0; ac1 <= ac; ++ac1) {
			for (int bc1 = 0; bc1 <= bc; ++bc1) {
				for (int cc1 = 0; cc1 <= cc; ++cc1) {
					for (int dc1 = 0; dc1 <= dc; ++dc1) {
						dp[ac1][bc1][cc1][dc1][0] = 0;
						dp[ac1][bc1][cc1][dc1][1] = 0;
						dp[ac1][bc1][cc1][dc1][2] = 0;
						dp[ac1][bc1][cc1][dc1][3] = 0;
						dp[0][0][1][0][1] = 1;
						dp[0][0][0][1][2] = 1;
						if (ac1 > 0) {
							dp[ac1][bc1][cc1][dc1][0] = (dp[ac1][bc1][cc1][dc1][0] + dp[ac1 - 1][bc1][cc1][dc1][0]) % mod;
							dp[ac1][bc1][cc1][dc1][0] = (dp[ac1][bc1][cc1][dc1][0] + dp[ac1 - 1][bc1][cc1][dc1][1]) % mod;
						}
						if (cc1 > 0) {
							dp[ac1][bc1][cc1][dc1][1] = (dp[ac1][bc1][cc1][dc1][1] + dp[ac1][bc1][cc1 - 1][dc1][3]) % mod;
							dp[ac1][bc1][cc1][dc1][1] = (dp[ac1][bc1][cc1][dc1][1] + dp[ac1][bc1][cc1 - 1][dc1][2]) % mod;
						}
						if (dc1 > 0) {
							
							dp[ac1][bc1][cc1][dc1][2] = (dp[ac1][bc1][cc1][dc1][2] + dp[ac1][bc1][cc1][dc1 - 1][3]) % mod;
							dp[ac1][bc1][cc1][dc1][2] = (dp[ac1][bc1][cc1][dc1][2] + dp[ac1][bc1][cc1][dc1 - 1][2]) % mod;
						}
						if (bc1 > 0) {
							
							dp[ac1][bc1][cc1][dc1][3] = (dp[ac1][bc1][cc1][dc1][3] + dp[ac1][bc1 - 1][cc1][dc1][0]) % mod;
							dp[ac1][bc1][cc1][dc1][3] = (dp[ac1][bc1][cc1][dc1][3] + dp[ac1][bc1 - 1][cc1][dc1][1]) % mod;
						}
					}
				}
			}
		}
		long long res = (dp[ac][bc][cc][dc][3] + dp[ac][bc][cc][dc][2]) % mod;
		res = (((((((factor(ac) * factor(bc)) % mod) * factor(cc)) % mod) * factor(dc)) % mod) * res) % mod;
		cout << res << "\n";
	}
	return 0;
}


/*
88888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888881111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
22222222222222222222222222222222222222222222222222333333333333333333333333333333333333333333333333332222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111114444444444444444444444444444444444444444444444444433333333333333333333333333333333333333333333333333

*/


/*
188181
232232
311414
*/


/*
123
123
246
*/


/*
01211
12099
23300
*/


/*
121
214
999
*/