#include <iostream>
#include <vector>

#define cin(a) for(auto& elem: a) cin >> a;
#define cout(a) { for(auto& elem: a) cout << elem << " "; cout << endl; }

using namespace std;

long long int n, m;
long long int total_sum = 0;

void get_total_sum() {
    total_sum = (1l + n * m) * n * m / 2;
}
long long int count_v(long long int x) {
    long long int left = ((n - 1) * n * m + n + n * x);
    if (left % 2 == 0) {
        left /= 2;
        left *= x;
    }
    else {
        left *= (x / 2);
    }

    long long int right = total_sum - left;
    return left - right;
}
long long int count_h(long long int x) {
    long long int top = (m * x + 1) * (m * x) / 2;
    long long int bot = total_sum - top;
    return top - bot;
}

void solution() {
    cin >> n >> m;
    get_total_sum();

    // get v
    long long int l = 0, r = m; // []
    while (r - l > 1) {
        long long int c = (r + l) / 2;
        if (count_v(c) > 0) r = c;
        else l = c;
    }
    long long int best_v = l;
    long long int answ_v = abs(count_v(l));
    if (abs(count_v(r)) < answ_v) {
        best_v = r;
        answ_v = abs(count_v(r));
    }

    // get h
    l = 0, r = n; // []
    while (r - l > 1) {
        long long int c = (r + l) / 2;
        if (count_h(c) > 0) r = c;
        else l = c;
    }
    long long int best_h = l;
    long long int answ_h = abs(count_h(l));
    if (abs(count_h(r) < answ_h)) {
        best_h = r;
        answ_h = abs(count_h(r));
    }

    // get answ

    //cout << "{ " << best_v << " " << answ_v << " } or { " << best_h << " " << answ_h << " }\n";

    if (answ_v <= answ_h) {
        cout << "V " << best_v + 1 << endl;
    }
    else {
        cout << "H " << best_h + 1 << endl;
    }

}

int main (){
    int t = 0;
    cin >> t;
    for (int i = 0; i < t; i++) solution();
}
