#include <iostream>
#include <vector>
#include <random>
#include <algorithm>

#define cin(a) for(auto& elem: a) cin >> elem;
#define cout(a) { for(auto& elem: a) cout << elem << " "; cout << endl; }

using namespace std;

struct line {
    int f;
    int s;
    line() {
        f = 0;
        s = 0;
    }
    line(int first, int second) {
        this->f = first;
        this->s = second;
    }
};

int main() {
    srand(1);
    int n = 0;
    cin >> n;
    vector<line> data(n);
    bool has_h = false;
    bool ok = true;
    int h = 0;
    int max_s = 0;
    for (int i = 0; i < n; i++) {
        int m, s;
        cin >> m >> s;
        max_s = max(s, max_s);
        int first_l = -1;
        int last_l = -1;
        int last = -1;
        int d_now = -1;
        if (has_h) d_now = h;
        for (int j = 0; j < m; j++) {
            int p = 0;
            cin >> p;
            if (first_l == -1) first_l = p;
            last_l = p;
            if (last != -1) {
                int d = p - last;
                if (d_now != -1 && d != d_now) ok = false;
                d_now = d;
            }
            last = p;
        }
        if (d_now != -1) {
            has_h = true;
            h = d_now;
        }
        data[i] = line(first_l, s - last_l);
    }

    if (!ok) {
        cout << "No\n";
        return 0;
    }


    for (int i = 0; i < 1e5; i++) {
        int h_now = -1;
        if (has_h) h_now = h;

        vector<int> order(n);
        for (int j = 0; j < n; j++) {
            order[j] = j;
        }
        for (int j = 0; j < 1e2; j++) {
            int a = rand() % n;
            int b = rand() % n;
            swap(order[a], order[b]);
        }

        bool ok = true;
        for (int j = 0; j < n - 1; j++) {
            int d_now = data[order[j]].s + data[order[j+1]].f;
            if (h_now == -1) h_now = d_now;
            if (d_now != h_now) ok = false;
        }
        if (ok) {
            cout << "Yes\n";
            for (auto& elem: order) cout << elem + 1 << " ";
            return 0;
        }
        else continue;
    }
    cout << "No\n";
}
