#include <iostream>
#include <vector>
#include <sstream>

#define cin(a) for(auto& elem: a) cin >> elem;
#define cout(a) { for(auto& elem: a) cout << elem << " "; cout << endl; }

using namespace std;

bool answ_for2(int n, int m, vector<vector<int>>& answ, int i, int j) {
    if (i >= n || j >= m) return true;

    bool is_ok1 = true;
    bool is_ok2 = true;
    for (int x = 0; x < j; x++) {
        for (int y = 0; y < i; y++) {
            int cnt_1 = 0, cnt_2 = 0;
            if (answ[i][x] == 1) cnt_1++;
            else cnt_2++;
            if (answ[y][j] == 1) cnt_1++;
            else cnt_2++;
            if (answ[y][x] == 1) cnt_1++;
            else cnt_2++;
            if (cnt_1 == 3) is_ok1 = false;
            if (cnt_2 == 3) is_ok2 = false;
            if (!is_ok1 && !is_ok2) return false;
        }
    }

    if (is_ok1) {
        answ[i][j] = 1;
        if (j < m - 1) {
            if (answ_for2(n, m, answ, i, j + 1)) return true;
        }
        else if (answ_for2(n, m, answ, i + 1, 0)) return true;
    }
    if (is_ok2) {
        answ[i][j] = 2;
        if (j < m - 1) {
            if (answ_for2(n, m, answ, i, j + 1)) return true;
        }
        else if (answ_for2(n, m, answ, i + 1, 0)) return true;
    }
    return false;
}

stringstream get_data() {
    string secret_data = "7 10 1 1 1 1 1 2 2 2 3 3 1 2 2 2 3 1 3 3 1 3 1 2 3 3 2 2 1 1 2 3 1 3 2 3 2 3 2 3 3 1 2 1 2 3 3 1 1 2 2 1 2 1 3 2 2 3 3 1 1 2 3 2 3 1 3 1 2 1 3 2 8 9 1 1 1 1 1 2 2 3 3 1 2 2 2 3 1 3 1 3 1 2 3 3 2 2 1 2 3 1 3 2 3 2 3 2 3 1 2 1 2 3 3 1 1 2 2 2 1 3 2 2 3 3 1 1 2 2 3 1 3 1 2 3 1 3 3 1 2 3 2 1 1 2 9 8 1 1 1 1 1 2 2 3 1 2 2 2 3 1 3 1 1 2 3 3 2 2 1 2 1 3 2 3 2 3 2 3 2 1 2 3 3 1 1 2 2 2 3 1 3 1 2 3 2 3 3 2 1 2 1 1 3 1 3 2 2 3 3 1 3 3 1 2 3 1 2 2 10 7 1 1 1 1 2 2 3 1 2 2 3 1 1 2 1 2 3 2 2 3 3 1 2 3 3 3 2 1 1 3 2 2 3 2 3 2 1 2 3 1 3 1 2 3 1 2 1 3 2 2 3 1 3 2 1 1 3 1 2 3 2 1 3 3 3 3 1 1 2 2";
    stringstream help;
    help << secret_data;
    return help;
}

int main () {
    int n, m, c;
    cin >> n >> m >> c;
    if (c == 2) {
        vector<vector<int>> answ(n, vector<int>(m, 0));
        if (answ_for2(n, m, answ, 0, 0)) {
            for (auto& line: answ) cout(line);
        }
        else {
            cout << "Nope\n";
        }
    }
    else {
        auto dat = get_data();
        for (int j = 4; j <= 10; j++) {
            int n_now, m_now;
            dat >> n_now >> m_now;
            vector<vector<int>> dat_now(n_now, vector<int>(m_now, 0));
            for (auto& line: dat_now) for (auto& elem: line) dat >> elem;
            if (n_now >= n && m_now >= m) {
                for (int i = 0; i < n; i++) {
                    for (int j = 0; j < m; j++) cout << dat_now[i][j] << " ";
                    cout << endl;
                }
                return 0;
            }
        }
        cout << ":(\n";
    }
}
