#include <iostream>
#include <vector>
#include <random>
#include <algorithm>
#include <string>

#define cin(a) for(auto& elem: a) cin >> elem;
#define cout(a) { for(auto& elem: a) cout << elem << " "; cout << endl; }

using namespace std;

long long int mod = 1e9 + 7;

long long int fact(int x) {
    long long int answ = 1;
    for (int i = 2; i <= x; i++) answ = (answ * i) % mod;
    return answ;
}

long long int anti_fact(int x, int c) {
    if (c <= 0) return 1;
    long long int answ = x;
    for (int i = x - 1; x - i < c; i--) {
        answ = (answ * i) % mod;
    }
    return answ;
}

long long int get_answ(int n, int pos, vector<int>& groups, bool need_1) {
    if (pos >= n) {
        return !need_1;
    }

    if (need_1) {
        long long int answ = 0;
        for (int l_group = 1; l_group - 1 <= groups[3]; l_group++) {
            long long int answ_now = (groups[2] * anti_fact(groups[3], l_group - 1));
            if (groups[2] == 0) continue;
            groups[2]--;
            groups[3]-= l_group - 1;
            long long int answ_2 = get_answ(n, pos + l_group, groups, false);
            groups[2]++;
            groups[3]+= l_group - 1;
            answ_now = (answ_2 * answ_now) % mod;
            answ = (answ_now + answ) % mod;
         }
         return answ;
    }
    else {
        long long int answ = 0;
        for (int l_group = 1; l_group - 2 <= groups[3]; l_group++) {
            if (l_group == 1) {
                if (groups[0] == 0) continue;
                long long int answ_now = groups[0];
                groups[0]--;
                answ_now = (answ_now * get_answ(n, pos + l_group, groups, false)) % mod;
                groups[0]++;
                answ = (answ + answ_now) % mod;
                continue;
            }
            if (groups[2] == 0 || groups[1] == 0) continue;
            long long int answ_now = (groups[1] * groups[2] * anti_fact(groups[3], l_group - 2));

            groups[2]--; groups[1]--;
            groups[3]-= l_group - 2;
            long long int answ_2 = get_answ(n, pos + l_group, groups, false);
            groups[2]++; groups[1]++;
            groups[3]+= l_group - 2;
            answ_now = (answ_2 * answ_now) % mod;
            answ = (answ_now + answ) % mod;
         }
         return answ;
    }
}

int main () {

    string a, b, c;
    cin >> a >> b >> c;
    int n = a.length();

    vector<bool> need_1(n, false);
    vector<bool> has_1(n, false);
    vector<bool> can_be_first(n, false);
    bool ok = true;
    for (int i = 0; i < n; i++) {
        int ai = a[i] - '0';
        int bi = b[i] - '0';
        int ci = c[i] - '0';
        if ((ai + bi + 1) % 10 == ci) need_1[i] = true;
        if (!need_1[i] && (ai + bi) % 10 != ci) {
            ok = false;
            break;
        }
        if (ai + bi + need_1[i] >= 10) {
            has_1[i] = true;
        }
        if (!has_1[i] && ai != 0 && bi != 0 && ci != 0) can_be_first[i] = true;
    }
    int cnt_h1 = 0, cnt_n1 = 0;
    for (int i = 0; i < n; i++) {
        cnt_h1 += has_1[i];
        cnt_n1 += need_1[i];
    }
    int cnt_s = 0;
    for (int i = 0; i < n; i++) cnt_s += can_be_first[i];
    if (!ok || cnt_h1 != cnt_n1 || cnt_s == 0) {
        cout << 0 << endl;
        return 0;
    }

    vector<int> groups(4, 0); // group: has_1 need_1
                               // 0: 0 0; 1: 0 1; 2: 1 0; 3: 1 1
    for (int i = 0; i < n; i++) {
        int g_now = has_1[i] * 2 + need_1[i];
        groups[g_now]++;
    }

    //cout(groups);

    long long int answ = 0;
    for (int i = 0; i < n; i++) {
        if (can_be_first[i]) {
            int g_now = has_1[i] * 2 + need_1[i];
            groups[g_now]--;
            answ = (get_answ(n, 1, groups, need_1[i]) + answ) % mod;
            groups[g_now]++;
            //cout << i << ": " << answ << " : ";
            //cout(groups);
        }
        //cout << i << " " << answ << endl;
    }

    cout << answ << endl;
    return 0;
}
