#include <bits/stdc++.h>

using namespace std;

#define int long long

typedef long long ll;
                    
const int INF = 2e18 + 239;

ll V_cut(int n, int m, int x) {
	return (ll)x * (x + 1) * n / 2 + (ll)x * (n)  * (n - 1) * m / 2;
}


pair<int, int> solve_V(int n, int m) {
	ll ans = INF;
	ll all = ((ll)n * m) * (n * m + 1) / 2;
	int best = 0; 
	auto relax = [&](int i) {
		if (1 <= i && i < m) {
			ll cand = abs(all - 2 * V_cut(n, m, i));
			if (ans > cand) {
				ans = cand;
				best = i;
			}	
		}
	};
	int L = 0LL;
	int R = m;
	while (R - L > 1) {
		int mid = (R + L) / 2;
		if (V_cut(n, m, mid) * 2 <= all) L = mid;
		else R = mid;
	}
	relax(L);
	relax(R);
	return {ans, best};	
}

int H_cut(int n, int m, int x) {
	return (x * m) * (x * m + 1) / 2;
} 

pair<ll, int> solve_H(int n, int m) {               
	int ans = INF;
	int all = (n * m) * (n * m + 1) / 2;
	int best = 0; 
	auto relax = [&](int i) {
		if (1 <= i && i < n) {
			int cand = abs(all - 2 * H_cut(n, m, i));
			if (ans > cand) {
				ans = cand;
				best = i;
			}	
		}
	};
	int l = 0;
	int r = n;
	while (r - l > 1) {
		int mid = (r + l) / 2;
		if (H_cut(n, m, mid) * 2 <= all) l = mid;
		else r = mid;
	}
	relax(l);
	relax(r);
	return {ans, best}; 	
}

void solve() {
	int n, m;
	cin >> n >> m;
	auto H = solve_H(n, m);
	auto V = solve_V(n, m);
	if (H.first < V.first) {
		cerr << H.first << endl;
		cout << "H " << H.second + 1 << endl; 
	} else {
		cerr << V.first << endl;
		cout << "V " << V.second + 1 << endl;
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	#ifdef LOCAL
	freopen("test", "r", stdin);
	#endif

	//cerr << V_cut(3, 5, 3) << endl;
	//exit(0);

	int q;
	cin >> q;
	while (q--) {
		solve();
	}
}
