#include <bits/stdc++.h>

using namespace std;

const int N = 4e5 + 7;
const int MOD = 1e9 + 7;

int add(int a, int b) {
	if (a + b < MOD) {
		return a + b;
	}
	return a + b - MOD;
}

int mul(int a, int b) {
	return 1LL * a * b % MOD;
}

int binpow(int a, int b) {
	int res = 1;
	while (b) {
		if (b & 1) res = mul(res, a);
		a = mul(a, a);
		b /= 2;
	}
	return res;
}

int divv(int a, int b) {
	return mul(a, binpow(b, MOD - 2));
}

int F[N];

void init() {
	F[0] = 1;
	for (int i = 1; i < N; i++) {
		F[i] = mul(i, F[i - 1]);
	}
}

int C(int n, int k) {
	return divv(F[n], mul(F[k], F[n - k]));
}

int solve_split(int n, int k) {
	if (n == 0) return 1;
	if (k == 0) return 0;
	return C(n + k - 1, n);
}

int solve_0(int c0, int c1, int c01, int c10) {
	int base = mul(F[c01], F[c10]);
	int p0 = 1 + c10;
	int p1 = c01;
	base = mul(base, solve_split(c0, p0));
	base = mul(base, F[c0]);
	base = mul(base, solve_split(c1, p1));
	base = mul(base, F[c1]);
	return base;
}

int solve_1(int c0, int c1, int c01, int c10) {
	if (c10 != c01 + 1) return 0;
	int base = mul(F[c01], F[c10]);
	int p0 = c10;
	int p1 = c01 + 1;
	base = mul(base, solve_split(c0, p0));
	base = mul(base, F[c0]);
	base = mul(base, solve_split(c1, p1));
	base = mul(base, F[c1]);
	return base;
}

int solve(int n, vector<int> a, vector<int> b, vector<int> c) {
	vector<int> f(n);
	vector<int> s(n);
	for (int i = 0; i < n; i++) {
		if ((a[i] + b[i]) % 10 == c[i] % 10) s[i] = 0;
		else s[i] = 1;

		if ((a[i] + b[i] + s[i]) % 10 != c[i]) return 0;
		f[i] = (a[i] + b[i] + s[i]) >= 10;
	}
	int c0 = 0;
	int c1 = 0;
	int c01 = 0;
	int c10 = 0;
	for (int i = 0; i < n; i++) {
		if (f[i] == s[i]) {
			if (f[i] == 0) c0++;
			else c1++;
		} else {
			if (f[i] == 0) c01++;
			else c10++;
		}
	}
	if (c01 != c10) return 0;
	int ans = 0;
	for (int i = 0; i < n; i++) {
		if (a[i] != 0 && b[i] != 0 && f[i] == 0) {
			if (f[i] == s[i]) {
				if (f[i] == 0) c0--;
				else c1--;
			} else {
				if (f[i] == 0) c01--;
				else c10--;
			}
				
			if (s[i] == 1) {
				ans = add(ans, solve_1(c0, c1, c01, c10));
			} else {
				ans = add(ans, solve_0(c0, c1, c01, c10));
			}
			
			if (f[i] == s[i]) {
				if (f[i] == 0) c0++;
				else c1++;
			} else {
				if (f[i] == 0) c01++;
				else c10++;
			}	
		}
	}		
	return ans;
}

vector<int> gv(string s) {
	vector<int> ans;
	for (auto t : s) {
		ans.push_back(t - '0');
	}
	return ans;
}

void read() {
	string a, b, c;
	cin >> a >> b >> c;
	vector<int> va = gv(a);
	vector<int> vb = gv(b);
	vector<int> vc = gv(c);
	int n = (int)a.size();
	cout << solve(n, va, vb, vc) << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	#ifdef LOCAL
	freopen("test", "r", stdin);
	#endif

	init();  

	read();
}