#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector,rename-registers")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <queue>
#include <ctime>
#include <sstream>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll INF = 7e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

bool maxi(ld& a, ld b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ld& a, ld b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ld mmax(ld a, ld b) {
	if (a > b) return a;
	return b;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ld mmin(ld a, ld b) {
	if (a < b) return a;
	return b;
}

ll n, k;
ll q;

vector <ll> cur;
vector <bool> used;
vector <ll> m, s;
vector <vector <ll>> a;

unordered_map <ll, set <pair <ll, ll>>> g;
unordered_map <ll, ll> indeg;

pair <bool, pair <ll, ll>> check() {
	/*	for (auto& x : g) {
			cout << x.first << ": ";
			for (auto& y : x.second) {
				cout << "(" << y.first << ", " << y.second << ") ";
			}
			cout << '\n';
		}*/
	ll cnt = 0;
	ll a = -INF, b = -INF;
	for (auto& x : g) {
		if (x.second.size() != indeg[x.first]) {
			if (x.second.size() > indeg[x.first]) {
				a = x.first;
			}
			else {
				b = x.first;
			}
			++cnt;
		}
	}
	if (cnt == 2) {
		return { true, { b, a } };
	}
	if (cnt == 0) {
		return { true, { -INF, -INF } };
	}
	return { false, { -1, -1 } };
}

vector <ll> euler;

void go(int v) {
	while (!g[v].empty()) {
		// remove edge v --> x
		ll x = g[v].begin()->first;
		ll id = g[v].begin()->second;
		g[v].erase(g[v].begin());
		go(x);
		euler.push_back(id);
	}
}

struct tt {
	ll s;
	bool oz, nn;

	tt(ll s = 0, bool oz = false, bool nn = false) : s(s), oz(oz), nn(nn) {};
};

ll add(ll a, ll b) {
	stringstream tmp;
	tmp << a + b;
	string t;
	tmp >> t;
	return t.size();
}

struct action {
	ll t;
	char c;
	ll pos;

	action(ll t = 0, char c = ' ', ll pos = 0) : t(t), c(c), pos(pos) {};
};

ll len(ll n) {
	ll ans = 0;
	while (n) {
		ans += 1;
		n /= 10;
	}
	return ans;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	string s;

	cin >> s;

	vector <pair <char, tt>> t;
	for (int i = 0; i < s.size(); ++i) {
		if (isdigit(s[i])) {
			ll r = i + 1;
			ll num = s[i] - 48;
			bool oz = s[i] == '1';
			bool nn = s[i] == '9';
			while (r < s.size() && isdigit(s[r])) {
				num = num * 10 + s[r] - 48;
				if (s[r] != '0') {
					oz = false;
				}
				if (s[r] != '9') {
					nn = false;
				}
				++r;
			}
			t.push_back({ s[r], tt(num, oz, nn) });
			i = r;
		}
		else {
			t.push_back({ s[i], tt(1, true, false) });
		}
	}

//	for (auto& x : t) {
//		cout << x.first << ' ' << x.second.s << '\n';
//	}

	// first of all, lets do minimal length;

	ll mine = s.size();
	action fa;

	ll pref = t[0].second.s;
	for (int i = 1; i < t.size() - 1; ++i) {
		if (t[i].second.s == 1) {
			if (t[i - 1].first == t[i + 1].first) {
//				cout << "trying\n";
				ll nl = add(t[i - 1].second.s, t[i + 1].second.s);
				ll saved = 0;
				// newlength is nl + 1
				// previous was t[i - 1].second.s.size() + 1 + t[i + 1].second.s.size() + 1
				// minus 1 for each of them if equals "1"
				ll newl = nl + 1;
				ll prev = len(t[i - 1].second.s) + 1 + len(t[i + 1].second.s) + 1 + 1;
				if (t[i - 1].second.s == 1) {
					--prev;
				}
				if (t[i + 1].second.s == 1) {
					--prev;
				}
//				cout << newl << ' ' << prev << '\n';
				saved = prev - newl;
//				cout << mine << ' ' << s.size() - saved << '\n';
				if (mini(mine, s.size() - saved)) {
					fa = action(2, t[i].first, pref + 1);
				}
			}
		}
		pref += t[i].second.s;
	}
	pref = 0;
	for (int i = 0; i < t.size(); ++i) {
		if (t[i].second.s == 2) {
			if (mini(mine, s.size() - 1)) {
				fa = action(2, t[i].first, pref + 1);
			}
		}
		if (t[i].second.s == 1) {
			if (mini(mine, s.size() - 1)) {
				fa = action(2, t[i].first, pref + 1);
			}
		}
		else {
			if (len(t[i].second.s - 1) < len(t[i].second.s)) {
				if (mini(mine, s.size() - 1)) {
					fa = action(2, t[i].first, pref + 1);
				}
			}
		}
		pref += t[i].second.s;
	}
	// if there's nothing found, default ans;
	if (fa.t == 0)
		fa = action(2, t[0].first, 1);
	// that's how we should do the minimum:
	cout << fa.t << ' ' << fa.pos << '\n';

	// now the maximum;
	ll maxe = s.size();
	if (s.back() == 'A') {
		if (maxi(maxe, s.size() + 1)) {
			fa = action(1, 'C', s.size());
		}
	}
	else {
		if (maxi(maxe, s.size() + 1)) {
			fa = action(1, 'A', s.size());
		}
	}

	pref = 0;

	for (int i = 0; i < t.size(); ++i) {
		ll left = 1;
		while (left < t[i].second.s) {
			ll added = len(left) + 1 + 1 + len(t[i].second.s - left) + 1 - (len(t[i].second.s) + 1);
			if (left == 1) --added;
			if (t[i].second.s - left == 1) --added;
			if (maxi(maxe, s.size() + added)) {
				if (t[i].first == 'A') {
					fa = action(1, 'C', pref + left);
				}
				else {
					fa = action(1, 'A', pref + left);
				}
			}
			left *= 10;
		}
		if (t[i].second.s >= 4) {
			left = 2;
			ll added = 1 + 1 + 1 + len(t[i].second.s - 2) + 1 - (len(t[i].second.s) + 1);
			if (maxi(maxe, s.size() + added)) {
				if (t[i].first == 'A') {
					fa = action(1, 'C', pref + left);
				}
				else {
					fa = action(1, 'A', pref + left);
				}
			}
		}
		pref += t[i].second.s;
	}
	cout << fa.t << ' ' << fa.pos << ' ' << fa.c << '\n';
	return 0;
}
/*
5AC5A2C
*/
/*
3
1 7
3
1 8
6
2 8
1 6

1
1 7
5

1
3 10
2 5 9

3
1 5
3
1 3
3
1 6
3

4
1 5
0
1 0
0
1 3
3
1 0
0
*/