#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector,rename-registers")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <queue>
#include <ctime>

using namespace std;
using ll = int;
using ld = long double;
using ull = unsigned long long;

const ll INF = 1e9 + 1;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

bool maxi(ld& a, ld b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ld& a, ld b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ld mmax(ld a, ld b) {
	if (a > b) return a;
	return b;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ld mmin(ld a, ld b) {
	if (a < b) return a;
	return b;
}

ll n, k;
ll q;

vector <ll> cur;
vector <bool> used;
vector <ll> m, s;
vector <vector <ll>> a;

struct hasher {
	ll operator()(const pair <ll, ll>& a) const {
		return a.first ^ a.second;
	}
};

unordered_map <ll, unordered_set <pair <ll, ll>, hasher>> g;
unordered_map <ll, ll> indeg;

pair <bool, pair <ll, ll>> check() {
	/*	for (auto& x : g) {
			cout << x.first << ": ";
			for (auto& y : x.second) {
				cout << "(" << y.first << ", " << y.second << ") ";
			}
			cout << '\n';
		}*/
	ll cnt = 0;
	ll a = -INF, b = -INF;
	for (auto& x : g) {
		if (x.second.size() != indeg[x.first]) {
			if (x.second.size() == indeg[x.first] + 1) {
				a = x.first;
			}
			else if (x.second.size() + 1 == indeg[x.first]) {
				b = x.first;
			}
			++cnt;
		}
	}
	if (cnt == 2 && a != -INF && b != -INF) {
		return { true, { b, a } };
	}
	if (cnt == 0) {
		return { true, { -INF, -INF } };
	}
	return { false, { -1, -1 } };
}

vector <ll> euler;

void go(int v) {
	while (!g[v].empty()) {
		// remove edge v --> x
		ll x = g[v].begin()->first;
		ll id = g[v].begin()->second;
		g[v].erase(g[v].begin());
		go(x);
		euler.push_back(id);
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	ll beg = clock();

	cin >> n;

	m.resize(n);
	a.resize(n);
	s.resize(n);
	used.assign(n, false);
	ll target = -1;
	set <ll> popavsya;
	for (int i = 0; i < n; ++i) {
		cin >> m[i] >> s[i];
		a[i].resize(m[i]);
		for (auto& x : a[i]) {
			cin >> x;
		}
		if (m[i] >= 2) {
			target = a[i][1] - a[i][0];
		}
		for (int j = 1; j < m[i]; ++j) {
			popavsya.insert(a[i][j] - a[i][j - 1]);
		}
	}

	if (popavsya.size() > 1) {
		cout << "No\n";
		return 0;
	}

	//	cout << "Target:\n";
	//	cout << target << '\n';

	if (~target) {
		for (int i = 0; i < n; ++i) {
			ll left = a[i][0], right = s[i] - a[i].back();
			// change of edges:
			// v --> u now becomes (target - v) --> u
			ll v = target - left, u = right;
			g[v].insert({ u, i });
			g[u];
			indeg[u]++;
		}
		auto res = check();
		if (!res.first) {
			cout << "No\n";
			return 0;
		}
		if (res.second.first == -INF) {
			// just go
			go(target - a[0][0]);
			if (euler.size() < n) {
				cout << "No\n";
				return 0;
			}
			reverse(euler.begin(), euler.end());
			cout << "Yes\n";
			for (auto& x : euler) {
				cout << x + 1 << ' ';
			}
			cout << '\n';
		}
		else {
			// add an edge, then remove it;
			g[res.second.first].insert({ res.second.second, -1 });
			go(target - a[0][0]);
			//			cout << euler.size() << '\n';
			if (euler.size() < n + 1) {
				cout << "No\n";
				return 0;
			}
			//			for (auto& x : euler) {
			//				cout << x + 1 << ' ';
			//			}
						// find -1 in euler array, shift it so we can delete -1;
			for (int i = 0; i < euler.size() - 1; ++i) {
				if (euler[i] == -1) {
					rotate(euler.begin(), euler.begin() + i + 1, euler.end());
					break;
				}
			}
			//			cout << "Rotated:/n";
			//			for (auto& x : euler) {
			//				cout << x + 1 << ' ';
			//			}
			//			cout << '\n';
			euler.pop_back();
			reverse(euler.begin(), euler.end());
			cout << "Yes\n";
			for (auto& x : euler) {
				cout << x + 1 << ' ';
			}
		}
		return 0;
	}
	else {
		for (int target = 0; target <= 100; ++target) {
			g.clear();
			euler.clear();
			indeg.clear();
			for (int i = 0; i < n; ++i) {
				ll left = a[i][0], right = s[i] - a[i].back();
				// change of edges:
				// v --> u now becomes (target - v) --> u
				ll v = target - left, u = right;
				g[v].insert({ u, i });
				g[u];
				indeg[u]++;
			}
			auto res = check();
			if (!res.first) {
				continue;
			}
			if (res.second.first == -INF) {
				// just go
				go(target - a[0][0]);
				if (euler.size() < n) {
					continue;
				}
				reverse(euler.begin(), euler.end());
				cout << "Yes\n";
				for (auto& x : euler) {
					cout << x + 1 << ' ';
				}
				cout << '\n';
				return 0;
			}
			else {
				// add an edge, then remove it;
				g[res.second.first].insert({ res.second.second, -1 });
				go(target - a[0][0]);
				if (euler.size() < n + 1) {
					continue;
				}
				// find -1 in euler array, shift it so we can delete -1;
				for (int i = 0; i < euler.size() - 1; ++i) {
					if (euler[i] == -1) {
						rotate(euler.begin(), euler.begin() + i + 1, euler.end());
						break;
					}
				}
				euler.pop_back();
				reverse(euler.begin(), euler.end());
				cout << "Yes\n";
				for (auto& x : euler) {
					cout << x + 1 << ' ';
				}
				return 0;
			}
		}
	}

	cout << "No\n";

	cerr << "Proccess terminated in " << (clock() - beg) * 1.0l / CLOCKS_PER_SEC << "s\n";

	return 0;
}
/*
3
1 7
3
1 8
6
2 8
1 6

1
1 7
5

1
3 10
2 5 9

3
1 5
3
1 3
3
1 6
3

4
1 5
0
1 0
0
1 3
3
1 0
0
*/