#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector,rename-registers")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <queue>
#include <ctime>

using namespace std;
using ll = int;
using ld = long double;
using ull = unsigned long long;

const ll INF = 1e9 + 10;
const long long mod = 1e9 + 7;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

bool maxi(ld& a, ld b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ld& a, ld b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ld mmax(ld a, ld b) {
	if (a > b) return a;
	return b;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ld mmin(ld a, ld b) {
	if (a < b) return a;
	return b;
}

ll n, m, k;
ll q;

inline ll add(ll a, ll b) {
	a += b;
	if (a >= mod) a -= mod;
	return a;
}

inline void addr(ll &a, ll b) {
	a += b;
	if (a >= mod) a -= mod;
}

bool check(vector <vector <ll>> a) {
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			for (int k = i + 1; k < n; ++k) {
				for (int l = j + 1; l < m; ++l) {
					if (a[i][j] == a[i][l] && a[i][j] == a[k][j] &&
						a[i][j] == a[k][l]) {
						cout << "Failed:\n";
						cout << i + 1 << ' ' << j + 1 << ' ' << k + 1 << ' ' << l + 1 << '\n';
						return false;
					}
				}
			}
		}
	}
	return true;
}

vector <vector <ll>> kek
{
	{ 1, 1, 2, 2, 3, 3 },
	{ 1, 2, 2, 3, 3, 1 },
	{ 2, 2, 3, 3, 1, 1 },
	{ 2, 3, 3, 1, 1, 2 },
	{ 3, 3, 1, 1, 2, 2 },
	{ 3, 1, 1, 2, 2, 3 }
};

/*
{
	{ 1, 1, 1, 2, 2, 2, 3, 3, 3 },
	{ 1, 1, 2, 2, 2, 3, 3, 3, 1 },
	{ 1, 2, 2, 2, 3, 3, 3, 1, 2 },
	{ 2, 2, 2, 3, 3, 3, 1, 2, 3 },
	{ 2, 2, 3, 3, 3, 1, 2, 3, 1 },
	{ 2, 3, 3, 3, 1, 2, 3, 1, 1 },
	{ 3, 3, 3, 1, 2, 3, 1, 1, 1 },
	{ 3, 3, 1, 2, 3, 1, 1, 1, 2 },
	{ 3, 1, 2, 3, 1, 1, 1, 2, 3 }
};
*/

vector <ll> types;
vector <ll> cur;
vector <bool> used;

/*
types:
0: straight up ok
1: takes 1 and keeps it
2: only gives 1
3: takes 1 and gives away 1
*/

string a, b, c;

ll ok(ll a, ll b) {
	return (a == 0 && (b == 0 || b == 2)) || (a == 1 && (b == 0 || b == 2)) || (a == 2 && (b == 1 || b == 3)) || (a == 3 && (b == 1));
}

ll ans = 0;

void go() {
	if (cur.size() == n) {
		if (types[cur.back()] <= 1) {
			++ans;
		}
		return;
	}
	if (cur.empty()) {
		for (int i = 0; i < n; ++i) {
			if (!used[i] && types[i] % 2 == 0 && a[i] != '0' && b[i] != '0' && c[i] != '0') {
				used[i] = true;
				cur.push_back(i);
				go();
				cur.pop_back();
				used[i] = false;
			}
		}
	}
	else {
		for (int i = 0; i < n; ++i) {
			if (!used[i] && ok(types[cur.back()], types[i])) {
				used[i] = true;
				cur.push_back(i);
				go();
				cur.pop_back();
				used[i] = false;
			}
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	ll beg = clock();

	cin >> a >> b >> c;
	for (int i = 0; i < a.size(); ++i) {
		ll f = a[i] - 48, s = b[i] - 48, r = c[i] - 48;
		if (f + s < 10) {
			if (f + s == r) {
				types.push_back(0);
			}
			else if ((f + s + 1) % 10 == r) {
				if (f + s + 1 <= 9) {
					types.push_back(1);
				}
				else {
					types.push_back(3);
				}
			}
			else {
				cout << 0 << '\n';
				return 0;
			}
		}
		else {
			if ((f + s) % 10 == r) {
				types.push_back(2);
			}
			else if ((f + s + 1) % 10 == r) {
				types.push_back(3);
			}
			else {
				cout << 0 << '\n';
				return 0;
			}
		}
	}
	n = a.size();
	used.assign(n, false);
	go();
	cout << ans << '\n';

	cerr << "Proccess terminated in " << (clock() - beg) * 1.0l / CLOCKS_PER_SEC << "s\n";

	return 0;
}
/*
123
123
246

01
02
03

01211
12099
23300

121
214
999
*/