#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector,rename-registers")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <queue>
#include <ctime>

using namespace std;
using ll = int;
using ld = long double;
using ull = unsigned long long;

const ll INF = 1e9 + 10;
const long long mod = 1e9 + 7;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

bool maxi(ld& a, ld b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ld& a, ld b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ld mmax(ld a, ld b) {
	if (a > b) return a;
	return b;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ld mmin(ld a, ld b) {
	if (a < b) return a;
	return b;
}

ll n, m, k;
ll q;

inline ll add(ll a, ll b) {
	a += b;
	if (a >= mod) a -= mod;
	return a;
}

inline void addr(ll &a, ll b) {
	a += b;
	if (a >= mod) a -= mod;
}

bool check(vector <vector <ll>> a) {
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			for (int k = i + 1; k < n; ++k) {
				for (int l = j + 1; l < m; ++l) {
					if (a[i][j] == a[i][l] && a[i][j] == a[k][j] &&
						a[i][j] == a[k][l]) {
						cout << "Failed:\n";
						cout << i + 1 << ' ' << j + 1 << ' ' << k + 1 << ' ' << l + 1 << '\n';
						return false;
					}
				}
			}
		}
	}
	return true;
}

vector <vector <ll>> kek
{
	{ 1, 1, 2, 2, 3, 3 },
	{ 1, 2, 2, 3, 3, 1 },
	{ 2, 2, 3, 3, 1, 1 },
	{ 2, 3, 3, 1, 1, 2 },
	{ 3, 3, 1, 1, 2, 2 },
	{ 3, 1, 1, 2, 2, 3 }
};

/*
{
	{ 1, 1, 1, 2, 2, 2, 3, 3, 3 },
	{ 1, 1, 2, 2, 2, 3, 3, 3, 1 },
	{ 1, 2, 2, 2, 3, 3, 3, 1, 2 },
	{ 2, 2, 2, 3, 3, 3, 1, 2, 3 },
	{ 2, 2, 3, 3, 3, 1, 2, 3, 1 },
	{ 2, 3, 3, 3, 1, 2, 3, 1, 1 },
	{ 3, 3, 3, 1, 2, 3, 1, 1, 1 },
	{ 3, 3, 1, 2, 3, 1, 1, 1, 2 },
	{ 3, 1, 2, 3, 1, 1, 1, 2, 3 }
};
*/

vector <ll> types;
vector <ll> cur;
vector <bool> used;

/*
types:
0: straight up ok
1: takes 1 and keeps it
2: only gives 1
3: takes 1 and gives away 1
*/

string a, b, c;

ll ok(ll a, ll b) {
	return (a == 0 && (b == 0 || b == 2)) || (a == 1 && (b == 0 || b == 2)) || (a == 2 && (b == 1 || b == 3)) || (a == 3 && (b == 1));
}

ll ans = 0;

string add(string a, string b) {
	ll n = max(a.size(), b.size()) + 3;
	string res(n, 0);
	reverse(a.begin(), a.end());
	reverse(b.begin(), b.end());
	for (int i = 0; i < a.size(); ++i) {
		res[i] += a[i] - 48;
	}
	for (int i = 0; i < b.size(); ++i) {
		res[i] += b[i] - 48;
	}
	ll z = 0;
	for (int i = 0; i < n; ++i) {
		res[i] += z;
		z = res[i] / 10;
		res[i] %= 10;
	}
	for (auto& x : res) {
		x += 48;
	}
	while (res.size() > 1 && res.back() == '0') {
		res.pop_back();
	}
	reverse(res.begin(), res.end());
	return res;
}

void go() {
	if (cur.size() == n) {
		string f, s, r;
		for (int i = 0; i < n; ++i) {
			f += a[cur[i]];
			s += b[cur[i]];
			r += c[cur[i]];
		}
		if (f[0] == '0' || s[0] == '0') return;
//		cout << "A\n";
		if (r == add(f, s)) {
			++ans;
		}
//		cout << r << ' ' << add(f, s) << '\n';
//		cout << "B\n";
		return;
	}
	for (int i = 0; i < n; ++i) {
//		cout << i << ' ' << used.size() << ' ' << n << '\n';
		if (!used[i]) {
			used[i] = true;
			cur.push_back(i);
			go();
			cur.pop_back();
			used[i] = false;
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	ll beg = clock();

	cin >> a >> b >> c;
	n = a.size();
	used.assign(n, false);
	go();
	cout << ans << '\n';

	cerr << "Proccess terminated in " << (clock() - beg) * 1.0l / CLOCKS_PER_SEC << "s\n";

	return 0;
}
/*
123
123
246

01
02
03

01211
12099
23300

121
214
999
*/