#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector,rename-registers")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <queue>
#include <ctime>

using namespace std;
using ll = int;
using ld = long double;
using ull = unsigned long long;

const ll INF = 1e9 + 10;
const long long mod = 1e9 + 7;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

bool maxi(ld& a, ld b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ld& a, ld b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ld mmax(ld a, ld b) {
	if (a > b) return a;
	return b;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ld mmin(ld a, ld b) {
	if (a < b) return a;
	return b;
}

ll n, m, k;
ll q;

inline void addr(ll& a, ll b) {
	a = (a + b) % mod;
}

/*
types:
0: straight up ok
1: takes 1 and keeps it
2: only gives 1
3: takes 1 and gives away 1
*/

vector <vector <ll>> g{
	{ 0, 2 },
	{ 0, 2 },
	{ 1, 3 },
	{ 1, 3 },
};

ll ans = 0;

string a, b, c;

vector <ll> types;
vector <ll> cur;
vector <bool> used;

string add(string a, string b) {
	ll n = max(a.size(), b.size()) + 3;
	string res(n, 0);
	reverse(a.begin(), a.end());
	reverse(b.begin(), b.end());
	for (int i = 0; i < a.size(); ++i) {
		res[i] += a[i] - 48;
	}
	for (int i = 0; i < b.size(); ++i) {
		res[i] += b[i] - 48;
	}
	ll z = 0;
	for (int i = 0; i < n; ++i) {
		res[i] += z;
		z = res[i] / 10;
		res[i] %= 10;
	}
	for (auto& x : res) {
		x += 48;
	}
	while (res.size() > 1 && res.back() == '0') {
		res.pop_back();
	}
	reverse(res.begin(), res.end());
	return res;
}

void go() {
	if (cur.size() == n) {
		string f, s, r;
		for (int i = 0; i < n; ++i) {
			f += a[cur[i]];
			s += b[cur[i]];
			r += c[cur[i]];
		}
		if (f[0] == '0' || s[0] == '0') return;
		//		cout << "A\n";
		if (r == add(f, s)) {
			++ans;
		}
		//		cout << r << ' ' << add(f, s) << '\n';
		//		cout << "B\n";
		return;
	}
	for (int i = 0; i < n; ++i) {
		//		cout << i << ' ' << used.size() << ' ' << n << '\n';
		if (!used[i]) {
			used[i] = true;
			cur.push_back(i);
			go();
			cur.pop_back();
			used[i] = false;
		}
	}
}


int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	ll beg = clock();

	cin >> a >> b >> c;
	if (a.size() <= 6) {
		n = a.size();
		used.assign(n, false);
		go();
		cout << ans << '\n';
		return 0;
	}
	for (int i = 0; i < a.size(); ++i) {
		ll f = a[i] - 48, s = b[i] - 48, r = c[i] - 48;
		if (f + s < 10) {
			if (f + s == r) {
				types.push_back(0);
			}
			else if ((f + s + 1) % 10 == r) {
				if (f + s + 1 <= 9) {
					types.push_back(1);
				}
				else {
					types.push_back(3);
				}
			}
			else {
				cout << 0 << '\n';
				return 0;
			}
		}
		else {
			if ((f + s) % 10 == r) {
				types.push_back(2);
			}
			else if ((f + s + 1) % 10 == r) {
				types.push_back(3);
			}
			else {
				cout << 0 << '\n';
				return 0;
			}
		}
	}

	ll cnt[4]{ 0, 0, 0, 0 };
	ll cntg[4]{ 0, 0, 0, 0 };
	for (int i = 0; i < a.size(); ++i) {
		cnt[types[i]]++;
		if (a[i] != '0' && b[i] != '0' && c[i] != '0') {
			cntg[types[i]]++;
		}
	}


	n = a.size();

	vector <long long> fact(n + 1, 1);
	for (ll i = 2; i <= n; ++i) {
		fact[i] = (fact[i - 1] * i) % mod;
	}

	ll dp[n + 1][cnt[0] + 1][cnt[1] + 1][cnt[2] + 1][4];
	//vector <vector <vector <vector <vector <ll>>>>> dp(n + 1, vector <vector <vector <vector <ll>>>>(cnt[0] + 1, vector <vector <vector <ll>>>(cnt[1] + 1, vector <vector <ll>>(cnt[2] + 1, vector <ll>(4, 0)))));

	for (int i = 0; i <= n; ++i) {
		for (int a = 0; a <= cnt[0]; ++a) {
			for (int b = 0; b <= cnt[1]; ++b) {
				for (int c = 0; c <= cnt[2]; ++c) {
					dp[i][a][b][c][0] = dp[i][a][b][c][1] = dp[i][a][b][c][2] = dp[i][a][b][c][3] = 0;
				}
			}
		}
	}
	/*
	types:
	0: straight up ok
	1: takes 1 and keeps it
	2: only gives 1
	3: takes 1 and gives away 1
	*/


	// now I need number of good beginings
	if (cntg[0]) {
		dp[1][1][0][0][0] = cntg[0];
	}
	if (cntg[2]) {
		dp[1][0][0][1][2] = cntg[2];
	}
	for (int i = 1; i < n; ++i) {
		for (int a = 0; a <= cnt[0]; ++a) {
			if (a > i) break;
			for (int b = 0; b <= cnt[1]; ++b) {
				if (a + b > i) break;
				for (int c = 0; c <= cnt[2]; ++c) {
					if (a + b + c > i) break;
					int d = i - a - b - c;
					if (d > cnt[3]) continue;
					//					cout << "in\n";
					//					cout << i << ' ' << a << ' ' << b << ' ' << c << ' ' << d << '\n';
					if (a < cnt[0]) {
						addr(dp[i + 1][a + 1][b][c][0], dp[i][a][b][c][0] * 1ll * (cnt[0] - a));
						addr(dp[i + 1][a + 1][b][c][0], dp[i][a][b][c][1] * 1ll * (cnt[0] - a));
					}
					if (b < cnt[1]) {
						addr(dp[i + 1][a][b + 1][c][1], dp[i][a][b][c][2] * 1ll * (cnt[1] - b));
						addr(dp[i + 1][a][b + 1][c][1], dp[i][a][b][c][3] * 1ll * (cnt[1] - b));
					}
					if (c < cnt[2]) {
						addr(dp[i + 1][a][b][c + 1][2], dp[i][a][b][c][0] * 1ll * (cnt[2] - c));
						addr(dp[i + 1][a][b][c + 1][2], dp[i][a][b][c][1] * 1ll * (cnt[2] - c));
					}
					if (d < cnt[3]) {
						addr(dp[i + 1][a][b][c][3], dp[i][a][b][c][2] * 1ll * (cnt[3] - d));
						addr(dp[i + 1][a][b][c][3], dp[i][a][b][c][3] * 1ll * (cnt[3] - d));
					}
				}
			}
		}
	}

	long long ans = (dp[n][cnt[0]][cnt[1]][cnt[2]][0] + dp[n][cnt[0]][cnt[1]][cnt[2]][1]) % mod;

//	cout << ans << '\n';

//	ans = (ans * fact[cnt[0]]) % mod;
//	ans = (ans * fact[cnt[1]]) % mod;
//	ans = (ans * fact[cnt[2]]) % mod;
//	ans = (ans * fact[cnt[3]]) % mod;

	cout << ans << '\n';

	cerr << "Proccess terminated in " << (clock() - beg) * 1.0l / CLOCKS_PER_SEC << "s\n";

	return 0;
}
/*
123
123
246

01
02
03

01211
12099
23300

121
214
999
*/