#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

long long Vsum(long long n, long long m, long long i) {
	if (i == 0)
		return 0;
	long long st1 = n + m * (n * (n - 1) / 2);
	long long res = i * st1 + n * (i * (i - 1) / 2);
	return res;
}

long long Hsum(long long n, long long m, long long i) {
	if (i == 0) {
		return 0;
	}
	long long res = i * m * (i * m + 1) / 2;
	return res;
}

pair < char, long long > solve(long long n, long long m) {
	long long s = n * m * (n * m + 1) / 2;
	if (s < 0) return { 'T', -1 };

	// V
	long long l = 0, r = m - 1;
	while (l < r) {
		long long mid = (l + r) / 2;
		long long f1 = abs(2 * Vsum(n, m, mid) - s);
		long long f2 = abs(2 * Vsum(n, m, mid + 1) - s);
		if (f1 < 0 || f2 < 0) return { 'T', -1 };
		if (f1 < f2) {
			r = mid;
		}
		else {
			l = mid + 1;
		}
	}
	while (abs(2 * Vsum(n, m, l - 1) - s) < abs(2 * Vsum(n, m, l) - s) && l >= 1) {
		l--;
	}
	while (abs(2 * Vsum(n, m, l + 1) - s) < abs(2 * Vsum(n, m, l) - s) && l < m) {
		l++;
	}
	long long ansV = abs(2 * Vsum(n, m, l) - s);
	pair < char, long long > res = { 'V', l + 1 };

	// H
	l = 0, r = n - 1;
	while (l < r) {
		long long mid = (l + r) / 2;
		long long f1 = abs(2 * Hsum(n, m, mid) - s);
		long long f2 = abs(2 * Hsum(n, m, mid + 1) - s);
		if (f1 < 0 || f2 < 0) return { 'T', -1 };
		if (f1 < f2) {
			r = mid;
		}
		else {
			l = mid + 1;
		}
	}
	while (abs(2 * Hsum(n, m, l - 1) - s) < abs(2 * Hsum(n, m, l) - s) && l >= 1) {
		l--;
	}
	while (abs(2 * Hsum(n, m, l + 1) - s) < abs(2 * Hsum(n, m, l) - s) && l < n) {
		l++;
	}
	long long ansH = abs(2 * Hsum(n, m, l) - s);
	if (ansH < ansV) {
		res = { 'H', l + 1 };
	}

	return res;
}

int main()
{
/*	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0); */

	long long t;
	cin >> t;
	for (int i = 0; i < t; i++) {
		long long n, m;
		cin >> n >> m;
		auto ans = solve(n, m);
		if (ans.first == 'T') {
			long long q = i - i;
			cout << 10 / q;
		}
		cout << ans.first << " " << ans.second << "\n";
	}
}
