#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

struct dna {
	char key;
	long long cnt;
	long long len;
	long long pos;
	dna(char a, long long b) {
		if (b == 0) {
			len = 0;
			key = a;
			cnt = b;
			return;
		}
		key = a;
		cnt = b;
		len = 1;
		if (b > 1) {
			while (b > 0) {
				len++;
				b /= 10;
			}
		}
	}
};

long long calc_len(long long t1, long long t2) {
	if (t1 == 1)
		t1 = 0;
	if (t2 == 1)
		t2 = 0;
	long long len1 = 0;
	while (t1 > 0) {
		len1++;
		t1 /= 10;
	}
	long long len2 = 0;
	while (t2 > 0) {
		len2++;
		t2 /= 10;
	}
	return len1 + len2;
}

pair < long long, long long > calc_max_len(long long cnt) {
	long long s = cnt;
	vector < int > a;
	while (s > 0) {
		a.push_back(s % 10);
		s /= 10;
	}
	reverse(a.begin(), a.end());
	if (a.size() == 1) {
		if (a[0] == 2) {
			return { 1, 1 };
		}
		if (a[0] == 3) {
			return { 2, 2 };
		}
		else {
			return { 3, 2 };
		}
	}
	else {
		long long tenpow = 1;
		for (int i = 0; i < a.size(); i++) {
			tenpow *= 10;
		}
		tenpow /= 10;
		long long temp = cnt - tenpow;
		long long lentmp = 0;
		if (temp != 1) {
			while (temp > 0) {
				lentmp++;
				temp /= 10;
			}
		}
		if (lentmp + 2 > a.size()) {
			return { lentmp + 2, tenpow };
		}
		else {
			return { a.size(), cnt / 2 };
		}
	}
}

int main()
{
	string s;
	cin >> s;

	vector < dna > a;
	long long id = 0;
	long long curcnt = 1;
	long long pref = 0;
	while (id < s.size()) {
		long long newnum = 0;
		while (id < s.size() && s[id] >= '0' && s[id] <= '9') {
			newnum *= 10;
			newnum += (s[id] - '0');
			id++;
		}
		if (newnum > 0)
			curcnt = newnum;
		a.push_back({ s[id], curcnt });
		a.back().pos = pref;
		pref += curcnt;
		curcnt = 1;
		id++;
	}
	vector < dna > d = a;

	long long length = 0;
	for (int i = 0; i < a.size(); i++) {
		length += a[i].len;
	}

	long long mint = 2;
	long long minpos = 1;
	long long minlen = 0;
	for (int i = 0; i < a.size(); i++) {
		long long temp = a[i].len;
		dna q = dna(a[i].key, a[i].cnt - 1);
		long long newlen = q.len;
		long long r = temp - newlen;
		if (q.cnt == 0 && i > 0 && i < a.size() - 1) {
			if (a[i - 1].key == a[i + 1].key) {
				dna w = { a[i - 1].key, a[i - 1].cnt + a[i + 1].cnt };
				r += ((a[i - 1].len + a[i + 1].len) - w.len);
			}
		}
		if (r >= minlen) {
			minlen = r;
			minpos = a[i].pos + 1;
		}
	}
	cout << mint << " " << minpos << "\n";

	bool ok = false;
	for (int i = 0; i < a.size(); i++) {
		if (a[i].cnt > 1) {
			ok = true;
		}
	}
	if (!ok) {
		char toadd = 'A';
		if (a.back().key == 'A')
			toadd = 'G';
		cout << 1 << " " << length << " " << toadd;
		return 0;
	}

	long long maxpos = length;
	char toadd = 'A';
	long long maxlen = -1e9;
	long long cut = 0;
	for (int j = 0; j < a.size(); j++) {
		if (a[j].cnt == 1)
			continue;
		auto curlen = calc_max_len(a[j].cnt);
/*		for (int i = 1; i < a[j].cnt; i++) {
			curlen = calc_len(i, a[j].cnt - i);
			if (curlen > maxlen) {
				maxlen = curlen;
				cut = i;
				maxpos = a[j].pos;
				if (a[j].key == 'A') {
					toadd = 'G';
				}
				else {
					toadd = 'A';
				}
			}
		} */
		if (curlen.first > maxlen) {
			maxlen = curlen.first;
			cut = curlen.second;
			maxpos = a[j].pos;
			if (a[j].key == 'A') {
				toadd = 'G';
			}
			else {
				toadd = 'A';
			}
		}
	}

	cout << 1 << " " << maxpos + cut << " " << toadd << "\n";
}