#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

long long mod = 1e9 + 7;

vector < bool > has1;
vector < bool > needs1;
vector < bool > has0;
int n;

long long dfs(int v, vector < vector < int > >& g, vector < bool >& used, int path = 1) {
    if (!has1[v] && path == n && !has0[v])
        return 1;
    used[v] = true;
    long long res = 0;
    for (int i = 0; i < g[v].size(); i++) {
        int to = g[v][i];
        if (!used[to]) {
            res = (res + dfs(to, g, used, path + 1)) % mod;
        }
    }
    used[v] = false;
    return res;
}

int main()
{
    string a, b, c;
    cin >> a >> b >> c;

    n = a.size();
    has1.assign(n, false);
    has0.assign(n, false);
    needs1.assign(n, false);
    
    for (int i = 0; i < n; i++) {
        int d1 = a[i] - '0';
        int d2 = b[i] - '0';
        int res = c[i] - '0';
        if (d1 == 0 || d2 == 0 || res == 0) {
            has0[i] = true;
        }
        if ((d1 + d2) % 10 == res) {
            if (d1 + d2 >= 10) {
                has1[i] = true;
            }
        }
        else if ((d1 + d2 + 1) % 10 == res) {
            needs1[i] = true;
            if (d1 + d2 + 1 >= 10) {
                has1[i] = true;
            }
        }
        else {
            cout << 0;
            return 0;
        }
    }

    vector < vector < int > > g(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j)
                continue;
            if (needs1[j] && has1[i]) {
                g[i].push_back(j);
            }
            if (!needs1[j] && !has1[i]) {
                g[i].push_back(j);
            }
        }
    }

    long long ans = 0;
    vector < bool > used(n, false);
    for (int i = 0; i < n; i++) {
        if (!needs1[i]) {
            ans = (ans + dfs(i, g, used)) % mod;
        }
    }
    cout << ans;
}
