#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

long long mod = 1e9 + 7;

vector < bool > has1;
vector < bool > needs1;
vector < bool > has0;
int n;

long long dfs(int v, vector < vector < int > >& g, vector < bool >& used, int path = 1) {
    if (!has1[v] && path == n && !has0[v])
        return 1;
    used[v] = true;
    long long res = 0;
    for (int i = 0; i < g[v].size(); i++) {
        int to = g[v][i];
        if (!used[to]) {
            res = (res + dfs(to, g, used, path + 1)) % mod;
        }
    }
    used[v] = false;
    return res;
}

long long f(int has1_cnt, int needs1_cnt, int has1needs1_cnt, int nice, int prev_t) {
    if (has1_cnt + needs1_cnt + has1needs1_cnt + nice == 0 && prev_t == 0) {
        return 1;
    }
    if (prev_t == 0) {
        long long res = 0;
        if (nice > 0) {
            res = (res + (nice * f(has1_cnt, needs1_cnt, has1needs1_cnt, nice - 1, 0)) % mod) % mod;
        }
        if (has1_cnt > 0) {
            res = (res + (has1_cnt * f(has1_cnt - 1, needs1_cnt, has1needs1_cnt, nice, 1)) % mod) % mod;
        }
        return res;
    }
    else {
        long long res = 0;
        if (needs1_cnt > 0) {
            res = (res + (needs1_cnt * f(has1_cnt, needs1_cnt - 1, has1needs1_cnt, nice, 0)) % mod) % mod;
        }
        if (has1needs1_cnt > 0) {
            res = (res + (has1needs1_cnt * f(has1_cnt, needs1_cnt, has1needs1_cnt - 1, nice, 1)) % mod) % mod;
        }
        return res;
    }
}

int main()
{
    string a, b, c;
    cin >> a >> b >> c;

    n = a.size();
    has1.assign(n, false);
    has0.assign(n, false);
    needs1.assign(n, false);
    
    int zero_cnt = 0;

    for (int i = 0; i < n; i++) {
        int d1 = a[i] - '0';
        int d2 = b[i] - '0';
        int res = c[i] - '0';
        if (d1 == 0 || d2 == 0 || res == 0) {
            has0[i] = true;
            zero_cnt++;
        }
        if ((d1 + d2) % 10 == res) {
            if (d1 + d2 >= 10) {
                has1[i] = true;
            }
        }
        else if ((d1 + d2 + 1) % 10 == res) {
            needs1[i] = true;
            if (d1 + d2 + 1 >= 10) {
                has1[i] = true;
            }
        }
        else {
            cout << 0;
            return 0;
        }
    }

    if (zero_cnt == 0) {
        int nice_cnt = 0;
        int has1_cnt = 0;
        int has1needs1_cnt = 0;
        int need1_cnt = 0;
        for (int i = 0; i < n; i++) {
            if (has1[i] && needs1[i]) {
                has1needs1_cnt++;
            }
            else if (has1[i]) {
                has1_cnt++;
            }
            else if (needs1[i]) {
                need1_cnt++;
            }
            else {
                nice_cnt++;
            }
        }

        cout << ((has1_cnt * f(has1_cnt - 1, need1_cnt, has1needs1_cnt, nice_cnt, 1)) % mod + (nice_cnt * f(has1_cnt, need1_cnt, has1needs1_cnt, nice_cnt - 1, 0)) % mod) % mod;
        return 0;
    }

    vector < vector < int > > g(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j)
                continue;
            if (needs1[j] && has1[i]) {
                g[i].push_back(j);
            }
            if (!needs1[j] && !has1[i]) {
                g[i].push_back(j);
            }
        }
    }

    long long ans = 0;
    vector < bool > used(n, false);
    for (int i = 0; i < n; i++) {
        if (!needs1[i]) {
            ans = (ans + dfs(i, g, used)) % mod;
        }
    }
    cout << ans;
}
