#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 7;

struct node{
    int type, fir, sec, thir;
};

vector<vector<int>> graf;
vector<vector<int>> dp;
int n;

ll dfs(int now, vector<bool> used, int depth) {
    if (used[now]) {
        return 0;
    }
    if (depth == n - 1) {
        return dp[now][n - 1] = 1;
    }
    if (dp[now][depth] != -1) {
        return dp[now][depth];
    }
    used[now] = true;
    ll res = 0;
    for (auto i : graf[now]) {
        if (!used[i])
            res += dfs(i, used, depth + 1);
    }
    return dp[now][depth] = res % INF;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    string a, b, c;
    cin >> a >> b >> c;
    n = a.size();
    dp.assign(n, vector<int> (n, -1));
    graf.resize(n);
    vector<node> mas(n);
    for (int i = 0; i < n; i++) {
        mas[i].fir = stoi(a.substr(i, 1));
        mas[i].sec = stoi(b.substr(i, 1));
        mas[i].thir = stoi(c.substr(i, 1));
        if ((mas[i].fir + mas[i].sec) % 10 == mas[i].thir) {
            if (mas[i].fir + mas[i].sec > 9) {
                mas[i].type = 1;
            } else {
                mas[i].type = 0;
            }
        } else if ((mas[i].fir + mas[i].sec + 1) % 10 == mas[i].thir) {
            if (mas[i].fir + mas[i].sec + 1 > 9) {
                mas[i].type = 3;
            } else {
                mas[i].type = 2;
            }
        } else {
            cout << 0;
            return 0;
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            if ((mas[i].type == 0 || mas[i].type == 2) && (mas[j].type == 0 || mas[j].type == 1)) {
                graf[i].push_back(j);
            } else if ((mas[i].type == 1 || mas[i].type == 3) && (mas[j].type == 3 || mas[j].type == 2)) {
                graf[i].push_back(j);
            }
        }
    }
    ll counter = 0;
    for (int i = 0; i < n; i++) {
        if (mas[i].fir != 0 && mas[i].sec != 0 && mas[i].thir != 0 && (mas[i].type == 0 || mas[i].type == 2)) {
            vector<bool> help(n, false);
            counter += dfs(i, help, 0);
        }
    }
    cout << counter % INF;
}