#include <iostream>
#include <vector>

using namespace std;

bool is_digit(char c) {
    return '0' <= c && c <= '9';
}

bool is_alpha(char c) {
    return c == 'A' || c == 'C' || c == 'G' || c == 'T';
}

string decode(string s) {
    vector<pair<int, char>> split;
    if (is_digit(s[0])) {
        split.emplace_back(s[0] - '0', '-');
    } else {
        split.emplace_back(1, s[0]);
    }
    for (int i = 1; i < s.length(); ++i) {
        if (is_digit(s[i])) {
            if (is_alpha(s[i - 1])) {
                split.emplace_back(0, '-');
            }
            split[split.size() - 1].first *= 10;
            split[split.size() - 1].first += s[i] - '0';
        } else {
            if (is_alpha(s[i - 1])) {
                split.emplace_back(1, '-');
            }
            split[split.size() - 1].second = s[i];
        }
    }
    string ns;
    for (auto elem: split) {
        for (int _ = 0; _ < elem.first; ++_) {
            ns += elem.second;
        }
    }
    return ns;
}

string encode(string s) {
    vector<pair<int, char>> split;
    for (char i : s) {
        if (split.empty() || split.back().second != i) {
            split.emplace_back(1, i);
        } else {
            split.back().first++;
        }
    }
    string ns;
    for (auto elem: split) {
        if (elem.first != 1) {
            ns += to_string(elem.first) + elem.second;
        } else {
            ns += elem.second;
        }
    }

    return ns;
}

signed main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();

    string s;
    cin >> s;

    auto full = decode(s);
    int max = -1;
    int min = 1e9 + 179;
    string max_op;
    string min_op;
    for (int i = 0; i < full.size() + 1; ++i) {
        for (auto c: {'A', 'C', 'G', 'T'}) {
            // 1
            string temp = full;
            temp.insert(temp.begin() + i, c);
            auto l = encode(temp);
            cerr << l << endl;

            if ((int) l.length() > max) {
                max_op = "1 " + to_string(i + 1) + ' ' + c;
                max = l.length();
            }
            if (l.length() < min) {
                min_op = "1 " + to_string(i + 1) + ' ' + c;
                min = l.length();
            }
            // 2
            if (i < full.size()) {
                temp = full;
                temp.erase(temp.begin() + i);
                l = encode(temp);
                cerr << l << endl;

                if ((int) l.length() > max) {
                    max_op = "2 " + to_string(i + 1);
                    max = l.length();
                }
                if (l.length() < min) {
                    min_op = "2 " + to_string(i + 1);
                    min = l.length();
                }
            }
            // 3
            if (i < full.size() && full[i] != c) {
                temp = full;
                temp[i] = c;
                l = encode(temp);
                cerr << l << endl;

                if ((int) l.length() > max) {
                    max_op = "3 " + to_string(i + 1) + ' ' + c;
                    max = l.length();
                }
                if (l.length() < min) {
                    min_op = "3 " + to_string(i + 1) + ' ' + c;
                    min = l.length();
                }
            }
        }
    }
    cout << min_op << '\n' << max_op;
    cerr << min << ' ' << max;
    return 0;
}
