#include <iostream>
#include <vector>

using namespace std;

int n, m;

long long cntv(long long x) {
    long long v1 = n*x*(x + 1 + m*(n - 1))/2;
    long long v2 = n*m*(n*m + 1)/2 - v1;
    return v2 - v1;
}

long long cnth(int x) {
    long long v1 = x*m*(x*m + 1)/2;
    long long v2 = n*m*(n*m + 1)/2 - v1;
    return v2 - v1;
}

signed main() {
    int t;
    cin >> t;
    for (int q = 0; q < t; ++q) {
        cin >> n >> m;

        // vertical split
        int ans1;
        {
            int lef = -1;
            int rig = m + 1;
            while (rig - lef > 1) {
                int mid = (lef + rig) / 2;
                // cout << lef << ' ' << mid << ' ' << rig << ' ' << cntv(mid) << '\n';
                if (cntv(mid) > 0) {
                    lef = mid;
                } else {
                    rig = mid;
                }
            }
            if (std::abs(cntv(lef)) <= std::abs(cntv(rig))) {
                ans1 = lef;
            } else {
                ans1 = rig;
            }
        }

        // horizontal split
        int ans2;
        {
            int lef = -1;
            int rig = n + 1;
            while (rig - lef > 1) {
                int mid = (lef + rig) / 2;
                if (cnth(mid) > 0) {
                    lef = mid;
                } else {
                    rig = mid;
                }
            }
            if (std::abs(cnth(lef)) <= std::abs(cnth(rig))) {
                ans2 = lef;
            } else {
                ans2 = rig;
            }
        }

        if (std::abs(cntv(ans1)) <= std::abs(cnth(ans2))) {
            cout << "V " << ans1 + 1 << '\n';
        } else {
            cout << "H " << ans2 + 1 << '\n';
        }
    }
}
