#include <iostream>
#include <vector>
#include <cassert>
#include <numeric>

using namespace std;

struct frag {
    int m, s;
    vector<int> p;
};

// only one perekladina on each palochka
void onlyOne(int n, vector<frag>& f) {
    exit(-1);
}

vector<vector<int>> g;

vector<int> dfs(int u, vector<int> used, vector<int> path) {
    used[u] = 1;
    path.push_back(u);
    /**cout << ">>" << u << " | ";
    for (int i : path) {
        cout << i << ' ';
    }
    cout << '\n';**/
    if (accumulate(used.begin(), used.end(), 0) == used.size()) {
        return path;
    }
    for (int v : g[u]) {
        if (!used[v]) {
            vector<int> ans = dfs(v, used, path);
            if (!ans.empty()) {
                return ans;
            }
        }
    }
    return {};
}

void notOnlyOne(int n, vector<frag>& f, int dist) {
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j) {
                continue;
            }
            if (f[i].s - f[i].p.back() + f[j].p.front() == dist) {
                g[i].push_back(j);
                //cout << i << " --> " << j << '\n';
            }
        }
    }

    for (int u = 0; u < n; ++u) {
        vector<int> ans = dfs(u, vector<int>(n, 0), {});
        if (!ans.empty()) {
            cout << "Yes\n";
            for (int v : ans) {
                cout << v + 1 << ' ';
            }
            return;
        }
    }
    cout << "No";
}

signed main() {
    int n;
    cin >> n;
    vector<frag> f(n);
    for (int i = 0; i < n; ++i) {
        cin >> f[i].m >> f[i].s;
        f[i].p.resize(f[i].m);
        for (int j = 0; j < f[i].m; ++j) {
            cin >> f[i].p[j];
        }
    }

    // check neighbour dist
    int dist = -1;
    for (int i = 0; i < n; ++i) {
        for (int j = 1; j < f[i].m; ++j) {
            if (dist == -1) {
                dist = f[i].p[j] - f[i].p[j - 1];
            }
            if (f[i].p[j] - f[i].p[j - 1] != dist) {
                cout << "No" << '\n';
                return 0;
            }
        }
    }
    if (dist == -1) {
        onlyOne(n, f);
    } else {
        notOnlyOne(n, f, dist);
    }
}
