#include <iostream>
#include <vector>
#include <cassert>
#include <numeric>

using namespace std;

struct frag {
    int m, s;
    vector<int> p;
};

vector<vector<int>> g;

vector<int> dfs(int u, vector<int> used, vector<int> path) {
    used[u] = 1;
    path.push_back(u);
    /**cout << ">>" << u << " | ";
    for (int i : path) {
        cout << i << ' ';
    }
    cout << '\n';**/
    if (accumulate(used.begin(), used.end(), 0) == used.size()) {
        return path;
    }
    for (int v : g[u]) {
        if (!used[v]) {
            vector<int> ans = dfs(v, used, path);
            if (!ans.empty()) {
                return ans;
            }
        }
    }
    return {};
}

vector<int> notOnlyOne(int n, vector<frag>& f, int dist) {
    g.assign(n, vector<int>());
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j) {
                continue;
            }
            if (f[i].s - f[i].p.back() + f[j].p.front() == dist) {
                g[i].push_back(j);
                // cout << i << " --> " << j << '\n';
            }
        }
    }

    for (int u = 0; u < n; ++u) {
        // cout << ">>>>" << u << '\n';
        vector<int> ans = dfs(u, vector<int>(n, 0), {});
        if (!ans.empty()) {
            return ans;
        }
    }
    return {};
}


// only one perekladina on each palochka
vector<int> onlyOne(int n, vector<frag>& f) {
    for (int s = 0; s <= 1e2+1; ++s) {
        // cout << ">>>>>>" << s << '\n';
        vector<int> ans = notOnlyOne(n, f, s);
        if (!ans.empty()) {
            return ans;
        }
    }
    return {};
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<frag> f(n);
    for (int i = 0; i < n; ++i) {
        cin >> f[i].m >> f[i].s;
        f[i].p.resize(f[i].m);
        for (int j = 0; j < f[i].m; ++j) {
            cin >> f[i].p[j];
        }
    }

    // check neighbour dist
    int dist = -1;
    for (int i = 0; i < n; ++i) {
        for (int j = 1; j < f[i].m; ++j) {
            if (dist == -1) {
                dist = f[i].p[j] - f[i].p[j - 1];
            }
            if (f[i].p[j] - f[i].p[j - 1] != dist) {
                cout << "No" << '\n';
                return 0;
            }
        }
    }

    vector<int> ans;
    if (dist == -1) {
        ans = onlyOne(n, f);
    } else {
        ans = notOnlyOne(n, f, dist);
    }
    if (!ans.empty()) {
        cout << "Yes\n";
        for (int v : ans) {
            cout << v + 1 << ' ';
        }
        return 0;
    }
    cout << "No";
}
