#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

struct column {
    int a, b, c;
};

vector<vector<int>> g;
vector<int> ord;
vector<int> used;

void dfs(int u) {
    used[u] = 1;
    for (int v : g[u]) {
        if (!used[v]) {
            dfs(v);
        }
    }
    ord.push_back(u);
}

signed main() {
    string s1, s2, s3;
    cin >> s1 >> s2 >> s3;
    int n = s1.size();
    vector<column> col(n);
    for (int i = 0; i < n; ++i) {
        col[i].a = s1[i] - '0';
        col[i].b = s2[i] - '0';
        col[i].c = s3[i] - '0';
    }

    for (int i = 0; i < n; ++i) {
        if ((col[i].a + col[i].b)%10 == col[i].c) {
            continue;
        }
        if ((col[i].a + col[i].b + 1)%10 == col[i].c) {
            continue;
        }
        cout << 0;
        return 0;
    }

    g.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j) {
                continue;
            }
            int flag = 0;
            // makes perenos
            if (col[i].a + col[i].b > 9) {
                flag ^= 1;
            }
            // need perenos
            if (col[j].a + col[j].b != col[j].c) {
                flag ^= 1;
            }
            if (flag == 0) {
                g[i].push_back(j);
            }
        }
    }

    used.assign(n, 0);
    ord.reserve(n);
    for (int u = 0; u < n; ++u) {
        if (!used[u]) {
            dfs(u);
        }
    }
    reverse(ord.begin(), ord.end());

    int ways = 0;
    vector<int> dp;
    for (int u : ord) {
        if (g[u].empty()) {
            dp[u] = 1;
            continue;
        }
        dp[u] = 0;
        for (int v : g[u]) {
            dp[u] = (dp[u] + dp[v]) % (int)(1e9 + 7);
        }
    }

    int ans = 0;
    for (int u = 0; u < n; ++u) {
        ans = (ans + dp[u]) % (int)(1e9 + 7);
    }
    cout << ans;
}
