#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <assert.h>

using namespace std;


const int mx_MEM = 2 * 1e8;
int mpos = 0;
char mem[mx_MEM];

inline void *operator new(size_t n) {
    assert((mpos += n) <= mx_MEM);
    return (void *) (mem + mpos - n);
}

inline void operator delete(void *) noexcept {}


#define int long long

pair<int, int> get_str(int n, int m) {
    int sm = (n * m) * (n * m + 1) / 2;
    int l = 0;
    int r = n + 1;
    while (l + 1 < r) {
        int mid = (l + r) >> 1;
        int cur = (mid * m) * (mid * m + 1);
        if (cur > sm) r = mid;
        else l = mid;
    }
    int md = abs(sm - (l * m) * (l * m + 1));
    int md1 = abs(sm - ((l + 1) * m) * ((l + 1) * m + 1));
    if (md > md1) return {l + 1, md1};
    return {l, md};
}

pair<int, int> get_stl(int n, int m) {
    int sm = (n * m) * (n * m + 1) / 2;
    int l = 0;
    int r = m + 1;
    while (l + 1 < r) {
        int mid = (l + r) >> 1;
        int cur = (mid) * (mid + 1) * n + n * (n - 1) * m * mid;
        if (cur > sm) r = mid;
        else l = mid;
    }
    int md = abs(sm - ((l) * (l + 1) * n + n * (n - 1) * m * l));
    int md1 = abs(sm - ((l + 1) * (l + 2) * n + n * (n - 1) * m * (l + 1)));
    if (md > md1) return {l + 1, md1};
    return {l, md};
}

signed main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        int n, m;
        cin >> n >> m;
        pair<int, int> srt = get_str(n, m);
        pair<int, int> stl = get_stl(n, m);
        if (srt.second < stl.second) {
            cout << "H " << srt.first + 1 << "\n";
        } else {
            cout << "V " << stl.first + 1 << "\n";
        }
        // cout << srt.second << " " << stl.second << "\n";
    }
    return 0;
}
