//#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <assert.h>
#include <map>

using namespace std;

/*
const int mx_MEM = 2 * 1e8;
int mpos = 0;
char mem[mx_MEM];

inline void *operator new(size_t n) {
    assert((mpos += n) <= mx_MEM);
    return (void *) (mem + mpos - n);
}

inline void operator delete(void *) noexcept {}
*/

#define int long long

int n, d;

vector<int> ms;
map<int, vector<int> > a;
map<int, vector<int> > b;
vector<pair<int, int> > pr;

pair<int, int> go_from(int cur) {
    if (ms[cur] != -1) return {cur, 0};
    int next = pr[cur].second;
    if (a[d - next].size() != 0) {
        int to = a[d - next][a[d - next].size() - 1];
        a[d - next].pop_back();
        ms[cur] = to;
        pair<int, int> curm = go_from(to);
        curm.second++;
        return curm;
    }
    return {cur, 0};
}

void build(int st) {
    while (st != -1) {
        int to = ms[st];
        pair<int, int> cur = go_from(st);
        if (pr[cur.first].second + pr[to].first != d) {
            a[pr[to].first].push_back(to);
        }
        if (cur.second == 0) st = ms[st];
    }
}

vector<int> mark;

void dfs(int cur) {
    mark[cur] = 1;
    for (int i = 0; i < a[d - pr[cur].second].size(); ++i) {
        int to = a[d - pr[cur].second][i];
        if (mark[to] == 0) dfs(to);
    }
    for (int j = 0; j < b[d - pr[cur].first].size(); ++j) {
        int to = b[d - pr[cur].first][j];
        if (mark[to] == 0) dfs(to);
    }
}

void check_dost() {
    mark.resize(n);
    for (int i = 0; i < n; ++i) {
        mark[i] = 0;
    }
    dfs(0);
    for (int i = 0; i < n; ++i) {
        if (mark[i] == 0) {
            cout << "No";
            exit(0);
        }
    }
}

signed main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n;
    d = -1;

    ms.resize(n);
    pr.resize(n);
    for (int i = 0; i < n; ++i) {
        ms[i] = -1;
        int m, s;
        cin >> m >> s;
        int l = 0;
        int r = 0;
        int cur;
        int bef = 0;
        for (int j = 0; j < m; ++j) {
            cin >> cur;
            if (j == 0) l = cur;
            if (j == m - 1) r = s - cur;
            if (j > 0) {
                if (d == -1) d = cur - bef;
                else if (d != cur - bef) {
                    cout << "No";
                    exit(0);
                }
            }
            bef = cur;
        }
        a[l].push_back(i);
        b[r].push_back(i);
        pr[i] = {l, r};
    }

    int cnut = 0;
    for (auto i : a) {
        // cout << i.first << "\n";
        if (i.second.size() > b[d - i.first].size()) {
            cnut += i.second.size() - b[d - i.first].size();
        }
    }
    for (auto i : b) {
        if (i.second.size() > a[d - i.first].size()) {
            cnut += i.second.size() - a[d - i.first].size();
        }
    }

    check_dost();

    if (cnut > 2) {
        cout << "No";
        exit(0);
    } else {

        int st = 0;
        for (auto i : a) {
            if (i.second.size() > b[d - i.first].size()) {
                st = i.second[i.second.size() - 1];
                i.second.pop_back();
                break;
            }
        }
        build(st);

        vector<int> ans(n, -1);
        for (int k = 0; k < n; ++k) {
            if (ms[k] != -1) ans[ms[k]] = k;
        }
        int pos = 0;
        int cnt = 0;
        for (int i = 0; i < n; ++i) {
            if (ans[i] == -1) {
                pos = i;
                cnt++;
            }
        }
        while (cnt > 1) {}
        cout << "Yes\n";
        while (pos != -1) {
            cout << pos + 1 << " ";
            pos = ms[pos];
        }
    }
    return 0;
}
