#pragma GCC optimize("Ofast,unroll-loops,fast-math")

#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <queue>
#include <cmath>
#include <tuple>
#include <deque>
#include <map>
#include <set>

#define all(x) x.begin(), x.end()

using namespace std;

using ll = long long;
using ld = long double;

ll allSum = 0;

inline ll getVert(ll n, ll m, ll x)
{
	return n * x * (x + 1) / 2 + n * (n - 1) * m * x / 2;
}

inline ll getVertDif(ll n, ll m, ll x)
{
	return getVert(n, m, x) - getVert(n, m, m - x) - n * (m - x) * x;
}

inline ll getHoriz(ll n, ll m, ll x)
{
	return (m * x) * (m * x + 1) / 2;
}

inline ll getHorizDif(ll n, ll m, ll x)
{
	ll sum1 = getHoriz(n, m, x);
	return sum1 - (allSum - sum1);
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int t = 0;
	cin >> t;

	while (t--)
	{
		ll n = 0, m = 0;
		cin >> n >> m;

		allSum = getHoriz(n, m, n);

		ll l = 0, r = m;
		while (l + 1 != r)
		{
			ll mid = (l + r) / 2;
			if (getVertDif(n, m, mid) > 0)
				r = mid;
			else
				l = mid;
		}

		ll minDif = abs(getVertDif(n, m, l)), ans = l;
		ll res1 = abs(getVertDif(n, m, l + 1));
		if (res1 < minDif)
			minDif = res1, ans = l + 1;

		l = 0, r = n;
		while (l + 1 != r)
		{
			ll mid = (l + r) / 2;
			if (getHorizDif(n, m, mid) > 0)
				r = mid;
			else
				l = mid;
		}

		res1 = abs(getHorizDif(n, m, l));
		if (res1 < minDif)
			minDif = res1, ans = -l;
		res1 = abs(getHorizDif(n, m, l + 1));
		if (res1 < minDif)
			minDif = res1, ans = -l - 1;

		if (ans > 0)
			cout << "V " << ans + 1 << "\n";
		else
			cout << "H " << -ans + 1 << "\n";
	}


	return 0;
}