#pragma GCC optimize("Ofast,unroll-loops,fast-math")

#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <cctype>
#include <string>
#include <queue>
#include <cmath>
#include <tuple>
#include <deque>
#include <map>
#include <set>

#define all(x) x.begin(), x.end()

using namespace std;

using ll = long long;
using ld = long double;

const string alphabet = "ACGT";

inline int getLen(int n)
{
	if (n <= 1)
		return n;
	else
		return to_string(n).length() + 1;
}

int getInterPlus(int n)
{
	if (n <= 3)
		return n + 1;

	return getLen(n / 2) + getLen(n - n / 2) + 1;
}

char getDifferent(char a, char b)
{
	for (auto c : alphabet)
		if (c != a && c != b)
			return c;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	string s;
	cin >> s;

	int curNum = -1;

	vector<pair<int, char>> arr;

	for (int i = 0; i < s.length(); ++i)
	{
		if (isdigit(s[i]))
		{
			if (curNum == -1)
				curNum = s[i] - '0';
			else
				curNum = curNum * 10 + s[i] - '0';
		}
		else
		{
			if (curNum == -1)
				arr.emplace_back(1, s[i]);
			else
				arr.emplace_back(curNum, s[i]);
			curNum = -1;
		}
	}

	int pos = 0;
	int minAns = s.length() + 1, minType = 0, minPos = 0;
	int maxAns = s.length(), maxType = 0, maxPos = 0;
	char minChar = 'A', maxChar = 'A';

	int n = s.length();
	for (int i = 0; i < arr.size(); ++i)
	{
		int maxInterRes = n - getLen(arr[i].first) + getInterPlus(arr[i].first);
		if (maxInterRes > maxAns)
		{
			maxAns = maxInterRes;
			maxType = 1;
			maxPos = pos + arr[i].first / 2;
			if (i > 0)
				maxChar = getDifferent(arr[i].second, arr[i - 1].second);
			else
				maxChar = getDifferent(arr[i].second, arr[i].second);
		}

		int minDelRes = n - getLen(arr[i].first) + getLen(arr[i].first - 1);
		if (arr[i].first == 1 && i > 0 && i < n - 1 && arr[i - 1].second == arr[i + 1].second)
			minDelRes = n - getLen(arr[i].first) - getLen(arr[i - 1].first - getLen(arr[i + 1].first) + getLen(arr[i - 1].first + arr[i + 1].first));
		if (minDelRes < minAns)
		{
			minAns = minDelRes;
			minType = 2;
			minPos = pos;
		}
		
		pos += arr[i].first;
	}

	if (minType == 2)
		cout << minType << " " << minPos + 1 << "\n";
	else
		cout << minType << " " << minPos + 1 << " " << minChar << "\n";

	if (maxType == 2)
		cout << maxType << " " << maxPos + 1 << "\n";
	else
		cout << maxType << " " << maxPos << " " << maxChar << "\n";



	return 0;
}