#pragma GCC optimize("Ofast,unroll-loops,fast-math")

#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <queue>
#include <cmath>
#include <tuple>
#include <deque>
#include <map>
#include <set>

#define all(x) x.begin(), x.end()

using namespace std;

using ll = long long;
using ld = long double;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0, m = 0, s = 0;
	cin >> n;

	vector<int> start(n), end(n);
	int len = -1;
	for (int i = 0; i < n; ++i)
	{
		cin >> m >> s;

		vector<int> p(m);
		for (int j = 0; j < m; ++j)
			cin >> p[j];

		start[i] = p[0], end[i] = s - p[m - 1];
		if (m > 1)
		{
			for (int i = 1; i < m; ++i)
			{
				int curLen = p[i] - p[i - 1];
				if (len != -1 && curLen != len)
				{
					cout << "No\n";
					return 0;
				}
				len = curLen;
			}	
		}
	}

	if (n == 1)
	{
		cout << "Yes\n1\n";
		return 0;
	}

	vector<int> perm(n);
	iota(all(perm), 0);

	do
	{
		int curLen = start[perm[1]] + end[perm[0]];
		if (len != -1 && curLen != len)
			continue;

		bool ok = true;
		for (int i = 1; i < n; ++i)
		{
			if (start[perm[i]] + end[perm[i - 1]] != curLen)
			{
				ok = false;
				break;
			}
		}

		if (ok)
		{
			cout << "Yes\n";
			for (auto x : perm)
				cout << x + 1 << " ";
			return 0;
		}
	} while (next_permutation(all(perm)));

	cout << "No\n";

	return 0;
}

/*
3
1 7
3
1 8
6
2 8
1 6

4
1 5
0
1 0
0
1 3
3
1 0
0

3
1 5
3
1 3
3
1 6
3
*/