#pragma GCC optimize("Ofast,unroll-loops,fast-math")

#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <queue>
#include <cmath>
#include <tuple>
#include <deque>
#include <map>
#include <set>

#define all(x) x.begin(), x.end()

using namespace std;

using ll = long long;
using ld = long double;

const int MAXN = 100000;

vector<int> g[MAXN];
int in[MAXN];
bool visited[MAXN];

void topsort(int u, vector<int>& res)
{
	visited[u] = true;
	for (auto v : g[u])
		if (!visited[v])
			topsort(v, res);
	res.push_back(u);
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0, m = 0, s = 0;
	cin >> n;

	vector<int> start(n), end(n);
	int len = -1;
	for (int i = 0; i < n; ++i)
	{
		cin >> m >> s;

		vector<int> p(m);
		for (int j = 0; j < m; ++j)
			cin >> p[j];

		start[i] = p[0], end[i] = s - p[m - 1];
		if (m > 1)
		{
			for (int i = 1; i < m; ++i)
			{
				int curLen = p[i] - p[i - 1];
				if (len != -1 && curLen != len)
				{
					cout << "No\n";
					return 0;
				}
				len = curLen;
			}
		}
	}

	if (n == 1)
	{
		cout << "Yes\n1\n";
		return 0;
	}
	else if (n <= 0)
	{
		vector<int> perm(n);
		iota(all(perm), 0);

		do
		{
			int curLen = start[perm[1]] + end[perm[0]];
			if (len != -1 && curLen != len)
				continue;

			bool ok = true;
			for (int i = 1; i < n; ++i)
			{
				if (start[perm[i]] + end[perm[i - 1]] != curLen)
				{
					ok = false;
					break;
				}
			}

			if (ok)
			{
				cout << "Yes\n";
				for (auto x : perm)
					cout << x + 1 << " ";
				return 0;
			}
		} while (next_permutation(all(perm)));

		cout << "No\n";
		return 0;
	}

	if (len != -1)
	{
		for (int i = 0; i < n; ++i)
		{
			g[i].clear();
			for (int j = 0; j < n; ++j)
			{
				if (i != j && end[i] + start[j] == len)
					g[i].push_back(j);
			}
		}

		for (int i = 0; i < n; ++i)
		{
			fill(visited, visited + n, false);
			vector<int> res;
			topsort(i, res);

			if (res.size() < n)
				continue;

			reverse(all(res));
			
			bool ok = true;
			for (int i = 1; i < n; ++i)
			{
				if (start[res[i]] + end[res[i - 1]] != len)
				{
					ok = false;
					break;
				}
			}

			if (ok)
			{
				cout << "Yes\n";
				for (auto x : res)
					cout << x + 1 << " ";
				return 0;
			}
		}
		
		cout << "No\n";
	}
	else
	{
		for (len = 0; len <= 200; ++len)
		{
			for (int i = 0; i < n; ++i)
			{
				g[i].clear();
				for (int j = 0; j < n; ++j)
				{
					if (i != j && end[i] + start[j] == len)
						g[i].push_back(j), ++in[j];
				}
			}

			for (int i = 0; i < n; ++i)
			{
				fill(visited, visited + n, false);
				vector<int> res;
				topsort(i, res);

				if (res.size() < n)
					continue;

				reverse(all(res));

				bool ok = true;
				for (int i = 1; i < n; ++i)
				{
					if (start[res[i]] + end[res[i - 1]] != len)
					{
						ok = false;
						break;
					}
				}

				if (ok)
				{
					cout << "Yes\n";
					for (auto x : res)
						cout << x + 1 << " ";
					return 0;
				}
			}
		}
		cout << "No\n";
	}
	

	return 0;
}

/*
3
1 7
3
1 8
6
2 8
1 6

4
1 5
0
1 0
0
1 3
3
1 0
0

3
1 5
3
1 3
3
1 6
3
*/