#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,abm,sse,popcnt")

#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <numeric>
#include <vector>
#include <cctype>
#include <string>
#include <random>
#include <cmath>
#include <deque>
#include <map>
#include <set>

#define all(x) x.begin(), x.end()

using namespace std;

using ll = long long;
using ld = long double;

const int MAXN = 10;

int a[MAXN][MAXN];
mt19937 gen;

bool check(int n, int m) noexcept
{
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			for (int k = i + 1; k < n; ++k)
				for (int p = j + 1; p < m; ++p)
					if (a[i][j] == a[i][p] && a[i][j] == a[k][j] && a[i][j] == a[k][p])
						return false;

	return true;
}

bool build2(int n, int m)
{
	vector<ll> masks(1 << (n * m));
	iota(all(masks), 0);
	shuffle(all(masks), gen);
	for (const auto& mask : masks)
	{
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < m; ++j)
				a[i][j] = 1 + ((mask >> (m * i + j)) & 1);

		if (check(n, m))
			return true;
	}
	return false;
}

bool build3(int n, int m)
{
	bool reversed = false;
	if (n < m)
	{
		swap(n, m);
		reversed = true;
	}

	int k = n - 1;
	if (m <= 4)
	{
		k = 3;
		if (!build2(k, m))
			return false;
	}
	else
	{
		if (!build3(n - 1, m))
			return false;
	}

	vector<ll> threePow(m + 1, 1);
	for (int i = 0; i < m; ++i)
		threePow[i + 1] = threePow[i] * 3;

	for (int i = k; i < n; ++i)
	{
		bool ok = false;
		if (gen() % 2)
		{
			for (ll mask = threePow.back(); mask >= 0; --mask)
			{
				ll mask1 = mask;
				for (int j = 0; j < m; ++j)
				{
					a[i][j] = mask1 % 3 + 1;
					mask1 /= 3;
				}

				if (check(i + 1, m))
				{
					ok = true;
					break;
				}
			}
		}
		else
		{
			for (ll mask = 0; mask < threePow.back(); ++mask)
			{
				ll mask1 = mask;
				for (int j = 0; j < m; ++j)
				{
					a[i][j] = mask1 % 3 + 1;
					mask1 /= 3;
				}

				if (check(i + 1, m))
				{
					ok = true;
					break;
				}
			}
		}
		
		if (!ok)
			return false;
	}

	if (reversed)
	{
		for (int i = 0; i < n; ++i)
			for (int j = i + 1; j < n; ++j)
				swap(a[i][j], a[j][i]);
	}

	return  true;
}

int res66[6][6];

int main()
{
	ios::sync_with_stdio(false);
	cout.tie(0), cin.tie(0);

	int n = 0, m = 0, c = 0;
	cin >> n >> m >> c;

	if ((max(n, m) > 6 && min(n, m) > 2) || (n >= 5 && m >= 5))
	{
		if (c == 2)
			return -1;

		/*--n, --m;
		if (!((max(n, m) > 6 && min(n, m) > 2) || (n >= 5 && m >= 5)))
		{
			for (ll mask = 0; mask < (1ll << (n * m)); ++mask)
			{
				for (int i = 0; i < n; ++i)
					for (int j = 0; j < m; ++j)
						a[i][j] = 1 + ((mask >> (m * i + j)) & 1);

				if (check(n, m))
				{
					for (int i = 0; i < n; ++i)
					{
						for (int j = 0; j < m; ++j)
							cout << a[i][j] << " ";
						cout << 3;
						cout << "\n";
					}
					for (int i = 0; i <= m; ++i)
						cout << 3 << " ";
					cout << "\n";

					return 0;
				}
			}
			++n, ++m;
		}*/

		while (!build3(n, m));

		for (int i = 0; i < n; ++i)
		{
			for (int j = 0; j < m; ++j)
				cout << a[i][j] << " ";
			cout << "\n";
		}

		return 0;
	}

	for (ll mask = 0; mask < (1ll << (n * m)); ++mask)
	{
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < m; ++j)
				a[i][j] = 1 + ((mask >> (m * i + j)) & 1);

		if (check(n, m))
		{
			for (int i = 0; i < n; ++i)
			{
				for (int j = 0; j < m; ++j)
					cout << a[i][j] << " ";
				cout << "\n";
			}
			break;
		}
	}



	return 0;
}