#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,abm,sse,popcnt")

#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <numeric>
#include <vector>
#include <cctype>
#include <string>
#include <cmath>
#include <deque>
#include <map>
#include <set>

#define all(x) x.begin(), x.end()

using namespace std;

using ll = long long;
using ld = long double;

const int mod = (int)1e9 + 7;

map<tuple<int, int, int, int, int>, int> mem;

int getAns(int cor0, int cor1, int inc0, int inc1, int plus)
{
	if (cor0 + cor1 + inc0 + inc1 == 0)
		return 1 ^ plus;

	if (mem.count({cor0, cor1, inc0, inc1, plus}))
		return mem[{cor0, cor1, inc0, inc1, plus}];

	ll ans = 0;
	if (plus)
	{
		if (inc0 > 0)
			ans += (ll)inc0 * getAns(cor0, cor1, inc0 - 1, inc1, 0);
		if (inc1 > 0)
			ans += (ll)inc1 * getAns(cor0, cor1, inc0, inc1 - 1, 1);
	}
	else
	{
		if (cor0 > 0)
			ans += (ll)cor0 * getAns(cor0 - 1, cor1, inc0, inc1, 0);
		if (cor1 > 0)
			ans += (ll)cor1 * getAns(cor0, cor1 - 1, inc0, inc1, 1);
	}
	return mem[{cor0, cor1, inc0, inc1, plus}] = ans % mod;
}

int main()
{
	ios::sync_with_stdio(false);
	cout.tie(0), cin.tie(0);

	string a, b, c;
	cin >> a >> b >> c;

	int n = a.size();

	bool possible = true;
	int cor0 = 0, cor1 = 0, inc0 = 0, inc1 = 0;
	for (int i = 0; i < n; ++i)
	{
		int val = a[i] - '0' + b[i] - '0';
		if (val % 10 == c[i] - '0')
		{
			if (val < 10)
				++cor0;
			else
				++cor1;
		}
		else if ((val + 1) % 10 == c[i] - '0')
		{
			if (val + 1 < 10)
				++inc0;
			else
				++inc1;
		}
		else
		{
			possible = false;
			break;
		}
	}

	if (!possible)
	{
		cout << 0;
		return 0;
	}

	if (n > 6)
	{
		cout << getAns(cor0, cor1, inc0, inc1, 0) << "\n";
		return 0;
	}

	vector<int> perm(n);
	iota(all(perm), 0);

	ll cnt = 0;
	do {
		string a1(n, '0'), b1(n, '0'), c1(n, '0');
		for (int i = 0; i < n; ++i)
		{
			a1[i] = a[perm[i]];
			b1[i] = b[perm[i]];
			c1[i] = c[perm[i]];
		}

		if (a1[0] != '0' && b1[0] != '0' && c1[0] != '0' && stoll(a1) + stoll(b1) == stoll(c1))
			++cnt;

	} while (next_permutation(all(perm)));

	cout << cnt;

	return 0;
}