#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,abm,sse,popcnt")

#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <numeric>
#include <vector>
#include <cctype>
#include <string>
#include <cmath>
#include <deque>
#include <map>
#include <set>

#define all(x) x.begin(), x.end()

using namespace std;

using ll = long long;
using ld = long double;

const int mod = (int)1e9 + 7;
const int MAXN = 750;

unordered_map<ll, int> mem;

ll myHash(int a, int b, int c, int d)
{
	return (((ll)a * MAXN + b) * MAXN + c) * 2 + d;
}

int getAns1(int cor0, int cor1, int inc0, int inc1, int plus) noexcept
{
	if (cor0 + cor1 + inc0 + inc1 == 0)
		return 1 ^ plus;

	if (inc0 != cor1 + plus)
		return 0;

	ll h = myHash(cor0, cor1, inc1, plus);
	auto it = mem.find(h);
	if (it != mem.end())
		return it->second;

	ll ans = 0;
	if (plus)
	{
		if (inc0 > 0)
			ans += (ll)inc0 * getAns1(cor0, cor1, inc0 - 1, inc1, 0);
		if (inc1 > 0)
			ans += (ll)inc1 * getAns1(cor0, cor1, inc0, inc1 - 1, 1);
	}
	else
	{
		if (cor0 > 0)
			ans += (ll)cor0 * getAns1(cor0 - 1, cor1, inc0, inc1, 0);
		if (cor1 > 0)
			ans += (ll)cor1 * getAns1(cor0, cor1 - 1, inc0, inc1, 1);
	}
	return mem[h] = ans % mod;
}

int getAns(int cor0, int cor1, int inc0, int inc1, int plus, int cor00 = 0, int cor10 = 0, int inc00 = 0, int inc10 = 0) noexcept
{
	if (cor0 + cor1 + inc0 + inc1 == 0)
		return 1 ^ plus;

	if (inc0 != cor1 + plus)
		return 0;

	ll ans = 0;
	if (plus)
	{
		if (inc0 - inc00 > 0)
			ans += (ll)(inc0 - inc00) * getAns1(cor0, cor1, inc0 - 1, inc1, 0);
		if (inc1 - inc10 > 0)
			ans += (ll)(inc1 - inc10) * getAns1(cor0, cor1, inc0, inc1 - 1, 1);
	}
	else
	{
		if (cor0 - cor00 > 0)
			ans += (ll)(cor0 - cor00) * getAns1(cor0 - 1, cor1, inc0, inc1, 0);
		if (cor1 - cor10 > 0)
			ans += (ll)(cor1 - cor10) * getAns1(cor0, cor1 - 1, inc0, inc1, 1);
	}
	return ans % mod;
}

int main()
{
	ios::sync_with_stdio(false);
	cout.tie(0), cin.tie(0);

	string a, b, c;
	cin >> a >> b >> c;

	int n = a.size();

	bool possible = true;
	int cor0 = 0, cor1 = 0, inc0 = 0, inc1 = 0, cor00 = 0, cor10 = 0, inc00 = 0, inc10 = 0;
	for (int i = 0; i < n; ++i)
	{
		int val = a[i] - '0' + b[i] - '0';
		if (val % 10 == c[i] - '0')
		{
			if (val < 10)
			{
				++cor0;
				if (a[i] == '0' || b[i] == '0' || c[i] == '0')
					++cor00;
			}
			else
			{
				++cor1;
				if (a[i] == '0' || b[i] == '0' || c[i] == '0')
					++cor10;
			}
		}
		else if ((val + 1) % 10 == c[i] - '0')
		{
			if (val + 1 < 10)
			{
				++inc0;
				if (a[i] == '0' || b[i] == '0' || c[i] == '0')
					++inc00;
			}
			else
			{
				++inc1;
				if (a[i] == '0' || b[i] == '0' || c[i] == '0')
					++inc10;
			}
		}
		else
		{
			possible = false;
			break;
		}
	}

	if (!possible)
	{
		cout << 0;
		return 0;
	}

	if (n > 0)
	{
		cout << getAns(cor0, inc0, cor1, inc1, 0, cor00, inc00, cor10, inc10) << "\n";
		return 0;
	}

	vector<int> perm(n);
	iota(all(perm), 0);

	ll cnt = 0;
	do {
		string a1(n, '0'), b1(n, '0'), c1(n, '0');
		for (int i = 0; i < n; ++i)
		{
			a1[i] = a[perm[i]];
			b1[i] = b[perm[i]];
			c1[i] = c[perm[i]];
		}

		if (a1[0] != '0' && b1[0] != '0' && c1[0] != '0' && stoll(a1) + stoll(b1) == stoll(c1))
			++cnt;

	} while (next_permutation(all(perm)));

	cout << cnt;

	return 0;
}